C     --=========================================--
C     Main subroutine
C     --=========================================--

      SUBROUTINE ML5_0_SLOOPMATRIX(P_USER,ANS)
C     
C     Generated by MadGraph5_aMC@NLO v. %(version)s, %(date)s
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Returns amplitude squared summed/avg over colors
C     and helicities for the point in phase space P(0:3,NEXTERNAL)
C     and external lines W(0:6,NEXTERNAL)
C     
C     Process: u u~ > d d~  [ QCD QED ] QED^2>2 QCD^2>0
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      CHARACTER*512 PARAMFNAME,HELCONFIGFNAME,LOOPFILTERFNAME
      CHARACTER*512 COLORNUMFNAME,COLORDENOMFNAME, HELFILTERFNAME
      CHARACTER*512 PROC_PREFIX
      PARAMETER ( PARAMFNAME='MadLoopParams.dat')
      PARAMETER ( HELCONFIGFNAME='HelConfigs.dat')
      PARAMETER ( LOOPFILTERFNAME='LoopFilter.dat')
      PARAMETER ( HELFILTERFNAME='HelFilter.dat')
      PARAMETER ( COLORNUMFNAME='ColorNumFactors.dat')
      PARAMETER ( COLORDENOMFNAME='ColorDenomFactors.dat')
      PARAMETER ( PROC_PREFIX='ML5_0_')

      INTEGER NBORNAMPS
      PARAMETER (NBORNAMPS=7)
      INTEGER    NLOOPS, NLOOPGROUPS, NCTAMPS
      PARAMETER (NLOOPS=776, NLOOPGROUPS=118, NCTAMPS=519)
      INTEGER    NCOLORROWS
      PARAMETER (NCOLORROWS=1295)
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=4)
      INTEGER    NWAVEFUNCS,NLOOPWAVEFUNCS
      PARAMETER (NWAVEFUNCS=18,NLOOPWAVEFUNCS=1193)
      INTEGER MAXLWFSIZE
      PARAMETER (MAXLWFSIZE=4)
      INTEGER LOOPMAXCOEFS, VERTEXMAXCOEFS
      PARAMETER (LOOPMAXCOEFS=210, VERTEXMAXCOEFS=35)
      INTEGER    NCOMB
      PARAMETER (NCOMB=16)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
      REAL*16     MP__ZERO
      PARAMETER (MP__ZERO=0E0_16)
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
C     These are constants related to the split orders
      INCLUDE 'nsqso_born.inc'
      INTEGER    NSO, NSQUAREDSO, NAMPSO
      PARAMETER (NSO=2, NSQUAREDSO=3, NAMPSO=4)
      INTEGER ANS_DIMENSION
      PARAMETER(ANS_DIMENSION=MAX(NSQSO_BORN,NSQUAREDSO))
      INTEGER NSQSOXNLG
      PARAMETER (NSQSOXNLG=NSQUAREDSO*NLOOPGROUPS)
      INTEGER NSQUAREDSOP1
      PARAMETER (NSQUAREDSOP1=NSQUAREDSO+1)
C     The total number of loop reduction libraries
C     At present, there are only CutTools,PJFry++,IREGI,Golem95
      INTEGER NLOOPLIB
      PARAMETER (NLOOPLIB=4)
C     Only CutTools provides QP
      INTEGER QP_NLOOPLIB
      PARAMETER (QP_NLOOPLIB=1)
C     This parameter is designed for the check timing command of MG5
      LOGICAL SKIPLOOPEVAL
      PARAMETER (SKIPLOOPEVAL=.FALSE.)
      LOGICAL BOOTANDSTOP
      PARAMETER (BOOTANDSTOP=.FALSE.)
      INTEGER MAXSTABILITYLENGTH
      DATA MAXSTABILITYLENGTH/20/
      COMMON/ML5_0_STABILITY_TESTS/MAXSTABILITYLENGTH
C     
C     ARGUMENTS 
C     
      REAL*8 P_USER(0:3,NEXTERNAL)
C     
C     The zeroth component of the second dimension is the result
C      summed over all
C     contributing split orders. The zeroth component of the first one
C      is the Born.
C     Notice that the upper bound of the second integer is not number
C      of squared orders
C     combination for the loops but the maximum between this number
C      for the Born
C     contributions and the loop ones. There are some cases for which
C      the Born contrib.
C     has squared split order contributions than the loop does. For
C      example
C     
C     generate u u~ > d d~ QCD^2<=2 QED^2<=99 [virt=QCD]
C     
C     It is however somehow academical. This is why ANS_DIMENSION is
C      not just NSQSO but rather MAX(NSQSO,NSQSO_BORN)
C     
      REAL*8 ANS(0:3,0:ANS_DIMENSION)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J,K,H,DUMMY,I_QP_LIB

      CHARACTER*512 PARAMFN,HELCONFIGFN,LOOPFILTERFN,COLORNUMFN
     $ ,COLORDENOMFN,HELFILTERFN
      CHARACTER*512 TMP
      SAVE PARAMFN
      SAVE HELCONFIGFN
      SAVE LOOPFILTERFN
      SAVE COLORNUMFN
      SAVE COLORDENOMFN
      SAVE HELFILTERFN

      INTEGER CTMODEINIT_BU
      REAL*8 MLSTABTHRES_BU
      INTEGER NEWHELREF
      LOGICAL HEL_INCONSISTENT
      REAL*8 P(0:3,NEXTERNAL)
C     DP_RES STORES THE DOUBLE PRECISION RESULT OBTAINED FROM
C      DIFFERENT EVALUATION METHODS IN ORDER TO ASSESS STABILITY.
C     THE STAB_STAGE COUNTER I CORRESPONDANCE GOES AS FOLLOWS
C     I=1 -> ORIGINAL PS, CTMODE=1
C     I=2 -> ORIGINAL PS, CTMODE=2, (ONLY WITH CTMODERUN=-1)
C     I=3 -> PS WITH ROTATION 1, CTMODE=1, (ONLY WITH CTMODERUN=-2)
C     I=4 -> PS WITH ROTATION 2, CTMODE=1, (ONLY WITH CTMODERUN=-3)
C     I=5 -> POSSIBLY MORE EVALUATION METHODS IN THE FUTURE, MAX IS
C      MAXSTABILITYLENGTH
C     IF UNSTABLE IT GOES TO THE SAME PATTERN BUT STAB_INDEX IS THEN
C      I+20.
      LOGICAL EVAL_DONE(MAXSTABILITYLENGTH)
      LOGICAL DOING_QP_EVALS
      INTEGER STAB_INDEX,BASIC_CT_MODE
      INTEGER N_DP_EVAL, N_QP_EVAL
      DATA N_DP_EVAL/1/
      DATA N_QP_EVAL/1/
      REAL*8 ACC(0:NSQUAREDSO)
      REAL*8 DP_RES(3,0:NSQUAREDSO,MAXSTABILITYLENGTH)
C     QP_RES STORES THE QUADRUPLE PRECISION RESULT OBTAINED FROM
C      DIFFERENT EVALUATION METHODS IN ORDER TO ASSESS STABILITY.
      REAL*8 QP_RES(3,0:NSQUAREDSO,MAXSTABILITYLENGTH)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
      INTEGER NATTEMPTS
      DATA NATTEMPTS/0/
      DATA IC/NEXTERNAL*1/
      REAL*8 HELSAVED(3,NCOMB)
      INTEGER ITEMP
      LOGICAL LTEMP
      REAL*8 BORNBUFF(0:NSQSO_BORN)
      REAL*8 BUFFR(3,0:NSQUAREDSO),BUFFR_BIS(3,0:NSQUAREDSO),TEMP(0:3
     $ ,0:NSQUAREDSO),TEMP1(0:NSQUAREDSO),TEMP2
      COMPLEX*16 COEFS(MAXLWFSIZE,0:VERTEXMAXCOEFS-1,MAXLWFSIZE)
      COMPLEX*16 CFTOT
      LOGICAL FOUNDHELFILTER,FOUNDLOOPFILTER
      DATA FOUNDHELFILTER/.TRUE./
      DATA FOUNDLOOPFILTER/.TRUE./
      LOGICAL LOOPFILTERBUFF(NSQUAREDSO,NLOOPGROUPS)
      DATA ((LOOPFILTERBUFF(J,I),J=1,NSQUAREDSO),I=1,NLOOPGROUPS)
     $ /NSQSOXNLG*.FALSE./

      INTEGER IDEN
      DATA IDEN/36/
      INTEGER HELAVGFACTOR
      DATA HELAVGFACTOR/4/
      LOGICAL DONEHELDOUBLECHECK
      DATA DONEHELDOUBLECHECK/.FALSE./
      INTEGER NEPS
      DATA NEPS/0/
C     Below are variables to bypass the checkphase and insure
C      stability check to take place
      LOGICAL OLD_CHECKPHASE, OLD_HELDOUBLECHECKED
      INTEGER OLD_GOODHEL(NCOMB)
      LOGICAL OLD_GOODAMP(NSQUAREDSO,NLOOPGROUPS)
      LOGICAL BYPASS_CHECK, ALWAYS_TEST_STABILITY
      COMMON/ML5_0_BYPASS_CHECK/BYPASS_CHECK, ALWAYS_TEST_STABILITY
C     
C     FUNCTIONS
C     
      INTEGER ML5_0_ML5SOINDEX_FOR_BORN_AMP
      INTEGER ML5_0_ML5SOINDEX_FOR_LOOP_AMP
      INTEGER ML5_0_ML5SQSOINDEX
      INTEGER ML5_0_ISSAME
      LOGICAL ML5_0_ISZERO
      INTEGER SET_RET_CODE_U
C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'coupl.inc'
      INCLUDE 'mp_coupl.inc'
      INCLUDE 'MadLoopParams.inc'

      LOGICAL CHOSEN_SO_CONFIGS(NSQUAREDSO)
      DATA CHOSEN_SO_CONFIGS/.FALSE.,.TRUE.,.FALSE./
      COMMON/ML5_0_CHOSEN_LOOP_SQSO/CHOSEN_SO_CONFIGS

      LOGICAL CHECKPHASE
      DATA CHECKPHASE/.TRUE./
      LOGICAL HELDOUBLECHECKED
      DATA HELDOUBLECHECKED/.FALSE./
      COMMON/ML5_0_INIT/CHECKPHASE, HELDOUBLECHECKED
      INTEGER NTRY
      DATA NTRY/0/
      REAL*8 REF
      DATA REF/0.0D0/

      LOGICAL MP_DONE
      DATA MP_DONE/.FALSE./
      COMMON/ML5_0_MP_DONE/MP_DONE
C     A FLAG TO DENOTE WHETHER THE CORRESPONDING LOOPLIBS ARE
C      AVAILABLE OR NOT
      LOGICAL LOOPLIBS_AVAILABLE(4)
      DATA LOOPLIBS_AVAILABLE /.TRUE.,.TRUE.,.TRUE.,.TRUE./
      COMMON/ML5_0_LOOPLIBS_AV/ LOOPLIBS_AVAILABLE
C     A FLAG TO DENOTE WHETHER THE CORRESPONDING DIRECTION TESTS
C      AVAILABLE OR NOT IN THE LOOPLIBS
C     PJFry++ and Golem95 do not support direction test
      LOGICAL LOOPLIBS_DIRECTEST(4)
      DATA LOOPLIBS_DIRECTEST /.TRUE.,.FALSE.,.TRUE.,.FALSE./

C     PS CAN POSSIBILY BE PASSED THROUGH IMPROVE_PS BUT IS NOT
C      MODIFIED FOR THE PURPOSE OF THE STABILITY TEST
C     EVEN THOUGH THEY ARE PUT IN COMMON BLOCK, FOR NOW THEY ARE NOT
C      USED ANYWHERE ELSE
      REAL*8 PS(0:3,NEXTERNAL)
      COMMON/ML5_0_PSPOINT/PS
C     AGAIN BELOW, MP_PS IS THE FIXED (POSSIBLY IMPROVED) MP PS POINT
C      AND MP_P IS THE ONE WHICH CAN BE MODIFIED (I.E. ROTATED ETC.)
C      FOR STABILITY PURPOSE
      REAL*16 MP_PS(0:3,NEXTERNAL),MP_P(0:3,NEXTERNAL)
      COMMON/ML5_0_MP_PSPOINT/MP_PS,MP_P

      REAL*8 LSCALE
      INTEGER CTMODE
      COMMON/ML5_0_CT/LSCALE,CTMODE
      LOGICAL MP_PS_SET
      DATA MP_PS_SET/.FALSE./

C     The parameter below sets the convention for the helicity filter
C     For a given helicity, the attached integer 'i' means
C     'i' in ]-inf;-HELOFFSET[ -> Helicity is equal, up to a sign, to
C      helicity number abs(i+HELOFFSET)
C     'i' == -HELOFFSET        -> Helicity is analytically zero
C     'i' in ]-HELOFFSET,inf[  -> Helicity is contributing with weight
C      'i'. If it is zero, it is skipped.
C     Typically, the hel_offset is 10000
      INTEGER HELOFFSET
      DATA HELOFFSET/10000/
      INTEGER GOODHEL(NCOMB)
      LOGICAL GOODAMP(NSQUAREDSO,NLOOPGROUPS)
      COMMON/ML5_0_FILTERS/GOODAMP,GOODHEL,HELOFFSET

      INTEGER HELPICKED
      DATA HELPICKED/-1/
      COMMON/ML5_0_HELCHOICE/HELPICKED
      INTEGER USERHEL
      DATA USERHEL/-1/
      COMMON/ML5_0_USERCHOICE/USERHEL

C     This integer can be accessed by an external user to set its
C      target squared split order.
C     If set to a value different than -1, the code will try to avoid
C      computing anything which
C     does not contribute to contributions of squared split orders
C      SQSO_TARGET and below.
      INTEGER SQSO_TARGET
      DATA SQSO_TARGET/-1/
      COMMON/ML5_0_SOCHOICE/SQSO_TARGET
C     The following logical are used to broadcast the fact that the
C      target 'required' CT and
C     loop split orders contributions have been reached already and
C      the rest can be skipped.
      LOGICAL UVCT_REQ_SO_DONE,MP_UVCT_REQ_SO_DONE,CT_REQ_SO_DONE
     $ ,MP_CT_REQ_SO_DONE,LOOP_REQ_SO_DONE,MP_LOOP_REQ_SO_DONE
     $ ,CTCALL_REQ_SO_DONE,FILTER_SO
      DATA UVCT_REQ_SO_DONE/.FALSE./
      DATA MP_UVCT_REQ_SO_DONE/.FALSE./
      DATA CT_REQ_SO_DONE/.FALSE./
      DATA MP_CT_REQ_SO_DONE/.FALSE./
      DATA LOOP_REQ_SO_DONE/.FALSE./
      DATA MP_LOOP_REQ_SO_DONE/.FALSE./
      DATA CTCALL_REQ_SO_DONE/.FALSE./
      DATA FILTER_SO/.FALSE./
      COMMON/ML5_0_SO_REQS/UVCT_REQ_SO_DONE,MP_UVCT_REQ_SO_DONE
     $ ,CT_REQ_SO_DONE,MP_CT_REQ_SO_DONE,LOOP_REQ_SO_DONE,MP_LOOP_REQ_S
     $ O_DONE,CTCALL_REQ_SO_DONE,FILTER_SO

      INTEGER I_SO
      DATA I_SO/1/
      COMMON/ML5_0_I_SO/I_SO
      INTEGER I_LIB
      DATA I_LIB/1/
      COMMON/ML5_0_I_LIB/I_LIB
C     TILL NOW, ONLY CUTTOOLS PROVIDE QP
      LOGICAL QP_TOOLS_AVAILABLE
      DATA QP_TOOLS_AVAILABLE/.FALSE./
      INTEGER INDEX_QP_TOOLS(QP_NLOOPLIB+1)
      COMMON/ML5_0_LOOP_TOOLS/QP_TOOLS_AVAILABLE,INDEX_QP_TOOLS

      COMPLEX*16 AMP(NBORNAMPS)
      COMMON/ML5_0_AMPS/AMP
      COMPLEX*16 W(20,NWAVEFUNCS)
      COMMON/ML5_0_W/W

      COMPLEX*32 MPW(20,NWAVEFUNCS)
      COMMON/ML5_0_MP_W/MPW

      COMPLEX*16 WL(MAXLWFSIZE,0:LOOPMAXCOEFS-1,MAXLWFSIZE,0:NLOOPWAVEF
     $ UNCS)
      COMPLEX*16 PL(0:3,0:NLOOPWAVEFUNCS)
      COMMON/ML5_0_WL/WL,PL

      COMPLEX*16 LOOPCOEFS(0:LOOPMAXCOEFS-1,NSQUAREDSO,NLOOPGROUPS)
      COMMON/ML5_0_LCOEFS/LOOPCOEFS

      COMPLEX*16 AMPL(3,NCTAMPS)
      COMMON/ML5_0_AMPL/AMPL

      COMPLEX*16 LOOPRES(3,NSQUAREDSO,NLOOPGROUPS)
      LOGICAL S(NSQUAREDSO,NLOOPGROUPS)
      COMMON/ML5_0_LOOPRES/LOOPRES,S

      INTEGER CF_D(NCOLORROWS,NBORNAMPS)
      INTEGER CF_N(NCOLORROWS,NBORNAMPS)
      COMMON/ML5_0_CF/CF_D,CF_N

      INTEGER HELC(NEXTERNAL,NCOMB)
      COMMON/ML5_0_HELCONFIGS/HELC

      REAL*8 PREC,USER_STAB_PREC
      DATA USER_STAB_PREC/-1.0D0/
      COMMON/ML5_0_USER_STAB_PREC/USER_STAB_PREC

C     Return codes H,T,U correspond to the hundreds, tens and units
C     building returncode, i.e.
C     RETURNCODE=100*RET_CODE_H+10*RET_CODE_T+RET_CODE_U

      INTEGER RET_CODE_H,RET_CODE_T,RET_CODE_U
      REAL*8 ACCURACY(0:NSQUAREDSO)
      DATA (ACCURACY(I),I=0,NSQUAREDSO)/NSQUAREDSOP1*1.0D0/
      DATA RET_CODE_H,RET_CODE_T,RET_CODE_U/1,1,0/
      COMMON/ML5_0_ACC/ACCURACY,RET_CODE_H,RET_CODE_T,RET_CODE_U

      LOGICAL MP_DONE_ONCE
      DATA MP_DONE_ONCE/.FALSE./
      COMMON/ML5_0_MP_DONE_ONCE/MP_DONE_ONCE

      CHARACTER(512) MLPATH
      COMMON/MLPATH/MLPATH

      LOGICAL ML_INIT
      COMMON/ML_INIT/ML_INIT

C     ----------
C     BEGIN CODE
C     ----------

      IF(ML_INIT) THEN
        CALL PRINT_MADLOOP_BANNER()
        TMP = 'auto'
        CALL SETMADLOOPPATH(TMP)
        CALL JOINPATH(MLPATH,PARAMFNAME,PARAMFN)
        CALL MADLOOPPARAMREADER(PARAMFN,.TRUE.)
        ML_INIT = .FALSE.
      ENDIF

      IF(NTRY.EQ.0) THEN
C       CALL MADLOOPPARAMREADER(paramFileName,.TRUE.)
        QP_TOOLS_AVAILABLE=.FALSE.
        INDEX_QP_TOOLS(1:QP_NLOOPLIB+1)=0
C       SKIP THE ONES THAT NOT AVAILABLE
        J=1
        DO I=1,NLOOPLIB
          IF(MLREDUCTIONLIB(J).EQ.0)EXIT
          IF(.NOT.LOOPLIBS_AVAILABLE(MLREDUCTIONLIB(J)))THEN
            MLREDUCTIONLIB(J:NLOOPLIB-1)=MLREDUCTIONLIB(J+1:NLOOPLIB)
            MLREDUCTIONLIB(NLOOPLIB)=0
          ELSE
            J=J+1
          ENDIF
        ENDDO
        IF(MLREDUCTIONLIB(1).EQ.0)THEN
          STOP 'No available loop reduction lib is provided. Make sur'
     $     //'e MLReductionLib is correct.'
        ENDIF
        J=0
        DO I=1,NLOOPLIB
          IF(MLREDUCTIONLIB(I).EQ.1)THEN
            J=J+1
            IF(.NOT.QP_TOOLS_AVAILABLE)QP_TOOLS_AVAILABLE=.TRUE.
            INDEX_QP_TOOLS(J)=I
          ENDIF
        ENDDO

C       Setup the file paths
        CALL JOINPATH(MLPATH,PARAMFNAME,PARAMFN)
        CALL JOINPATH(MLPATH,PROC_PREFIX,TMP)
        CALL JOINPATH(TMP,HELCONFIGFNAME,HELCONFIGFN)
        CALL JOINPATH(TMP,LOOPFILTERFNAME,LOOPFILTERFN)
        CALL JOINPATH(TMP,COLORNUMFNAME,COLORNUMFN)
        CALL JOINPATH(TMP,COLORDENOMFNAME,COLORDENOMFN)
        CALL JOINPATH(TMP,HELFILTERFNAME,HELFILTERFN)

        CALL ML5_0_SET_N_EVALS(N_DP_EVAL,N_QP_EVAL)

        HELDOUBLECHECKED=.NOT.DOUBLECHECKHELICITYFILTER
        OPEN(1, FILE=LOOPFILTERFN, ERR=100, STATUS='OLD',          
     $    ACTION='READ')
        DO J=1,NLOOPGROUPS
          READ(1,*,END=101) (GOODAMP(I,J),I=1,NSQUAREDSO)
        ENDDO
        GOTO 101
 100    CONTINUE
        FOUNDLOOPFILTER=.FALSE.
        DO J=1,NLOOPGROUPS
          DO I=1,NSQUAREDSO
            GOODAMP(I,J)=(.NOT.USELOOPFILTER)
          ENDDO
        ENDDO
 101    CONTINUE
        CLOSE(1)

        OPEN(1, FILE=HELFILTERFN, ERR=102, STATUS='OLD',          
     $    ACTION='READ')
        DO I=1,NCOMB
          READ(1,*,END=103) GOODHEL(I)
        ENDDO
        GOTO 103
 102    CONTINUE
        FOUNDHELFILTER=.FALSE.
        DO J=1,NCOMB
          GOODHEL(J)=1
        ENDDO
 103    CONTINUE
        CLOSE(1)

        OPEN(1, FILE=COLORNUMFN, ERR=104, STATUS='OLD',          
     $    ACTION='READ')
        DO I=1,NCOLORROWS
          READ(1,*,END=105) (CF_N(I,J),J=1,NBORNAMPS)
        ENDDO
        GOTO 105
 104    CONTINUE
        STOP 'Color factors could not be initialized from fil'
     $   //'e ML5_0_ColorNumFactors.dat. File not found'
 105    CONTINUE
        CLOSE(1)
        OPEN(1, FILE=COLORDENOMFN, ERR=106, STATUS='OLD',          
     $    ACTION='READ')
        DO I=1,NCOLORROWS
          READ(1,*,END=107) (CF_D(I,J),J=1,NBORNAMPS)
        ENDDO
        GOTO 107
 106    CONTINUE
        STOP 'Color factors could not be initialized from fil'
     $   //'e ML5_0_ColorDenomFactors.dat. File not found'
 107    CONTINUE
        CLOSE(1)
        OPEN(1, FILE=HELCONFIGFN, ERR=108, STATUS='OLD',              
     $       ACTION='READ')
        DO H=1,NCOMB
          READ(1,*,END=109) (HELC(I,H),I=1,NEXTERNAL)
        ENDDO
        GOTO 109
 108    CONTINUE
        STOP 'Color helictiy configurations could not be initialize'
     $   //'d from file ML5_0_HelConfigs.dat. File not found'
 109    CONTINUE
        CLOSE(1)

C       SETUP OF THE COMMON STARTING EXTERNAL LOOP WAVEFUNCTION
C       IT IS ALSO PS POINT INDEPENDENT, SO IT CAN BE DONE HERE.
        DO I=0,3
          PL(I,0)=(0.0D0,0.0D0)
        ENDDO
        DO I=1,MAXLWFSIZE
          DO J=0,LOOPMAXCOEFS-1
            DO K=1,MAXLWFSIZE
              IF(I.EQ.K.AND.J.EQ.0) THEN
                WL(I,J,K,0)=(1.0D0,0.0D0)
              ELSE
                WL(I,J,K,0)=(0.0D0,0.0D0)
              ENDIF
            ENDDO
          ENDDO
        ENDDO
        IF(BOOTANDSTOP) THEN
          WRITE(*,*) 'Stopped by user request.'
          STOP
        ENDIF
      ENDIF


C     First compute the borns, it will store them in ANS(0,I)
C     It is left untouched for the rest of MadLoop evaluation.
C     Notice that the squared split order index I does NOT
C     correspond to the same ordering of J for the loop ME 
C     results stored in ANS(K,J), with K in [1-3].The ordering 
C     of each can be obtained with ML5SOINDEX_FOR_SQUARED_ORDERS 
C     and SQSOINDEX_FROM_ORDERS for the loop ME and born ME 
C     respectively. For this to work, we assume that there is 
C     always more squared split orders in the loop ME than in the
C     born ME, which is practically always true. In any case, only
C     the split_order summed value I=0 is used in ML5 code.
      DO I=0,NSQSO_BORN
        BORNBUFF(I)=0.0D0
      ENDDO
      CALL ML5_0_SMATRIXHEL_SPLITORDERS(P_USER,USERHEL,BORNBUFF(0))
      DO I=0,NSQSO_BORN
        ANS(0,I)=BORNBUFF(I)
      ENDDO


C     We set here the reference to the born summed over all split
C      orders
      REF=0.0D0
      DO I=1,NSQSO_BORN
        REF=REF+ANS(0,I)
      ENDDO

      MP_DONE=.FALSE.
      MP_DONE_ONCE=.FALSE.
      MP_PS_SET=.FALSE.
      STAB_INDEX=0
      DOING_QP_EVALS=.FALSE.
      EVAL_DONE(1)=.TRUE.
      DO I=2,MAXSTABILITYLENGTH
        EVAL_DONE(I)=.FALSE.
      ENDDO

      IF(.NOT.BYPASS_CHECK) THEN
        NTRY=NTRY+1
      ENDIF

      IF (USER_STAB_PREC.GT.0.0D0) THEN
        MLSTABTHRES_BU=MLSTABTHRES
        MLSTABTHRES=USER_STAB_PREC
C       In the initialization, I cannot perform stability test and
C        therefore guarantee any precision
        CTMODEINIT_BU=CTMODEINIT
C       So either one choses quad precision directly
C       CTMODEINIT=4
C       Or, because this is very slow, we keep the orignal value. The
C        accuracy returned is -1 and tells the MC that he should not
C        trust the evaluation for checks.
        CTMODEINIT=CTMODEINIT_BU
      ENDIF

      IF(DONEHELDOUBLECHECK.AND.(.NOT.HELDOUBLECHECKED)) THEN
        HELDOUBLECHECKED=.TRUE.
        DONEHELDOUBLECHECK=.FALSE.
      ENDIF

      CHECKPHASE=(NTRY.LE.CHECKCYCLE).AND.(((.NOT.FOUNDLOOPFILTER
     $ ).AND.USELOOPFILTER).OR.(.NOT.FOUNDHELFILTER))

      IF (WRITEOUTFILTERS) THEN
        IF ((.NOT. CHECKPHASE).AND.(.NOT.FOUNDHELFILTER)) THEN

          OPEN(1, FILE=HELFILTERFN, ERR=110, STATUS='NEW',ACTION='WRIT'
     $     //'E')
          DO I=1,NCOMB
            WRITE(1,*) GOODHEL(I)
          ENDDO
 110      CONTINUE
          CLOSE(1)
          FOUNDHELFILTER=.TRUE.
        ENDIF

        IF ((.NOT. CHECKPHASE).AND.(.NOT.FOUNDLOOPFILTER).AND.USELOOPFI
     $   LTER) THEN
          OPEN(1, FILE=LOOPFILTERFN, ERR=111, STATUS='NEW',ACTION='WRI'
     $     //'TE')
          DO J=1,NLOOPGROUPS
            WRITE(1,*) (GOODAMP(I,J),I=1,NSQUAREDSO)
          ENDDO
 111      CONTINUE
          CLOSE(1)
          FOUNDLOOPFILTER=.TRUE.
        ENDIF
      ENDIF

      IF (BYPASS_CHECK) THEN
        OLD_CHECKPHASE = CHECKPHASE
        OLD_HELDOUBLECHECKED = HELDOUBLECHECKED
        CHECKPHASE = .FALSE.
        HELDOUBLECHECKED = .TRUE.
        DO I=1,NCOMB
          OLD_GOODHEL(I)=GOODHEL(I)
          GOODHEL(I)=1
        ENDDO
        DO I=1,NSQUAREDSO
          DO J=1,NLOOPGROUPS
            OLD_GOODAMP(I,J)=GOODAMP(I,J)
            GOODAMP(I,J)=.TRUE.
          ENDDO
        ENDDO
      ENDIF

      IF(CHECKPHASE.OR.(.NOT.HELDOUBLECHECKED)) THEN
        HELPICKED=1
        CTMODE=CTMODEINIT
      ELSE
        IF (USERHEL.NE.-1) THEN
          IF(GOODHEL(USERHEL).EQ.-HELOFFSET) THEN
            DO I=0,NSQUAREDSO
              ANS(1,I)=0.0D0
              ANS(2,I)=0.0D0
              ANS(3,I)=0.0D0
            ENDDO
            GOTO 9999
          ENDIF
        ENDIF
        HELPICKED=USERHEL
        IF (CTMODERUN.NE.-1) THEN
          CTMODE=CTMODERUN
        ELSE
          CTMODE=1
        ENDIF
      ENDIF

      DO I=1,NEXTERNAL
        DO J=0,3
          PS(J,I)=P_USER(J,I)
        ENDDO
      ENDDO

      IF (IMPROVEPSPOINT.GE.0) THEN
C       Make the input PS more precise (exact onshell and energy-moment
C       um conservation)
        CALL ML5_0_IMPROVE_PS_POINT_PRECISION(PS)
      ENDIF

      DO I=1,NEXTERNAL
        DO J=0,3
          P(J,I)=PS(J,I)
        ENDDO
      ENDDO

      DO K=1, 3
        DO I=0,NSQUAREDSO
          BUFFR(K,I)=0.0D0
        ENDDO
        DO I=1,NCTAMPS
          AMPL(K,I)=(0.0D0,0.0D0)
        ENDDO
      ENDDO
C     USE THE FIRST LOOP REDUCTION LIBRARY AND THE FIRST QP LOOP
C      REDUCTION LIBRARY
      I_LIB=1
      I_QP_LIB=1
 200  CONTINUE

      IF (.NOT.MP_PS_SET.AND.(CTMODE.EQ.0.OR.CTMODE.GE.4)) THEN
        CALL ML5_0_SET_MP_PS(P_USER)
        MP_PS_SET = .TRUE.
      ENDIF

      LSCALE=DSQRT(ABS((P(0,1)+P(0,2))**2-(P(1,1)+P(1,2))**2-(P(2,1)
     $ +P(2,2))**2-(P(3,1)+P(3,2))**2))

      CTCALL_REQ_SO_DONE=.FALSE.
      FILTER_SO = (.NOT.CHECKPHASE).AND.HELDOUBLECHECKED.AND.(SQSO_TARG
     $ ET.NE.-1)

      DO I=1,NLOOPGROUPS
        DO J=0,LOOPMAXCOEFS-1
          DO K=1,NSQUAREDSO
            LOOPCOEFS(J,K,I)=(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ENDDO

      DO I=1,NLOOPGROUPS
        DO J=1,3
          DO K=1,NSQUAREDSO
            LOOPRES(J,K,I)=0.0D0
          ENDDO
        ENDDO
      ENDDO

      DO K=1,3
        DO I=0,NSQUAREDSO
          ANS(K,I)=0.0D0
        ENDDO
      ENDDO

C     Check if we directly go to multiple precision
      IF (CTMODE.GE.4) THEN
        IF (.NOT.MP_DONE) THEN
          CALL ML5_0_MP_COMPUTE_LOOP_COEFS(MP_P,BUFFR_BIS)
C         It should be safe to directly set MP_DONE to true already
C          here. But maybe I overlooked something.
          MP_DONE=.TRUE.
        ENDIF
C       Even if MP_DONE is .TRUE. we should anyway skip the
C       double precision evaluation as it as already been
C       computed in quadruple precision.
        GOTO 300
      ENDIF

      DO H=1,NCOMB
        IF ((HELPICKED.EQ.H).OR.((HELPICKED.EQ.-1).AND.(CHECKPHASE.OR.(
     $   .NOT.HELDOUBLECHECKED).OR.(GOODHEL(H).GT.-HELOFFSET.AND.GOODHE
     $   L(H).NE.0)))) THEN
          DO I=1,NEXTERNAL
            NHEL(I)=HELC(I,H)
          ENDDO

          UVCT_REQ_SO_DONE=.FALSE.
          CT_REQ_SO_DONE=.FALSE.
          LOOP_REQ_SO_DONE=.FALSE.

C         Helas calls for the born amplitudes and counterterms
C          associated to given loops
          CALL IXXXXX(P(0,1),MDL_MU,NHEL(1),+1*IC(1),W(1,1))
          CALL OXXXXX(P(0,2),MDL_MU,NHEL(2),-1*IC(2),W(1,2))
          CALL OXXXXX(P(0,3),MDL_MD,NHEL(3),+1*IC(3),W(1,3))
          CALL IXXXXX(P(0,4),MDL_MD,NHEL(4),-1*IC(4),W(1,4))
          CALL FFV1P0_3(W(1,1),W(1,2),GC_11,ZERO,ZERO,W(1,5))
C         Amplitude(s) for born diagram with ID 1
          CALL FFV1_0(W(1,4),W(1,3),W(1,5),GC_11,AMP(1))
          CALL FFV1P0_3(W(1,1),W(1,2),GC_2,ZERO,ZERO,W(1,6))
C         Amplitude(s) for born diagram with ID 2
          CALL FFV1_0(W(1,4),W(1,3),W(1,6),GC_1,AMP(2))
          CALL FFV2_5_3(W(1,1),W(1,2),GC_69,GC_76,MDL_MZ,MDL_WZ,W(1,7))
C         Amplitude(s) for born diagram with ID 3
          CALL FFV2_3_0(W(1,4),W(1,3),W(1,7),GC_68,GC_76,AMP(3))
          CALL FFS2_3(W(1,1),W(1,2),GC_123,MDL_MZ,MDL_WZ,W(1,8))
C         Amplitude(s) for born diagram with ID 4
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),GC_104,AMP(4))
          CALL FFS4_3(W(1,1),W(1,2),GC_122,MDL_MH,MDL_WH,W(1,9))
C         Amplitude(s) for born diagram with ID 5
          CALL FFS4_0(W(1,4),W(1,3),W(1,9),GC_105,AMP(5))
          CALL FFV2_3(W(1,1),W(1,3),GC_124,MDL_MW,MDL_WW,W(1,10))
C         Amplitude(s) for born diagram with ID 6
          CALL FFV2_0(W(1,4),W(1,2),W(1,10),GC_59,AMP(6))
          CALL FFS1_3_3(W(1,1),W(1,3),GC_13,GC_22,MDL_MW,MDL_WW,W(1
     $     ,11))
C         Amplitude(s) for born diagram with ID 7
          CALL FFS1_3_0(W(1,4),W(1,2),W(1,11),GC_31,GC_40,AMP(7))
C         Counter-term amplitude(s) for loop diagram number 8
          CALL FFV1_0(W(1,4),W(1,3),W(1,6),R2_DDA,AMPL(1,1))
          CALL FFV1_0(W(1,4),W(1,3),W(1,6),R2_DDA_1EPS,AMPL(2,2))
          CALL FFV1_0(W(1,4),W(1,3),W(1,6),R2_DDA_2EPS,AMPL(3,3))
C         Counter-term amplitude(s) for loop diagram number 9
          CALL FFV2_3_0(W(1,4),W(1,3),W(1,7),R2_DDZ_V2,R2_DDZ_V3
     $     ,AMPL(1,4))
          CALL FFV2_3_0(W(1,4),W(1,3),W(1,7),R2_DDZ_V2_1EPS,R2_DDZ_V3_1
     $     EPS,AMPL(2,5))
          CALL FFV2_3_0(W(1,4),W(1,3),W(1,7),R2_DDZ_V2_2EPS,R2_DDZ_V3_2
     $     EPS,AMPL(3,6))
C         Counter-term amplitude(s) for loop diagram number 10
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_DDG0,AMPL(1,7))
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_DDG0_1EPS,AMPL(2,8))
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_DDG0_2EPS,AMPL(3,9))
C         Counter-term amplitude(s) for loop diagram number 11
          CALL FFS4_0(W(1,4),W(1,3),W(1,9),R2_DDH,AMPL(1,10))
          CALL FFS4_0(W(1,4),W(1,3),W(1,9),R2_DDH_1EPS,AMPL(2,11))
          CALL FFS4_0(W(1,4),W(1,3),W(1,9),R2_DDH_2EPS,AMPL(3,12))
C         Counter-term amplitude(s) for loop diagram number 12
          CALL FFV2_0(W(1,4),W(1,2),W(1,10),R2_DXUW,AMPL(1,13))
          CALL FFV2_0(W(1,4),W(1,2),W(1,10),R2_DXUW_1EPS,AMPL(2,14))
          CALL FFV2_0(W(1,4),W(1,2),W(1,10),R2_DXUW_2EPS,AMPL(3,15))
C         Counter-term amplitude(s) for loop diagram number 13
          CALL FFS4_2_0(W(1,4),W(1,2),W(1,11),R2_DXUGM,R2_DXUGMA
     $     ,AMPL(1,16))
          CALL FFS4_2_0(W(1,4),W(1,2),W(1,11),R2_DXUGM_1EPS,R2_DXUGMA_1
     $     EPS,AMPL(2,17))
          CALL FFS4_2_0(W(1,4),W(1,2),W(1,11),R2_DXUGM_2EPS,R2_DXUGMA_2
     $     EPS,AMPL(3,18))
          CALL FFV2_3(W(1,4),W(1,2),GC_59,MDL_MW,MDL_WW,W(1,12))
C         Counter-term amplitude(s) for loop diagram number 14
          CALL FFV2_0(W(1,1),W(1,3),W(1,12),R2_UXDW,AMPL(1,19))
          CALL FFV2_0(W(1,1),W(1,3),W(1,12),R2_UXDW_1EPS,AMPL(2,20))
          CALL FFV2_0(W(1,1),W(1,3),W(1,12),R2_UXDW_2EPS,AMPL(3,21))
          CALL FFS1_3_3(W(1,4),W(1,2),GC_31,GC_40,MDL_MW,MDL_WW,W(1
     $     ,13))
C         Counter-term amplitude(s) for loop diagram number 15
          CALL FFS4_2_0(W(1,1),W(1,3),W(1,13),R2_UXDGP,R2_UXDGPA
     $     ,AMPL(1,22))
          CALL FFS4_2_0(W(1,1),W(1,3),W(1,13),R2_UXDGP_1EPS,R2_UXDGPA_1
     $     EPS,AMPL(2,23))
          CALL FFS4_2_0(W(1,1),W(1,3),W(1,13),R2_UXDGP_2EPS,R2_UXDGPA_2
     $     EPS,AMPL(3,24))
          CALL FFV1P0_3(W(1,4),W(1,3),GC_1,ZERO,ZERO,W(1,14))
C         Counter-term amplitude(s) for loop diagram number 18
          CALL FFV1_0(W(1,1),W(1,2),W(1,14),R2_UUA,AMPL(1,25))
          CALL FFV1_0(W(1,1),W(1,2),W(1,14),R2_UUA_1EPS,AMPL(2,26))
          CALL FFV1_0(W(1,1),W(1,2),W(1,14),R2_UUA_2EPS,AMPL(3,27))
          CALL FFV2_3_3(W(1,4),W(1,3),GC_68,GC_76,MDL_MZ,MDL_WZ,W(1
     $     ,15))
C         Counter-term amplitude(s) for loop diagram number 19
          CALL FFV2_5_0(W(1,1),W(1,2),W(1,15),R2_UUZ_V2,R2_UUZ_V5
     $     ,AMPL(1,28))
          CALL FFV2_5_0(W(1,1),W(1,2),W(1,15),R2_UUZ_V2_1EPS,R2_UUZ_V5_
     $     1EPS,AMPL(2,29))
          CALL FFV2_5_0(W(1,1),W(1,2),W(1,15),R2_UUZ_V2_2EPS,R2_UUZ_V5_
     $     2EPS,AMPL(3,30))
          CALL FFS2_3(W(1,4),W(1,3),GC_104,MDL_MZ,MDL_WZ,W(1,16))
C         Counter-term amplitude(s) for loop diagram number 20
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_UUG0,AMPL(1,31))
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_UUG0_1EPS,AMPL(2,32))
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_UUG0_2EPS,AMPL(3,33))
          CALL FFS4_3(W(1,4),W(1,3),GC_105,MDL_MH,MDL_WH,W(1,17))
C         Counter-term amplitude(s) for loop diagram number 21
          CALL FFS4_0(W(1,1),W(1,2),W(1,17),R2_UUH,AMPL(1,34))
          CALL FFS4_0(W(1,1),W(1,2),W(1,17),R2_UUH_1EPS,AMPL(2,35))
          CALL FFS4_0(W(1,1),W(1,2),W(1,17),R2_UUH_2EPS,AMPL(3,36))
C         Counter-term amplitude(s) for loop diagram number 44
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),UV_GDDLEW,UV_GDDREW
     $     ,AMPL(1,37))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),UV_GDDLEW_1EPS,UV_GDDREW_1
     $     EPS,AMPL(2,38))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),UV_GDDLEW_2EPS,UV_GDDREW_2
     $     EPS,AMPL(3,39))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),R2_GDD2CPU,R2_GDD2CMU
     $     ,AMPL(1,40))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),R2_GDD2CPU_1EPS,R2_GDD2CMU
     $     _1EPS,AMPL(2,41))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),R2_GDD2CPU_2EPS,R2_GDD2CMU
     $     _2EPS,AMPL(3,42))
          CALL FFV1P0_3(W(1,4),W(1,3),GC_11,ZERO,ZERO,W(1,18))
C         Counter-term amplitude(s) for loop diagram number 46
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),UV_GUULEW,UV_GUUREW
     $     ,AMPL(1,43))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),UV_GUULEW_1EPS,UV_GUUREW_
     $     1EPS,AMPL(2,44))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),UV_GUULEW_2EPS,UV_GUUREW_
     $     2EPS,AMPL(3,45))
C         Counter-term amplitude(s) for loop diagram number 47
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),R2_GUU2CP,R2_GUU2CM
     $     ,AMPL(1,46))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),R2_GUU2CP_1EPS,R2_GUU2CM_
     $     1EPS,AMPL(2,47))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),R2_GUU2CP_2EPS,R2_GUU2CM_
     $     2EPS,AMPL(3,48))
C         Counter-term amplitude(s) for loop diagram number 50
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),R2_GDD2CPC,R2_GDD2CMC
     $     ,AMPL(1,49))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),R2_GDD2CPC_1EPS,R2_GDD2CMC
     $     _1EPS,AMPL(2,50))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),R2_GDD2CPC_2EPS,R2_GDD2CMC
     $     _2EPS,AMPL(3,51))
C         Counter-term amplitude(s) for loop diagram number 52
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),R2_GDD2CPT,R2_GDD2CMT
     $     ,AMPL(1,52))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),R2_GDD2CPT_1EPS,R2_GDD2CMT
     $     _1EPS,AMPL(2,53))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),R2_GDD2CPT_2EPS,R2_GDD2CMT
     $     _2EPS,AMPL(3,54))
C         Counter-term amplitude(s) for loop diagram number 55
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),R2_GDD2CP,R2_GDD2CM
     $     ,AMPL(1,55))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),R2_GDD2CP_1EPS,R2_GDD2CM_1
     $     EPS,AMPL(2,56))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,5),R2_GDD2CP_2EPS,R2_GDD2CM_2
     $     EPS,AMPL(3,57))
C         Counter-term amplitude(s) for loop diagram number 58
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),R2_GUU2CPD,R2_GUU2CMD
     $     ,AMPL(1,58))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),R2_GUU2CPD_1EPS
     $     ,R2_GUU2CMD_1EPS,AMPL(2,59))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),R2_GUU2CPD_2EPS
     $     ,R2_GUU2CMD_2EPS,AMPL(3,60))
C         Counter-term amplitude(s) for loop diagram number 60
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),R2_GUU2CPS,R2_GUU2CMS
     $     ,AMPL(1,61))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),R2_GUU2CPS_1EPS
     $     ,R2_GUU2CMS_1EPS,AMPL(2,62))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),R2_GUU2CPS_2EPS
     $     ,R2_GUU2CMS_2EPS,AMPL(3,63))
C         Counter-term amplitude(s) for loop diagram number 62
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),R2_GUU2CPB,R2_GUU2CMB
     $     ,AMPL(1,64))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),R2_GUU2CPB_1EPS
     $     ,R2_GUU2CMB_1EPS,AMPL(2,65))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,18),R2_GUU2CPB_2EPS
     $     ,R2_GUU2CMB_2EPS,AMPL(3,66))
C         At this point, all CT amps needed for (QCD=4 QED=2), i.e. of
C          split order ID=0, are computed.
          IF(FILTER_SO.AND.SQSO_TARGET.EQ.1) GOTO 2000
C         Counter-term amplitude(s) for loop diagram number 64
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAU,R2_AAU3,AMPL(1
     $     ,67))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAU_1EPS,R2_AAU3_1EP
     $     S,AMPL(2,68))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAU_2EPS,R2_AAU3_2EP
     $     S,AMPL(3,69))
C         Counter-term amplitude(s) for loop diagram number 65
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZU,R2_AZU3,AMPL(1
     $     ,70))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZU_1EPS,R2_AZU3_1EP
     $     S,AMPL(2,71))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZU_2EPS,R2_AZU3_2EP
     $     S,AMPL(3,72))
C         Counter-term amplitude(s) for loop diagram number 68
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZU,R2_AZU3,AMPL(1
     $     ,73))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZU_1EPS,R2_AZU3_1EP
     $     S,AMPL(2,74))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZU_2EPS,R2_AZU3_2EP
     $     S,AMPL(3,75))
C         Counter-term amplitude(s) for loop diagram number 69
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZU,R2_ZZU3,AMPL(1
     $     ,76))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZU_1EPS,R2_ZZU3_1EP
     $     S,AMPL(2,77))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZU_2EPS,R2_ZZU3_2EP
     $     S,AMPL(3,78))
C         Counter-term amplitude(s) for loop diagram number 74
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHU1,R2_HHU2,AMPL(1
     $     ,79))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHU1_1EPS,R2_HHU2_1E
     $     PS,AMPL(2,80))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHU1_2EPS,R2_HHU2_2E
     $     PS,AMPL(3,81))
C         Counter-term amplitude(s) for loop diagram number 79
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHU1,R2_HHU2,AMPL(1
     $     ,82))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHU1_1EPS,R2_HHU2_1E
     $     PS,AMPL(2,83))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHU1_2EPS,R2_HHU2_2E
     $     PS,AMPL(3,84))
C         Counter-term amplitude(s) for loop diagram number 80
          CALL L_VEXVEA21_L_VEXVEA22_0(W(1,4),W(1,3),W(1,6),C_UVDXDA1EW
     $     ,C_UVDXDA2EW,AMPL(1,85))
          CALL L_VEXVEA21_L_VEXVEA22_0(W(1,4),W(1,3),W(1,6),C_UVDXDA1EW
     $     _1EPS,C_UVDXDA2EW_1EPS,AMPL(2,86))
          CALL L_VEXVEA21_L_VEXVEA22_0(W(1,4),W(1,3),W(1,6),C_UVDXDA1EW
     $     _2EPS,C_UVDXDA2EW_2EPS,AMPL(3,87))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,6),R2_DDA2CP_U,R2_DDA2CM_U
     $     ,AMPL(1,88))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,6),R2_DDA2CP_U_1EPS
     $     ,R2_DDA2CM_U_1EPS,AMPL(2,89))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,6),R2_DDA2CP_U_2EPS
     $     ,R2_DDA2CM_U_2EPS,AMPL(3,90))
C         Counter-term amplitude(s) for loop diagram number 82
          CALL L_VEXVEA21_L_VEXVEA22_0(W(1,4),W(1,3),W(1,7),C_UVDXDZ1EW
     $     ,C_UVDXDZ2EW,AMPL(1,91))
          CALL L_VEXVEA21_L_VEXVEA22_0(W(1,4),W(1,3),W(1,7),C_UVDXDZ1EW
     $     _1EPS,C_UVDXDZ2EW_1EPS,AMPL(2,92))
          CALL L_VEXVEA21_L_VEXVEA22_0(W(1,4),W(1,3),W(1,7),C_UVDXDZ1EW
     $     _2EPS,C_UVDXDZ2EW_2EPS,AMPL(3,93))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,7),R2_DDZ2CP_U,R2_DDZ2CM_U
     $     ,AMPL(1,94))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,7),R2_DDZ2CP_U_1EPS
     $     ,R2_DDZ2CM_U_1EPS,AMPL(2,95))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,7),R2_DDZ2CP_U_2EPS
     $     ,R2_DDZ2CM_U_2EPS,AMPL(3,96))
C         Counter-term amplitude(s) for loop diagram number 84
          CALL L_EPEMH23_L_EPEMH24_0(W(1,4),W(1,3),W(1,8),C_UVDXDG01EW
     $     ,C_UVDXDG02EW,AMPL(1,97))
          CALL L_EPEMH23_L_EPEMH24_0(W(1,4),W(1,3),W(1,8),C_UVDXDG01EW_
     $     1EPS,C_UVDXDG02EW_1EPS,AMPL(2,98))
          CALL L_EPEMH23_L_EPEMH24_0(W(1,4),W(1,3),W(1,8),C_UVDXDG01EW_
     $     2EPS,C_UVDXDG02EW_2EPS,AMPL(3,99))
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_G0DD_U,AMPL(1,100))
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_G0DD_U_1EPS,AMPL(2,101))
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_G0DD_U_2EPS,AMPL(3,102))
C         Counter-term amplitude(s) for loop diagram number 86
          CALL L_EPEMH23_L_EPEMH24_0(W(1,4),W(1,3),W(1,9),C_UVDXDH1EW
     $     ,C_UVDXDH2EW,AMPL(1,103))
          CALL L_EPEMH23_L_EPEMH24_0(W(1,4),W(1,3),W(1,9),C_UVDXDH1EW_1
     $     EPS,C_UVDXDH2EW_1EPS,AMPL(2,104))
          CALL L_EPEMH23_L_EPEMH24_0(W(1,4),W(1,3),W(1,9),C_UVDXDH1EW_2
     $     EPS,C_UVDXDH2EW_2EPS,AMPL(3,105))
          CALL FFS5_0(W(1,4),W(1,3),W(1,9),R2_HDD_U,AMPL(1,106))
          CALL FFS5_0(W(1,4),W(1,3),W(1,9),R2_HDD_U_1EPS,AMPL(2,107))
          CALL FFS5_0(W(1,4),W(1,3),W(1,9),R2_HDD_U_2EPS,AMPL(3,108))
C         Counter-term amplitude(s) for loop diagram number 102
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWUD1,R2_WWUD3
     $     ,AMPL(1,109))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWUD1_1EPS
     $     ,R2_WWUD3_1EPS,AMPL(2,110))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWUD1_2EPS
     $     ,R2_WWUD3_2EPS,AMPL(3,111))
C         Counter-term amplitude(s) for loop diagram number 103
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWUS1,R2_WWUS3
     $     ,AMPL(1,112))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWUS1_1EPS
     $     ,R2_WWUS3_1EPS,AMPL(2,113))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWUS1_2EPS
     $     ,R2_WWUS3_2EPS,AMPL(3,114))
C         Counter-term amplitude(s) for loop diagram number 104
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWUB1,R2_WWUB3
     $     ,AMPL(1,115))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWUB1_1EPS
     $     ,R2_WWUB3_1EPS,AMPL(2,116))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWUB1_2EPS
     $     ,R2_WWUB3_2EPS,AMPL(3,117))
C         Counter-term amplitude(s) for loop diagram number 111
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPUD1,R2_GMGPUD2
     $     ,AMPL(1,118))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPUD1_1EPS
     $     ,R2_GMGPUD2_1EPS,AMPL(2,119))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPUD1_2EPS
     $     ,R2_GMGPUD2_2EPS,AMPL(3,120))
C         Counter-term amplitude(s) for loop diagram number 112
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPUS1,R2_GMGPUS2
     $     ,AMPL(1,121))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPUS1_1EPS
     $     ,R2_GMGPUS2_1EPS,AMPL(2,122))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPUS1_2EPS
     $     ,R2_GMGPUS2_2EPS,AMPL(3,123))
C         Counter-term amplitude(s) for loop diagram number 113
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPUB1,R2_GMGPUB2
     $     ,AMPL(1,124))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPUB1_1EPS
     $     ,R2_GMGPUB2_1EPS,AMPL(2,125))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPUB1_2EPS
     $     ,R2_GMGPUB2_2EPS,AMPL(3,126))
C         Counter-term amplitude(s) for loop diagram number 114
          CALL L_VEXVEA21_0(W(1,4),W(1,2),W(1,10),C_UVDXUWM1EW,AMPL(1
     $     ,127))
          CALL L_VEXVEA21_0(W(1,4),W(1,2),W(1,10),C_UVDXUWM1EW_1EPS
     $     ,AMPL(2,128))
          CALL L_VEXVEA21_0(W(1,4),W(1,2),W(1,10),C_UVDXUWM1EW_2EPS
     $     ,AMPL(3,129))
C         Counter-term amplitude(s) for loop diagram number 115
          CALL FFV2_0(W(1,4),W(1,2),W(1,10),R2_DXUW2CP,AMPL(1,130))
          CALL FFV2_0(W(1,4),W(1,2),W(1,10),R2_DXUW2CP_1EPS,AMPL(2
     $     ,131))
          CALL FFV2_0(W(1,4),W(1,2),W(1,10),R2_DXUW2CP_2EPS,AMPL(3
     $     ,132))
C         Counter-term amplitude(s) for loop diagram number 118
          CALL L_EPEMH23_L_EPEMH24_0(W(1,4),W(1,2),W(1,11),C_UVDXUGM1EW
     $     ,C_UVDXUGM2EW,AMPL(1,133))
          CALL L_EPEMH23_L_EPEMH24_0(W(1,4),W(1,2),W(1,11),C_UVDXUGM1EW
     $     _1EPS,C_UVDXUGM2EW_1EPS,AMPL(2,134))
          CALL L_EPEMH23_L_EPEMH24_0(W(1,4),W(1,2),W(1,11),C_UVDXUGM1EW
     $     _2EPS,C_UVDXUGM2EW_2EPS,AMPL(3,135))
C         Counter-term amplitude(s) for loop diagram number 119
          CALL FFS1_3_0(W(1,4),W(1,2),W(1,11),R2_DXUGM2CM,R2_DXUGM2CP
     $     ,AMPL(1,136))
          CALL FFS1_3_0(W(1,4),W(1,2),W(1,11),R2_DXUGM2CM_1EPS
     $     ,R2_DXUGM2CP_1EPS,AMPL(2,137))
          CALL FFS1_3_0(W(1,4),W(1,2),W(1,11),R2_DXUGM2CM_2EPS
     $     ,R2_DXUGM2CP_2EPS,AMPL(3,138))
C         Counter-term amplitude(s) for loop diagram number 136
          CALL L_VEXVEA21_0(W(1,1),W(1,3),W(1,12),C_UVUXDWP1EW,AMPL(1
     $     ,139))
          CALL L_VEXVEA21_0(W(1,1),W(1,3),W(1,12),C_UVUXDWP1EW_1EPS
     $     ,AMPL(2,140))
          CALL L_VEXVEA21_0(W(1,1),W(1,3),W(1,12),C_UVUXDWP1EW_2EPS
     $     ,AMPL(3,141))
C         Counter-term amplitude(s) for loop diagram number 137
          CALL L_EPEMH23_L_EPEMH24_0(W(1,1),W(1,3),W(1,13),C_UVUXDGP1EW
     $     ,C_UVUXDGP2EW,AMPL(1,142))
          CALL L_EPEMH23_L_EPEMH24_0(W(1,1),W(1,3),W(1,13),C_UVUXDGP1EW
     $     _1EPS,C_UVUXDGP2EW_1EPS,AMPL(2,143))
          CALL L_EPEMH23_L_EPEMH24_0(W(1,1),W(1,3),W(1,13),C_UVUXDGP1EW
     $     _2EPS,C_UVUXDGP2EW_2EPS,AMPL(3,144))
C         Counter-term amplitude(s) for loop diagram number 138
          CALL FFV2_0(W(1,1),W(1,3),W(1,12),R2_UXDW2CP,AMPL(1,145))
          CALL FFV2_0(W(1,1),W(1,3),W(1,12),R2_UXDW2CP_1EPS,AMPL(2
     $     ,146))
          CALL FFV2_0(W(1,1),W(1,3),W(1,12),R2_UXDW2CP_2EPS,AMPL(3
     $     ,147))
C         Counter-term amplitude(s) for loop diagram number 139
          CALL FFS1_3_0(W(1,1),W(1,3),W(1,13),R2_UXDGP2CM,R2_UXDGP2CP
     $     ,AMPL(1,148))
          CALL FFS1_3_0(W(1,1),W(1,3),W(1,13),R2_UXDGP2CM_1EPS
     $     ,R2_UXDGP2CP_1EPS,AMPL(2,149))
          CALL FFS1_3_0(W(1,1),W(1,3),W(1,13),R2_UXDGP2CM_2EPS
     $     ,R2_UXDGP2CP_2EPS,AMPL(3,150))
C         Counter-term amplitude(s) for loop diagram number 190
          CALL L_EPEMH23_L_EPEMH24_0(W(1,1),W(1,2),W(1,17),C_UVUXUH1EW
     $     ,C_UVUXUH2EW,AMPL(1,151))
          CALL L_EPEMH23_L_EPEMH24_0(W(1,1),W(1,2),W(1,17),C_UVUXUH1EW_
     $     1EPS,C_UVUXUH2EW_1EPS,AMPL(2,152))
          CALL L_EPEMH23_L_EPEMH24_0(W(1,1),W(1,2),W(1,17),C_UVUXUH1EW_
     $     2EPS,C_UVUXUH2EW_2EPS,AMPL(3,153))
          CALL FFS5_0(W(1,1),W(1,2),W(1,17),R2_HUU,AMPL(1,154))
          CALL FFS5_0(W(1,1),W(1,2),W(1,17),R2_HUU_1EPS,AMPL(2,155))
          CALL FFS5_0(W(1,1),W(1,2),W(1,17),R2_HUU_2EPS,AMPL(3,156))
C         Counter-term amplitude(s) for loop diagram number 192
          CALL L_VEXVEA21_L_VEXVEA22_0(W(1,1),W(1,2),W(1,15),C_UVUXUZ1E
     $     W,C_UVUXUZ2EW,AMPL(1,157))
          CALL L_VEXVEA21_L_VEXVEA22_0(W(1,1),W(1,2),W(1,15),C_UVUXUZ1E
     $     W_1EPS,C_UVUXUZ2EW_1EPS,AMPL(2,158))
          CALL L_VEXVEA21_L_VEXVEA22_0(W(1,1),W(1,2),W(1,15),C_UVUXUZ1E
     $     W_2EPS,C_UVUXUZ2EW_2EPS,AMPL(3,159))
C         Counter-term amplitude(s) for loop diagram number 193
          CALL L_EPEMH23_L_EPEMH24_0(W(1,1),W(1,2),W(1,16),C_UVUXUG01EW
     $     ,C_UVUXUG02EW,AMPL(1,160))
          CALL L_EPEMH23_L_EPEMH24_0(W(1,1),W(1,2),W(1,16),C_UVUXUG01EW
     $     _1EPS,C_UVUXUG02EW_1EPS,AMPL(2,161))
          CALL L_EPEMH23_L_EPEMH24_0(W(1,1),W(1,2),W(1,16),C_UVUXUG01EW
     $     _2EPS,C_UVUXUG02EW_2EPS,AMPL(3,162))
C         Counter-term amplitude(s) for loop diagram number 203
          CALL L_VEXVEA21_L_VEXVEA22_0(W(1,1),W(1,2),W(1,14),C_UVUXUA1E
     $     W,C_UVUXUA2EW,AMPL(1,163))
          CALL L_VEXVEA21_L_VEXVEA22_0(W(1,1),W(1,2),W(1,14),C_UVUXUA1E
     $     W_1EPS,C_UVUXUA2EW_1EPS,AMPL(2,164))
          CALL L_VEXVEA21_L_VEXVEA22_0(W(1,1),W(1,2),W(1,14),C_UVUXUA1E
     $     W_2EPS,C_UVUXUA2EW_2EPS,AMPL(3,165))
C         Counter-term amplitude(s) for loop diagram number 207
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,14),R2_UUA2CP,R2_UUA2CM
     $     ,AMPL(1,166))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,14),R2_UUA2CP_1EPS,R2_UUA2CM_
     $     1EPS,AMPL(2,167))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,14),R2_UUA2CP_2EPS,R2_UUA2CM_
     $     2EPS,AMPL(3,168))
C         Counter-term amplitude(s) for loop diagram number 208
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,15),R2_UUZ2CP,R2_UUZ2CM
     $     ,AMPL(1,169))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,15),R2_UUZ2CP_1EPS,R2_UUZ2CM_
     $     1EPS,AMPL(2,170))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,15),R2_UUZ2CP_2EPS,R2_UUZ2CM_
     $     2EPS,AMPL(3,171))
C         Counter-term amplitude(s) for loop diagram number 209
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_G0UU,AMPL(1,172))
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_G0UU_1EPS,AMPL(2,173))
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_G0UU_2EPS,AMPL(3,174))
C         Counter-term amplitude(s) for loop diagram number 255
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAU,R2_AAC3,AMPL(1
     $     ,175))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAU_1EPS,R2_AAC3_1EP
     $     S,AMPL(2,176))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAU_2EPS,R2_AAC3_2EP
     $     S,AMPL(3,177))
C         Counter-term amplitude(s) for loop diagram number 256
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZU,R2_AZC3,AMPL(1
     $     ,178))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZU_1EPS,R2_AZC3_1EP
     $     S,AMPL(2,179))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZU_2EPS,R2_AZC3_2EP
     $     S,AMPL(3,180))
C         Counter-term amplitude(s) for loop diagram number 259
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZU,R2_AZC3,AMPL(1
     $     ,181))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZU_1EPS,R2_AZC3_1EP
     $     S,AMPL(2,182))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZU_2EPS,R2_AZC3_2EP
     $     S,AMPL(3,183))
C         Counter-term amplitude(s) for loop diagram number 260
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZU,R2_ZZC3,AMPL(1
     $     ,184))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZU_1EPS,R2_ZZC3_1EP
     $     S,AMPL(2,185))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZU_2EPS,R2_ZZC3_2EP
     $     S,AMPL(3,186))
C         Counter-term amplitude(s) for loop diagram number 265
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHC1,R2_HHC2,AMPL(1
     $     ,187))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHC1_1EPS,R2_HHC2_1E
     $     PS,AMPL(2,188))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHC1_2EPS,R2_HHC2_2E
     $     PS,AMPL(3,189))
C         Counter-term amplitude(s) for loop diagram number 270
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHC1,R2_HHC2,AMPL(1
     $     ,190))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHC1_1EPS,R2_HHC2_1E
     $     PS,AMPL(2,191))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHC1_2EPS,R2_HHC2_2E
     $     PS,AMPL(3,192))
C         Counter-term amplitude(s) for loop diagram number 271
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,6),R2_DDA2CP_C,R2_DDA2CM_C
     $     ,AMPL(1,193))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,6),R2_DDA2CP_C_1EPS
     $     ,R2_DDA2CM_C_1EPS,AMPL(2,194))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,6),R2_DDA2CP_C_2EPS
     $     ,R2_DDA2CM_C_2EPS,AMPL(3,195))
C         Counter-term amplitude(s) for loop diagram number 273
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,7),R2_DDZ2CP_C,R2_DDZ2CM_C
     $     ,AMPL(1,196))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,7),R2_DDZ2CP_C_1EPS
     $     ,R2_DDZ2CM_C_1EPS,AMPL(2,197))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,7),R2_DDZ2CP_C_2EPS
     $     ,R2_DDZ2CM_C_2EPS,AMPL(3,198))
C         Counter-term amplitude(s) for loop diagram number 275
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_G0DD_C,AMPL(1,199))
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_G0DD_C_1EPS,AMPL(2,200))
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_G0DD_C_2EPS,AMPL(3,201))
C         Counter-term amplitude(s) for loop diagram number 277
          CALL FFS5_0(W(1,4),W(1,3),W(1,9),R2_HDD_C,AMPL(1,202))
          CALL FFS5_0(W(1,4),W(1,3),W(1,9),R2_HDD_C_1EPS,AMPL(2,203))
          CALL FFS5_0(W(1,4),W(1,3),W(1,9),R2_HDD_C_2EPS,AMPL(3,204))
C         Counter-term amplitude(s) for loop diagram number 293
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWCD1,R2_WWCD3
     $     ,AMPL(1,205))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWCD1_1EPS
     $     ,R2_WWCD3_1EPS,AMPL(2,206))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWCD1_2EPS
     $     ,R2_WWCD3_2EPS,AMPL(3,207))
C         Counter-term amplitude(s) for loop diagram number 294
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWCS1,R2_WWCS3
     $     ,AMPL(1,208))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWCS1_1EPS
     $     ,R2_WWCS3_1EPS,AMPL(2,209))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWCS1_2EPS
     $     ,R2_WWCS3_2EPS,AMPL(3,210))
C         Counter-term amplitude(s) for loop diagram number 295
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWCB1,R2_WWCB3
     $     ,AMPL(1,211))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWCB1_1EPS
     $     ,R2_WWCB3_1EPS,AMPL(2,212))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWCB1_2EPS
     $     ,R2_WWCB3_2EPS,AMPL(3,213))
C         Counter-term amplitude(s) for loop diagram number 302
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPCD1,R2_GMGPCD2
     $     ,AMPL(1,214))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPCD1_1EPS
     $     ,R2_GMGPCD2_1EPS,AMPL(2,215))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPCD1_2EPS
     $     ,R2_GMGPCD2_2EPS,AMPL(3,216))
C         Counter-term amplitude(s) for loop diagram number 303
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPCS1,R2_GMGPCS2
     $     ,AMPL(1,217))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPCS1_1EPS
     $     ,R2_GMGPCS2_1EPS,AMPL(2,218))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPCS1_2EPS
     $     ,R2_GMGPCS2_2EPS,AMPL(3,219))
C         Counter-term amplitude(s) for loop diagram number 304
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPCB1,R2_GMGPCB2
     $     ,AMPL(1,220))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPCB1_1EPS
     $     ,R2_GMGPCB2_1EPS,AMPL(2,221))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPCB1_2EPS
     $     ,R2_GMGPCB2_2EPS,AMPL(3,222))
C         Counter-term amplitude(s) for loop diagram number 317
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAU,R2_AAT3,AMPL(1
     $     ,223))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAU_1EPS,R2_AAT3_1EP
     $     S,AMPL(2,224))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAU_2EPS,R2_AAT3_2EP
     $     S,AMPL(3,225))
C         Counter-term amplitude(s) for loop diagram number 318
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZU,R2_AZT3,AMPL(1
     $     ,226))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZU_1EPS,R2_AZT3_1EP
     $     S,AMPL(2,227))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZU_2EPS,R2_AZT3_2EP
     $     S,AMPL(3,228))
C         Counter-term amplitude(s) for loop diagram number 321
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZU,R2_AZT3,AMPL(1
     $     ,229))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZU_1EPS,R2_AZT3_1EP
     $     S,AMPL(2,230))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZU_2EPS,R2_AZT3_2EP
     $     S,AMPL(3,231))
C         Counter-term amplitude(s) for loop diagram number 322
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZU,R2_ZZT3,AMPL(1
     $     ,232))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZU_1EPS,R2_ZZT3_1EP
     $     S,AMPL(2,233))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZU_2EPS,R2_ZZT3_2EP
     $     S,AMPL(3,234))
C         Counter-term amplitude(s) for loop diagram number 327
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHT1,R2_HHT2,AMPL(1
     $     ,235))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHT1_1EPS,R2_HHT2_1E
     $     PS,AMPL(2,236))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHT1_2EPS,R2_HHT2_2E
     $     PS,AMPL(3,237))
C         Counter-term amplitude(s) for loop diagram number 332
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHT1,R2_HHT2,AMPL(1
     $     ,238))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHT1_1EPS,R2_HHT2_1E
     $     PS,AMPL(2,239))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHT1_2EPS,R2_HHT2_2E
     $     PS,AMPL(3,240))
C         Counter-term amplitude(s) for loop diagram number 333
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,6),R2_DDA2CP_T,R2_DDA2CM_T
     $     ,AMPL(1,241))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,6),R2_DDA2CP_T_1EPS
     $     ,R2_DDA2CM_T_1EPS,AMPL(2,242))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,6),R2_DDA2CP_T_2EPS
     $     ,R2_DDA2CM_T_2EPS,AMPL(3,243))
C         Counter-term amplitude(s) for loop diagram number 335
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,7),R2_DDZ2CP_T,R2_DDZ2CM_T
     $     ,AMPL(1,244))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,7),R2_DDZ2CP_T_1EPS
     $     ,R2_DDZ2CM_T_1EPS,AMPL(2,245))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,7),R2_DDZ2CP_T_2EPS
     $     ,R2_DDZ2CM_T_2EPS,AMPL(3,246))
C         Counter-term amplitude(s) for loop diagram number 337
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_G0DD_T,AMPL(1,247))
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_G0DD_T_1EPS,AMPL(2,248))
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_G0DD_T_2EPS,AMPL(3,249))
C         Counter-term amplitude(s) for loop diagram number 339
          CALL FFS5_0(W(1,4),W(1,3),W(1,9),R2_HDD_T,AMPL(1,250))
          CALL FFS5_0(W(1,4),W(1,3),W(1,9),R2_HDD_T_1EPS,AMPL(2,251))
          CALL FFS5_0(W(1,4),W(1,3),W(1,9),R2_HDD_T_2EPS,AMPL(3,252))
C         Counter-term amplitude(s) for loop diagram number 355
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWTD1,R2_WWTD3
     $     ,AMPL(1,253))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWTD1_1EPS
     $     ,R2_WWTD3_1EPS,AMPL(2,254))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWTD1_2EPS
     $     ,R2_WWTD3_2EPS,AMPL(3,255))
C         Counter-term amplitude(s) for loop diagram number 356
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWTS1,R2_WWTS3
     $     ,AMPL(1,256))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWTS1_1EPS
     $     ,R2_WWTS3_1EPS,AMPL(2,257))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWTS1_2EPS
     $     ,R2_WWTS3_2EPS,AMPL(3,258))
C         Counter-term amplitude(s) for loop diagram number 357
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWTB1,R2_WWTB3
     $     ,AMPL(1,259))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWTB1_1EPS
     $     ,R2_WWTB3_1EPS,AMPL(2,260))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWTB1_2EPS
     $     ,R2_WWTB3_2EPS,AMPL(3,261))
C         Counter-term amplitude(s) for loop diagram number 364
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPTD1,R2_GMGPTD2
     $     ,AMPL(1,262))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPTD1_1EPS
     $     ,R2_GMGPTD2_1EPS,AMPL(2,263))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPTD1_2EPS
     $     ,R2_GMGPTD2_2EPS,AMPL(3,264))
C         Counter-term amplitude(s) for loop diagram number 365
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPTS1,R2_GMGPTS2
     $     ,AMPL(1,265))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPTS1_1EPS
     $     ,R2_GMGPTS2_1EPS,AMPL(2,266))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPTS1_2EPS
     $     ,R2_GMGPTS2_2EPS,AMPL(3,267))
C         Counter-term amplitude(s) for loop diagram number 366
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPTB1,R2_GMGPTB2
     $     ,AMPL(1,268))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPTB1_1EPS
     $     ,R2_GMGPTB2_1EPS,AMPL(2,269))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPTB1_2EPS
     $     ,R2_GMGPTB2_2EPS,AMPL(3,270))
C         Counter-term amplitude(s) for loop diagram number 379
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAD,R2_AAD3,AMPL(1
     $     ,271))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAD_1EPS,R2_AAD3_1EP
     $     S,AMPL(2,272))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAD_2EPS,R2_AAD3_2EP
     $     S,AMPL(3,273))
C         Counter-term amplitude(s) for loop diagram number 380
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZD,R2_AZD3,AMPL(1
     $     ,274))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZD_1EPS,R2_AZD3_1EP
     $     S,AMPL(2,275))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZD_2EPS,R2_AZD3_2EP
     $     S,AMPL(3,276))
C         Counter-term amplitude(s) for loop diagram number 383
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZD,R2_AZD3,AMPL(1
     $     ,277))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZD_1EPS,R2_AZD3_1EP
     $     S,AMPL(2,278))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZD_2EPS,R2_AZD3_2EP
     $     S,AMPL(3,279))
C         Counter-term amplitude(s) for loop diagram number 384
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZD,R2_ZZD3,AMPL(1
     $     ,280))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZD_1EPS,R2_ZZD3_1EP
     $     S,AMPL(2,281))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZD_2EPS,R2_ZZD3_2EP
     $     S,AMPL(3,282))
C         Counter-term amplitude(s) for loop diagram number 389
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHD1,R2_HHD2,AMPL(1
     $     ,283))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHD1_1EPS,R2_HHD2_1E
     $     PS,AMPL(2,284))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHD1_2EPS,R2_HHD2_2E
     $     PS,AMPL(3,285))
C         Counter-term amplitude(s) for loop diagram number 394
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHD1,R2_HHD2,AMPL(1
     $     ,286))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHD1_1EPS,R2_HHD2_1E
     $     PS,AMPL(2,287))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHD1_2EPS,R2_HHD2_2E
     $     PS,AMPL(3,288))
C         Counter-term amplitude(s) for loop diagram number 396
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,6),R2_DDA2CP,R2_DDA2CM
     $     ,AMPL(1,289))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,6),R2_DDA2CP_1EPS,R2_DDA2CM_1
     $     EPS,AMPL(2,290))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,6),R2_DDA2CP_2EPS,R2_DDA2CM_2
     $     EPS,AMPL(3,291))
C         Counter-term amplitude(s) for loop diagram number 400
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,7),R2_DDZ2CP,R2_DDZ2CM
     $     ,AMPL(1,292))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,7),R2_DDZ2CP_1EPS,R2_DDZ2CM_1
     $     EPS,AMPL(2,293))
          CALL FFV2_6_0(W(1,4),W(1,3),W(1,7),R2_DDZ2CP_2EPS,R2_DDZ2CM_2
     $     EPS,AMPL(3,294))
C         Counter-term amplitude(s) for loop diagram number 404
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_G0DD,AMPL(1,295))
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_G0DD_1EPS,AMPL(2,296))
          CALL FFS2_0(W(1,4),W(1,3),W(1,8),R2_G0DD_2EPS,AMPL(3,297))
C         Counter-term amplitude(s) for loop diagram number 408
          CALL FFS5_0(W(1,4),W(1,3),W(1,9),R2_HDD,AMPL(1,298))
          CALL FFS5_0(W(1,4),W(1,3),W(1,9),R2_HDD_1EPS,AMPL(2,299))
          CALL FFS5_0(W(1,4),W(1,3),W(1,9),R2_HDD_2EPS,AMPL(3,300))
C         Counter-term amplitude(s) for loop diagram number 452
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,14),R2_UUA2CP_D,R2_UUA2CM_D
     $     ,AMPL(1,301))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,14),R2_UUA2CP_D_1EPS
     $     ,R2_UUA2CM_D_1EPS,AMPL(2,302))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,14),R2_UUA2CP_D_2EPS
     $     ,R2_UUA2CM_D_2EPS,AMPL(3,303))
C         Counter-term amplitude(s) for loop diagram number 453
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,15),R2_UUZ2CP_D,R2_UUZ2CM_D
     $     ,AMPL(1,304))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,15),R2_UUZ2CP_D_1EPS
     $     ,R2_UUZ2CM_D_1EPS,AMPL(2,305))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,15),R2_UUZ2CP_D_2EPS
     $     ,R2_UUZ2CM_D_2EPS,AMPL(3,306))
C         Counter-term amplitude(s) for loop diagram number 454
          CALL FFS5_0(W(1,1),W(1,2),W(1,17),R2_HUU_D,AMPL(1,307))
          CALL FFS5_0(W(1,1),W(1,2),W(1,17),R2_HUU_D_1EPS,AMPL(2,308))
          CALL FFS5_0(W(1,1),W(1,2),W(1,17),R2_HUU_D_2EPS,AMPL(3,309))
C         Counter-term amplitude(s) for loop diagram number 468
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_G0UU_D,AMPL(1,310))
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_G0UU_D_1EPS,AMPL(2,311))
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_G0UU_D_2EPS,AMPL(3,312))
C         Counter-term amplitude(s) for loop diagram number 482
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAD,R2_AAS3,AMPL(1
     $     ,313))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAD_1EPS,R2_AAS3_1EP
     $     S,AMPL(2,314))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAD_2EPS,R2_AAS3_2EP
     $     S,AMPL(3,315))
C         Counter-term amplitude(s) for loop diagram number 483
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZD,R2_AZS3,AMPL(1
     $     ,316))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZD_1EPS,R2_AZS3_1EP
     $     S,AMPL(2,317))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZD_2EPS,R2_AZS3_2EP
     $     S,AMPL(3,318))
C         Counter-term amplitude(s) for loop diagram number 486
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZD,R2_AZS3,AMPL(1
     $     ,319))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZD_1EPS,R2_AZS3_1EP
     $     S,AMPL(2,320))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZD_2EPS,R2_AZS3_2EP
     $     S,AMPL(3,321))
C         Counter-term amplitude(s) for loop diagram number 487
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZD,R2_ZZS3,AMPL(1
     $     ,322))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZD_1EPS,R2_ZZS3_1EP
     $     S,AMPL(2,323))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZD_2EPS,R2_ZZS3_2EP
     $     S,AMPL(3,324))
C         Counter-term amplitude(s) for loop diagram number 492
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHS1,R2_HHS2,AMPL(1
     $     ,325))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHS1_1EPS,R2_HHS2_1E
     $     PS,AMPL(2,326))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHS1_2EPS,R2_HHS2_2E
     $     PS,AMPL(3,327))
C         Counter-term amplitude(s) for loop diagram number 497
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHS1,R2_HHS2,AMPL(1
     $     ,328))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHS1_1EPS,R2_HHS2_1E
     $     PS,AMPL(2,329))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHS1_2EPS,R2_HHS2_2E
     $     PS,AMPL(3,330))
C         Counter-term amplitude(s) for loop diagram number 498
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,14),R2_UUA2CP_S,R2_UUA2CM_S
     $     ,AMPL(1,331))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,14),R2_UUA2CP_S_1EPS
     $     ,R2_UUA2CM_S_1EPS,AMPL(2,332))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,14),R2_UUA2CP_S_2EPS
     $     ,R2_UUA2CM_S_2EPS,AMPL(3,333))
C         Counter-term amplitude(s) for loop diagram number 499
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,15),R2_UUZ2CP_S,R2_UUZ2CM_S
     $     ,AMPL(1,334))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,15),R2_UUZ2CP_S_1EPS
     $     ,R2_UUZ2CM_S_1EPS,AMPL(2,335))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,15),R2_UUZ2CP_S_2EPS
     $     ,R2_UUZ2CM_S_2EPS,AMPL(3,336))
C         Counter-term amplitude(s) for loop diagram number 500
          CALL FFS5_0(W(1,1),W(1,2),W(1,17),R2_HUU_S,AMPL(1,337))
          CALL FFS5_0(W(1,1),W(1,2),W(1,17),R2_HUU_S_1EPS,AMPL(2,338))
          CALL FFS5_0(W(1,1),W(1,2),W(1,17),R2_HUU_S_2EPS,AMPL(3,339))
C         Counter-term amplitude(s) for loop diagram number 514
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_G0UU_S,AMPL(1,340))
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_G0UU_S_1EPS,AMPL(2,341))
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_G0UU_S_2EPS,AMPL(3,342))
C         Counter-term amplitude(s) for loop diagram number 520
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAD,R2_AAB3,AMPL(1
     $     ,343))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAD_1EPS,R2_AAB3_1EP
     $     S,AMPL(2,344))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAD_2EPS,R2_AAB3_2EP
     $     S,AMPL(3,345))
C         Counter-term amplitude(s) for loop diagram number 521
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZD,R2_AZB3,AMPL(1
     $     ,346))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZD_1EPS,R2_AZB3_1EP
     $     S,AMPL(2,347))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZD_2EPS,R2_AZB3_2EP
     $     S,AMPL(3,348))
C         Counter-term amplitude(s) for loop diagram number 524
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZD,R2_AZB3,AMPL(1
     $     ,349))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZD_1EPS,R2_AZB3_1EP
     $     S,AMPL(2,350))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZD_2EPS,R2_AZB3_2EP
     $     S,AMPL(3,351))
C         Counter-term amplitude(s) for loop diagram number 525
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZD,R2_ZZB3,AMPL(1
     $     ,352))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZD_1EPS,R2_ZZB3_1EP
     $     S,AMPL(2,353))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZD_2EPS,R2_ZZB3_2EP
     $     S,AMPL(3,354))
C         Counter-term amplitude(s) for loop diagram number 530
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHB1,R2_HHB2,AMPL(1
     $     ,355))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHB1_1EPS,R2_HHB2_1E
     $     PS,AMPL(2,356))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHB1_2EPS,R2_HHB2_2E
     $     PS,AMPL(3,357))
C         Counter-term amplitude(s) for loop diagram number 535
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHB1,R2_HHB2,AMPL(1
     $     ,358))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHB1_1EPS,R2_HHB2_1E
     $     PS,AMPL(2,359))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHB1_2EPS,R2_HHB2_2E
     $     PS,AMPL(3,360))
C         Counter-term amplitude(s) for loop diagram number 536
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,14),R2_UUA2CP_B,R2_UUA2CM_B
     $     ,AMPL(1,361))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,14),R2_UUA2CP_B_1EPS
     $     ,R2_UUA2CM_B_1EPS,AMPL(2,362))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,14),R2_UUA2CP_B_2EPS
     $     ,R2_UUA2CM_B_2EPS,AMPL(3,363))
C         Counter-term amplitude(s) for loop diagram number 537
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,15),R2_UUZ2CP_B,R2_UUZ2CM_B
     $     ,AMPL(1,364))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,15),R2_UUZ2CP_B_1EPS
     $     ,R2_UUZ2CM_B_1EPS,AMPL(2,365))
          CALL FFV2_6_0(W(1,1),W(1,2),W(1,15),R2_UUZ2CP_B_2EPS
     $     ,R2_UUZ2CM_B_2EPS,AMPL(3,366))
C         Counter-term amplitude(s) for loop diagram number 538
          CALL FFS5_0(W(1,1),W(1,2),W(1,17),R2_HUU_B,AMPL(1,367))
          CALL FFS5_0(W(1,1),W(1,2),W(1,17),R2_HUU_B_1EPS,AMPL(2,368))
          CALL FFS5_0(W(1,1),W(1,2),W(1,17),R2_HUU_B_2EPS,AMPL(3,369))
C         Counter-term amplitude(s) for loop diagram number 552
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_G0UU_B,AMPL(1,370))
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_G0UU_B_1EPS,AMPL(2,371))
          CALL FFS2_0(W(1,1),W(1,2),W(1,16),R2_G0UU_B_2EPS,AMPL(3,372))
C         Counter-term amplitude(s) for loop diagram number 558
          CALL L_WMWPMASS1_L_WMWPMASS2_L_WMWPMASS3_0(W(1,12),W(1,10)
     $     ,C_UVWMWPMASS1EW,C_UVWMWPMASS2EW,C_UVWMWPMASS3EW,AMPL(1
     $     ,373))
          CALL L_WMWPMASS1_L_WMWPMASS2_L_WMWPMASS3_0(W(1,12),W(1,10)
     $     ,C_UVWMWPMASS1EW_1EPS,C_UVWMWPMASS2EW_1EPS,C_UVWMWPMASS3EW_1
     $     EPS,AMPL(2,374))
          CALL L_WMWPMASS1_L_WMWPMASS2_L_WMWPMASS3_0(W(1,12),W(1,10)
     $     ,C_UVWMWPMASS1EW_2EPS,C_UVWMWPMASS2EW_2EPS,C_UVWMWPMASS3EW_2
     $     EPS,AMPL(3,375))
C         Counter-term amplitude(s) for loop diagram number 560
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,13),W(1,10),C_UVGPWMMASS1E
     $     W,C_UVGPWMMASS2EW,AMPL(1,376))
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,13),W(1,10),C_UVGPWMMASS1E
     $     W_1EPS,C_UVGPWMMASS2EW_1EPS,AMPL(2,377))
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,13),W(1,10),C_UVGPWMMASS1E
     $     W_2EPS,C_UVGPWMMASS2EW_2EPS,AMPL(3,378))
C         Counter-term amplitude(s) for loop diagram number 563
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,11),W(1,12),C_UVGMWPMASS1E
     $     W,C_UVGMWPMASS2EW,AMPL(1,379))
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,11),W(1,12),C_UVGMWPMASS1E
     $     W_1EPS,C_UVGMWPMASS2EW_1EPS,AMPL(2,380))
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,11),W(1,12),C_UVGMWPMASS1E
     $     W_2EPS,C_UVGMWPMASS2EW_2EPS,AMPL(3,381))
C         Counter-term amplitude(s) for loop diagram number 567
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,16),W(1,7),C_UVG0ZMASS1EW
     $     ,C_UVG0ZMASS2EW,AMPL(1,382))
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,16),W(1,7),C_UVG0ZMASS1EW_
     $     1EPS,C_UVG0ZMASS2EW_1EPS,AMPL(2,383))
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,16),W(1,7),C_UVG0ZMASS1EW_
     $     2EPS,C_UVG0ZMASS2EW_2EPS,AMPL(3,384))
C         Counter-term amplitude(s) for loop diagram number 568
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,8),W(1,15),C_UVG0ZMASS1EW
     $     ,C_UVG0ZMASS2EW,AMPL(1,385))
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,8),W(1,15),C_UVG0ZMASS1EW_
     $     1EPS,C_UVG0ZMASS2EW_1EPS,AMPL(2,386))
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,8),W(1,15),C_UVG0ZMASS1EW_
     $     2EPS,C_UVG0ZMASS2EW_2EPS,AMPL(3,387))
C         Counter-term amplitude(s) for loop diagram number 584
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,6),W(1,14),R2_AABOSON1
     $     ,R2_AABOSON2,R2_AABOSON3,AMPL(1,388))
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,6),W(1,14),R2_AABOSON1_1EP
     $     S,R2_AABOSON2_1EPS,R2_AABOSON3_1EPS,AMPL(2,389))
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,6),W(1,14),R2_AABOSON1_2EP
     $     S,R2_AABOSON2_2EPS,R2_AABOSON3_2EPS,AMPL(3,390))
C         Counter-term amplitude(s) for loop diagram number 588
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,6),W(1,15),R2_AZBOSON1
     $     ,R2_AZBOSON2,R2_AZBOSON3,AMPL(1,391))
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,6),W(1,15),R2_AZBOSON1_1EP
     $     S,R2_AZBOSON2_1EPS,R2_AZBOSON3_1EPS,AMPL(2,392))
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,6),W(1,15),R2_AZBOSON1_2EP
     $     S,R2_AZBOSON2_2EPS,R2_AZBOSON3_2EPS,AMPL(3,393))
          CALL L_WMWPMASS1_L_WMWPMASS2_L_WMWPMASS3_0(W(1,6),W(1,15)
     $     ,C_UVAZMASS1EW,C_UVAZMASS2EW,C_UVAZMASS3EW,AMPL(1,394))
          CALL L_WMWPMASS1_L_WMWPMASS2_L_WMWPMASS3_0(W(1,6),W(1,15)
     $     ,C_UVAZMASS1EW_1EPS,C_UVAZMASS2EW_1EPS,C_UVAZMASS3EW_1EPS
     $     ,AMPL(2,395))
          CALL L_WMWPMASS1_L_WMWPMASS2_L_WMWPMASS3_0(W(1,6),W(1,15)
     $     ,C_UVAZMASS1EW_2EPS,C_UVAZMASS2EW_2EPS,C_UVAZMASS3EW_2EPS
     $     ,AMPL(3,396))
C         Counter-term amplitude(s) for loop diagram number 592
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,16),W(1,6),C_UVAG0MASS1EW
     $     ,C_UVAG0MASS2EW,AMPL(1,397))
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,16),W(1,6),C_UVAG0MASS1EW_
     $     1EPS,C_UVAG0MASS2EW_1EPS,AMPL(2,398))
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,16),W(1,6),C_UVAG0MASS1EW_
     $     2EPS,C_UVAG0MASS2EW_2EPS,AMPL(3,399))
C         Counter-term amplitude(s) for loop diagram number 597
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,14),W(1,7),R2_AZBOSON1
     $     ,R2_AZBOSON2,R2_AZBOSON3,AMPL(1,400))
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,14),W(1,7),R2_AZBOSON1_1EP
     $     S,R2_AZBOSON2_1EPS,R2_AZBOSON3_1EPS,AMPL(2,401))
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,14),W(1,7),R2_AZBOSON1_2EP
     $     S,R2_AZBOSON2_2EPS,R2_AZBOSON3_2EPS,AMPL(3,402))
          CALL L_WMWPMASS1_L_WMWPMASS2_L_WMWPMASS3_0(W(1,14),W(1,7)
     $     ,C_UVAZMASS1EW,C_UVAZMASS2EW,C_UVAZMASS3EW,AMPL(1,403))
          CALL L_WMWPMASS1_L_WMWPMASS2_L_WMWPMASS3_0(W(1,14),W(1,7)
     $     ,C_UVAZMASS1EW_1EPS,C_UVAZMASS2EW_1EPS,C_UVAZMASS3EW_1EPS
     $     ,AMPL(2,404))
          CALL L_WMWPMASS1_L_WMWPMASS2_L_WMWPMASS3_0(W(1,14),W(1,7)
     $     ,C_UVAZMASS1EW_2EPS,C_UVAZMASS2EW_2EPS,C_UVAZMASS3EW_2EPS
     $     ,AMPL(3,405))
C         Counter-term amplitude(s) for loop diagram number 610
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,8),W(1,14),C_UVAG0MASS1EW
     $     ,C_UVAG0MASS2EW,AMPL(1,406))
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,8),W(1,14),C_UVAG0MASS1EW_
     $     1EPS,C_UVAG0MASS2EW_1EPS,AMPL(2,407))
          CALL L_GPWMMASS4_L_GPWMMASS5_0(W(1,8),W(1,14),C_UVAG0MASS1EW_
     $     2EPS,C_UVAG0MASS2EW_2EPS,AMPL(3,408))
C         Counter-term amplitude(s) for loop diagram number 683
          CALL R2_GG_1_0(W(1,7),W(1,15),R2_ZZV,AMPL(1,409))
          CALL R2_GG_1_0(W(1,7),W(1,15),R2_ZZV_1EPS,AMPL(2,410))
          CALL R2_GG_1_0(W(1,7),W(1,15),R2_ZZV_2EPS,AMPL(3,411))
C         Counter-term amplitude(s) for loop diagram number 684
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWL,R2_WWE3,AMPL(1
     $     ,412))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWL_1EPS,R2_WWE3_1E
     $     PS,AMPL(2,413))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWL_2EPS,R2_WWE3_2E
     $     PS,AMPL(3,414))
C         Counter-term amplitude(s) for loop diagram number 687
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPE,R2_HHE2
     $     ,AMPL(1,415))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPE_1EPS
     $     ,R2_HHE2_1EPS,AMPL(2,416))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPE_2EPS
     $     ,R2_HHE2_2EPS,AMPL(3,417))
C         Counter-term amplitude(s) for loop diagram number 688
          CALL R2_GG_1_0(W(1,7),W(1,15),R2_ZZV,AMPL(1,418))
          CALL R2_GG_1_0(W(1,7),W(1,15),R2_ZZV_1EPS,AMPL(2,419))
          CALL R2_GG_1_0(W(1,7),W(1,15),R2_ZZV_2EPS,AMPL(3,420))
C         Counter-term amplitude(s) for loop diagram number 689
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWL,R2_WWM3,AMPL(1
     $     ,421))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWL_1EPS,R2_WWM3_1E
     $     PS,AMPL(2,422))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWL_2EPS,R2_WWM3_2E
     $     PS,AMPL(3,423))
C         Counter-term amplitude(s) for loop diagram number 692
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPM,R2_HHM2
     $     ,AMPL(1,424))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPM_1EPS
     $     ,R2_HHM2_1EPS,AMPL(2,425))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPM_2EPS
     $     ,R2_HHM2_2EPS,AMPL(3,426))
C         Counter-term amplitude(s) for loop diagram number 693
          CALL R2_GG_1_0(W(1,7),W(1,15),R2_ZZV,AMPL(1,427))
          CALL R2_GG_1_0(W(1,7),W(1,15),R2_ZZV_1EPS,AMPL(2,428))
          CALL R2_GG_1_0(W(1,7),W(1,15),R2_ZZV_2EPS,AMPL(3,429))
C         Counter-term amplitude(s) for loop diagram number 694
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWL,R2_WWTAU3
     $     ,AMPL(1,430))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWL_1EPS,R2_WWTAU3_
     $     1EPS,AMPL(2,431))
          CALL R2_GG_1_R2_GG_3_0(W(1,10),W(1,12),R2_WWL_2EPS,R2_WWTAU3_
     $     2EPS,AMPL(3,432))
C         Counter-term amplitude(s) for loop diagram number 697
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPTAU,R2_HHTAU2
     $     ,AMPL(1,433))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPTAU_1EPS
     $     ,R2_HHTAU2_1EPS,AMPL(2,434))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPTAU_2EPS
     $     ,R2_HHTAU2_2EPS,AMPL(3,435))
C         Counter-term amplitude(s) for loop diagram number 698
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAL,R2_AAE3,AMPL(1
     $     ,436))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAL_1EPS,R2_AAE3_1EP
     $     S,AMPL(2,437))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAL_2EPS,R2_AAE3_2EP
     $     S,AMPL(3,438))
          CALL L_WMWPMASS1_L_WMWPMASS3_0(W(1,6),W(1,14),C_UVAMASS1EW
     $     ,C_UVAMASS2EW,AMPL(1,439))
          CALL L_WMWPMASS1_L_WMWPMASS3_0(W(1,6),W(1,14),C_UVAMASS1EW_1E
     $     PS,C_UVAMASS2EW_1EPS,AMPL(2,440))
          CALL L_WMWPMASS1_L_WMWPMASS3_0(W(1,6),W(1,14),C_UVAMASS1EW_2E
     $     PS,C_UVAMASS2EW_2EPS,AMPL(3,441))
C         Counter-term amplitude(s) for loop diagram number 699
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZL,R2_AZE3,AMPL(1
     $     ,442))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZL_1EPS,R2_AZE3_1EP
     $     S,AMPL(2,443))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZL_2EPS,R2_AZE3_2EP
     $     S,AMPL(3,444))
C         Counter-term amplitude(s) for loop diagram number 702
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZL,R2_AZE3,AMPL(1
     $     ,445))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZL_1EPS,R2_AZE3_1EP
     $     S,AMPL(2,446))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZL_2EPS,R2_AZE3_2EP
     $     S,AMPL(3,447))
C         Counter-term amplitude(s) for loop diagram number 703
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZL,R2_ZZE3,AMPL(1
     $     ,448))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZL_1EPS,R2_ZZE3_1EP
     $     S,AMPL(2,449))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZL_2EPS,R2_ZZE3_2EP
     $     S,AMPL(3,450))
C         Counter-term amplitude(s) for loop diagram number 708
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHE1,R2_HHE2,AMPL(1
     $     ,451))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHE1_1EPS,R2_HHE2_1E
     $     PS,AMPL(2,452))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHE1_2EPS,R2_HHE2_2E
     $     PS,AMPL(3,453))
C         Counter-term amplitude(s) for loop diagram number 713
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHE1,R2_HHE2,AMPL(1
     $     ,454))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHE1_1EPS,R2_HHE2_1E
     $     PS,AMPL(2,455))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHE1_2EPS,R2_HHE2_2E
     $     PS,AMPL(3,456))
C         Counter-term amplitude(s) for loop diagram number 714
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAL,R2_AAM3,AMPL(1
     $     ,457))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAL_1EPS,R2_AAM3_1EP
     $     S,AMPL(2,458))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAL_2EPS,R2_AAM3_2EP
     $     S,AMPL(3,459))
C         Counter-term amplitude(s) for loop diagram number 715
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZL,R2_AZM3,AMPL(1
     $     ,460))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZL_1EPS,R2_AZM3_1EP
     $     S,AMPL(2,461))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZL_2EPS,R2_AZM3_2EP
     $     S,AMPL(3,462))
C         Counter-term amplitude(s) for loop diagram number 718
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZL,R2_AZM3,AMPL(1
     $     ,463))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZL_1EPS,R2_AZM3_1EP
     $     S,AMPL(2,464))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZL_2EPS,R2_AZM3_2EP
     $     S,AMPL(3,465))
C         Counter-term amplitude(s) for loop diagram number 719
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZL,R2_ZZM3,AMPL(1
     $     ,466))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZL_1EPS,R2_ZZM3_1EP
     $     S,AMPL(2,467))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZL_2EPS,R2_ZZM3_2EP
     $     S,AMPL(3,468))
C         Counter-term amplitude(s) for loop diagram number 724
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHM1,R2_HHM2,AMPL(1
     $     ,469))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHM1_1EPS,R2_HHM2_1E
     $     PS,AMPL(2,470))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHM1_2EPS,R2_HHM2_2E
     $     PS,AMPL(3,471))
C         Counter-term amplitude(s) for loop diagram number 729
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHM1,R2_HHM2,AMPL(1
     $     ,472))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHM1_1EPS,R2_HHM2_1E
     $     PS,AMPL(2,473))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHM1_2EPS,R2_HHM2_2E
     $     PS,AMPL(3,474))
C         Counter-term amplitude(s) for loop diagram number 730
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAL,R2_AATAU3
     $     ,AMPL(1,475))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAL_1EPS,R2_AATAU3_1
     $     EPS,AMPL(2,476))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,14),R2_AAL_2EPS,R2_AATAU3_2
     $     EPS,AMPL(3,477))
C         Counter-term amplitude(s) for loop diagram number 731
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZL,R2_AZTAU3
     $     ,AMPL(1,478))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZL_1EPS,R2_AZTAU3_1
     $     EPS,AMPL(2,479))
          CALL R2_GG_1_R2_GG_3_0(W(1,6),W(1,15),R2_AZL_2EPS,R2_AZTAU3_2
     $     EPS,AMPL(3,480))
C         Counter-term amplitude(s) for loop diagram number 734
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZL,R2_AZTAU3
     $     ,AMPL(1,481))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZL_1EPS,R2_AZTAU3_1
     $     EPS,AMPL(2,482))
          CALL R2_GG_1_R2_GG_3_0(W(1,14),W(1,7),R2_AZL_2EPS,R2_AZTAU3_2
     $     EPS,AMPL(3,483))
C         Counter-term amplitude(s) for loop diagram number 735
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZL,R2_ZZTAU3
     $     ,AMPL(1,484))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZL_1EPS,R2_ZZTAU3_1
     $     EPS,AMPL(2,485))
          CALL R2_GG_1_R2_GG_3_0(W(1,7),W(1,15),R2_ZZL_2EPS,R2_ZZTAU3_2
     $     EPS,AMPL(3,486))
C         Counter-term amplitude(s) for loop diagram number 740
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHTAU1,R2_HHTAU2
     $     ,AMPL(1,487))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHTAU1_1EPS
     $     ,R2_HHTAU2_1EPS,AMPL(2,488))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_HHTAU1_2EPS
     $     ,R2_HHTAU2_2EPS,AMPL(3,489))
C         Counter-term amplitude(s) for loop diagram number 745
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHTAU1,R2_HHTAU2
     $     ,AMPL(1,490))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHTAU1_1EPS
     $     ,R2_HHTAU2_1EPS,AMPL(2,491))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHTAU1_2EPS
     $     ,R2_HHTAU2_2EPS,AMPL(3,492))
C         Counter-term amplitude(s) for loop diagram number 746
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,7),W(1,15),R2_ZZBOSON1
     $     ,R2_ZZBOSON2,R2_ZZBOSON3,AMPL(1,493))
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,7),W(1,15),R2_ZZBOSON1_1EP
     $     S,R2_ZZBOSON2_1EPS,R2_ZZBOSON3_1EPS,AMPL(2,494))
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,7),W(1,15),R2_ZZBOSON1_2EP
     $     S,R2_ZZBOSON2_2EPS,R2_ZZBOSON3_2EPS,AMPL(3,495))
          CALL L_WMWPMASS1_L_WMWPMASS2_L_WMWPMASS3_0(W(1,7),W(1,15)
     $     ,C_UVZMASS1EW,C_UVZMASS2EW,C_UVZMASS3EW,AMPL(1,496))
          CALL L_WMWPMASS1_L_WMWPMASS2_L_WMWPMASS3_0(W(1,7),W(1,15)
     $     ,C_UVZMASS1EW_1EPS,C_UVZMASS2EW_1EPS,C_UVZMASS3EW_1EPS
     $     ,AMPL(2,497))
          CALL L_WMWPMASS1_L_WMWPMASS2_L_WMWPMASS3_0(W(1,7),W(1,15)
     $     ,C_UVZMASS1EW_2EPS,C_UVZMASS2EW_2EPS,C_UVZMASS3EW_2EPS
     $     ,AMPL(3,498))
C         Counter-term amplitude(s) for loop diagram number 750
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_G0G0BOSON1
     $     ,R2_G0G0BOSON2,AMPL(1,499))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_G0G0BOSON1_1EPS
     $     ,R2_G0G0BOSON2_1EPS,AMPL(2,500))
          CALL R2_SS_1_R2_SS_2_0(W(1,8),W(1,16),R2_G0G0BOSON1_2EPS
     $     ,R2_G0G0BOSON2_2EPS,AMPL(3,501))
          CALL L_HMASS6_L_HMASS7_0(W(1,8),W(1,16),C_UVG0MASS1EW
     $     ,C_UVG0MASS2EW,AMPL(1,502))
          CALL L_HMASS6_L_HMASS7_0(W(1,8),W(1,16),C_UVG0MASS1EW_1EPS
     $     ,C_UVG0MASS2EW_1EPS,AMPL(2,503))
          CALL L_HMASS6_L_HMASS7_0(W(1,8),W(1,16),C_UVG0MASS1EW_2EPS
     $     ,C_UVG0MASS2EW_2EPS,AMPL(3,504))
C         Counter-term amplitude(s) for loop diagram number 752
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHBOSON1,R2_HHBOSON2
     $     ,AMPL(1,505))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHBOSON1_1EPS
     $     ,R2_HHBOSON2_1EPS,AMPL(2,506))
          CALL R2_SS_1_R2_SS_2_0(W(1,9),W(1,17),R2_HHBOSON1_2EPS
     $     ,R2_HHBOSON2_2EPS,AMPL(3,507))
          CALL L_HMASS6_L_HMASS7_0(W(1,9),W(1,17),C_UVHMASS1EW
     $     ,C_UVHMASS2EW,AMPL(1,508))
          CALL L_HMASS6_L_HMASS7_0(W(1,9),W(1,17),C_UVHMASS1EW_1EPS
     $     ,C_UVHMASS2EW_1EPS,AMPL(2,509))
          CALL L_HMASS6_L_HMASS7_0(W(1,9),W(1,17),C_UVHMASS1EW_2EPS
     $     ,C_UVHMASS2EW_2EPS,AMPL(3,510))
C         Counter-term amplitude(s) for loop diagram number 754
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,10),W(1,12),R2_WWBOSON1
     $     ,R2_WWBOSON2,R2_WWBOSON3,AMPL(1,511))
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,10),W(1,12),R2_WWBOSON1_1E
     $     PS,R2_WWBOSON2_1EPS,R2_WWBOSON3_1EPS,AMPL(2,512))
          CALL R2_GG_1_R2_GG_2_R2_GG_3_0(W(1,10),W(1,12),R2_WWBOSON1_2E
     $     PS,R2_WWBOSON2_2EPS,R2_WWBOSON3_2EPS,AMPL(3,513))
C         Counter-term amplitude(s) for loop diagram number 758
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPBOSON1
     $     ,R2_GMGPBOSON2,AMPL(1,514))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPBOSON1_1EPS
     $     ,R2_GMGPBOSON2_1EPS,AMPL(2,515))
          CALL R2_SS_1_R2_SS_2_0(W(1,11),W(1,13),R2_GMGPBOSON1_2EPS
     $     ,R2_GMGPBOSON2_2EPS,AMPL(3,516))
          CALL L_HMASS6_L_HMASS7_0(W(1,11),W(1,13),C_UVGMGPMASS1EW
     $     ,C_UVG0MASS2EW,AMPL(1,517))
          CALL L_HMASS6_L_HMASS7_0(W(1,11),W(1,13),C_UVGMGPMASS1EW_1EPS
     $     ,C_UVG0MASS2EW_1EPS,AMPL(2,518))
          CALL L_HMASS6_L_HMASS7_0(W(1,11),W(1,13),C_UVGMGPMASS1EW_2EPS
     $     ,C_UVG0MASS2EW_2EPS,AMPL(3,519))
C         At this point, all CT amps needed for (QCD=2 QED=4), i.e. of
C          split order ID=1, are computed.
          IF(FILTER_SO.AND.SQSO_TARGET.EQ.2) GOTO 2000
C         At this point, all CT amps needed for (QCD=0 QED=6), i.e. of
C          split order ID=2, are computed.
          IF(FILTER_SO.AND.SQSO_TARGET.EQ.3) GOTO 2000
 2000     CONTINUE
          CT_REQ_SO_DONE=.TRUE.

C         Helas calls for the counterterm of type 'UVtree' in the UFO.
C         These are generated irrespectively of the produced loops.
C         In general, only wavefunction renormalization counterterms
C         (if needed by the loop UFO model) are of this type.
C         Quite often and in principle for all loop UFO models from 
C         FeynRules, there are none of these type of counterterms.

 3000     CONTINUE
          UVCT_REQ_SO_DONE=.TRUE.

          IF (.NOT.CHECKPHASE.AND.HELDOUBLECHECKED.AND.HELPICKED.EQ.
     $     -1) THEN
            DUMMY=GOODHEL(H)
          ELSE
            DUMMY=1
          ENDIF
          DO I=1,NCTAMPS
            DO J=1,NBORNAMPS
              CFTOT=DCMPLX(CF_N(I,J)/DBLE(ABS(CF_D(I,J))),0.0D0)
              IF(CF_D(I,J).LT.0) CFTOT=CFTOT*IMAG1
              ITEMP = ML5_0_ML5SQSOINDEX(ML5_0_ML5SOINDEX_FOR_LOOP_AMP(
     $         I),ML5_0_ML5SOINDEX_FOR_BORN_AMP(J))
              IF (.NOT.FILTER_SO.OR.SQSO_TARGET.EQ.ITEMP) THEN
                DO K=1,3
                  TEMP2 = 2.0D0*DUMMY*DBLE(CFTOT*AMPL(K,I)*DCONJG(AMP(J
     $             )))
                  ANS(K,ITEMP)=ANS(K,ITEMP)+TEMP2
                  ANS(K,0)=ANS(K,0)+TEMP2
                ENDDO
              ENDIF
            ENDDO
          ENDDO

C         Coefficient construction for loop diagram with ID 8
          CALL FFV1L1P0_3(PL(0,0),W(1,3),GC_11,ZERO,ZERO,PL(0,1),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,1))
          CALL FFV1L3_2(PL(0,1),W(1,4),GC_11,MDL_MD,ZERO,PL(0,2),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1),4,COEFS,4,4,WL(1,0,1,2))
          CALL FFV1L1_2(PL(0,2),W(1,6),GC_1,MDL_MD,ZERO,PL(0,3),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,2),4,COEFS,4,4,WL(1,0,1,3))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,3),2,4,1,1,520,H)
C         Coefficient construction for loop diagram with ID 9
          CALL FFV2_3L1_2(PL(0,2),W(1,7),GC_68,GC_76,MDL_MD,ZERO,PL(0
     $     ,4),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,2),4,COEFS,4,4,WL(1,0,1,4))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,4),2,4,1,1,521,H)
C         Coefficient construction for loop diagram with ID 10
          CALL FFS2L1_2(PL(0,2),W(1,8),GC_104,MDL_MD,ZERO,PL(0,5)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,2),4,COEFS,4,4,WL(1,0,1,5))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,5),2,4,1,1,522,H)
C         Coefficient construction for loop diagram with ID 11
          CALL FFS4L1_2(PL(0,2),W(1,9),GC_105,MDL_MD,ZERO,PL(0,6)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,2),4,COEFS,4,4,WL(1,0,1,6))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,6),2,4,1,1,523,H)
C         Coefficient construction for loop diagram with ID 12
          CALL FFV1L1P0_3(PL(0,0),W(1,2),GC_11,ZERO,ZERO,PL(0,7),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,7))
          CALL FFV1L3_2(PL(0,7),W(1,4),GC_11,MDL_MD,ZERO,PL(0,8),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,7),4,COEFS,4,4,WL(1,0,1,8))
          CALL FFV2L1_2(PL(0,8),W(1,10),GC_59,MDL_MU,ZERO,PL(0,9)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,8),4,COEFS,4,4,WL(1,0,1,9))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,9),2,4,2,1,524,H)
C         Coefficient construction for loop diagram with ID 13
          CALL FFS1_3L1_2(PL(0,8),W(1,11),GC_31,GC_40,MDL_MU,ZERO,PL(0
     $     ,10),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,8),4,COEFS,4,4,WL(1,0,1
     $     ,10))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,10),2,4,2,1,525,H)
C         Coefficient construction for loop diagram with ID 14
          CALL FFV1L2P0_3(PL(0,0),W(1,1),GC_11,ZERO,ZERO,PL(0,11)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,11))
          CALL FFV1L3_1(PL(0,11),W(1,3),GC_11,MDL_MD,ZERO,PL(0,12)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,11),4,COEFS,4,4,WL(1,0,1
     $     ,12))
          CALL FFV2L2_1(PL(0,12),W(1,12),GC_124,MDL_MU,ZERO,PL(0,13)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,12),4,COEFS,4,4,WL(1,0,1
     $     ,13))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,13),2,4,3,1,526,H)
C         Coefficient construction for loop diagram with ID 15
          CALL FFS1_3L2_1(PL(0,12),W(1,13),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,14),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,12),4,COEFS,4,4,WL(1,0,1
     $     ,14))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,14),2,4,3,1,527,H)
C         Coefficient construction for loop diagram with ID 16
          CALL FFV1L3_1(PL(0,11),W(1,2),GC_11,MDL_MU,ZERO,PL(0,15)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,11),4,COEFS,4,4,WL(1,0,1
     $     ,15))
          CALL FFV2L2_3(PL(0,15),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,16)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,15),4,COEFS,4,4,WL(1,0,1
     $     ,16))
          CALL FFV2L3_1(PL(0,16),W(1,3),GC_124,MDL_MU,ZERO,PL(0,17)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,16),4,COEFS,4,4,WL(1,0,1
     $     ,17))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,17),4,4,4,1,528,H)
C         Coefficient construction for loop diagram with ID 17
          CALL FFS1_3L2_3(PL(0,15),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,18),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,15),4,COEFS,4,1,WL(1,0,1
     $     ,18))
          CALL FFS1_3L3_1(PL(0,18),W(1,3),GC_13,GC_22,MDL_MU,ZERO,PL(0
     $     ,19),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,18),4,COEFS,1,4,WL(1,0,1
     $     ,19))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,19),2,4,4,1,529,H)
C         Coefficient construction for loop diagram with ID 18
          CALL FFV1L2_1(PL(0,15),W(1,14),GC_2,MDL_MU,ZERO,PL(0,20)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,15),4,COEFS,4,4,WL(1,0,1
     $     ,20))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,20),2,4,5,1,530,H)
C         Coefficient construction for loop diagram with ID 19
          CALL FFV2_5L2_1(PL(0,15),W(1,15),GC_69,GC_76,MDL_MU,ZERO
     $     ,PL(0,21),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,15),4,COEFS,4,4,WL(1,0,1
     $     ,21))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,21),2,4,5,1,531,H)
C         Coefficient construction for loop diagram with ID 20
          CALL FFS2L2_1(PL(0,15),W(1,16),GC_123,MDL_MU,ZERO,PL(0,22)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,15),4,COEFS,4,4,WL(1,0,1
     $     ,22))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,22),2,4,5,1,532,H)
C         Coefficient construction for loop diagram with ID 21
          CALL FFS4L2_1(PL(0,15),W(1,17),GC_122,MDL_MU,ZERO,PL(0,23)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,15),4,COEFS,4,4,WL(1,0,1
     $     ,23))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,23),2,4,5,1,533,H)
C         Coefficient construction for loop diagram with ID 22
          CALL FFV1L3_2(PL(0,0),W(1,1),GC_11,MDL_MU,ZERO,PL(0,24)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,24))
          CALL FFV1L1P0_3(PL(0,24),W(1,2),GC_2,ZERO,ZERO,PL(0,25)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,24),4,COEFS,4,4,WL(1,0,1
     $     ,25))
          CALL FFV1L3_2(PL(0,25),W(1,4),GC_1,MDL_MD,ZERO,PL(0,26)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,25),4,COEFS,4,4,WL(1,0,1
     $     ,26))
          CALL FFV1L1P0_3(PL(0,26),W(1,3),GC_11,ZERO,ZERO,PL(0,27)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,26),4,COEFS,4,4,WL(1,0,1
     $     ,27))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,27),2,4,6,1,534,H)
C         Coefficient construction for loop diagram with ID 23
          CALL FFV2_5L1_3(PL(0,24),W(1,2),GC_69,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,28),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,24),4,COEFS,4,4,WL(1,0,1
     $     ,28))
          CALL FFV2_3L3_2(PL(0,28),W(1,4),GC_68,GC_76,MDL_MD,ZERO,PL(0
     $     ,29),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,28),4,COEFS,4,4,WL(1,0,1
     $     ,29))
          CALL FFV1L1P0_3(PL(0,29),W(1,3),GC_11,ZERO,ZERO,PL(0,30)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,29),4,COEFS,4,4,WL(1,0,1
     $     ,30))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,30),4,4,7,1,535,H)
C         Coefficient construction for loop diagram with ID 24
          CALL FFS2L1_3(PL(0,24),W(1,2),GC_123,MDL_MZ,MDL_WZ,PL(0,31)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,24),4,COEFS,4,1,WL(1,0,1
     $     ,31))
          CALL FFS2L3_2(PL(0,31),W(1,4),GC_104,MDL_MD,ZERO,PL(0,32)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,31),4,COEFS,1,4,WL(1,0,1
     $     ,32))
          CALL FFV1L1P0_3(PL(0,32),W(1,3),GC_11,ZERO,ZERO,PL(0,33)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,32),4,COEFS,4,4,WL(1,0,1
     $     ,33))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,33),2,4,7,1,536,H)
C         Coefficient construction for loop diagram with ID 25
          CALL FFS4L1_3(PL(0,24),W(1,2),GC_122,MDL_MH,MDL_WH,PL(0,34)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,24),4,COEFS,4,1,WL(1,0,1
     $     ,34))
          CALL FFS4L3_2(PL(0,34),W(1,4),GC_105,MDL_MD,ZERO,PL(0,35)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,34),4,COEFS,1,4,WL(1,0,1
     $     ,35))
          CALL FFV1L1P0_3(PL(0,35),W(1,3),GC_11,ZERO,ZERO,PL(0,36)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,35),4,COEFS,4,4,WL(1,0,1
     $     ,36))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,36),2,4,8,1,537,H)
C         Coefficient construction for loop diagram with ID 26
          CALL FFV1L3_1(PL(0,25),W(1,3),GC_1,MDL_MD,ZERO,PL(0,37)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,25),4,COEFS,4,4,WL(1,0,1
     $     ,37))
          CALL FFV1L2P0_3(PL(0,37),W(1,4),GC_11,ZERO,ZERO,PL(0,38)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,37),4,COEFS,4,4,WL(1,0,1
     $     ,38))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,38),2,4,9,1,538,H)
C         Coefficient construction for loop diagram with ID 27
          CALL FFV2_3L3_1(PL(0,28),W(1,3),GC_68,GC_76,MDL_MD,ZERO,PL(0
     $     ,39),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,28),4,COEFS,4,4,WL(1,0,1
     $     ,39))
          CALL FFV1L2P0_3(PL(0,39),W(1,4),GC_11,ZERO,ZERO,PL(0,40)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,39),4,COEFS,4,4,WL(1,0,1
     $     ,40))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,40),4,4,10,1,539,H)
C         Coefficient construction for loop diagram with ID 28
          CALL FFS2L3_1(PL(0,31),W(1,3),GC_104,MDL_MD,ZERO,PL(0,41)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,31),4,COEFS,1,4,WL(1,0,1
     $     ,41))
          CALL FFV1L2P0_3(PL(0,41),W(1,4),GC_11,ZERO,ZERO,PL(0,42)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,41),4,COEFS,4,4,WL(1,0,1
     $     ,42))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,42),2,4,10,1,540,H)
C         Coefficient construction for loop diagram with ID 29
          CALL FFS4L3_1(PL(0,34),W(1,3),GC_105,MDL_MD,ZERO,PL(0,43)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,34),4,COEFS,1,4,WL(1,0,1
     $     ,43))
          CALL FFV1L2P0_3(PL(0,43),W(1,4),GC_11,ZERO,ZERO,PL(0,44)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,43),4,COEFS,4,4,WL(1,0,1
     $     ,44))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,44),2,4,11,1,541,H)
C         Coefficient construction for loop diagram with ID 30
          CALL FFV2L1_3(PL(0,24),W(1,3),GC_124,MDL_MW,MDL_WW,PL(0,45)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,24),4,COEFS,4,4,WL(1,0,1
     $     ,45))
          CALL FFV2L3_1(PL(0,45),W(1,2),GC_59,MDL_MD,ZERO,PL(0,46)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,45),4,COEFS,4,4,WL(1,0,1
     $     ,46))
          CALL FFV1L2P0_3(PL(0,46),W(1,4),GC_11,ZERO,ZERO,PL(0,47)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,46),4,COEFS,4,4,WL(1,0,1
     $     ,47))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,47),4,4,12,1,542,H)
C         Coefficient construction for loop diagram with ID 31
          CALL FFS1_3L1_3(PL(0,24),W(1,3),GC_13,GC_22,MDL_MW,MDL_WW
     $     ,PL(0,48),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,24),4,COEFS,4,1,WL(1,0,1
     $     ,48))
          CALL FFS1_3L3_1(PL(0,48),W(1,2),GC_31,GC_40,MDL_MD,ZERO,PL(0
     $     ,49),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,48),4,COEFS,1,4,WL(1,0,1
     $     ,49))
          CALL FFV1L2P0_3(PL(0,49),W(1,4),GC_11,ZERO,ZERO,PL(0,50)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,49),4,COEFS,4,4,WL(1,0,1
     $     ,50))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,50),2,4,12,1,543,H)
C         Coefficient construction for loop diagram with ID 32
          CALL FFV1L3_2(PL(0,0),W(1,1),GC_2,MDL_MU,ZERO,PL(0,51),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,51))
          CALL FFV1L1P0_3(PL(0,51),W(1,2),GC_11,ZERO,ZERO,PL(0,52)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,51),4,COEFS,4,4,WL(1,0,1
     $     ,52))
          CALL FFV1L3_1(PL(0,52),W(1,3),GC_11,MDL_MD,ZERO,PL(0,53)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,52),4,COEFS,4,4,WL(1,0,1
     $     ,53))
          CALL FFV1L2P0_3(PL(0,53),W(1,4),GC_1,ZERO,ZERO,PL(0,54)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,53),4,COEFS,4,4,WL(1,0,1
     $     ,54))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,54),2,4,9,1,544,H)
C         Coefficient construction for loop diagram with ID 33
          CALL FFV2_5L3_2(PL(0,0),W(1,1),GC_69,GC_76,MDL_MU,ZERO,PL(0
     $     ,55),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,55))
          CALL FFV1L1P0_3(PL(0,55),W(1,2),GC_11,ZERO,ZERO,PL(0,56)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,55),4,COEFS,4,4,WL(1,0,1
     $     ,56))
          CALL FFV1L3_1(PL(0,56),W(1,3),GC_11,MDL_MD,ZERO,PL(0,57)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,56),4,COEFS,4,4,WL(1,0,1
     $     ,57))
          CALL FFV2_3L2_3(PL(0,57),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,58),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,57),4,COEFS,4,4,WL(1,0,1
     $     ,58))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,58),4,4,13,1,545,H)
C         Coefficient construction for loop diagram with ID 34
          CALL FFS2L3_2(PL(0,0),W(1,1),GC_123,MDL_MU,ZERO,PL(0,59)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,4,WL(1,0,1
     $     ,59))
          CALL FFV1L1P0_3(PL(0,59),W(1,2),GC_11,ZERO,ZERO,PL(0,60)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,59),1,COEFS,4,4,WL(1,0,1
     $     ,60))
          CALL FFV1L3_1(PL(0,60),W(1,3),GC_11,MDL_MD,ZERO,PL(0,61)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,60),1,COEFS,4,4,WL(1,0,1
     $     ,61))
          CALL FFS2L2_3(PL(0,61),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0,62)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,61),1,COEFS,4,1,WL(1,0,1
     $     ,62))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,62),2,1,13,1,546,H)
C         Coefficient construction for loop diagram with ID 35
          CALL FFS4L3_2(PL(0,0),W(1,1),GC_122,MDL_MU,ZERO,PL(0,63)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,4,WL(1,0,1
     $     ,63))
          CALL FFV1L1P0_3(PL(0,63),W(1,2),GC_11,ZERO,ZERO,PL(0,64)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,63),1,COEFS,4,4,WL(1,0,1
     $     ,64))
          CALL FFV1L3_1(PL(0,64),W(1,3),GC_11,MDL_MD,ZERO,PL(0,65)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,64),1,COEFS,4,4,WL(1,0,1
     $     ,65))
          CALL FFS4L2_3(PL(0,65),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0,66)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,65),1,COEFS,4,1,WL(1,0,1
     $     ,66))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,66),2,1,14,1,547,H)
C         Coefficient construction for loop diagram with ID 36
          CALL FFV2L3_2(PL(0,0),W(1,1),GC_124,MDL_MD,ZERO,PL(0,67)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,67))
          CALL FFV1L1P0_3(PL(0,67),W(1,3),GC_11,ZERO,ZERO,PL(0,68)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,67),4,COEFS,4,4,WL(1,0,1
     $     ,68))
          CALL FFV1L3_1(PL(0,68),W(1,2),GC_11,MDL_MU,ZERO,PL(0,69)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,68),4,COEFS,4,4,WL(1,0,1
     $     ,69))
          CALL FFV2L2_3(PL(0,69),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,70)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,69),4,COEFS,4,4,WL(1,0,1
     $     ,70))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,70),4,4,15,1,548,H)
C         Coefficient construction for loop diagram with ID 37
          CALL FFS1_3L3_2(PL(0,0),W(1,1),GC_13,GC_22,MDL_MD,ZERO,PL(0
     $     ,71),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,4,WL(1,0,1
     $     ,71))
          CALL FFV1L1P0_3(PL(0,71),W(1,3),GC_11,ZERO,ZERO,PL(0,72)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,71),1,COEFS,4,4,WL(1,0,1
     $     ,72))
          CALL FFV1L3_1(PL(0,72),W(1,2),GC_11,MDL_MU,ZERO,PL(0,73)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,72),1,COEFS,4,4,WL(1,0,1
     $     ,73))
          CALL FFS1_3L2_3(PL(0,73),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,74),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,73),1,COEFS,4,1,WL(1,0,1
     $     ,74))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,74),2,1,15,1,549,H)
C         Coefficient construction for loop diagram with ID 38
          CALL FFV1L3_2(PL(0,52),W(1,4),GC_11,MDL_MD,ZERO,PL(0,75)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,52),4,COEFS,4,4,WL(1,0,1
     $     ,75))
          CALL FFV1L1P0_3(PL(0,75),W(1,3),GC_1,ZERO,ZERO,PL(0,76)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,75),4,COEFS,4,4,WL(1,0,1
     $     ,76))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,76),2,4,6,1,550,H)
C         Coefficient construction for loop diagram with ID 39
          CALL FFV1L3_2(PL(0,56),W(1,4),GC_11,MDL_MD,ZERO,PL(0,77)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,56),4,COEFS,4,4,WL(1,0,1
     $     ,77))
          CALL FFV2_3L1_3(PL(0,77),W(1,3),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,78),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,77),4,COEFS,4,4,WL(1,0,1
     $     ,78))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,78),4,4,16,1,551,H)
C         Coefficient construction for loop diagram with ID 40
          CALL FFV1L3_2(PL(0,60),W(1,4),GC_11,MDL_MD,ZERO,PL(0,79)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,60),1,COEFS,4,4,WL(1,0,1
     $     ,79))
          CALL FFS2L1_3(PL(0,79),W(1,3),GC_104,MDL_MZ,MDL_WZ,PL(0,80)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,79),1,COEFS,4,1,WL(1,0,1
     $     ,80))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,80),2,1,16,1,552,H)
C         Coefficient construction for loop diagram with ID 41
          CALL FFV1L3_2(PL(0,64),W(1,4),GC_11,MDL_MD,ZERO,PL(0,81)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,64),1,COEFS,4,4,WL(1,0,1
     $     ,81))
          CALL FFS4L1_3(PL(0,81),W(1,3),GC_105,MDL_MH,MDL_WH,PL(0,82)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,81),1,COEFS,4,1,WL(1,0,1
     $     ,82))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,82),2,1,17,1,553,H)
C         Coefficient construction for loop diagram with ID 42
          CALL FFV2L2_3(PL(0,0),W(1,1),GC_124,MDL_MW,MDL_WW,PL(0,83)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,83))
          CALL FFV2L3_1(PL(0,83),W(1,2),GC_59,MDL_MD,ZERO,PL(0,84)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_1(WL(1,0,1,83),4,COEFS,4,4,WL(1,0,1
     $     ,84))
          CALL FFV1L2P0_3(PL(0,84),W(1,4),GC_11,ZERO,ZERO,PL(0,85)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,84),4,COEFS,4,4,WL(1,0,1
     $     ,85))
          CALL FFV1L3_1(PL(0,85),W(1,3),GC_11,MDL_MD,ZERO,PL(0,86)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,85),4,COEFS,4,4,WL(1,0,1
     $     ,86))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,86),4,4,18,1,554,H)
C         Coefficient construction for loop diagram with ID 43
          CALL FFS1_3L2_3(PL(0,0),W(1,1),GC_13,GC_22,MDL_MW,MDL_WW
     $     ,PL(0,87),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,87))
          CALL FFS1_3L3_1(PL(0,87),W(1,2),GC_31,GC_40,MDL_MD,ZERO,PL(0
     $     ,88),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,87),4,COEFS,1,4,WL(1,0,1
     $     ,88))
          CALL FFV1L2P0_3(PL(0,88),W(1,4),GC_11,ZERO,ZERO,PL(0,89)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,88),4,COEFS,4,4,WL(1,0,1
     $     ,89))
          CALL FFV1L3_1(PL(0,89),W(1,3),GC_11,MDL_MD,ZERO,PL(0,90)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,89),4,COEFS,4,4,WL(1,0,1
     $     ,90))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,90),2,4,18,1,555,H)
C         Coefficient construction for loop diagram with ID 44
          CALL FFV2L1_3(PL(0,0),W(1,3),GC_124,MDL_MW,MDL_WW,PL(0,91)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,91))
          CALL FFV2L3_2(PL(0,91),W(1,4),GC_59,MDL_MU,ZERO,PL(0,92)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_1(WL(1,0,1,91),4,COEFS,4,4,WL(1,0,1
     $     ,92))
          CALL FFV1L1_2(PL(0,92),W(1,5),GC_11,MDL_MU,ZERO,PL(0,93)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,92),4,COEFS,4,4,WL(1,0,1
     $     ,93))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,93),4,4,19,1,556,H)
C         Coefficient construction for loop diagram with ID 45
          CALL FFS1_3L1_3(PL(0,0),W(1,3),GC_13,GC_22,MDL_MW,MDL_WW
     $     ,PL(0,94),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,94))
          CALL FFS1_3L3_2(PL(0,94),W(1,4),GC_31,GC_40,MDL_MU,ZERO,PL(0
     $     ,95),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,94),4,COEFS,1,4,WL(1,0,1
     $     ,95))
          CALL FFV1L1_2(PL(0,95),W(1,5),GC_11,MDL_MU,ZERO,PL(0,96)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,95),4,COEFS,4,4,WL(1,0,1
     $     ,96))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,96),2,4,19,1,557,H)
C         Coefficient construction for loop diagram with ID 46
          CALL FFV1L2P0_3(PL(0,0),W(1,1),GC_2,ZERO,ZERO,PL(0,97),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,97))
          CALL FFV1L3_1(PL(0,97),W(1,2),GC_2,MDL_MU,ZERO,PL(0,98)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,97),4,COEFS,4,4,WL(1,0,1
     $     ,98))
          CALL FFV1L2_1(PL(0,98),W(1,18),GC_11,MDL_MU,ZERO,PL(0,99)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,98),4,COEFS,4,4,WL(1,0,1
     $     ,99))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,99),2,4,5,1,558,H)
C         Coefficient construction for loop diagram with ID 47
          CALL FFV2_5L2_3(PL(0,0),W(1,1),GC_69,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,100),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,100))
          CALL FFV2_5L3_1(PL(0,100),W(1,2),GC_69,GC_76,MDL_MU,ZERO
     $     ,PL(0,101),COEFS)
          CALL ML5_0_UPDATE_WL_2_1(WL(1,0,1,100),4,COEFS,4,4,WL(1,0,1
     $     ,101))
          CALL FFV1L2_1(PL(0,101),W(1,18),GC_11,MDL_MU,ZERO,PL(0,102)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,101),4,COEFS,4,4,WL(1,0,1
     $     ,102))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,102),4,4,20,1,559,H)
C         Coefficient construction for loop diagram with ID 48
          CALL FFS2L2_3(PL(0,0),W(1,1),GC_123,MDL_MZ,MDL_WZ,PL(0,103)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,103))
          CALL FFS2L3_1(PL(0,103),W(1,2),GC_123,MDL_MU,ZERO,PL(0,104)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,103),4,COEFS,1,4,WL(1,0,1
     $     ,104))
          CALL FFV1L2_1(PL(0,104),W(1,18),GC_11,MDL_MU,ZERO,PL(0,105)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,104),4,COEFS,4,4,WL(1,0,1
     $     ,105))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,105),2,4,20,1,560,H)
C         Coefficient construction for loop diagram with ID 49
          CALL FFS4L2_3(PL(0,0),W(1,1),GC_122,MDL_MH,MDL_WH,PL(0,106)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,106))
          CALL FFS4L3_1(PL(0,106),W(1,2),GC_122,MDL_MU,ZERO,PL(0,107)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,106),4,COEFS,1,4,WL(1,0,1
     $     ,107))
          CALL FFV1L2_1(PL(0,107),W(1,18),GC_11,MDL_MU,ZERO,PL(0,108)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,107),4,COEFS,4,4,WL(1,0,1
     $     ,108))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,108),2,4,21,1,561,H)
C         Coefficient construction for loop diagram with ID 50
          CALL FFV2L1_3(PL(0,0),W(1,3),GC_127,MDL_MW,MDL_WW,PL(0,109)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,109))
          CALL FFV2L3_2(PL(0,109),W(1,4),GC_62,MDL_MC,ZERO,PL(0,110)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_1(WL(1,0,1,109),4,COEFS,4,4,WL(1,0,1
     $     ,110))
          CALL FFV1L1_2(PL(0,110),W(1,5),GC_11,MDL_MC,ZERO,PL(0,111)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,110),4,COEFS,4,4,WL(1,0,1
     $     ,111))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,111),4,4,22,1,562,H)
C         Coefficient construction for loop diagram with ID 51
          CALL FFS1_3L1_3(PL(0,0),W(1,3),GC_14,GC_23,MDL_MW,MDL_WW
     $     ,PL(0,112),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,112))
          CALL FFS1_3L3_2(PL(0,112),W(1,4),GC_34,GC_43,MDL_MC,ZERO
     $     ,PL(0,113),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,112),4,COEFS,1,4,WL(1,0,1
     $     ,113))
          CALL FFV1L1_2(PL(0,113),W(1,5),GC_11,MDL_MC,ZERO,PL(0,114)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,113),4,COEFS,4,4,WL(1,0,1
     $     ,114))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,114),2,4,22,1,563,H)
C         Coefficient construction for loop diagram with ID 52
          CALL FFV2L1_3(PL(0,0),W(1,3),GC_130,MDL_MW,MDL_WW,PL(0,115)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,115))
          CALL FFV2L3_2(PL(0,115),W(1,4),GC_65,MDL_MT,MDL_WT,PL(0,116)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_1(WL(1,0,1,115),4,COEFS,4,4,WL(1,0,1
     $     ,116))
          CALL FFV1L1_2(PL(0,116),W(1,5),GC_11,MDL_MT,MDL_WT,PL(0,117)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,116),4,COEFS,4,4,WL(1,0,1
     $     ,117))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,117),4,4,23,1,564,H)
C         Coefficient construction for loop diagram with ID 53
          CALL FFS1_3L1_3(PL(0,0),W(1,3),GC_15,GC_24,MDL_MW,MDL_WW
     $     ,PL(0,118),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,118))
          CALL FFS1_3L3_2(PL(0,118),W(1,4),GC_37,GC_46,MDL_MT,MDL_WT
     $     ,PL(0,119),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,118),4,COEFS,1,4,WL(1,0,1
     $     ,119))
          CALL FFV1L1_2(PL(0,119),W(1,5),GC_11,MDL_MT,MDL_WT,PL(0,120)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,119),4,COEFS,4,4,WL(1,0,1
     $     ,120))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,120),2,4,23,1,565,H)
C         Coefficient construction for loop diagram with ID 54
          CALL FFV1L1P0_3(PL(0,0),W(1,3),GC_1,ZERO,ZERO,PL(0,121)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,121))
          CALL FFV1L3_2(PL(0,121),W(1,4),GC_1,MDL_MD,ZERO,PL(0,122)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,121),4,COEFS,4,4,WL(1,0,1
     $     ,122))
          CALL FFV1L1_2(PL(0,122),W(1,5),GC_11,MDL_MD,ZERO,PL(0,123)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,122),4,COEFS,4,4,WL(1,0,1
     $     ,123))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,123),2,4,1,1,566,H)
C         Coefficient construction for loop diagram with ID 55
          CALL FFV2_3L1_3(PL(0,0),W(1,3),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,124),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,124))
          CALL FFV2_3L3_2(PL(0,124),W(1,4),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,125),COEFS)
          CALL ML5_0_UPDATE_WL_2_1(WL(1,0,1,124),4,COEFS,4,4,WL(1,0,1
     $     ,125))
          CALL FFV1L1_2(PL(0,125),W(1,5),GC_11,MDL_MD,ZERO,PL(0,126)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,125),4,COEFS,4,4,WL(1,0,1
     $     ,126))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,126),4,4,24,1,567,H)
C         Coefficient construction for loop diagram with ID 56
          CALL FFS2L1_3(PL(0,0),W(1,3),GC_104,MDL_MZ,MDL_WZ,PL(0,127)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,127))
          CALL FFS2L3_2(PL(0,127),W(1,4),GC_104,MDL_MD,ZERO,PL(0,128)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,127),4,COEFS,1,4,WL(1,0,1
     $     ,128))
          CALL FFV1L1_2(PL(0,128),W(1,5),GC_11,MDL_MD,ZERO,PL(0,129)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,128),4,COEFS,4,4,WL(1,0,1
     $     ,129))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,129),2,4,24,1,568,H)
C         Coefficient construction for loop diagram with ID 57
          CALL FFS4L1_3(PL(0,0),W(1,3),GC_105,MDL_MH,MDL_WH,PL(0,130)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,130))
          CALL FFS4L3_2(PL(0,130),W(1,4),GC_105,MDL_MD,ZERO,PL(0,131)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,130),4,COEFS,1,4,WL(1,0,1
     $     ,131))
          CALL FFV1L1_2(PL(0,131),W(1,5),GC_11,MDL_MD,ZERO,PL(0,132)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,131),4,COEFS,4,4,WL(1,0,1
     $     ,132))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,132),2,4,25,1,569,H)
C         Coefficient construction for loop diagram with ID 58
          CALL FFV1L2_1(PL(0,84),W(1,18),GC_11,MDL_MD,ZERO,PL(0,133)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,84),4,COEFS,4,4,WL(1,0,1
     $     ,133))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,133),4,4,26,1,570,H)
C         Coefficient construction for loop diagram with ID 59
          CALL FFV1L2_1(PL(0,88),W(1,18),GC_11,MDL_MD,ZERO,PL(0,134)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,88),4,COEFS,4,4,WL(1,0,1
     $     ,134))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,134),2,4,26,1,571,H)
C         Coefficient construction for loop diagram with ID 60
          CALL FFV2L2_3(PL(0,0),W(1,1),GC_125,MDL_MW,MDL_WW,PL(0,135)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,135))
          CALL FFV2L3_1(PL(0,135),W(1,2),GC_60,MDL_MS,ZERO,PL(0,136)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_1(WL(1,0,1,135),4,COEFS,4,4,WL(1,0,1
     $     ,136))
          CALL FFV1L2_1(PL(0,136),W(1,18),GC_11,MDL_MS,ZERO,PL(0,137)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,136),4,COEFS,4,4,WL(1,0,1
     $     ,137))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,137),4,4,27,1,572,H)
C         Coefficient construction for loop diagram with ID 61
          CALL FFS1_3L2_3(PL(0,0),W(1,1),GC_16,GC_25,MDL_MW,MDL_WW
     $     ,PL(0,138),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,138))
          CALL FFS1_3L3_1(PL(0,138),W(1,2),GC_32,GC_41,MDL_MS,ZERO
     $     ,PL(0,139),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,138),4,COEFS,1,4,WL(1,0,1
     $     ,139))
          CALL FFV1L2_1(PL(0,139),W(1,18),GC_11,MDL_MS,ZERO,PL(0,140)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,139),4,COEFS,4,4,WL(1,0,1
     $     ,140))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,140),2,4,27,1,573,H)
C         Coefficient construction for loop diagram with ID 62
          CALL FFV2L2_3(PL(0,0),W(1,1),GC_126,MDL_MW,MDL_WW,PL(0,141)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,141))
          CALL FFV2L3_1(PL(0,141),W(1,2),GC_61,MDL_MB,ZERO,PL(0,142)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_1(WL(1,0,1,141),4,COEFS,4,4,WL(1,0,1
     $     ,142))
          CALL FFV1L2_1(PL(0,142),W(1,18),GC_11,MDL_MB,ZERO,PL(0,143)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,142),4,COEFS,4,4,WL(1,0,1
     $     ,143))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,143),4,4,28,1,574,H)
C         Coefficient construction for loop diagram with ID 63
          CALL FFS1_3L2_3(PL(0,0),W(1,1),GC_19,GC_28,MDL_MW,MDL_WW
     $     ,PL(0,144),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,144))
          CALL FFS1_3L3_1(PL(0,144),W(1,2),GC_33,GC_42,MDL_MB,ZERO
     $     ,PL(0,145),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,144),4,COEFS,1,4,WL(1,0,1
     $     ,145))
          CALL FFV1L2_1(PL(0,145),W(1,18),GC_11,MDL_MB,ZERO,PL(0,146)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,145),4,COEFS,4,4,WL(1,0,1
     $     ,146))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,146),2,4,28,1,575,H)
C         At this point, all loop coefficients needed for (QCD=4
C          QED=2), i.e. of split order ID=0, are computed.
          IF(FILTER_SO.AND.SQSO_TARGET.EQ.1) GOTO 4000
C         Coefficient construction for loop diagram with ID 64
          CALL FFV1L2_1(PL(0,0),W(1,6),GC_2,MDL_MU,ZERO,PL(0,147)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,147))
          CALL FFV1L2_1(PL(0,147),W(1,14),GC_2,MDL_MU,ZERO,PL(0,148)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,147),4,COEFS,4,4,WL(1,0,1
     $     ,148))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,148),2,4,29,1,576,H)
C         Coefficient construction for loop diagram with ID 65
          CALL FFV2_5L2_1(PL(0,147),W(1,15),GC_69,GC_76,MDL_MU,ZERO
     $     ,PL(0,149),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,147),4,COEFS,4,4,WL(1,0,1
     $     ,149))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,149),2,4,29,1,577,H)
C         Coefficient construction for loop diagram with ID 66
          CALL FFS2L2_1(PL(0,147),W(1,16),GC_123,MDL_MU,ZERO,PL(0,150)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,147),4,COEFS,4,4,WL(1,0,1
     $     ,150))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,150),2,4,29,1,578,H)
C         Coefficient construction for loop diagram with ID 67
          CALL FFS4L2_1(PL(0,147),W(1,17),GC_122,MDL_MU,ZERO,PL(0,151)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,147),4,COEFS,4,4,WL(1,0,1
     $     ,151))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,151),2,4,29,1,579,H)
C         Coefficient construction for loop diagram with ID 68
          CALL FFV2_5L2_1(PL(0,0),W(1,7),GC_69,GC_76,MDL_MU,ZERO,PL(0
     $     ,152),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,152))
          CALL FFV1L2_1(PL(0,152),W(1,14),GC_2,MDL_MU,ZERO,PL(0,153)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,152),4,COEFS,4,4,WL(1,0,1
     $     ,153))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,153),2,4,29,1,580,H)
C         Coefficient construction for loop diagram with ID 69
          CALL FFV2_5L2_1(PL(0,152),W(1,15),GC_69,GC_76,MDL_MU,ZERO
     $     ,PL(0,154),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,152),4,COEFS,4,4,WL(1,0,1
     $     ,154))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,154),2,4,29,1,581,H)
C         Coefficient construction for loop diagram with ID 70
          CALL FFS2L2_1(PL(0,152),W(1,16),GC_123,MDL_MU,ZERO,PL(0,155)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,152),4,COEFS,4,4,WL(1,0,1
     $     ,155))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,155),2,4,29,1,582,H)
C         Coefficient construction for loop diagram with ID 71
          CALL FFS4L2_1(PL(0,152),W(1,17),GC_122,MDL_MU,ZERO,PL(0,156)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,152),4,COEFS,4,4,WL(1,0,1
     $     ,156))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,156),2,4,29,1,583,H)
C         Coefficient construction for loop diagram with ID 72
          CALL FFS2L2_1(PL(0,0),W(1,8),GC_123,MDL_MU,ZERO,PL(0,157)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,157))
          CALL FFV1L2_1(PL(0,157),W(1,14),GC_2,MDL_MU,ZERO,PL(0,158)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,157),4,COEFS,4,4,WL(1,0,1
     $     ,158))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,158),2,4,29,1,584,H)
C         Coefficient construction for loop diagram with ID 73
          CALL FFV2_5L2_1(PL(0,157),W(1,15),GC_69,GC_76,MDL_MU,ZERO
     $     ,PL(0,159),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,157),4,COEFS,4,4,WL(1,0,1
     $     ,159))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,159),2,4,29,1,585,H)
C         Coefficient construction for loop diagram with ID 74
          CALL FFS2L2_1(PL(0,157),W(1,16),GC_123,MDL_MU,ZERO,PL(0,160)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,157),4,COEFS,4,4,WL(1,0,1
     $     ,160))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,160),2,4,29,1,586,H)
C         Coefficient construction for loop diagram with ID 75
          CALL FFS4L2_1(PL(0,157),W(1,17),GC_122,MDL_MU,ZERO,PL(0,161)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,157),4,COEFS,4,4,WL(1,0,1
     $     ,161))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,161),2,4,29,1,587,H)
C         Coefficient construction for loop diagram with ID 76
          CALL FFS4L2_1(PL(0,0),W(1,9),GC_122,MDL_MU,ZERO,PL(0,162)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,162))
          CALL FFV1L2_1(PL(0,162),W(1,14),GC_2,MDL_MU,ZERO,PL(0,163)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,162),4,COEFS,4,4,WL(1,0,1
     $     ,163))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,163),2,4,29,1,588,H)
C         Coefficient construction for loop diagram with ID 77
          CALL FFV2_5L2_1(PL(0,162),W(1,15),GC_69,GC_76,MDL_MU,ZERO
     $     ,PL(0,164),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,162),4,COEFS,4,4,WL(1,0,1
     $     ,164))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,164),2,4,29,1,589,H)
C         Coefficient construction for loop diagram with ID 78
          CALL FFS2L2_1(PL(0,162),W(1,16),GC_123,MDL_MU,ZERO,PL(0,165)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,162),4,COEFS,4,4,WL(1,0,1
     $     ,165))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,165),2,4,29,1,590,H)
C         Coefficient construction for loop diagram with ID 79
          CALL FFS4L2_1(PL(0,162),W(1,17),GC_122,MDL_MU,ZERO,PL(0,166)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,162),4,COEFS,4,4,WL(1,0,1
     $     ,166))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,166),2,4,29,1,591,H)
C         Coefficient construction for loop diagram with ID 80
          CALL FFV1L1_2(PL(0,92),W(1,6),GC_2,MDL_MU,ZERO,PL(0,167)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,92),4,COEFS,4,4,WL(1,0,1
     $     ,167))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,167),4,4,19,1,592,H)
C         Coefficient construction for loop diagram with ID 81
          CALL FFV1L1_2(PL(0,95),W(1,6),GC_2,MDL_MU,ZERO,PL(0,168)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,95),4,COEFS,4,4,WL(1,0,1
     $     ,168))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,168),2,4,19,1,593,H)
C         Coefficient construction for loop diagram with ID 82
          CALL FFV2_5L1_2(PL(0,92),W(1,7),GC_69,GC_76,MDL_MU,ZERO,PL(0
     $     ,169),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,92),4,COEFS,4,4,WL(1,0,1
     $     ,169))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,169),4,4,19,1,594,H)
C         Coefficient construction for loop diagram with ID 83
          CALL FFV2_5L1_2(PL(0,95),W(1,7),GC_69,GC_76,MDL_MU,ZERO,PL(0
     $     ,170),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,95),4,COEFS,4,4,WL(1,0,1
     $     ,170))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,170),2,4,19,1,595,H)
C         Coefficient construction for loop diagram with ID 84
          CALL FFS2L1_2(PL(0,92),W(1,8),GC_123,MDL_MU,ZERO,PL(0,171)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,92),4,COEFS,4,4,WL(1,0,1
     $     ,171))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,171),4,4,19,1,596,H)
C         Coefficient construction for loop diagram with ID 85
          CALL FFS2L1_2(PL(0,95),W(1,8),GC_123,MDL_MU,ZERO,PL(0,172)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,95),4,COEFS,4,4,WL(1,0,1
     $     ,172))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,172),2,4,19,1,597,H)
C         Coefficient construction for loop diagram with ID 86
          CALL FFS4L1_2(PL(0,92),W(1,9),GC_122,MDL_MU,ZERO,PL(0,173)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,92),4,COEFS,4,4,WL(1,0,1
     $     ,173))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,173),4,4,19,1,598,H)
C         Coefficient construction for loop diagram with ID 87
          CALL FFS4L1_2(PL(0,95),W(1,9),GC_122,MDL_MU,ZERO,PL(0,174)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,95),4,COEFS,4,4,WL(1,0,1
     $     ,174))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,174),2,4,19,1,599,H)
C         Coefficient construction for loop diagram with ID 88
          CALL FFV2L3_1(PL(0,0),W(1,3),GC_124,MDL_MU,ZERO,PL(0,175)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,175))
          CALL FFV2L2_3(PL(0,175),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,176)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,175),4,COEFS,4,4,WL(1,0,1
     $     ,176))
          CALL VVV1L3_2(PL(0,176),W(1,6),GC_4,MDL_MW,MDL_WW,PL(0,177)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,176),4,COEFS,4,4,WL(1,0,1
     $     ,177))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,177),5,4,30,1,600,H)
C         Coefficient construction for loop diagram with ID 89
          CALL FFS1_3L2_3(PL(0,175),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,178),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,175),4,COEFS,4,1,WL(1,0,1
     $     ,178))
          CALL VVS1L3_2(PL(0,178),W(1,6),GC_92,MDL_MW,MDL_WW,PL(0,179)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,178),4,COEFS,1,4,WL(1,0,1
     $     ,179))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,179),2,4,30,1,601,H)
C         Coefficient construction for loop diagram with ID 90
          CALL FFS1_3L3_1(PL(0,0),W(1,3),GC_13,GC_22,MDL_MU,ZERO,PL(0
     $     ,180),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,4,WL(1,0,1
     $     ,180))
          CALL FFV2L2_3(PL(0,180),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,181)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,180),1,COEFS,4,4,WL(1,0,1
     $     ,181))
          CALL VVS1L2_3(PL(0,181),W(1,6),GC_93,MDL_MW,MDL_WW,PL(0,182)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,181),1,COEFS,4,1,WL(1,0,1
     $     ,182))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,182),3,1,30,1,602,H)
C         Coefficient construction for loop diagram with ID 91
          CALL FFS1_3L2_3(PL(0,180),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,183),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,180),1,COEFS,4,1,WL(1,0,1
     $     ,183))
          CALL VSS1L3_2(PL(0,183),W(1,6),GC_3,MDL_MW,MDL_WW,PL(0,184)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,183),1,COEFS,1,1,WL(1,0,1
     $     ,184))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,184),2,1,30,1,603,H)
C         Coefficient construction for loop diagram with ID 92
          CALL VVV1L2_1(PL(0,176),W(1,7),GC_71,MDL_MW,MDL_WW,PL(0,185)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,176),4,COEFS,4,4,WL(1,0,1
     $     ,185))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,185),5,4,30,1,604,H)
C         Coefficient construction for loop diagram with ID 93
          CALL VVS1L3_1(PL(0,178),W(1,7),GC_85,MDL_MW,MDL_WW,PL(0,186)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,178),4,COEFS,1,4,WL(1,0,1
     $     ,186))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,186),2,4,30,1,605,H)
C         Coefficient construction for loop diagram with ID 94
          CALL VVS1L1_3(PL(0,181),W(1,7),GC_84,MDL_MW,MDL_WW,PL(0,187)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,181),1,COEFS,4,1,WL(1,0,1
     $     ,187))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,187),3,1,30,1,606,H)
C         Coefficient construction for loop diagram with ID 95
          CALL VSS1L3_2(PL(0,183),W(1,7),GC_79,MDL_MW,MDL_WW,PL(0,188)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,183),1,COEFS,1,1,WL(1,0,1
     $     ,188))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,188),2,1,30,1,607,H)
C         Coefficient construction for loop diagram with ID 96
          CALL VSS1L3_1(PL(0,178),W(1,8),GC_57,MDL_MW,MDL_WW,PL(0,189)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,178),4,COEFS,1,4,WL(1,0,1
     $     ,189))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,189),4,4,30,1,608,H)
C         Coefficient construction for loop diagram with ID 97
          CALL VSS1L1_3(PL(0,181),W(1,8),GC_56,MDL_MW,MDL_WW,PL(0,190)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,181),1,COEFS,4,1,WL(1,0,1
     $     ,190))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,190),4,1,30,1,609,H)
C         Coefficient construction for loop diagram with ID 98
          CALL VVS1L2_1(PL(0,176),W(1,9),GC_90,MDL_MW,MDL_WW,PL(0,191)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,176),4,COEFS,4,4,WL(1,0,1
     $     ,191))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,191),5,4,30,1,610,H)
C         Coefficient construction for loop diagram with ID 99
          CALL VSS1L2_1(PL(0,178),W(1,9),GC_55,MDL_MW,MDL_WW,PL(0,192)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,178),4,COEFS,1,4,WL(1,0,1
     $     ,192))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,192),4,4,30,1,611,H)
C         Coefficient construction for loop diagram with ID 100
          CALL VSS1L1_2(PL(0,181),W(1,9),GC_55,MDL_MW,MDL_WW,PL(0,193)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,181),1,COEFS,4,1,WL(1,0,1
     $     ,193))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,193),4,1,30,1,612,H)
C         Coefficient construction for loop diagram with ID 101
          CALL SSS1L2_1(PL(0,183),W(1,9),GC_86,MDL_MW,MDL_WW,PL(0,194)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,183),1,COEFS,1,1,WL(1,0,1
     $     ,194))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,194),1,1,30,1,613,H)
C         Coefficient construction for loop diagram with ID 102
          CALL FFV2L1_2(PL(0,0),W(1,10),GC_59,MDL_MU,ZERO,PL(0,195)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,195))
          CALL FFV2L1_2(PL(0,195),W(1,12),GC_124,MDL_MD,ZERO,PL(0,196)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,195),4,COEFS,4,4,WL(1,0,1
     $     ,196))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,196),2,4,31,1,614,H)
C         Coefficient construction for loop diagram with ID 103
          CALL FFV2L2_1(PL(0,0),W(1,10),GC_60,MDL_MS,ZERO,PL(0,197)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,197))
          CALL FFV2L2_1(PL(0,197),W(1,12),GC_125,MDL_MU,ZERO,PL(0,198)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,197),4,COEFS,4,4,WL(1,0,1
     $     ,198))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,198),2,4,32,1,615,H)
C         Coefficient construction for loop diagram with ID 104
          CALL FFV2L2_1(PL(0,0),W(1,10),GC_61,MDL_MB,ZERO,PL(0,199)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,199))
          CALL FFV2L2_1(PL(0,199),W(1,12),GC_126,MDL_MU,ZERO,PL(0,200)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,199),4,COEFS,4,4,WL(1,0,1
     $     ,200))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,200),2,4,33,1,616,H)
C         Coefficient construction for loop diagram with ID 105
          CALL FFS1_3L1_2(PL(0,195),W(1,13),GC_13,GC_22,MDL_MD,ZERO
     $     ,PL(0,201),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,195),4,COEFS,4,4,WL(1,0,1
     $     ,201))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,201),2,4,31,1,617,H)
C         Coefficient construction for loop diagram with ID 106
          CALL FFS1_3L2_1(PL(0,197),W(1,13),GC_16,GC_25,MDL_MU,ZERO
     $     ,PL(0,202),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,197),4,COEFS,4,4,WL(1,0,1
     $     ,202))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,202),2,4,32,1,618,H)
C         Coefficient construction for loop diagram with ID 107
          CALL FFS1_3L2_1(PL(0,199),W(1,13),GC_19,GC_28,MDL_MU,ZERO
     $     ,PL(0,203),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,199),4,COEFS,4,4,WL(1,0,1
     $     ,203))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,203),2,4,33,1,619,H)
C         Coefficient construction for loop diagram with ID 108
          CALL FFS1_3L1_2(PL(0,0),W(1,11),GC_31,GC_40,MDL_MU,ZERO,PL(0
     $     ,204),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,204))
          CALL FFV2L1_2(PL(0,204),W(1,12),GC_124,MDL_MD,ZERO,PL(0,205)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,204),4,COEFS,4,4,WL(1,0,1
     $     ,205))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,205),2,4,31,1,620,H)
C         Coefficient construction for loop diagram with ID 109
          CALL FFS1_3L2_1(PL(0,0),W(1,11),GC_32,GC_41,MDL_MS,ZERO,PL(0
     $     ,206),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,206))
          CALL FFV2L2_1(PL(0,206),W(1,12),GC_125,MDL_MU,ZERO,PL(0,207)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,206),4,COEFS,4,4,WL(1,0,1
     $     ,207))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,207),2,4,32,1,621,H)
C         Coefficient construction for loop diagram with ID 110
          CALL FFS1_3L2_1(PL(0,0),W(1,11),GC_33,GC_42,MDL_MB,ZERO,PL(0
     $     ,208),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,208))
          CALL FFV2L2_1(PL(0,208),W(1,12),GC_126,MDL_MU,ZERO,PL(0,209)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,208),4,COEFS,4,4,WL(1,0,1
     $     ,209))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,209),2,4,33,1,622,H)
C         Coefficient construction for loop diagram with ID 111
          CALL FFS1_3L1_2(PL(0,204),W(1,13),GC_13,GC_22,MDL_MD,ZERO
     $     ,PL(0,210),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,204),4,COEFS,4,4,WL(1,0,1
     $     ,210))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,210),2,4,31,1,623,H)
C         Coefficient construction for loop diagram with ID 112
          CALL FFS1_3L2_1(PL(0,206),W(1,13),GC_16,GC_25,MDL_MU,ZERO
     $     ,PL(0,211),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,206),4,COEFS,4,4,WL(1,0,1
     $     ,211))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,211),2,4,32,1,624,H)
C         Coefficient construction for loop diagram with ID 113
          CALL FFS1_3L2_1(PL(0,208),W(1,13),GC_19,GC_28,MDL_MU,ZERO
     $     ,PL(0,212),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,208),4,COEFS,4,4,WL(1,0,1
     $     ,212))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,212),2,4,33,1,625,H)
C         Coefficient construction for loop diagram with ID 114
          CALL FFV1L1P0_3(PL(0,0),W(1,2),GC_2,ZERO,ZERO,PL(0,213)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,213))
          CALL FFV1L3_2(PL(0,213),W(1,4),GC_1,MDL_MD,ZERO,PL(0,214)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,213),4,COEFS,4,4,WL(1,0,1
     $     ,214))
          CALL FFV2L1_2(PL(0,214),W(1,10),GC_59,MDL_MU,ZERO,PL(0,215)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,214),4,COEFS,4,4,WL(1,0,1
     $     ,215))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,215),2,4,2,1,626,H)
C         Coefficient construction for loop diagram with ID 115
          CALL FFV2_5L1_3(PL(0,0),W(1,2),GC_69,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,216),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,216))
          CALL FFV2_3L3_2(PL(0,216),W(1,4),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,217),COEFS)
          CALL ML5_0_UPDATE_WL_2_1(WL(1,0,1,216),4,COEFS,4,4,WL(1,0,1
     $     ,217))
          CALL FFV2L1_2(PL(0,217),W(1,10),GC_59,MDL_MU,ZERO,PL(0,218)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,217),4,COEFS,4,4,WL(1,0,1
     $     ,218))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,218),4,4,34,1,627,H)
C         Coefficient construction for loop diagram with ID 116
          CALL FFS2L1_3(PL(0,0),W(1,2),GC_123,MDL_MZ,MDL_WZ,PL(0,219)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,219))
          CALL FFS2L3_2(PL(0,219),W(1,4),GC_104,MDL_MD,ZERO,PL(0,220)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,219),4,COEFS,1,4,WL(1,0,1
     $     ,220))
          CALL FFV2L1_2(PL(0,220),W(1,10),GC_59,MDL_MU,ZERO,PL(0,221)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,220),4,COEFS,4,4,WL(1,0,1
     $     ,221))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,221),2,4,34,1,628,H)
C         Coefficient construction for loop diagram with ID 117
          CALL FFS4L1_3(PL(0,0),W(1,2),GC_122,MDL_MH,MDL_WH,PL(0,222)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,222))
          CALL FFS4L3_2(PL(0,222),W(1,4),GC_105,MDL_MD,ZERO,PL(0,223)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,222),4,COEFS,1,4,WL(1,0,1
     $     ,223))
          CALL FFV2L1_2(PL(0,223),W(1,10),GC_59,MDL_MU,ZERO,PL(0,224)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,223),4,COEFS,4,4,WL(1,0,1
     $     ,224))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,224),2,4,35,1,629,H)
C         Coefficient construction for loop diagram with ID 118
          CALL FFS1_3L1_2(PL(0,214),W(1,11),GC_31,GC_40,MDL_MU,ZERO
     $     ,PL(0,225),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,214),4,COEFS,4,4,WL(1,0,1
     $     ,225))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,225),2,4,2,1,630,H)
C         Coefficient construction for loop diagram with ID 119
          CALL FFS1_3L1_2(PL(0,217),W(1,11),GC_31,GC_40,MDL_MU,ZERO
     $     ,PL(0,226),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,217),4,COEFS,4,4,WL(1,0,1
     $     ,226))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,226),4,4,34,1,631,H)
C         Coefficient construction for loop diagram with ID 120
          CALL FFS1_3L1_2(PL(0,220),W(1,11),GC_31,GC_40,MDL_MU,ZERO
     $     ,PL(0,227),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,220),4,COEFS,4,4,WL(1,0,1
     $     ,227))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,227),2,4,34,1,632,H)
C         Coefficient construction for loop diagram with ID 121
          CALL FFS1_3L1_2(PL(0,223),W(1,11),GC_31,GC_40,MDL_MU,ZERO
     $     ,PL(0,228),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,223),4,COEFS,4,4,WL(1,0,1
     $     ,228))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,228),2,4,35,1,633,H)
C         Coefficient construction for loop diagram with ID 122
          CALL FFV1L3_1(PL(0,0),W(1,2),GC_2,MDL_MU,ZERO,PL(0,229)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,229))
          CALL FFV2L2_3(PL(0,229),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,230)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,229),4,COEFS,4,4,WL(1,0,1
     $     ,230))
          CALL VVV1L3P0_1(PL(0,230),W(1,10),GC_4,ZERO,ZERO,PL(0,231)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,230),4,COEFS,4,4,WL(1,0,1
     $     ,231))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,231),4,4,36,1,634,H)
C         Coefficient construction for loop diagram with ID 123
          CALL FFS1_3L2_3(PL(0,229),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,232),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,229),4,COEFS,4,1,WL(1,0,1
     $     ,232))
          CALL VVS1L3P0_1(PL(0,232),W(1,10),GC_92,ZERO,ZERO,PL(0,233)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,232),4,COEFS,1,4,WL(1,0,1
     $     ,233))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,233),1,4,36,1,635,H)
C         Coefficient construction for loop diagram with ID 124
          CALL FFV2_5L3_1(PL(0,0),W(1,2),GC_69,GC_76,MDL_MU,ZERO,PL(0
     $     ,234),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,234))
          CALL FFV2L2_3(PL(0,234),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,235)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,234),4,COEFS,4,4,WL(1,0,1
     $     ,235))
          CALL VVV1L2_3(PL(0,235),W(1,10),GC_71,MDL_MZ,MDL_WZ,PL(0
     $     ,236),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,235),4,COEFS,4,4,WL(1,0,1
     $     ,236))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,236),5,4,37,1,636,H)
C         Coefficient construction for loop diagram with ID 125
          CALL FFS1_3L2_3(PL(0,234),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,237),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,234),4,COEFS,4,1,WL(1,0,1
     $     ,237))
          CALL VVS1L3_2(PL(0,237),W(1,10),GC_85,MDL_MZ,MDL_WZ,PL(0
     $     ,238),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,237),4,COEFS,1,4,WL(1,0,1
     $     ,238))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,238),2,4,37,1,637,H)
C         Coefficient construction for loop diagram with ID 126
          CALL FFS2L3_1(PL(0,0),W(1,2),GC_123,MDL_MU,ZERO,PL(0,239)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,4,WL(1,0,1
     $     ,239))
          CALL FFS1_3L2_3(PL(0,239),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,240),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,239),1,COEFS,4,1,WL(1,0,1
     $     ,240))
          CALL VSS1L3_2(PL(0,240),W(1,10),GC_57,MDL_MZ,MDL_WZ,PL(0
     $     ,241),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,240),1,COEFS,1,1,WL(1,0,1
     $     ,241))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,241),2,1,37,1,638,H)
C         Coefficient construction for loop diagram with ID 127
          CALL FFS4L3_1(PL(0,0),W(1,2),GC_122,MDL_MU,ZERO,PL(0,242)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,4,WL(1,0,1
     $     ,242))
          CALL FFV2L2_3(PL(0,242),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,243)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,242),1,COEFS,4,4,WL(1,0,1
     $     ,243))
          CALL VVS1L2_3(PL(0,243),W(1,10),GC_90,MDL_MH,MDL_WH,PL(0
     $     ,244),COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,243),1,COEFS,4,1,WL(1,0,1
     $     ,244))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,244),3,1,38,1,639,H)
C         Coefficient construction for loop diagram with ID 128
          CALL FFS1_3L2_3(PL(0,242),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,245),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,242),1,COEFS,4,1,WL(1,0,1
     $     ,245))
          CALL VSS1L2_3(PL(0,245),W(1,10),GC_55,MDL_MH,MDL_WH,PL(0
     $     ,246),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,245),1,COEFS,1,1,WL(1,0,1
     $     ,246))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,246),2,1,38,1,640,H)
C         Coefficient construction for loop diagram with ID 129
          CALL VVS1L2P0_1(PL(0,230),W(1,11),GC_93,ZERO,ZERO,PL(0,247)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,230),4,COEFS,4,4,WL(1,0,1
     $     ,247))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,247),3,4,36,1,641,H)
C         Coefficient construction for loop diagram with ID 130
          CALL VSS1L3P0_1(PL(0,232),W(1,11),GC_3,ZERO,ZERO,PL(0,248)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,232),4,COEFS,1,4,WL(1,0,1
     $     ,248))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,248),2,4,36,1,642,H)
C         Coefficient construction for loop diagram with ID 131
          CALL VVS1L1_2(PL(0,235),W(1,11),GC_84,MDL_MZ,MDL_WZ,PL(0
     $     ,249),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,235),4,COEFS,4,4,WL(1,0,1
     $     ,249))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,249),5,4,37,1,643,H)
C         Coefficient construction for loop diagram with ID 132
          CALL VSS1L3_1(PL(0,237),W(1,11),GC_79,MDL_MZ,MDL_WZ,PL(0
     $     ,250),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,237),4,COEFS,1,4,WL(1,0,1
     $     ,250))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,250),4,4,37,1,644,H)
C         Coefficient construction for loop diagram with ID 133
          CALL FFV2L2_3(PL(0,239),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,251)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,239),1,COEFS,4,4,WL(1,0,1
     $     ,251))
          CALL VSS1L1_2(PL(0,251),W(1,11),GC_56,MDL_MZ,MDL_WZ,PL(0
     $     ,252),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,251),1,COEFS,4,1,WL(1,0,1
     $     ,252))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,252),4,1,37,1,645,H)
C         Coefficient construction for loop diagram with ID 134
          CALL VSS1L1_3(PL(0,243),W(1,11),GC_55,MDL_MH,MDL_WH,PL(0
     $     ,253),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,243),1,COEFS,4,1,WL(1,0,1
     $     ,253))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,253),4,1,38,1,646,H)
C         Coefficient construction for loop diagram with ID 135
          CALL SSS1L2_3(PL(0,245),W(1,11),GC_86,MDL_MH,MDL_WH,PL(0
     $     ,254),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,245),1,COEFS,1,1,WL(1,0,1
     $     ,254))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,254),1,1,38,1,647,H)
C         Coefficient construction for loop diagram with ID 136
          CALL FFV1L3_1(PL(0,97),W(1,3),GC_1,MDL_MD,ZERO,PL(0,255)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,97),4,COEFS,4,4,WL(1,0,1
     $     ,255))
          CALL FFV2L2_1(PL(0,255),W(1,12),GC_124,MDL_MU,ZERO,PL(0,256)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,255),4,COEFS,4,4,WL(1,0,1
     $     ,256))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,256),2,4,3,1,648,H)
C         Coefficient construction for loop diagram with ID 137
          CALL FFS1_3L2_1(PL(0,255),W(1,13),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,257),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,255),4,COEFS,4,4,WL(1,0,1
     $     ,257))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,257),2,4,3,1,649,H)
C         Coefficient construction for loop diagram with ID 138
          CALL FFV2_3L3_1(PL(0,100),W(1,3),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,258),COEFS)
          CALL ML5_0_UPDATE_WL_2_1(WL(1,0,1,100),4,COEFS,4,4,WL(1,0,1
     $     ,258))
          CALL FFV2L2_1(PL(0,258),W(1,12),GC_124,MDL_MU,ZERO,PL(0,259)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,258),4,COEFS,4,4,WL(1,0,1
     $     ,259))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,259),4,4,39,1,650,H)
C         Coefficient construction for loop diagram with ID 139
          CALL FFS1_3L2_1(PL(0,258),W(1,13),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,260),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,258),4,COEFS,4,4,WL(1,0,1
     $     ,260))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,260),4,4,39,1,651,H)
C         Coefficient construction for loop diagram with ID 140
          CALL FFS2L3_1(PL(0,103),W(1,3),GC_104,MDL_MD,ZERO,PL(0,261)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,103),4,COEFS,1,4,WL(1,0,1
     $     ,261))
          CALL FFV2L2_1(PL(0,261),W(1,12),GC_124,MDL_MU,ZERO,PL(0,262)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,261),4,COEFS,4,4,WL(1,0,1
     $     ,262))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,262),2,4,39,1,652,H)
C         Coefficient construction for loop diagram with ID 141
          CALL FFS1_3L2_1(PL(0,261),W(1,13),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,263),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,261),4,COEFS,4,4,WL(1,0,1
     $     ,263))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,263),2,4,39,1,653,H)
C         Coefficient construction for loop diagram with ID 142
          CALL FFS4L3_1(PL(0,106),W(1,3),GC_105,MDL_MD,ZERO,PL(0,264)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,106),4,COEFS,1,4,WL(1,0,1
     $     ,264))
          CALL FFV2L2_1(PL(0,264),W(1,12),GC_124,MDL_MU,ZERO,PL(0,265)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,264),4,COEFS,4,4,WL(1,0,1
     $     ,265))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,265),2,4,40,1,654,H)
C         Coefficient construction for loop diagram with ID 143
          CALL FFS1_3L2_1(PL(0,264),W(1,13),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,266),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,264),4,COEFS,4,4,WL(1,0,1
     $     ,266))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,266),2,4,40,1,655,H)
C         Coefficient construction for loop diagram with ID 144
          CALL FFV2L1_3(PL(0,51),W(1,3),GC_124,MDL_MW,MDL_WW,PL(0,267)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,51),4,COEFS,4,4,WL(1,0,1
     $     ,267))
          CALL VVV1L2P0_1(PL(0,267),W(1,12),GC_4,ZERO,ZERO,PL(0,268)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,267),4,COEFS,4,4,WL(1,0,1
     $     ,268))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,268),4,4,41,1,656,H)
C         Coefficient construction for loop diagram with ID 145
          CALL FFS1_3L1_3(PL(0,51),W(1,3),GC_13,GC_22,MDL_MW,MDL_WW
     $     ,PL(0,269),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,51),4,COEFS,4,1,WL(1,0,1
     $     ,269))
          CALL VVS1L3P0_1(PL(0,269),W(1,12),GC_93,ZERO,ZERO,PL(0,270)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,269),4,COEFS,1,4,WL(1,0,1
     $     ,270))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,270),1,4,41,1,657,H)
C         Coefficient construction for loop diagram with ID 146
          CALL VVS1L2P0_1(PL(0,267),W(1,13),GC_92,ZERO,ZERO,PL(0,271)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,267),4,COEFS,4,4,WL(1,0,1
     $     ,271))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,271),3,4,41,1,658,H)
C         Coefficient construction for loop diagram with ID 147
          CALL VSS1L2P0_1(PL(0,269),W(1,13),GC_3,ZERO,ZERO,PL(0,272)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,269),4,COEFS,1,4,WL(1,0,1
     $     ,272))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,272),2,4,41,1,659,H)
C         Coefficient construction for loop diagram with ID 148
          CALL FFV2L1_3(PL(0,55),W(1,3),GC_124,MDL_MW,MDL_WW,PL(0,273)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,55),4,COEFS,4,4,WL(1,0,1
     $     ,273))
          CALL VVV1L1_3(PL(0,273),W(1,12),GC_71,MDL_MZ,MDL_WZ,PL(0
     $     ,274),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,273),4,COEFS,4,4,WL(1,0,1
     $     ,274))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,274),5,4,42,1,660,H)
C         Coefficient construction for loop diagram with ID 149
          CALL FFS1_3L1_3(PL(0,55),W(1,3),GC_13,GC_22,MDL_MW,MDL_WW
     $     ,PL(0,275),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,55),4,COEFS,4,1,WL(1,0,1
     $     ,275))
          CALL VVS1L3_2(PL(0,275),W(1,12),GC_84,MDL_MZ,MDL_WZ,PL(0
     $     ,276),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,275),4,COEFS,1,4,WL(1,0,1
     $     ,276))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,276),2,4,42,1,661,H)
C         Coefficient construction for loop diagram with ID 150
          CALL VVS1L1_2(PL(0,273),W(1,13),GC_85,MDL_MZ,MDL_WZ,PL(0
     $     ,277),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,273),4,COEFS,4,4,WL(1,0,1
     $     ,277))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,277),5,4,42,1,662,H)
C         Coefficient construction for loop diagram with ID 151
          CALL VSS1L2_1(PL(0,275),W(1,13),GC_79,MDL_MZ,MDL_WZ,PL(0
     $     ,278),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,275),4,COEFS,1,4,WL(1,0,1
     $     ,278))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,278),4,4,42,1,663,H)
C         Coefficient construction for loop diagram with ID 152
          CALL FFS1_3L1_3(PL(0,59),W(1,3),GC_13,GC_22,MDL_MW,MDL_WW
     $     ,PL(0,279),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,59),1,COEFS,4,1,WL(1,0,1
     $     ,279))
          CALL VSS1L3_2(PL(0,279),W(1,12),GC_56,MDL_MZ,MDL_WZ,PL(0
     $     ,280),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,279),1,COEFS,1,1,WL(1,0,1
     $     ,280))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,280),2,1,42,1,664,H)
C         Coefficient construction for loop diagram with ID 153
          CALL FFV2L1_3(PL(0,59),W(1,3),GC_124,MDL_MW,MDL_WW,PL(0,281)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,59),1,COEFS,4,4,WL(1,0,1
     $     ,281))
          CALL VSS1L1_2(PL(0,281),W(1,13),GC_57,MDL_MZ,MDL_WZ,PL(0
     $     ,282),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,281),1,COEFS,4,1,WL(1,0,1
     $     ,282))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,282),4,1,42,1,665,H)
C         Coefficient construction for loop diagram with ID 154
          CALL FFV2L1_3(PL(0,63),W(1,3),GC_124,MDL_MW,MDL_WW,PL(0,283)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,63),1,COEFS,4,4,WL(1,0,1
     $     ,283))
          CALL VVS1L1_3(PL(0,283),W(1,12),GC_90,MDL_MH,MDL_WH,PL(0
     $     ,284),COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,283),1,COEFS,4,1,WL(1,0,1
     $     ,284))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,284),3,1,43,1,666,H)
C         Coefficient construction for loop diagram with ID 155
          CALL FFS1_3L1_3(PL(0,63),W(1,3),GC_13,GC_22,MDL_MW,MDL_WW
     $     ,PL(0,285),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,63),1,COEFS,4,1,WL(1,0,1
     $     ,285))
          CALL VSS1L2_3(PL(0,285),W(1,12),GC_55,MDL_MH,MDL_WH,PL(0
     $     ,286),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,285),1,COEFS,1,1,WL(1,0,1
     $     ,286))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,286),2,1,43,1,667,H)
C         Coefficient construction for loop diagram with ID 156
          CALL VSS1L1_3(PL(0,283),W(1,13),GC_55,MDL_MH,MDL_WH,PL(0
     $     ,287),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,283),1,COEFS,4,1,WL(1,0,1
     $     ,287))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,287),4,1,43,1,668,H)
C         Coefficient construction for loop diagram with ID 157
          CALL SSS1L1_3(PL(0,285),W(1,13),GC_86,MDL_MH,MDL_WH,PL(0
     $     ,288),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,285),1,COEFS,1,1,WL(1,0,1
     $     ,288))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,288),1,1,43,1,669,H)
C         Coefficient construction for loop diagram with ID 158
          CALL FFV1L1P0_3(PL(0,51),W(1,2),GC_2,ZERO,ZERO,PL(0,289)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,51),4,COEFS,4,4,WL(1,0,1
     $     ,289))
          CALL FFV1L3_2(PL(0,289),W(1,4),GC_1,MDL_MD,ZERO,PL(0,290)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,289),4,COEFS,4,4,WL(1,0,1
     $     ,290))
          CALL FFV1L1P0_3(PL(0,290),W(1,3),GC_1,ZERO,ZERO,PL(0,291)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,290),4,COEFS,4,4,WL(1,0,1
     $     ,291))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,291),2,4,6,1,670,H)
C         Coefficient construction for loop diagram with ID 159
          CALL FFV1L3_1(PL(0,289),W(1,3),GC_1,MDL_MD,ZERO,PL(0,292)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,289),4,COEFS,4,4,WL(1,0,1
     $     ,292))
          CALL FFV1L2P0_3(PL(0,292),W(1,4),GC_1,ZERO,ZERO,PL(0,293)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,292),4,COEFS,4,4,WL(1,0,1
     $     ,293))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,293),2,4,9,1,671,H)
C         Coefficient construction for loop diagram with ID 160
          CALL FFV2_5L1_3(PL(0,51),W(1,2),GC_69,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,294),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,51),4,COEFS,4,4,WL(1,0,1
     $     ,294))
          CALL FFV2_3L3_2(PL(0,294),W(1,4),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,295),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,294),4,COEFS,4,4,WL(1,0,1
     $     ,295))
          CALL FFV1L1P0_3(PL(0,295),W(1,3),GC_1,ZERO,ZERO,PL(0,296)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,295),4,COEFS,4,4,WL(1,0,1
     $     ,296))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,296),4,4,7,1,672,H)
C         Coefficient construction for loop diagram with ID 161
          CALL FFV2_3L3_1(PL(0,294),W(1,3),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,297),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,294),4,COEFS,4,4,WL(1,0,1
     $     ,297))
          CALL FFV1L2P0_3(PL(0,297),W(1,4),GC_1,ZERO,ZERO,PL(0,298)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,297),4,COEFS,4,4,WL(1,0,1
     $     ,298))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,298),4,4,10,1,673,H)
C         Coefficient construction for loop diagram with ID 162
          CALL FFS2L1_3(PL(0,51),W(1,2),GC_123,MDL_MZ,MDL_WZ,PL(0,299)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,51),4,COEFS,4,1,WL(1,0,1
     $     ,299))
          CALL FFS2L3_2(PL(0,299),W(1,4),GC_104,MDL_MD,ZERO,PL(0,300)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,299),4,COEFS,1,4,WL(1,0,1
     $     ,300))
          CALL FFV1L1P0_3(PL(0,300),W(1,3),GC_1,ZERO,ZERO,PL(0,301)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,300),4,COEFS,4,4,WL(1,0,1
     $     ,301))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,301),2,4,7,1,674,H)
C         Coefficient construction for loop diagram with ID 163
          CALL FFS2L3_1(PL(0,299),W(1,3),GC_104,MDL_MD,ZERO,PL(0,302)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,299),4,COEFS,1,4,WL(1,0,1
     $     ,302))
          CALL FFV1L2P0_3(PL(0,302),W(1,4),GC_1,ZERO,ZERO,PL(0,303)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,302),4,COEFS,4,4,WL(1,0,1
     $     ,303))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,303),2,4,10,1,675,H)
C         Coefficient construction for loop diagram with ID 164
          CALL FFS4L1_3(PL(0,51),W(1,2),GC_122,MDL_MH,MDL_WH,PL(0,304)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,51),4,COEFS,4,1,WL(1,0,1
     $     ,304))
          CALL FFS4L3_2(PL(0,304),W(1,4),GC_105,MDL_MD,ZERO,PL(0,305)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,304),4,COEFS,1,4,WL(1,0,1
     $     ,305))
          CALL FFV1L1P0_3(PL(0,305),W(1,3),GC_1,ZERO,ZERO,PL(0,306)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,305),4,COEFS,4,4,WL(1,0,1
     $     ,306))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,306),2,4,8,1,676,H)
C         Coefficient construction for loop diagram with ID 165
          CALL FFS4L3_1(PL(0,304),W(1,3),GC_105,MDL_MD,ZERO,PL(0,307)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,304),4,COEFS,1,4,WL(1,0,1
     $     ,307))
          CALL FFV1L2P0_3(PL(0,307),W(1,4),GC_1,ZERO,ZERO,PL(0,308)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,307),4,COEFS,4,4,WL(1,0,1
     $     ,308))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,308),2,4,11,1,677,H)
C         Coefficient construction for loop diagram with ID 166
          CALL FFV1L1P0_3(PL(0,55),W(1,2),GC_2,ZERO,ZERO,PL(0,309)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,55),4,COEFS,4,4,WL(1,0,1
     $     ,309))
          CALL FFV1L3_2(PL(0,309),W(1,4),GC_1,MDL_MD,ZERO,PL(0,310)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,309),4,COEFS,4,4,WL(1,0,1
     $     ,310))
          CALL FFV2_3L1_3(PL(0,310),W(1,3),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,311),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,310),4,COEFS,4,4,WL(1,0,1
     $     ,311))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,311),4,4,16,1,678,H)
C         Coefficient construction for loop diagram with ID 167
          CALL FFV1L3_1(PL(0,309),W(1,3),GC_1,MDL_MD,ZERO,PL(0,312)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,309),4,COEFS,4,4,WL(1,0,1
     $     ,312))
          CALL FFV2_3L2_3(PL(0,312),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,313),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,312),4,COEFS,4,4,WL(1,0,1
     $     ,313))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,313),4,4,13,1,679,H)
C         Coefficient construction for loop diagram with ID 168
          CALL FFV2_5L1_3(PL(0,55),W(1,2),GC_69,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,314),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,55),4,COEFS,4,4,WL(1,0,1
     $     ,314))
          CALL FFV2_3L3_2(PL(0,314),W(1,4),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,315),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,314),4,COEFS,4,4,WL(1,0,1
     $     ,315))
          CALL FFV2_3L1_3(PL(0,315),W(1,3),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,316),COEFS)
          CALL ML5_0_UPDATE_WL_4_2(WL(1,0,1,315),4,COEFS,4,4,WL(1,0,1
     $     ,316))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,316),6,4,44,1,680,H)
C         Coefficient construction for loop diagram with ID 169
          CALL FFV2_3L3_1(PL(0,314),W(1,3),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,317),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,314),4,COEFS,4,4,WL(1,0,1
     $     ,317))
          CALL FFV2_3L2_3(PL(0,317),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,318),COEFS)
          CALL ML5_0_UPDATE_WL_4_2(WL(1,0,1,317),4,COEFS,4,4,WL(1,0,1
     $     ,318))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,318),6,4,45,1,681,H)
C         Coefficient construction for loop diagram with ID 170
          CALL FFS2L1_3(PL(0,55),W(1,2),GC_123,MDL_MZ,MDL_WZ,PL(0,319)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,55),4,COEFS,4,1,WL(1,0,1
     $     ,319))
          CALL FFS2L3_2(PL(0,319),W(1,4),GC_104,MDL_MD,ZERO,PL(0,320)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,319),4,COEFS,1,4,WL(1,0,1
     $     ,320))
          CALL FFV2_3L1_3(PL(0,320),W(1,3),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,321),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,320),4,COEFS,4,4,WL(1,0,1
     $     ,321))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,321),4,4,44,1,682,H)
C         Coefficient construction for loop diagram with ID 171
          CALL FFS2L3_1(PL(0,319),W(1,3),GC_104,MDL_MD,ZERO,PL(0,322)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,319),4,COEFS,1,4,WL(1,0,1
     $     ,322))
          CALL FFV2_3L2_3(PL(0,322),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,323),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,322),4,COEFS,4,4,WL(1,0,1
     $     ,323))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,323),4,4,45,1,683,H)
C         Coefficient construction for loop diagram with ID 172
          CALL FFS4L1_3(PL(0,55),W(1,2),GC_122,MDL_MH,MDL_WH,PL(0,324)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,55),4,COEFS,4,1,WL(1,0,1
     $     ,324))
          CALL FFS4L3_2(PL(0,324),W(1,4),GC_105,MDL_MD,ZERO,PL(0,325)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,324),4,COEFS,1,4,WL(1,0,1
     $     ,325))
          CALL FFV2_3L1_3(PL(0,325),W(1,3),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,326),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,325),4,COEFS,4,4,WL(1,0,1
     $     ,326))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,326),4,4,46,1,684,H)
C         Coefficient construction for loop diagram with ID 173
          CALL FFS4L3_1(PL(0,324),W(1,3),GC_105,MDL_MD,ZERO,PL(0,327)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,324),4,COEFS,1,4,WL(1,0,1
     $     ,327))
          CALL FFV2_3L2_3(PL(0,327),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,328),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,327),4,COEFS,4,4,WL(1,0,1
     $     ,328))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,328),4,4,47,1,685,H)
C         Coefficient construction for loop diagram with ID 174
          CALL FFV1L1P0_3(PL(0,59),W(1,2),GC_2,ZERO,ZERO,PL(0,329)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,59),1,COEFS,4,4,WL(1,0,1
     $     ,329))
          CALL FFV1L3_2(PL(0,329),W(1,4),GC_1,MDL_MD,ZERO,PL(0,330)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,329),1,COEFS,4,4,WL(1,0,1
     $     ,330))
          CALL FFS2L1_3(PL(0,330),W(1,3),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,331),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,330),1,COEFS,4,1,WL(1,0,1
     $     ,331))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,331),2,1,16,1,686,H)
C         Coefficient construction for loop diagram with ID 175
          CALL FFV1L3_1(PL(0,329),W(1,3),GC_1,MDL_MD,ZERO,PL(0,332)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,329),1,COEFS,4,4,WL(1,0,1
     $     ,332))
          CALL FFS2L2_3(PL(0,332),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,333),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,332),1,COEFS,4,1,WL(1,0,1
     $     ,333))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,333),2,1,13,1,687,H)
C         Coefficient construction for loop diagram with ID 176
          CALL FFV2_5L1_3(PL(0,59),W(1,2),GC_69,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,334),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,59),1,COEFS,4,4,WL(1,0,1
     $     ,334))
          CALL FFV2_3L3_2(PL(0,334),W(1,4),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,335),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,334),1,COEFS,4,4,WL(1,0,1
     $     ,335))
          CALL FFS2L1_3(PL(0,335),W(1,3),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,336),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,335),1,COEFS,4,1,WL(1,0,1
     $     ,336))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,336),4,1,44,1,688,H)
C         Coefficient construction for loop diagram with ID 177
          CALL FFV2_3L3_1(PL(0,334),W(1,3),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,337),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,334),1,COEFS,4,4,WL(1,0,1
     $     ,337))
          CALL FFS2L2_3(PL(0,337),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,338),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,337),1,COEFS,4,1,WL(1,0,1
     $     ,338))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,338),4,1,45,1,689,H)
C         Coefficient construction for loop diagram with ID 178
          CALL FFS2L1_3(PL(0,59),W(1,2),GC_123,MDL_MZ,MDL_WZ,PL(0,339)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,59),1,COEFS,4,1,WL(1,0,1
     $     ,339))
          CALL FFS2L3_2(PL(0,339),W(1,4),GC_104,MDL_MD,ZERO,PL(0,340)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,339),1,COEFS,1,4,WL(1,0,1
     $     ,340))
          CALL FFS2L1_3(PL(0,340),W(1,3),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,341),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,340),1,COEFS,4,1,WL(1,0,1
     $     ,341))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,341),2,1,44,1,690,H)
C         Coefficient construction for loop diagram with ID 179
          CALL FFS2L3_1(PL(0,339),W(1,3),GC_104,MDL_MD,ZERO,PL(0,342)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,339),1,COEFS,1,4,WL(1,0,1
     $     ,342))
          CALL FFS2L2_3(PL(0,342),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,343),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,342),1,COEFS,4,1,WL(1,0,1
     $     ,343))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,343),2,1,45,1,691,H)
C         Coefficient construction for loop diagram with ID 180
          CALL FFS4L1_3(PL(0,59),W(1,2),GC_122,MDL_MH,MDL_WH,PL(0,344)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,59),1,COEFS,4,1,WL(1,0,1
     $     ,344))
          CALL FFS4L3_2(PL(0,344),W(1,4),GC_105,MDL_MD,ZERO,PL(0,345)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,344),1,COEFS,1,4,WL(1,0,1
     $     ,345))
          CALL FFS2L1_3(PL(0,345),W(1,3),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,346),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,345),1,COEFS,4,1,WL(1,0,1
     $     ,346))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,346),2,1,46,1,692,H)
C         Coefficient construction for loop diagram with ID 181
          CALL FFS4L3_1(PL(0,344),W(1,3),GC_105,MDL_MD,ZERO,PL(0,347)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,344),1,COEFS,1,4,WL(1,0,1
     $     ,347))
          CALL FFS2L2_3(PL(0,347),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,348),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,347),1,COEFS,4,1,WL(1,0,1
     $     ,348))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,348),2,1,47,1,693,H)
C         Coefficient construction for loop diagram with ID 182
          CALL FFV1L1P0_3(PL(0,63),W(1,2),GC_2,ZERO,ZERO,PL(0,349)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,63),1,COEFS,4,4,WL(1,0,1
     $     ,349))
          CALL FFV1L3_2(PL(0,349),W(1,4),GC_1,MDL_MD,ZERO,PL(0,350)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,349),1,COEFS,4,4,WL(1,0,1
     $     ,350))
          CALL FFS4L1_3(PL(0,350),W(1,3),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,351),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,350),1,COEFS,4,1,WL(1,0,1
     $     ,351))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,351),2,1,17,1,694,H)
C         Coefficient construction for loop diagram with ID 183
          CALL FFV1L3_1(PL(0,349),W(1,3),GC_1,MDL_MD,ZERO,PL(0,352)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,349),1,COEFS,4,4,WL(1,0,1
     $     ,352))
          CALL FFS4L2_3(PL(0,352),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,353),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,352),1,COEFS,4,1,WL(1,0,1
     $     ,353))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,353),2,1,14,1,695,H)
C         Coefficient construction for loop diagram with ID 184
          CALL FFV2_5L1_3(PL(0,63),W(1,2),GC_69,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,354),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,63),1,COEFS,4,4,WL(1,0,1
     $     ,354))
          CALL FFV2_3L3_2(PL(0,354),W(1,4),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,355),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,354),1,COEFS,4,4,WL(1,0,1
     $     ,355))
          CALL FFS4L1_3(PL(0,355),W(1,3),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,356),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,355),1,COEFS,4,1,WL(1,0,1
     $     ,356))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,356),4,1,48,1,696,H)
C         Coefficient construction for loop diagram with ID 185
          CALL FFV2_3L3_1(PL(0,354),W(1,3),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,357),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,354),1,COEFS,4,4,WL(1,0,1
     $     ,357))
          CALL FFS4L2_3(PL(0,357),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,358),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,357),1,COEFS,4,1,WL(1,0,1
     $     ,358))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,358),4,1,49,1,697,H)
C         Coefficient construction for loop diagram with ID 186
          CALL FFS2L1_3(PL(0,63),W(1,2),GC_123,MDL_MZ,MDL_WZ,PL(0,359)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,63),1,COEFS,4,1,WL(1,0,1
     $     ,359))
          CALL FFS2L3_2(PL(0,359),W(1,4),GC_104,MDL_MD,ZERO,PL(0,360)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,359),1,COEFS,1,4,WL(1,0,1
     $     ,360))
          CALL FFS4L1_3(PL(0,360),W(1,3),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,361),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,360),1,COEFS,4,1,WL(1,0,1
     $     ,361))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,361),2,1,48,1,698,H)
C         Coefficient construction for loop diagram with ID 187
          CALL FFS2L3_1(PL(0,359),W(1,3),GC_104,MDL_MD,ZERO,PL(0,362)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,359),1,COEFS,1,4,WL(1,0,1
     $     ,362))
          CALL FFS4L2_3(PL(0,362),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,363),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,362),1,COEFS,4,1,WL(1,0,1
     $     ,363))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,363),2,1,49,1,699,H)
C         Coefficient construction for loop diagram with ID 188
          CALL FFS4L1_3(PL(0,63),W(1,2),GC_122,MDL_MH,MDL_WH,PL(0,364)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,63),1,COEFS,4,1,WL(1,0,1
     $     ,364))
          CALL FFS4L3_2(PL(0,364),W(1,4),GC_105,MDL_MD,ZERO,PL(0,365)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,364),1,COEFS,1,4,WL(1,0,1
     $     ,365))
          CALL FFS4L1_3(PL(0,365),W(1,3),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,366),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,365),1,COEFS,4,1,WL(1,0,1
     $     ,366))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,366),2,1,50,1,700,H)
C         Coefficient construction for loop diagram with ID 189
          CALL FFS4L3_1(PL(0,364),W(1,3),GC_105,MDL_MD,ZERO,PL(0,367)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,364),1,COEFS,1,4,WL(1,0,1
     $     ,367))
          CALL FFS4L2_3(PL(0,367),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,368),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,367),1,COEFS,4,1,WL(1,0,1
     $     ,368))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,368),2,1,51,1,701,H)
C         Coefficient construction for loop diagram with ID 190
          CALL VVS1L2_1(PL(0,314),W(1,17),GC_99,MDL_MZ,MDL_WZ,PL(0
     $     ,369),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,314),4,COEFS,4,4,WL(1,0,1
     $     ,369))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,369),5,4,52,1,702,H)
C         Coefficient construction for loop diagram with ID 191
          CALL VSS1L2_1(PL(0,319),W(1,17),GC_78,MDL_MZ,MDL_WZ,PL(0
     $     ,370),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,319),4,COEFS,1,4,WL(1,0,1
     $     ,370))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,370),4,4,52,1,703,H)
C         Coefficient construction for loop diagram with ID 192
          CALL VVS1L3_1(PL(0,324),W(1,15),GC_99,MDL_MZ,MDL_WZ,PL(0
     $     ,371),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,324),4,COEFS,1,4,WL(1,0,1
     $     ,371))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,371),2,4,53,1,704,H)
C         Coefficient construction for loop diagram with ID 193
          CALL VSS1L3_1(PL(0,324),W(1,16),GC_78,MDL_MZ,MDL_WZ,PL(0
     $     ,372),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,324),4,COEFS,1,4,WL(1,0,1
     $     ,372))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,372),4,4,53,1,705,H)
C         Coefficient construction for loop diagram with ID 194
          CALL VSS1L1_2(PL(0,334),W(1,17),GC_78,MDL_MZ,MDL_WZ,PL(0
     $     ,373),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,334),1,COEFS,4,1,WL(1,0,1
     $     ,373))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,373),4,1,52,1,706,H)
C         Coefficient construction for loop diagram with ID 195
          CALL SSS1L2_1(PL(0,339),W(1,17),GC_86,MDL_MZ,MDL_WZ,PL(0
     $     ,374),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,339),1,COEFS,1,1,WL(1,0,1
     $     ,374))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,374),1,1,52,1,707,H)
C         Coefficient construction for loop diagram with ID 196
          CALL VSS1L3_2(PL(0,344),W(1,15),GC_78,MDL_MZ,MDL_WZ,PL(0
     $     ,375),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,344),1,COEFS,1,1,WL(1,0,1
     $     ,375))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,375),2,1,53,1,708,H)
C         Coefficient construction for loop diagram with ID 197
          CALL SSS1L3_1(PL(0,344),W(1,16),GC_86,MDL_MZ,MDL_WZ,PL(0
     $     ,376),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,344),1,COEFS,1,1,WL(1,0,1
     $     ,376))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,376),1,1,53,1,709,H)
C         Coefficient construction for loop diagram with ID 198
          CALL VVS1L1_3(PL(0,354),W(1,15),GC_99,MDL_MH,MDL_WH,PL(0
     $     ,377),COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,354),1,COEFS,4,1,WL(1,0,1
     $     ,377))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,377),3,1,54,1,710,H)
C         Coefficient construction for loop diagram with ID 199
          CALL VSS1L1_3(PL(0,354),W(1,16),GC_78,MDL_MH,MDL_WH,PL(0
     $     ,378),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,354),1,COEFS,4,1,WL(1,0,1
     $     ,378))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,378),4,1,54,1,711,H)
C         Coefficient construction for loop diagram with ID 200
          CALL VSS1L2_3(PL(0,359),W(1,15),GC_78,MDL_MH,MDL_WH,PL(0
     $     ,379),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,359),1,COEFS,1,1,WL(1,0,1
     $     ,379))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,379),2,1,54,1,712,H)
C         Coefficient construction for loop diagram with ID 201
          CALL SSS1L1_3(PL(0,359),W(1,16),GC_86,MDL_MH,MDL_WH,PL(0
     $     ,380),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,359),1,COEFS,1,1,WL(1,0,1
     $     ,380))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,380),1,1,54,1,713,H)
C         Coefficient construction for loop diagram with ID 202
          CALL SSS1L2_1(PL(0,364),W(1,17),GC_87,MDL_MH,MDL_WH,PL(0
     $     ,381),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,364),1,COEFS,1,1,WL(1,0,1
     $     ,381))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,381),1,1,55,1,714,H)
C         Coefficient construction for loop diagram with ID 203
          CALL FFV1L2_1(PL(0,98),W(1,14),GC_2,MDL_MU,ZERO,PL(0,382)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,98),4,COEFS,4,4,WL(1,0,1
     $     ,382))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,382),2,4,5,1,715,H)
C         Coefficient construction for loop diagram with ID 204
          CALL FFV2_5L2_1(PL(0,98),W(1,15),GC_69,GC_76,MDL_MU,ZERO
     $     ,PL(0,383),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,98),4,COEFS,4,4,WL(1,0,1
     $     ,383))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,383),2,4,5,1,716,H)
C         Coefficient construction for loop diagram with ID 205
          CALL FFS2L2_1(PL(0,98),W(1,16),GC_123,MDL_MU,ZERO,PL(0,384)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,98),4,COEFS,4,4,WL(1,0,1
     $     ,384))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,384),2,4,5,1,717,H)
C         Coefficient construction for loop diagram with ID 206
          CALL FFS4L2_1(PL(0,98),W(1,17),GC_122,MDL_MU,ZERO,PL(0,385)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,98),4,COEFS,4,4,WL(1,0,1
     $     ,385))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,385),2,4,5,1,718,H)
C         Coefficient construction for loop diagram with ID 207
          CALL FFV1L2_1(PL(0,101),W(1,14),GC_2,MDL_MU,ZERO,PL(0,386)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,101),4,COEFS,4,4,WL(1,0,1
     $     ,386))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,386),4,4,20,1,719,H)
C         Coefficient construction for loop diagram with ID 208
          CALL FFV2_5L2_1(PL(0,101),W(1,15),GC_69,GC_76,MDL_MU,ZERO
     $     ,PL(0,387),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,101),4,COEFS,4,4,WL(1,0,1
     $     ,387))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,387),4,4,20,1,720,H)
C         Coefficient construction for loop diagram with ID 209
          CALL FFS2L2_1(PL(0,101),W(1,16),GC_123,MDL_MU,ZERO,PL(0,388)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,101),4,COEFS,4,4,WL(1,0,1
     $     ,388))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,388),4,4,20,1,721,H)
C         Coefficient construction for loop diagram with ID 210
          CALL FFS4L2_1(PL(0,101),W(1,17),GC_122,MDL_MU,ZERO,PL(0,389)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,101),4,COEFS,4,4,WL(1,0,1
     $     ,389))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,389),4,4,20,1,722,H)
C         Coefficient construction for loop diagram with ID 211
          CALL FFV1L2_1(PL(0,104),W(1,14),GC_2,MDL_MU,ZERO,PL(0,390)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,104),4,COEFS,4,4,WL(1,0,1
     $     ,390))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,390),2,4,20,1,723,H)
C         Coefficient construction for loop diagram with ID 212
          CALL FFV2_5L2_1(PL(0,104),W(1,15),GC_69,GC_76,MDL_MU,ZERO
     $     ,PL(0,391),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,104),4,COEFS,4,4,WL(1,0,1
     $     ,391))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,391),2,4,20,1,724,H)
C         Coefficient construction for loop diagram with ID 213
          CALL FFS2L2_1(PL(0,104),W(1,16),GC_123,MDL_MU,ZERO,PL(0,392)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,104),4,COEFS,4,4,WL(1,0,1
     $     ,392))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,392),2,4,20,1,725,H)
C         Coefficient construction for loop diagram with ID 214
          CALL FFS4L2_1(PL(0,104),W(1,17),GC_122,MDL_MU,ZERO,PL(0,393)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,104),4,COEFS,4,4,WL(1,0,1
     $     ,393))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,393),2,4,20,1,726,H)
C         Coefficient construction for loop diagram with ID 215
          CALL FFV1L2_1(PL(0,107),W(1,14),GC_2,MDL_MU,ZERO,PL(0,394)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,107),4,COEFS,4,4,WL(1,0,1
     $     ,394))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,394),2,4,21,1,727,H)
C         Coefficient construction for loop diagram with ID 216
          CALL FFV2_5L2_1(PL(0,107),W(1,15),GC_69,GC_76,MDL_MU,ZERO
     $     ,PL(0,395),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,107),4,COEFS,4,4,WL(1,0,1
     $     ,395))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,395),2,4,21,1,728,H)
C         Coefficient construction for loop diagram with ID 217
          CALL FFS2L2_1(PL(0,107),W(1,16),GC_123,MDL_MU,ZERO,PL(0,396)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,107),4,COEFS,4,4,WL(1,0,1
     $     ,396))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,396),2,4,21,1,729,H)
C         Coefficient construction for loop diagram with ID 218
          CALL FFS4L2_1(PL(0,107),W(1,17),GC_122,MDL_MU,ZERO,PL(0,397)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,107),4,COEFS,4,4,WL(1,0,1
     $     ,397))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,397),2,4,21,1,730,H)
C         Coefficient construction for loop diagram with ID 219
          CALL FFV2L2_3(PL(0,98),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,398)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,98),4,COEFS,4,4,WL(1,0,1
     $     ,398))
          CALL FFV2L3_1(PL(0,398),W(1,3),GC_124,MDL_MU,ZERO,PL(0,399)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,398),4,COEFS,4,4,WL(1,0,1
     $     ,399))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,399),4,4,4,1,731,H)
C         Coefficient construction for loop diagram with ID 220
          CALL FFV2L3_1(PL(0,267),W(1,2),GC_59,MDL_MD,ZERO,PL(0,400)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,267),4,COEFS,4,4,WL(1,0,1
     $     ,400))
          CALL FFV1L2P0_3(PL(0,400),W(1,4),GC_1,ZERO,ZERO,PL(0,401)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,400),4,COEFS,4,4,WL(1,0,1
     $     ,401))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,401),4,4,12,1,732,H)
C         Coefficient construction for loop diagram with ID 221
          CALL FFS1_3L2_3(PL(0,98),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,402),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,98),4,COEFS,4,1,WL(1,0,1
     $     ,402))
          CALL FFS1_3L3_1(PL(0,402),W(1,3),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,403),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,402),4,COEFS,1,4,WL(1,0,1
     $     ,403))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,403),2,4,4,1,733,H)
C         Coefficient construction for loop diagram with ID 222
          CALL FFS1_3L3_1(PL(0,269),W(1,2),GC_31,GC_40,MDL_MD,ZERO
     $     ,PL(0,404),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,269),4,COEFS,1,4,WL(1,0,1
     $     ,404))
          CALL FFV1L2P0_3(PL(0,404),W(1,4),GC_1,ZERO,ZERO,PL(0,405)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,404),4,COEFS,4,4,WL(1,0,1
     $     ,405))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,405),2,4,12,1,734,H)
C         Coefficient construction for loop diagram with ID 223
          CALL FFV2L2_3(PL(0,101),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,406)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,101),4,COEFS,4,4,WL(1,0,1
     $     ,406))
          CALL FFV2L3_1(PL(0,406),W(1,3),GC_124,MDL_MU,ZERO,PL(0,407)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_5_1(WL(1,0,1,406),4,COEFS,4,4,WL(1,0,1
     $     ,407))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,407),6,4,56,1,735,H)
C         Coefficient construction for loop diagram with ID 224
          CALL FFV2L3_1(PL(0,273),W(1,2),GC_59,MDL_MD,ZERO,PL(0,408)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,273),4,COEFS,4,4,WL(1,0,1
     $     ,408))
          CALL FFV2_3L2_3(PL(0,408),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,409),COEFS)
          CALL ML5_0_UPDATE_WL_4_2(WL(1,0,1,408),4,COEFS,4,4,WL(1,0,1
     $     ,409))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,409),6,4,57,1,736,H)
C         Coefficient construction for loop diagram with ID 225
          CALL FFS1_3L2_3(PL(0,101),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,410),COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,101),4,COEFS,4,1,WL(1,0,1
     $     ,410))
          CALL FFS1_3L3_1(PL(0,410),W(1,3),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,411),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,410),4,COEFS,1,4,WL(1,0,1
     $     ,411))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,411),4,4,56,1,737,H)
C         Coefficient construction for loop diagram with ID 226
          CALL FFS1_3L3_1(PL(0,275),W(1,2),GC_31,GC_40,MDL_MD,ZERO
     $     ,PL(0,412),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,275),4,COEFS,1,4,WL(1,0,1
     $     ,412))
          CALL FFV2_3L2_3(PL(0,412),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,413),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,412),4,COEFS,4,4,WL(1,0,1
     $     ,413))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,413),4,4,57,1,738,H)
C         Coefficient construction for loop diagram with ID 227
          CALL FFV2L2_3(PL(0,104),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,414)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,104),4,COEFS,4,4,WL(1,0,1
     $     ,414))
          CALL FFV2L3_1(PL(0,414),W(1,3),GC_124,MDL_MU,ZERO,PL(0,415)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,414),4,COEFS,4,4,WL(1,0,1
     $     ,415))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,415),4,4,56,1,739,H)
C         Coefficient construction for loop diagram with ID 228
          CALL FFV2L3_1(PL(0,281),W(1,2),GC_59,MDL_MD,ZERO,PL(0,416)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,281),1,COEFS,4,4,WL(1,0,1
     $     ,416))
          CALL FFS2L2_3(PL(0,416),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,417),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,416),1,COEFS,4,1,WL(1,0,1
     $     ,417))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,417),4,1,57,1,740,H)
C         Coefficient construction for loop diagram with ID 229
          CALL FFS1_3L2_3(PL(0,104),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,418),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,104),4,COEFS,4,1,WL(1,0,1
     $     ,418))
          CALL FFS1_3L3_1(PL(0,418),W(1,3),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,419),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,418),4,COEFS,1,4,WL(1,0,1
     $     ,419))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,419),2,4,56,1,741,H)
C         Coefficient construction for loop diagram with ID 230
          CALL FFS1_3L3_1(PL(0,279),W(1,2),GC_31,GC_40,MDL_MD,ZERO
     $     ,PL(0,420),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,279),1,COEFS,1,4,WL(1,0,1
     $     ,420))
          CALL FFS2L2_3(PL(0,420),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,421),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,420),1,COEFS,4,1,WL(1,0,1
     $     ,421))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,421),2,1,57,1,742,H)
C         Coefficient construction for loop diagram with ID 231
          CALL FFV2L2_3(PL(0,107),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,422)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,107),4,COEFS,4,4,WL(1,0,1
     $     ,422))
          CALL FFV2L3_1(PL(0,422),W(1,3),GC_124,MDL_MU,ZERO,PL(0,423)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,422),4,COEFS,4,4,WL(1,0,1
     $     ,423))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,423),4,4,58,1,743,H)
C         Coefficient construction for loop diagram with ID 232
          CALL FFV2L3_1(PL(0,283),W(1,2),GC_59,MDL_MD,ZERO,PL(0,424)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,283),1,COEFS,4,4,WL(1,0,1
     $     ,424))
          CALL FFS4L2_3(PL(0,424),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,425),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,424),1,COEFS,4,1,WL(1,0,1
     $     ,425))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,425),4,1,59,1,744,H)
C         Coefficient construction for loop diagram with ID 233
          CALL FFS1_3L2_3(PL(0,107),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,426),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,107),4,COEFS,4,1,WL(1,0,1
     $     ,426))
          CALL FFS1_3L3_1(PL(0,426),W(1,3),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,427),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,426),4,COEFS,1,4,WL(1,0,1
     $     ,427))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,427),2,4,58,1,745,H)
C         Coefficient construction for loop diagram with ID 234
          CALL FFS1_3L3_1(PL(0,285),W(1,2),GC_31,GC_40,MDL_MD,ZERO
     $     ,PL(0,428),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,285),1,COEFS,1,4,WL(1,0,1
     $     ,428))
          CALL FFS4L2_3(PL(0,428),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,429),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,428),1,COEFS,4,1,WL(1,0,1
     $     ,429))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,429),2,1,59,1,746,H)
C         Coefficient construction for loop diagram with ID 235
          CALL FFV1L1P0_3(PL(0,67),W(1,3),GC_1,ZERO,ZERO,PL(0,430)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,67),4,COEFS,4,4,WL(1,0,1
     $     ,430))
          CALL FFV1L3_1(PL(0,430),W(1,2),GC_2,MDL_MU,ZERO,PL(0,431)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,430),4,COEFS,4,4,WL(1,0,1
     $     ,431))
          CALL FFV2L2_3(PL(0,431),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,432)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,431),4,COEFS,4,4,WL(1,0,1
     $     ,432))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,432),4,4,15,1,747,H)
C         Coefficient construction for loop diagram with ID 236
          CALL FFV1L1P0_3(PL(0,71),W(1,3),GC_1,ZERO,ZERO,PL(0,433)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,71),1,COEFS,4,4,WL(1,0,1
     $     ,433))
          CALL FFV1L3_1(PL(0,433),W(1,2),GC_2,MDL_MU,ZERO,PL(0,434)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,433),1,COEFS,4,4,WL(1,0,1
     $     ,434))
          CALL FFS1_3L2_3(PL(0,434),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,435),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,434),1,COEFS,4,1,WL(1,0,1
     $     ,435))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,435),2,1,15,1,748,H)
C         Coefficient construction for loop diagram with ID 237
          CALL FFV2_3L1_3(PL(0,67),W(1,3),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,436),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,67),4,COEFS,4,4,WL(1,0,1
     $     ,436))
          CALL FFV2_5L3_1(PL(0,436),W(1,2),GC_69,GC_76,MDL_MU,ZERO
     $     ,PL(0,437),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,436),4,COEFS,4,4,WL(1,0,1
     $     ,437))
          CALL FFV2L2_3(PL(0,437),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,438)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_2(WL(1,0,1,437),4,COEFS,4,4,WL(1,0,1
     $     ,438))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,438),6,4,60,1,749,H)
C         Coefficient construction for loop diagram with ID 238
          CALL FFV2_3L1_3(PL(0,71),W(1,3),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,439),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,71),1,COEFS,4,4,WL(1,0,1
     $     ,439))
          CALL FFV2_5L3_1(PL(0,439),W(1,2),GC_69,GC_76,MDL_MU,ZERO
     $     ,PL(0,440),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,439),1,COEFS,4,4,WL(1,0,1
     $     ,440))
          CALL FFS1_3L2_3(PL(0,440),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,441),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,440),1,COEFS,4,1,WL(1,0,1
     $     ,441))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,441),4,1,60,1,750,H)
C         Coefficient construction for loop diagram with ID 239
          CALL FFS2L1_3(PL(0,67),W(1,3),GC_104,MDL_MZ,MDL_WZ,PL(0,442)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,67),4,COEFS,4,1,WL(1,0,1
     $     ,442))
          CALL FFS2L3_1(PL(0,442),W(1,2),GC_123,MDL_MU,ZERO,PL(0,443)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,442),4,COEFS,1,4,WL(1,0,1
     $     ,443))
          CALL FFV2L2_3(PL(0,443),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,444)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,443),4,COEFS,4,4,WL(1,0,1
     $     ,444))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,444),4,4,60,1,751,H)
C         Coefficient construction for loop diagram with ID 240
          CALL FFS2L1_3(PL(0,71),W(1,3),GC_104,MDL_MZ,MDL_WZ,PL(0,445)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,71),1,COEFS,4,1,WL(1,0,1
     $     ,445))
          CALL FFS2L3_1(PL(0,445),W(1,2),GC_123,MDL_MU,ZERO,PL(0,446)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,445),1,COEFS,1,4,WL(1,0,1
     $     ,446))
          CALL FFS1_3L2_3(PL(0,446),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,447),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,446),1,COEFS,4,1,WL(1,0,1
     $     ,447))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,447),2,1,60,1,752,H)
C         Coefficient construction for loop diagram with ID 241
          CALL FFS4L1_3(PL(0,67),W(1,3),GC_105,MDL_MH,MDL_WH,PL(0,448)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,67),4,COEFS,4,1,WL(1,0,1
     $     ,448))
          CALL FFS4L3_1(PL(0,448),W(1,2),GC_122,MDL_MU,ZERO,PL(0,449)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,448),4,COEFS,1,4,WL(1,0,1
     $     ,449))
          CALL FFV2L2_3(PL(0,449),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,450)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,449),4,COEFS,4,4,WL(1,0,1
     $     ,450))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,450),4,4,61,1,753,H)
C         Coefficient construction for loop diagram with ID 242
          CALL FFS4L1_3(PL(0,71),W(1,3),GC_105,MDL_MH,MDL_WH,PL(0,451)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,71),1,COEFS,4,1,WL(1,0,1
     $     ,451))
          CALL FFS4L3_1(PL(0,451),W(1,2),GC_122,MDL_MU,ZERO,PL(0,452)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,451),1,COEFS,1,4,WL(1,0,1
     $     ,452))
          CALL FFS1_3L2_3(PL(0,452),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,453),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,452),1,COEFS,4,1,WL(1,0,1
     $     ,453))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,453),2,1,61,1,754,H)
C         Coefficient construction for loop diagram with ID 243
          CALL FFV2L1_3(PL(0,67),W(1,2),GC_59,MDL_MW,MDL_WW,PL(0,454)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,67),4,COEFS,4,4,WL(1,0,1
     $     ,454))
          CALL FFV2L3_1(PL(0,454),W(1,3),GC_124,MDL_MU,ZERO,PL(0,455)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,454),4,COEFS,4,4,WL(1,0,1
     $     ,455))
          CALL FFV2L2_3(PL(0,455),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,456)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_2(WL(1,0,1,455),4,COEFS,4,4,WL(1,0,1
     $     ,456))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,456),6,4,62,1,755,H)
C         Coefficient construction for loop diagram with ID 244
          CALL FFV2L3_2(PL(0,0),W(1,1),GC_125,MDL_MS,ZERO,PL(0,457)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,457))
          CALL FFV2L1_3(PL(0,457),W(1,2),GC_60,MDL_MW,MDL_WW,PL(0,458)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,457),4,COEFS,4,4,WL(1,0,1
     $     ,458))
          CALL FFV2L3_1(PL(0,458),W(1,3),GC_124,MDL_MU,ZERO,PL(0,459)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,458),4,COEFS,4,4,WL(1,0,1
     $     ,459))
          CALL FFV2L2_3(PL(0,459),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,460)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_2(WL(1,0,1,459),4,COEFS,4,4,WL(1,0,1
     $     ,460))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,460),6,4,63,1,756,H)
C         Coefficient construction for loop diagram with ID 245
          CALL FFV2L3_2(PL(0,0),W(1,1),GC_126,MDL_MB,ZERO,PL(0,461)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,461))
          CALL FFV2L1_3(PL(0,461),W(1,2),GC_61,MDL_MW,MDL_WW,PL(0,462)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,461),4,COEFS,4,4,WL(1,0,1
     $     ,462))
          CALL FFV2L3_1(PL(0,462),W(1,3),GC_124,MDL_MU,ZERO,PL(0,463)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,462),4,COEFS,4,4,WL(1,0,1
     $     ,463))
          CALL FFV2L2_3(PL(0,463),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,464)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_2(WL(1,0,1,463),4,COEFS,4,4,WL(1,0,1
     $     ,464))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,464),6,4,64,1,757,H)
C         Coefficient construction for loop diagram with ID 246
          CALL FFV2L1_3(PL(0,71),W(1,2),GC_59,MDL_MW,MDL_WW,PL(0,465)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,71),1,COEFS,4,4,WL(1,0,1
     $     ,465))
          CALL FFV2L3_1(PL(0,465),W(1,3),GC_124,MDL_MU,ZERO,PL(0,466)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,465),1,COEFS,4,4,WL(1,0,1
     $     ,466))
          CALL FFS1_3L2_3(PL(0,466),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,467),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,466),1,COEFS,4,1,WL(1,0,1
     $     ,467))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,467),4,1,62,1,758,H)
C         Coefficient construction for loop diagram with ID 247
          CALL FFS1_3L3_2(PL(0,0),W(1,1),GC_16,GC_25,MDL_MS,ZERO,PL(0
     $     ,468),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,4,WL(1,0,1
     $     ,468))
          CALL FFV2L1_3(PL(0,468),W(1,2),GC_60,MDL_MW,MDL_WW,PL(0,469)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,468),1,COEFS,4,4,WL(1,0,1
     $     ,469))
          CALL FFV2L3_1(PL(0,469),W(1,3),GC_124,MDL_MU,ZERO,PL(0,470)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,469),1,COEFS,4,4,WL(1,0,1
     $     ,470))
          CALL FFS1_3L2_3(PL(0,470),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,471),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,470),1,COEFS,4,1,WL(1,0,1
     $     ,471))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,471),4,1,63,1,759,H)
C         Coefficient construction for loop diagram with ID 248
          CALL FFS1_3L3_2(PL(0,0),W(1,1),GC_19,GC_28,MDL_MB,ZERO,PL(0
     $     ,472),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,4,WL(1,0,1
     $     ,472))
          CALL FFV2L1_3(PL(0,472),W(1,2),GC_61,MDL_MW,MDL_WW,PL(0,473)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,472),1,COEFS,4,4,WL(1,0,1
     $     ,473))
          CALL FFV2L3_1(PL(0,473),W(1,3),GC_124,MDL_MU,ZERO,PL(0,474)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,473),1,COEFS,4,4,WL(1,0,1
     $     ,474))
          CALL FFS1_3L2_3(PL(0,474),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,475),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,474),1,COEFS,4,1,WL(1,0,1
     $     ,475))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,475),4,1,64,1,760,H)
C         Coefficient construction for loop diagram with ID 249
          CALL FFS1_3L1_3(PL(0,67),W(1,2),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,476),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,67),4,COEFS,4,1,WL(1,0,1
     $     ,476))
          CALL FFS1_3L3_1(PL(0,476),W(1,3),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,477),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,476),4,COEFS,1,4,WL(1,0,1
     $     ,477))
          CALL FFV2L2_3(PL(0,477),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,478)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,477),4,COEFS,4,4,WL(1,0,1
     $     ,478))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,478),4,4,62,1,761,H)
C         Coefficient construction for loop diagram with ID 250
          CALL FFS1_3L1_3(PL(0,457),W(1,2),GC_32,GC_41,MDL_MW,MDL_WW
     $     ,PL(0,479),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,457),4,COEFS,4,1,WL(1,0,1
     $     ,479))
          CALL FFS1_3L3_1(PL(0,479),W(1,3),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,480),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,479),4,COEFS,1,4,WL(1,0,1
     $     ,480))
          CALL FFV2L2_3(PL(0,480),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,481)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,480),4,COEFS,4,4,WL(1,0,1
     $     ,481))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,481),4,4,63,1,762,H)
C         Coefficient construction for loop diagram with ID 251
          CALL FFS1_3L1_3(PL(0,461),W(1,2),GC_33,GC_42,MDL_MW,MDL_WW
     $     ,PL(0,482),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,461),4,COEFS,4,1,WL(1,0,1
     $     ,482))
          CALL FFS1_3L3_1(PL(0,482),W(1,3),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,483),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,482),4,COEFS,1,4,WL(1,0,1
     $     ,483))
          CALL FFV2L2_3(PL(0,483),W(1,4),GC_59,MDL_MW,MDL_WW,PL(0,484)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,483),4,COEFS,4,4,WL(1,0,1
     $     ,484))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,484),4,4,64,1,763,H)
C         Coefficient construction for loop diagram with ID 252
          CALL FFS1_3L1_3(PL(0,71),W(1,2),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,485),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,71),1,COEFS,4,1,WL(1,0,1
     $     ,485))
          CALL FFS1_3L3_1(PL(0,485),W(1,3),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,486),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,485),1,COEFS,1,4,WL(1,0,1
     $     ,486))
          CALL FFS1_3L2_3(PL(0,486),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,487),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,486),1,COEFS,4,1,WL(1,0,1
     $     ,487))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,487),2,1,62,1,764,H)
C         Coefficient construction for loop diagram with ID 253
          CALL FFS1_3L1_3(PL(0,468),W(1,2),GC_32,GC_41,MDL_MW,MDL_WW
     $     ,PL(0,488),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,468),1,COEFS,4,1,WL(1,0,1
     $     ,488))
          CALL FFS1_3L3_1(PL(0,488),W(1,3),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,489),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,488),1,COEFS,1,4,WL(1,0,1
     $     ,489))
          CALL FFS1_3L2_3(PL(0,489),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,490),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,489),1,COEFS,4,1,WL(1,0,1
     $     ,490))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,490),2,1,63,1,765,H)
C         Coefficient construction for loop diagram with ID 254
          CALL FFS1_3L1_3(PL(0,472),W(1,2),GC_33,GC_42,MDL_MW,MDL_WW
     $     ,PL(0,491),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,472),1,COEFS,4,1,WL(1,0,1
     $     ,491))
          CALL FFS1_3L3_1(PL(0,491),W(1,3),GC_13,GC_22,MDL_MU,ZERO
     $     ,PL(0,492),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,491),1,COEFS,1,4,WL(1,0,1
     $     ,492))
          CALL FFS1_3L2_3(PL(0,492),W(1,4),GC_31,GC_40,MDL_MW,MDL_WW
     $     ,PL(0,493),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,492),1,COEFS,4,1,WL(1,0,1
     $     ,493))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,493),2,1,64,1,766,H)
C         Coefficient construction for loop diagram with ID 255
          CALL FFV1L2_1(PL(0,0),W(1,6),GC_2,MDL_MC,ZERO,PL(0,494)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,494))
          CALL FFV1L2_1(PL(0,494),W(1,14),GC_2,MDL_MC,ZERO,PL(0,495)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,494),4,COEFS,4,4,WL(1,0,1
     $     ,495))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,495),2,4,65,1,767,H)
C         Coefficient construction for loop diagram with ID 256
          CALL FFV2_5L2_1(PL(0,494),W(1,15),GC_69,GC_76,MDL_MC,ZERO
     $     ,PL(0,496),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,494),4,COEFS,4,4,WL(1,0,1
     $     ,496))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,496),2,4,65,1,768,H)
C         Coefficient construction for loop diagram with ID 257
          CALL FFS2L2_1(PL(0,494),W(1,16),GC_103,MDL_MC,ZERO,PL(0,497)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,494),4,COEFS,4,4,WL(1,0,1
     $     ,497))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,497),2,4,65,1,769,H)
C         Coefficient construction for loop diagram with ID 258
          CALL FFS4L2_1(PL(0,494),W(1,17),GC_102,MDL_MC,ZERO,PL(0,498)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,494),4,COEFS,4,4,WL(1,0,1
     $     ,498))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,498),2,4,65,1,770,H)
C         Coefficient construction for loop diagram with ID 259
          CALL FFV2_5L2_1(PL(0,0),W(1,7),GC_69,GC_76,MDL_MC,ZERO,PL(0
     $     ,499),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,499))
          CALL FFV1L2_1(PL(0,499),W(1,14),GC_2,MDL_MC,ZERO,PL(0,500)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,499),4,COEFS,4,4,WL(1,0,1
     $     ,500))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,500),2,4,65,1,771,H)
C         Coefficient construction for loop diagram with ID 260
          CALL FFV2_5L2_1(PL(0,499),W(1,15),GC_69,GC_76,MDL_MC,ZERO
     $     ,PL(0,501),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,499),4,COEFS,4,4,WL(1,0,1
     $     ,501))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,501),2,4,65,1,772,H)
C         Coefficient construction for loop diagram with ID 261
          CALL FFS2L2_1(PL(0,499),W(1,16),GC_103,MDL_MC,ZERO,PL(0,502)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,499),4,COEFS,4,4,WL(1,0,1
     $     ,502))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,502),2,4,65,1,773,H)
C         Coefficient construction for loop diagram with ID 262
          CALL FFS4L2_1(PL(0,499),W(1,17),GC_102,MDL_MC,ZERO,PL(0,503)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,499),4,COEFS,4,4,WL(1,0,1
     $     ,503))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,503),2,4,65,1,774,H)
C         Coefficient construction for loop diagram with ID 263
          CALL FFS2L2_1(PL(0,0),W(1,8),GC_103,MDL_MC,ZERO,PL(0,504)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,504))
          CALL FFV1L2_1(PL(0,504),W(1,14),GC_2,MDL_MC,ZERO,PL(0,505)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,504),4,COEFS,4,4,WL(1,0,1
     $     ,505))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,505),2,4,65,1,775,H)
C         Coefficient construction for loop diagram with ID 264
          CALL FFV2_5L2_1(PL(0,504),W(1,15),GC_69,GC_76,MDL_MC,ZERO
     $     ,PL(0,506),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,504),4,COEFS,4,4,WL(1,0,1
     $     ,506))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,506),2,4,65,1,776,H)
C         Coefficient construction for loop diagram with ID 265
          CALL FFS2L2_1(PL(0,504),W(1,16),GC_103,MDL_MC,ZERO,PL(0,507)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,504),4,COEFS,4,4,WL(1,0,1
     $     ,507))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,507),2,4,65,1,777,H)
C         Coefficient construction for loop diagram with ID 266
          CALL FFS4L2_1(PL(0,504),W(1,17),GC_102,MDL_MC,ZERO,PL(0,508)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,504),4,COEFS,4,4,WL(1,0,1
     $     ,508))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,508),2,4,65,1,778,H)
C         Coefficient construction for loop diagram with ID 267
          CALL FFS4L2_1(PL(0,0),W(1,9),GC_102,MDL_MC,ZERO,PL(0,509)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,509))
          CALL FFV1L2_1(PL(0,509),W(1,14),GC_2,MDL_MC,ZERO,PL(0,510)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,509),4,COEFS,4,4,WL(1,0,1
     $     ,510))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,510),2,4,65,1,779,H)
C         Coefficient construction for loop diagram with ID 268
          CALL FFV2_5L2_1(PL(0,509),W(1,15),GC_69,GC_76,MDL_MC,ZERO
     $     ,PL(0,511),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,509),4,COEFS,4,4,WL(1,0,1
     $     ,511))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,511),2,4,65,1,780,H)
C         Coefficient construction for loop diagram with ID 269
          CALL FFS2L2_1(PL(0,509),W(1,16),GC_103,MDL_MC,ZERO,PL(0,512)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,509),4,COEFS,4,4,WL(1,0,1
     $     ,512))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,512),2,4,65,1,781,H)
C         Coefficient construction for loop diagram with ID 270
          CALL FFS4L2_1(PL(0,509),W(1,17),GC_102,MDL_MC,ZERO,PL(0,513)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,509),4,COEFS,4,4,WL(1,0,1
     $     ,513))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,513),2,4,65,1,782,H)
C         Coefficient construction for loop diagram with ID 271
          CALL FFV1L1_2(PL(0,110),W(1,6),GC_2,MDL_MC,ZERO,PL(0,514)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,110),4,COEFS,4,4,WL(1,0,1
     $     ,514))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,514),4,4,22,1,783,H)
C         Coefficient construction for loop diagram with ID 272
          CALL FFV1L1_2(PL(0,113),W(1,6),GC_2,MDL_MC,ZERO,PL(0,515)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,113),4,COEFS,4,4,WL(1,0,1
     $     ,515))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,515),2,4,22,1,784,H)
C         Coefficient construction for loop diagram with ID 273
          CALL FFV2_5L1_2(PL(0,110),W(1,7),GC_69,GC_76,MDL_MC,ZERO
     $     ,PL(0,516),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,110),4,COEFS,4,4,WL(1,0,1
     $     ,516))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,516),4,4,22,1,785,H)
C         Coefficient construction for loop diagram with ID 274
          CALL FFV2_5L1_2(PL(0,113),W(1,7),GC_69,GC_76,MDL_MC,ZERO
     $     ,PL(0,517),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,113),4,COEFS,4,4,WL(1,0,1
     $     ,517))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,517),2,4,22,1,786,H)
C         Coefficient construction for loop diagram with ID 275
          CALL FFS2L1_2(PL(0,110),W(1,8),GC_103,MDL_MC,ZERO,PL(0,518)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,110),4,COEFS,4,4,WL(1,0,1
     $     ,518))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,518),4,4,22,1,787,H)
C         Coefficient construction for loop diagram with ID 276
          CALL FFS2L1_2(PL(0,113),W(1,8),GC_103,MDL_MC,ZERO,PL(0,519)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,113),4,COEFS,4,4,WL(1,0,1
     $     ,519))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,519),2,4,22,1,788,H)
C         Coefficient construction for loop diagram with ID 277
          CALL FFS4L1_2(PL(0,110),W(1,9),GC_102,MDL_MC,ZERO,PL(0,520)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,110),4,COEFS,4,4,WL(1,0,1
     $     ,520))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,520),4,4,22,1,789,H)
C         Coefficient construction for loop diagram with ID 278
          CALL FFS4L1_2(PL(0,113),W(1,9),GC_102,MDL_MC,ZERO,PL(0,521)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,113),4,COEFS,4,4,WL(1,0,1
     $     ,521))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,521),2,4,22,1,790,H)
C         Coefficient construction for loop diagram with ID 279
          CALL FFV2L3_1(PL(0,0),W(1,3),GC_127,MDL_MC,ZERO,PL(0,522)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,522))
          CALL FFV2L2_3(PL(0,522),W(1,4),GC_62,MDL_MW,MDL_WW,PL(0,523)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,522),4,COEFS,4,4,WL(1,0,1
     $     ,523))
          CALL VVV1L3_2(PL(0,523),W(1,6),GC_4,MDL_MW,MDL_WW,PL(0,524)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,523),4,COEFS,4,4,WL(1,0,1
     $     ,524))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,524),5,4,66,1,791,H)
C         Coefficient construction for loop diagram with ID 280
          CALL FFS1_3L2_3(PL(0,522),W(1,4),GC_34,GC_43,MDL_MW,MDL_WW
     $     ,PL(0,525),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,522),4,COEFS,4,1,WL(1,0,1
     $     ,525))
          CALL VVS1L3_2(PL(0,525),W(1,6),GC_92,MDL_MW,MDL_WW,PL(0,526)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,525),4,COEFS,1,4,WL(1,0,1
     $     ,526))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,526),2,4,66,1,792,H)
C         Coefficient construction for loop diagram with ID 281
          CALL FFS1_3L3_1(PL(0,0),W(1,3),GC_14,GC_23,MDL_MC,ZERO,PL(0
     $     ,527),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,4,WL(1,0,1
     $     ,527))
          CALL FFV2L2_3(PL(0,527),W(1,4),GC_62,MDL_MW,MDL_WW,PL(0,528)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,527),1,COEFS,4,4,WL(1,0,1
     $     ,528))
          CALL VVS1L2_3(PL(0,528),W(1,6),GC_93,MDL_MW,MDL_WW,PL(0,529)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,528),1,COEFS,4,1,WL(1,0,1
     $     ,529))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,529),3,1,66,1,793,H)
C         Coefficient construction for loop diagram with ID 282
          CALL FFS1_3L2_3(PL(0,527),W(1,4),GC_34,GC_43,MDL_MW,MDL_WW
     $     ,PL(0,530),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,527),1,COEFS,4,1,WL(1,0,1
     $     ,530))
          CALL VSS1L3_2(PL(0,530),W(1,6),GC_3,MDL_MW,MDL_WW,PL(0,531)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,530),1,COEFS,1,1,WL(1,0,1
     $     ,531))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,531),2,1,66,1,794,H)
C         Coefficient construction for loop diagram with ID 283
          CALL VVV1L2_1(PL(0,523),W(1,7),GC_71,MDL_MW,MDL_WW,PL(0,532)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,523),4,COEFS,4,4,WL(1,0,1
     $     ,532))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,532),5,4,66,1,795,H)
C         Coefficient construction for loop diagram with ID 284
          CALL VVS1L3_1(PL(0,525),W(1,7),GC_85,MDL_MW,MDL_WW,PL(0,533)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,525),4,COEFS,1,4,WL(1,0,1
     $     ,533))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,533),2,4,66,1,796,H)
C         Coefficient construction for loop diagram with ID 285
          CALL VVS1L1_3(PL(0,528),W(1,7),GC_84,MDL_MW,MDL_WW,PL(0,534)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,528),1,COEFS,4,1,WL(1,0,1
     $     ,534))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,534),3,1,66,1,797,H)
C         Coefficient construction for loop diagram with ID 286
          CALL VSS1L3_2(PL(0,530),W(1,7),GC_79,MDL_MW,MDL_WW,PL(0,535)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,530),1,COEFS,1,1,WL(1,0,1
     $     ,535))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,535),2,1,66,1,798,H)
C         Coefficient construction for loop diagram with ID 287
          CALL VSS1L3_1(PL(0,525),W(1,8),GC_57,MDL_MW,MDL_WW,PL(0,536)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,525),4,COEFS,1,4,WL(1,0,1
     $     ,536))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,536),4,4,66,1,799,H)
C         Coefficient construction for loop diagram with ID 288
          CALL VSS1L1_3(PL(0,528),W(1,8),GC_56,MDL_MW,MDL_WW,PL(0,537)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,528),1,COEFS,4,1,WL(1,0,1
     $     ,537))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,537),4,1,66,1,800,H)
C         Coefficient construction for loop diagram with ID 289
          CALL VVS1L2_1(PL(0,523),W(1,9),GC_90,MDL_MW,MDL_WW,PL(0,538)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,523),4,COEFS,4,4,WL(1,0,1
     $     ,538))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,538),5,4,66,1,801,H)
C         Coefficient construction for loop diagram with ID 290
          CALL VSS1L2_1(PL(0,525),W(1,9),GC_55,MDL_MW,MDL_WW,PL(0,539)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,525),4,COEFS,1,4,WL(1,0,1
     $     ,539))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,539),4,4,66,1,802,H)
C         Coefficient construction for loop diagram with ID 291
          CALL VSS1L1_2(PL(0,528),W(1,9),GC_55,MDL_MW,MDL_WW,PL(0,540)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,528),1,COEFS,4,1,WL(1,0,1
     $     ,540))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,540),4,1,66,1,803,H)
C         Coefficient construction for loop diagram with ID 292
          CALL SSS1L2_1(PL(0,530),W(1,9),GC_86,MDL_MW,MDL_WW,PL(0,541)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,530),1,COEFS,1,1,WL(1,0,1
     $     ,541))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,541),1,1,66,1,804,H)
C         Coefficient construction for loop diagram with ID 293
          CALL FFV2L1_2(PL(0,0),W(1,10),GC_62,MDL_MC,ZERO,PL(0,542)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,542))
          CALL FFV2L1_2(PL(0,542),W(1,12),GC_127,MDL_MD,ZERO,PL(0,543)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,542),4,COEFS,4,4,WL(1,0,1
     $     ,543))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,543),2,4,67,1,805,H)
C         Coefficient construction for loop diagram with ID 294
          CALL FFV2L1_2(PL(0,0),W(1,10),GC_63,MDL_MC,ZERO,PL(0,544)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,544))
          CALL FFV2L1_2(PL(0,544),W(1,12),GC_128,MDL_MS,ZERO,PL(0,545)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,544),4,COEFS,4,4,WL(1,0,1
     $     ,545))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,545),2,4,68,1,806,H)
C         Coefficient construction for loop diagram with ID 295
          CALL FFV2L2_1(PL(0,0),W(1,10),GC_64,MDL_MB,ZERO,PL(0,546)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,546))
          CALL FFV2L2_1(PL(0,546),W(1,12),GC_129,MDL_MC,ZERO,PL(0,547)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,546),4,COEFS,4,4,WL(1,0,1
     $     ,547))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,547),2,4,69,1,807,H)
C         Coefficient construction for loop diagram with ID 296
          CALL FFS1_3L1_2(PL(0,542),W(1,13),GC_14,GC_23,MDL_MD,ZERO
     $     ,PL(0,548),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,542),4,COEFS,4,4,WL(1,0,1
     $     ,548))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,548),2,4,67,1,808,H)
C         Coefficient construction for loop diagram with ID 297
          CALL FFS1_3L1_2(PL(0,544),W(1,13),GC_17,GC_26,MDL_MS,ZERO
     $     ,PL(0,549),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,544),4,COEFS,4,4,WL(1,0,1
     $     ,549))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,549),2,4,68,1,809,H)
C         Coefficient construction for loop diagram with ID 298
          CALL FFS1_3L2_1(PL(0,546),W(1,13),GC_20,GC_29,MDL_MC,ZERO
     $     ,PL(0,550),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,546),4,COEFS,4,4,WL(1,0,1
     $     ,550))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,550),2,4,69,1,810,H)
C         Coefficient construction for loop diagram with ID 299
          CALL FFS1_3L1_2(PL(0,0),W(1,11),GC_34,GC_43,MDL_MC,ZERO,PL(0
     $     ,551),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,551))
          CALL FFV2L1_2(PL(0,551),W(1,12),GC_127,MDL_MD,ZERO,PL(0,552)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,551),4,COEFS,4,4,WL(1,0,1
     $     ,552))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,552),2,4,67,1,811,H)
C         Coefficient construction for loop diagram with ID 300
          CALL FFS1_3L1_2(PL(0,0),W(1,11),GC_35,GC_44,MDL_MC,ZERO,PL(0
     $     ,553),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,553))
          CALL FFV2L1_2(PL(0,553),W(1,12),GC_128,MDL_MS,ZERO,PL(0,554)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,553),4,COEFS,4,4,WL(1,0,1
     $     ,554))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,554),2,4,68,1,812,H)
C         Coefficient construction for loop diagram with ID 301
          CALL FFS1_3L2_1(PL(0,0),W(1,11),GC_36,GC_45,MDL_MB,ZERO,PL(0
     $     ,555),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,555))
          CALL FFV2L2_1(PL(0,555),W(1,12),GC_129,MDL_MC,ZERO,PL(0,556)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,555),4,COEFS,4,4,WL(1,0,1
     $     ,556))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,556),2,4,69,1,813,H)
C         Coefficient construction for loop diagram with ID 302
          CALL FFS1_3L1_2(PL(0,551),W(1,13),GC_14,GC_23,MDL_MD,ZERO
     $     ,PL(0,557),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,551),4,COEFS,4,4,WL(1,0,1
     $     ,557))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,557),2,4,67,1,814,H)
C         Coefficient construction for loop diagram with ID 303
          CALL FFS1_3L1_2(PL(0,553),W(1,13),GC_17,GC_26,MDL_MS,ZERO
     $     ,PL(0,558),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,553),4,COEFS,4,4,WL(1,0,1
     $     ,558))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,558),2,4,68,1,815,H)
C         Coefficient construction for loop diagram with ID 304
          CALL FFS1_3L2_1(PL(0,555),W(1,13),GC_20,GC_29,MDL_MC,ZERO
     $     ,PL(0,559),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,555),4,COEFS,4,4,WL(1,0,1
     $     ,559))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,559),2,4,69,1,816,H)
C         Coefficient construction for loop diagram with ID 305
          CALL FFV2L3_1(PL(0,454),W(1,3),GC_127,MDL_MC,ZERO,PL(0,560)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,454),4,COEFS,4,4,WL(1,0,1
     $     ,560))
          CALL FFV2L2_3(PL(0,560),W(1,4),GC_62,MDL_MW,MDL_WW,PL(0,561)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_2(WL(1,0,1,560),4,COEFS,4,4,WL(1,0,1
     $     ,561))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,561),6,4,70,1,817,H)
C         Coefficient construction for loop diagram with ID 306
          CALL FFV2L3_1(PL(0,458),W(1,3),GC_127,MDL_MC,ZERO,PL(0,562)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,458),4,COEFS,4,4,WL(1,0,1
     $     ,562))
          CALL FFV2L2_3(PL(0,562),W(1,4),GC_62,MDL_MW,MDL_WW,PL(0,563)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_2(WL(1,0,1,562),4,COEFS,4,4,WL(1,0,1
     $     ,563))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,563),6,4,71,1,818,H)
C         Coefficient construction for loop diagram with ID 307
          CALL FFV2L3_1(PL(0,462),W(1,3),GC_127,MDL_MC,ZERO,PL(0,564)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,462),4,COEFS,4,4,WL(1,0,1
     $     ,564))
          CALL FFV2L2_3(PL(0,564),W(1,4),GC_62,MDL_MW,MDL_WW,PL(0,565)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_2(WL(1,0,1,564),4,COEFS,4,4,WL(1,0,1
     $     ,565))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,565),6,4,72,1,819,H)
C         Coefficient construction for loop diagram with ID 308
          CALL FFV2L3_1(PL(0,465),W(1,3),GC_127,MDL_MC,ZERO,PL(0,566)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,465),1,COEFS,4,4,WL(1,0,1
     $     ,566))
          CALL FFS1_3L2_3(PL(0,566),W(1,4),GC_34,GC_43,MDL_MW,MDL_WW
     $     ,PL(0,567),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,566),1,COEFS,4,1,WL(1,0,1
     $     ,567))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,567),4,1,70,1,820,H)
C         Coefficient construction for loop diagram with ID 309
          CALL FFV2L3_1(PL(0,469),W(1,3),GC_127,MDL_MC,ZERO,PL(0,568)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,469),1,COEFS,4,4,WL(1,0,1
     $     ,568))
          CALL FFS1_3L2_3(PL(0,568),W(1,4),GC_34,GC_43,MDL_MW,MDL_WW
     $     ,PL(0,569),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,568),1,COEFS,4,1,WL(1,0,1
     $     ,569))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,569),4,1,71,1,821,H)
C         Coefficient construction for loop diagram with ID 310
          CALL FFV2L3_1(PL(0,473),W(1,3),GC_127,MDL_MC,ZERO,PL(0,570)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,473),1,COEFS,4,4,WL(1,0,1
     $     ,570))
          CALL FFS1_3L2_3(PL(0,570),W(1,4),GC_34,GC_43,MDL_MW,MDL_WW
     $     ,PL(0,571),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,570),1,COEFS,4,1,WL(1,0,1
     $     ,571))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,571),4,1,72,1,822,H)
C         Coefficient construction for loop diagram with ID 311
          CALL FFS1_3L3_1(PL(0,476),W(1,3),GC_14,GC_23,MDL_MC,ZERO
     $     ,PL(0,572),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,476),4,COEFS,1,4,WL(1,0,1
     $     ,572))
          CALL FFV2L2_3(PL(0,572),W(1,4),GC_62,MDL_MW,MDL_WW,PL(0,573)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,572),4,COEFS,4,4,WL(1,0,1
     $     ,573))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,573),4,4,70,1,823,H)
C         Coefficient construction for loop diagram with ID 312
          CALL FFS1_3L3_1(PL(0,479),W(1,3),GC_14,GC_23,MDL_MC,ZERO
     $     ,PL(0,574),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,479),4,COEFS,1,4,WL(1,0,1
     $     ,574))
          CALL FFV2L2_3(PL(0,574),W(1,4),GC_62,MDL_MW,MDL_WW,PL(0,575)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,574),4,COEFS,4,4,WL(1,0,1
     $     ,575))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,575),4,4,71,1,824,H)
C         Coefficient construction for loop diagram with ID 313
          CALL FFS1_3L3_1(PL(0,482),W(1,3),GC_14,GC_23,MDL_MC,ZERO
     $     ,PL(0,576),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,482),4,COEFS,1,4,WL(1,0,1
     $     ,576))
          CALL FFV2L2_3(PL(0,576),W(1,4),GC_62,MDL_MW,MDL_WW,PL(0,577)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,576),4,COEFS,4,4,WL(1,0,1
     $     ,577))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,577),4,4,72,1,825,H)
C         Coefficient construction for loop diagram with ID 314
          CALL FFS1_3L3_1(PL(0,485),W(1,3),GC_14,GC_23,MDL_MC,ZERO
     $     ,PL(0,578),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,485),1,COEFS,1,4,WL(1,0,1
     $     ,578))
          CALL FFS1_3L2_3(PL(0,578),W(1,4),GC_34,GC_43,MDL_MW,MDL_WW
     $     ,PL(0,579),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,578),1,COEFS,4,1,WL(1,0,1
     $     ,579))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,579),2,1,70,1,826,H)
C         Coefficient construction for loop diagram with ID 315
          CALL FFS1_3L3_1(PL(0,488),W(1,3),GC_14,GC_23,MDL_MC,ZERO
     $     ,PL(0,580),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,488),1,COEFS,1,4,WL(1,0,1
     $     ,580))
          CALL FFS1_3L2_3(PL(0,580),W(1,4),GC_34,GC_43,MDL_MW,MDL_WW
     $     ,PL(0,581),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,580),1,COEFS,4,1,WL(1,0,1
     $     ,581))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,581),2,1,71,1,827,H)
C         Coefficient construction for loop diagram with ID 316
          CALL FFS1_3L3_1(PL(0,491),W(1,3),GC_14,GC_23,MDL_MC,ZERO
     $     ,PL(0,582),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,491),1,COEFS,1,4,WL(1,0,1
     $     ,582))
          CALL FFS1_3L2_3(PL(0,582),W(1,4),GC_34,GC_43,MDL_MW,MDL_WW
     $     ,PL(0,583),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,582),1,COEFS,4,1,WL(1,0,1
     $     ,583))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,583),2,1,72,1,828,H)
C         Coefficient construction for loop diagram with ID 317
          CALL FFV1L2_1(PL(0,0),W(1,6),GC_2,MDL_MT,MDL_WT,PL(0,584)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,584))
          CALL FFV1L2_1(PL(0,584),W(1,14),GC_2,MDL_MT,MDL_WT,PL(0,585)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,584),4,COEFS,4,4,WL(1,0,1
     $     ,585))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,585),2,4,73,1,829,H)
C         Coefficient construction for loop diagram with ID 318
          CALL FFV2_5L2_1(PL(0,584),W(1,15),GC_69,GC_76,MDL_MT,MDL_WT
     $     ,PL(0,586),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,584),4,COEFS,4,4,WL(1,0,1
     $     ,586))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,586),2,4,73,1,830,H)
C         Coefficient construction for loop diagram with ID 319
          CALL FFS2L2_1(PL(0,584),W(1,16),GC_117,MDL_MT,MDL_WT,PL(0
     $     ,587),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,584),4,COEFS,4,4,WL(1,0,1
     $     ,587))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,587),2,4,73,1,831,H)
C         Coefficient construction for loop diagram with ID 320
          CALL FFS4L2_1(PL(0,584),W(1,17),GC_116,MDL_MT,MDL_WT,PL(0
     $     ,588),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,584),4,COEFS,4,4,WL(1,0,1
     $     ,588))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,588),2,4,73,1,832,H)
C         Coefficient construction for loop diagram with ID 321
          CALL FFV2_5L2_1(PL(0,0),W(1,7),GC_69,GC_76,MDL_MT,MDL_WT
     $     ,PL(0,589),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,589))
          CALL FFV1L2_1(PL(0,589),W(1,14),GC_2,MDL_MT,MDL_WT,PL(0,590)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,589),4,COEFS,4,4,WL(1,0,1
     $     ,590))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,590),2,4,73,1,833,H)
C         Coefficient construction for loop diagram with ID 322
          CALL FFV2_5L2_1(PL(0,589),W(1,15),GC_69,GC_76,MDL_MT,MDL_WT
     $     ,PL(0,591),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,589),4,COEFS,4,4,WL(1,0,1
     $     ,591))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,591),2,4,73,1,834,H)
C         Coefficient construction for loop diagram with ID 323
          CALL FFS2L2_1(PL(0,589),W(1,16),GC_117,MDL_MT,MDL_WT,PL(0
     $     ,592),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,589),4,COEFS,4,4,WL(1,0,1
     $     ,592))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,592),2,4,73,1,835,H)
C         Coefficient construction for loop diagram with ID 324
          CALL FFS4L2_1(PL(0,589),W(1,17),GC_116,MDL_MT,MDL_WT,PL(0
     $     ,593),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,589),4,COEFS,4,4,WL(1,0,1
     $     ,593))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,593),2,4,73,1,836,H)
C         Coefficient construction for loop diagram with ID 325
          CALL FFS2L2_1(PL(0,0),W(1,8),GC_117,MDL_MT,MDL_WT,PL(0,594)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,594))
          CALL FFV1L2_1(PL(0,594),W(1,14),GC_2,MDL_MT,MDL_WT,PL(0,595)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,594),4,COEFS,4,4,WL(1,0,1
     $     ,595))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,595),2,4,73,1,837,H)
C         Coefficient construction for loop diagram with ID 326
          CALL FFV2_5L2_1(PL(0,594),W(1,15),GC_69,GC_76,MDL_MT,MDL_WT
     $     ,PL(0,596),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,594),4,COEFS,4,4,WL(1,0,1
     $     ,596))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,596),2,4,73,1,838,H)
C         Coefficient construction for loop diagram with ID 327
          CALL FFS2L2_1(PL(0,594),W(1,16),GC_117,MDL_MT,MDL_WT,PL(0
     $     ,597),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,594),4,COEFS,4,4,WL(1,0,1
     $     ,597))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,597),2,4,73,1,839,H)
C         Coefficient construction for loop diagram with ID 328
          CALL FFS4L2_1(PL(0,594),W(1,17),GC_116,MDL_MT,MDL_WT,PL(0
     $     ,598),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,594),4,COEFS,4,4,WL(1,0,1
     $     ,598))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,598),2,4,73,1,840,H)
C         Coefficient construction for loop diagram with ID 329
          CALL FFS4L2_1(PL(0,0),W(1,9),GC_116,MDL_MT,MDL_WT,PL(0,599)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,599))
          CALL FFV1L2_1(PL(0,599),W(1,14),GC_2,MDL_MT,MDL_WT,PL(0,600)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,599),4,COEFS,4,4,WL(1,0,1
     $     ,600))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,600),2,4,73,1,841,H)
C         Coefficient construction for loop diagram with ID 330
          CALL FFV2_5L2_1(PL(0,599),W(1,15),GC_69,GC_76,MDL_MT,MDL_WT
     $     ,PL(0,601),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,599),4,COEFS,4,4,WL(1,0,1
     $     ,601))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,601),2,4,73,1,842,H)
C         Coefficient construction for loop diagram with ID 331
          CALL FFS2L2_1(PL(0,599),W(1,16),GC_117,MDL_MT,MDL_WT,PL(0
     $     ,602),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,599),4,COEFS,4,4,WL(1,0,1
     $     ,602))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,602),2,4,73,1,843,H)
C         Coefficient construction for loop diagram with ID 332
          CALL FFS4L2_1(PL(0,599),W(1,17),GC_116,MDL_MT,MDL_WT,PL(0
     $     ,603),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,599),4,COEFS,4,4,WL(1,0,1
     $     ,603))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,603),2,4,73,1,844,H)
C         Coefficient construction for loop diagram with ID 333
          CALL FFV1L1_2(PL(0,116),W(1,6),GC_2,MDL_MT,MDL_WT,PL(0,604)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,116),4,COEFS,4,4,WL(1,0,1
     $     ,604))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,604),4,4,23,1,845,H)
C         Coefficient construction for loop diagram with ID 334
          CALL FFV1L1_2(PL(0,119),W(1,6),GC_2,MDL_MT,MDL_WT,PL(0,605)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,119),4,COEFS,4,4,WL(1,0,1
     $     ,605))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,605),2,4,23,1,846,H)
C         Coefficient construction for loop diagram with ID 335
          CALL FFV2_5L1_2(PL(0,116),W(1,7),GC_69,GC_76,MDL_MT,MDL_WT
     $     ,PL(0,606),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,116),4,COEFS,4,4,WL(1,0,1
     $     ,606))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,606),4,4,23,1,847,H)
C         Coefficient construction for loop diagram with ID 336
          CALL FFV2_5L1_2(PL(0,119),W(1,7),GC_69,GC_76,MDL_MT,MDL_WT
     $     ,PL(0,607),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,119),4,COEFS,4,4,WL(1,0,1
     $     ,607))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,607),2,4,23,1,848,H)
C         Coefficient construction for loop diagram with ID 337
          CALL FFS2L1_2(PL(0,116),W(1,8),GC_117,MDL_MT,MDL_WT,PL(0
     $     ,608),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,116),4,COEFS,4,4,WL(1,0,1
     $     ,608))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,608),4,4,23,1,849,H)
C         Coefficient construction for loop diagram with ID 338
          CALL FFS2L1_2(PL(0,119),W(1,8),GC_117,MDL_MT,MDL_WT,PL(0
     $     ,609),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,119),4,COEFS,4,4,WL(1,0,1
     $     ,609))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,609),2,4,23,1,850,H)
C         Coefficient construction for loop diagram with ID 339
          CALL FFS4L1_2(PL(0,116),W(1,9),GC_116,MDL_MT,MDL_WT,PL(0
     $     ,610),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,116),4,COEFS,4,4,WL(1,0,1
     $     ,610))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,610),4,4,23,1,851,H)
C         Coefficient construction for loop diagram with ID 340
          CALL FFS4L1_2(PL(0,119),W(1,9),GC_116,MDL_MT,MDL_WT,PL(0
     $     ,611),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,119),4,COEFS,4,4,WL(1,0,1
     $     ,611))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,611),2,4,23,1,852,H)
C         Coefficient construction for loop diagram with ID 341
          CALL FFV2L3_1(PL(0,0),W(1,3),GC_130,MDL_MT,MDL_WT,PL(0,612)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,612))
          CALL FFV2L2_3(PL(0,612),W(1,4),GC_65,MDL_MW,MDL_WW,PL(0,613)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,612),4,COEFS,4,4,WL(1,0,1
     $     ,613))
          CALL VVV1L3_2(PL(0,613),W(1,6),GC_4,MDL_MW,MDL_WW,PL(0,614)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,613),4,COEFS,4,4,WL(1,0,1
     $     ,614))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,614),5,4,74,1,853,H)
C         Coefficient construction for loop diagram with ID 342
          CALL FFS1_3L2_3(PL(0,612),W(1,4),GC_37,GC_46,MDL_MW,MDL_WW
     $     ,PL(0,615),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,612),4,COEFS,4,1,WL(1,0,1
     $     ,615))
          CALL VVS1L3_2(PL(0,615),W(1,6),GC_92,MDL_MW,MDL_WW,PL(0,616)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,615),4,COEFS,1,4,WL(1,0,1
     $     ,616))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,616),2,4,74,1,854,H)
C         Coefficient construction for loop diagram with ID 343
          CALL FFS1_3L3_1(PL(0,0),W(1,3),GC_15,GC_24,MDL_MT,MDL_WT
     $     ,PL(0,617),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,4,WL(1,0,1
     $     ,617))
          CALL FFV2L2_3(PL(0,617),W(1,4),GC_65,MDL_MW,MDL_WW,PL(0,618)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,617),1,COEFS,4,4,WL(1,0,1
     $     ,618))
          CALL VVS1L2_3(PL(0,618),W(1,6),GC_93,MDL_MW,MDL_WW,PL(0,619)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,618),1,COEFS,4,1,WL(1,0,1
     $     ,619))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,619),3,1,74,1,855,H)
C         Coefficient construction for loop diagram with ID 344
          CALL FFS1_3L2_3(PL(0,617),W(1,4),GC_37,GC_46,MDL_MW,MDL_WW
     $     ,PL(0,620),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,617),1,COEFS,4,1,WL(1,0,1
     $     ,620))
          CALL VSS1L3_2(PL(0,620),W(1,6),GC_3,MDL_MW,MDL_WW,PL(0,621)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,620),1,COEFS,1,1,WL(1,0,1
     $     ,621))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,621),2,1,74,1,856,H)
C         Coefficient construction for loop diagram with ID 345
          CALL VVV1L2_1(PL(0,613),W(1,7),GC_71,MDL_MW,MDL_WW,PL(0,622)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,613),4,COEFS,4,4,WL(1,0,1
     $     ,622))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,622),5,4,74,1,857,H)
C         Coefficient construction for loop diagram with ID 346
          CALL VVS1L3_1(PL(0,615),W(1,7),GC_85,MDL_MW,MDL_WW,PL(0,623)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,615),4,COEFS,1,4,WL(1,0,1
     $     ,623))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,623),2,4,74,1,858,H)
C         Coefficient construction for loop diagram with ID 347
          CALL VVS1L1_3(PL(0,618),W(1,7),GC_84,MDL_MW,MDL_WW,PL(0,624)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,618),1,COEFS,4,1,WL(1,0,1
     $     ,624))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,624),3,1,74,1,859,H)
C         Coefficient construction for loop diagram with ID 348
          CALL VSS1L3_2(PL(0,620),W(1,7),GC_79,MDL_MW,MDL_WW,PL(0,625)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,620),1,COEFS,1,1,WL(1,0,1
     $     ,625))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,625),2,1,74,1,860,H)
C         Coefficient construction for loop diagram with ID 349
          CALL VSS1L3_1(PL(0,615),W(1,8),GC_57,MDL_MW,MDL_WW,PL(0,626)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,615),4,COEFS,1,4,WL(1,0,1
     $     ,626))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,626),4,4,74,1,861,H)
C         Coefficient construction for loop diagram with ID 350
          CALL VSS1L1_3(PL(0,618),W(1,8),GC_56,MDL_MW,MDL_WW,PL(0,627)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,618),1,COEFS,4,1,WL(1,0,1
     $     ,627))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,627),4,1,74,1,862,H)
C         Coefficient construction for loop diagram with ID 351
          CALL VVS1L2_1(PL(0,613),W(1,9),GC_90,MDL_MW,MDL_WW,PL(0,628)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,613),4,COEFS,4,4,WL(1,0,1
     $     ,628))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,628),5,4,74,1,863,H)
C         Coefficient construction for loop diagram with ID 352
          CALL VSS1L2_1(PL(0,615),W(1,9),GC_55,MDL_MW,MDL_WW,PL(0,629)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,615),4,COEFS,1,4,WL(1,0,1
     $     ,629))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,629),4,4,74,1,864,H)
C         Coefficient construction for loop diagram with ID 353
          CALL VSS1L1_2(PL(0,618),W(1,9),GC_55,MDL_MW,MDL_WW,PL(0,630)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,618),1,COEFS,4,1,WL(1,0,1
     $     ,630))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,630),4,1,74,1,865,H)
C         Coefficient construction for loop diagram with ID 354
          CALL SSS1L2_1(PL(0,620),W(1,9),GC_86,MDL_MW,MDL_WW,PL(0,631)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,620),1,COEFS,1,1,WL(1,0,1
     $     ,631))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,631),1,1,74,1,866,H)
C         Coefficient construction for loop diagram with ID 355
          CALL FFV2L1_2(PL(0,0),W(1,10),GC_65,MDL_MT,MDL_WT,PL(0,632)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,632))
          CALL FFV2L1_2(PL(0,632),W(1,12),GC_130,MDL_MD,ZERO,PL(0,633)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,632),4,COEFS,4,4,WL(1,0,1
     $     ,633))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,633),2,4,75,1,867,H)
C         Coefficient construction for loop diagram with ID 356
          CALL FFV2L1_2(PL(0,0),W(1,10),GC_66,MDL_MT,MDL_WT,PL(0,634)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,634))
          CALL FFV2L1_2(PL(0,634),W(1,12),GC_131,MDL_MS,ZERO,PL(0,635)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,634),4,COEFS,4,4,WL(1,0,1
     $     ,635))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,635),2,4,76,1,868,H)
C         Coefficient construction for loop diagram with ID 357
          CALL FFV2L1_2(PL(0,0),W(1,10),GC_67,MDL_MT,MDL_WT,PL(0,636)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,636))
          CALL FFV2L1_2(PL(0,636),W(1,12),GC_132,MDL_MB,ZERO,PL(0,637)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,636),4,COEFS,4,4,WL(1,0,1
     $     ,637))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,637),2,4,77,1,869,H)
C         Coefficient construction for loop diagram with ID 358
          CALL FFS1_3L1_2(PL(0,632),W(1,13),GC_15,GC_24,MDL_MD,ZERO
     $     ,PL(0,638),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,632),4,COEFS,4,4,WL(1,0,1
     $     ,638))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,638),2,4,75,1,870,H)
C         Coefficient construction for loop diagram with ID 359
          CALL FFS1_3L1_2(PL(0,634),W(1,13),GC_18,GC_27,MDL_MS,ZERO
     $     ,PL(0,639),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,634),4,COEFS,4,4,WL(1,0,1
     $     ,639))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,639),2,4,76,1,871,H)
C         Coefficient construction for loop diagram with ID 360
          CALL FFS1_3L1_2(PL(0,636),W(1,13),GC_21,GC_30,MDL_MB,ZERO
     $     ,PL(0,640),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,636),4,COEFS,4,4,WL(1,0,1
     $     ,640))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,640),2,4,77,1,872,H)
C         Coefficient construction for loop diagram with ID 361
          CALL FFS1_3L1_2(PL(0,0),W(1,11),GC_37,GC_46,MDL_MT,MDL_WT
     $     ,PL(0,641),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,641))
          CALL FFV2L1_2(PL(0,641),W(1,12),GC_130,MDL_MD,ZERO,PL(0,642)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,641),4,COEFS,4,4,WL(1,0,1
     $     ,642))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,642),2,4,75,1,873,H)
C         Coefficient construction for loop diagram with ID 362
          CALL FFS1_3L1_2(PL(0,0),W(1,11),GC_38,GC_47,MDL_MT,MDL_WT
     $     ,PL(0,643),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,643))
          CALL FFV2L1_2(PL(0,643),W(1,12),GC_131,MDL_MS,ZERO,PL(0,644)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,643),4,COEFS,4,4,WL(1,0,1
     $     ,644))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,644),2,4,76,1,874,H)
C         Coefficient construction for loop diagram with ID 363
          CALL FFS1_3L1_2(PL(0,0),W(1,11),GC_39,GC_48,MDL_MT,MDL_WT
     $     ,PL(0,645),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,645))
          CALL FFV2L1_2(PL(0,645),W(1,12),GC_132,MDL_MB,ZERO,PL(0,646)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,645),4,COEFS,4,4,WL(1,0,1
     $     ,646))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,646),2,4,77,1,875,H)
C         Coefficient construction for loop diagram with ID 364
          CALL FFS1_3L1_2(PL(0,641),W(1,13),GC_15,GC_24,MDL_MD,ZERO
     $     ,PL(0,647),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,641),4,COEFS,4,4,WL(1,0,1
     $     ,647))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,647),2,4,75,1,876,H)
C         Coefficient construction for loop diagram with ID 365
          CALL FFS1_3L1_2(PL(0,643),W(1,13),GC_18,GC_27,MDL_MS,ZERO
     $     ,PL(0,648),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,643),4,COEFS,4,4,WL(1,0,1
     $     ,648))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,648),2,4,76,1,877,H)
C         Coefficient construction for loop diagram with ID 366
          CALL FFS1_3L1_2(PL(0,645),W(1,13),GC_21,GC_30,MDL_MB,ZERO
     $     ,PL(0,649),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,645),4,COEFS,4,4,WL(1,0,1
     $     ,649))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,649),2,4,77,1,878,H)
C         Coefficient construction for loop diagram with ID 367
          CALL FFV2L3_1(PL(0,454),W(1,3),GC_130,MDL_MT,MDL_WT,PL(0
     $     ,650),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,454),4,COEFS,4,4,WL(1,0,1
     $     ,650))
          CALL FFV2L2_3(PL(0,650),W(1,4),GC_65,MDL_MW,MDL_WW,PL(0,651)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_2(WL(1,0,1,650),4,COEFS,4,4,WL(1,0,1
     $     ,651))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,651),6,4,78,1,879,H)
C         Coefficient construction for loop diagram with ID 368
          CALL FFV2L3_1(PL(0,458),W(1,3),GC_130,MDL_MT,MDL_WT,PL(0
     $     ,652),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,458),4,COEFS,4,4,WL(1,0,1
     $     ,652))
          CALL FFV2L2_3(PL(0,652),W(1,4),GC_65,MDL_MW,MDL_WW,PL(0,653)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_2(WL(1,0,1,652),4,COEFS,4,4,WL(1,0,1
     $     ,653))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,653),6,4,79,1,880,H)
C         Coefficient construction for loop diagram with ID 369
          CALL FFV2L3_1(PL(0,462),W(1,3),GC_130,MDL_MT,MDL_WT,PL(0
     $     ,654),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,462),4,COEFS,4,4,WL(1,0,1
     $     ,654))
          CALL FFV2L2_3(PL(0,654),W(1,4),GC_65,MDL_MW,MDL_WW,PL(0,655)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_4_2(WL(1,0,1,654),4,COEFS,4,4,WL(1,0,1
     $     ,655))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,655),6,4,80,1,881,H)
C         Coefficient construction for loop diagram with ID 370
          CALL FFV2L3_1(PL(0,465),W(1,3),GC_130,MDL_MT,MDL_WT,PL(0
     $     ,656),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,465),1,COEFS,4,4,WL(1,0,1
     $     ,656))
          CALL FFS1_3L2_3(PL(0,656),W(1,4),GC_37,GC_46,MDL_MW,MDL_WW
     $     ,PL(0,657),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,656),1,COEFS,4,1,WL(1,0,1
     $     ,657))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,657),4,1,78,1,882,H)
C         Coefficient construction for loop diagram with ID 371
          CALL FFV2L3_1(PL(0,469),W(1,3),GC_130,MDL_MT,MDL_WT,PL(0
     $     ,658),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,469),1,COEFS,4,4,WL(1,0,1
     $     ,658))
          CALL FFS1_3L2_3(PL(0,658),W(1,4),GC_37,GC_46,MDL_MW,MDL_WW
     $     ,PL(0,659),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,658),1,COEFS,4,1,WL(1,0,1
     $     ,659))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,659),4,1,79,1,883,H)
C         Coefficient construction for loop diagram with ID 372
          CALL FFV2L3_1(PL(0,473),W(1,3),GC_130,MDL_MT,MDL_WT,PL(0
     $     ,660),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,473),1,COEFS,4,4,WL(1,0,1
     $     ,660))
          CALL FFS1_3L2_3(PL(0,660),W(1,4),GC_37,GC_46,MDL_MW,MDL_WW
     $     ,PL(0,661),COEFS)
          CALL ML5_0_UPDATE_WL_4_0(WL(1,0,1,660),1,COEFS,4,1,WL(1,0,1
     $     ,661))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,661),4,1,80,1,884,H)
C         Coefficient construction for loop diagram with ID 373
          CALL FFS1_3L3_1(PL(0,476),W(1,3),GC_15,GC_24,MDL_MT,MDL_WT
     $     ,PL(0,662),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,476),4,COEFS,1,4,WL(1,0,1
     $     ,662))
          CALL FFV2L2_3(PL(0,662),W(1,4),GC_65,MDL_MW,MDL_WW,PL(0,663)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,662),4,COEFS,4,4,WL(1,0,1
     $     ,663))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,663),4,4,78,1,885,H)
C         Coefficient construction for loop diagram with ID 374
          CALL FFS1_3L3_1(PL(0,479),W(1,3),GC_15,GC_24,MDL_MT,MDL_WT
     $     ,PL(0,664),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,479),4,COEFS,1,4,WL(1,0,1
     $     ,664))
          CALL FFV2L2_3(PL(0,664),W(1,4),GC_65,MDL_MW,MDL_WW,PL(0,665)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,664),4,COEFS,4,4,WL(1,0,1
     $     ,665))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,665),4,4,79,1,886,H)
C         Coefficient construction for loop diagram with ID 375
          CALL FFS1_3L3_1(PL(0,482),W(1,3),GC_15,GC_24,MDL_MT,MDL_WT
     $     ,PL(0,666),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,482),4,COEFS,1,4,WL(1,0,1
     $     ,666))
          CALL FFV2L2_3(PL(0,666),W(1,4),GC_65,MDL_MW,MDL_WW,PL(0,667)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,666),4,COEFS,4,4,WL(1,0,1
     $     ,667))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,667),4,4,80,1,887,H)
C         Coefficient construction for loop diagram with ID 376
          CALL FFS1_3L3_1(PL(0,485),W(1,3),GC_15,GC_24,MDL_MT,MDL_WT
     $     ,PL(0,668),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,485),1,COEFS,1,4,WL(1,0,1
     $     ,668))
          CALL FFS1_3L2_3(PL(0,668),W(1,4),GC_37,GC_46,MDL_MW,MDL_WW
     $     ,PL(0,669),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,668),1,COEFS,4,1,WL(1,0,1
     $     ,669))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,669),2,1,78,1,888,H)
C         Coefficient construction for loop diagram with ID 377
          CALL FFS1_3L3_1(PL(0,488),W(1,3),GC_15,GC_24,MDL_MT,MDL_WT
     $     ,PL(0,670),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,488),1,COEFS,1,4,WL(1,0,1
     $     ,670))
          CALL FFS1_3L2_3(PL(0,670),W(1,4),GC_37,GC_46,MDL_MW,MDL_WW
     $     ,PL(0,671),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,670),1,COEFS,4,1,WL(1,0,1
     $     ,671))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,671),2,1,79,1,889,H)
C         Coefficient construction for loop diagram with ID 378
          CALL FFS1_3L3_1(PL(0,491),W(1,3),GC_15,GC_24,MDL_MT,MDL_WT
     $     ,PL(0,672),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,491),1,COEFS,1,4,WL(1,0,1
     $     ,672))
          CALL FFS1_3L2_3(PL(0,672),W(1,4),GC_37,GC_46,MDL_MW,MDL_WW
     $     ,PL(0,673),COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,672),1,COEFS,4,1,WL(1,0,1
     $     ,673))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,673),2,1,80,1,890,H)
C         Coefficient construction for loop diagram with ID 379
          CALL FFV1L2_1(PL(0,0),W(1,6),GC_1,MDL_MD,ZERO,PL(0,674)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,674))
          CALL FFV1L2_1(PL(0,674),W(1,14),GC_1,MDL_MD,ZERO,PL(0,675)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,674),4,COEFS,4,4,WL(1,0,1
     $     ,675))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,675),2,4,81,1,891,H)
C         Coefficient construction for loop diagram with ID 380
          CALL FFV2_3L2_1(PL(0,674),W(1,15),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,676),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,674),4,COEFS,4,4,WL(1,0,1
     $     ,676))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,676),2,4,81,1,892,H)
C         Coefficient construction for loop diagram with ID 381
          CALL FFS2L2_1(PL(0,674),W(1,16),GC_104,MDL_MD,ZERO,PL(0,677)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,674),4,COEFS,4,4,WL(1,0,1
     $     ,677))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,677),2,4,81,1,893,H)
C         Coefficient construction for loop diagram with ID 382
          CALL FFS4L2_1(PL(0,674),W(1,17),GC_105,MDL_MD,ZERO,PL(0,678)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,674),4,COEFS,4,4,WL(1,0,1
     $     ,678))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,678),2,4,81,1,894,H)
C         Coefficient construction for loop diagram with ID 383
          CALL FFV2_3L2_1(PL(0,0),W(1,7),GC_68,GC_76,MDL_MD,ZERO,PL(0
     $     ,679),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,679))
          CALL FFV1L2_1(PL(0,679),W(1,14),GC_1,MDL_MD,ZERO,PL(0,680)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,679),4,COEFS,4,4,WL(1,0,1
     $     ,680))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,680),2,4,81,1,895,H)
C         Coefficient construction for loop diagram with ID 384
          CALL FFV2_3L2_1(PL(0,679),W(1,15),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,681),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,679),4,COEFS,4,4,WL(1,0,1
     $     ,681))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,681),2,4,81,1,896,H)
C         Coefficient construction for loop diagram with ID 385
          CALL FFS2L2_1(PL(0,679),W(1,16),GC_104,MDL_MD,ZERO,PL(0,682)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,679),4,COEFS,4,4,WL(1,0,1
     $     ,682))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,682),2,4,81,1,897,H)
C         Coefficient construction for loop diagram with ID 386
          CALL FFS4L2_1(PL(0,679),W(1,17),GC_105,MDL_MD,ZERO,PL(0,683)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,679),4,COEFS,4,4,WL(1,0,1
     $     ,683))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,683),2,4,81,1,898,H)
C         Coefficient construction for loop diagram with ID 387
          CALL FFS2L2_1(PL(0,0),W(1,8),GC_104,MDL_MD,ZERO,PL(0,684)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,684))
          CALL FFV1L2_1(PL(0,684),W(1,14),GC_1,MDL_MD,ZERO,PL(0,685)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,684),4,COEFS,4,4,WL(1,0,1
     $     ,685))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,685),2,4,81,1,899,H)
C         Coefficient construction for loop diagram with ID 388
          CALL FFV2_3L2_1(PL(0,684),W(1,15),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,686),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,684),4,COEFS,4,4,WL(1,0,1
     $     ,686))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,686),2,4,81,1,900,H)
C         Coefficient construction for loop diagram with ID 389
          CALL FFS2L2_1(PL(0,684),W(1,16),GC_104,MDL_MD,ZERO,PL(0,687)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,684),4,COEFS,4,4,WL(1,0,1
     $     ,687))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,687),2,4,81,1,901,H)
C         Coefficient construction for loop diagram with ID 390
          CALL FFS4L2_1(PL(0,684),W(1,17),GC_105,MDL_MD,ZERO,PL(0,688)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,684),4,COEFS,4,4,WL(1,0,1
     $     ,688))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,688),2,4,81,1,902,H)
C         Coefficient construction for loop diagram with ID 391
          CALL FFS4L2_1(PL(0,0),W(1,9),GC_105,MDL_MD,ZERO,PL(0,689)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,689))
          CALL FFV1L2_1(PL(0,689),W(1,14),GC_1,MDL_MD,ZERO,PL(0,690)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,689),4,COEFS,4,4,WL(1,0,1
     $     ,690))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,690),2,4,81,1,903,H)
C         Coefficient construction for loop diagram with ID 392
          CALL FFV2_3L2_1(PL(0,689),W(1,15),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,691),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,689),4,COEFS,4,4,WL(1,0,1
     $     ,691))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,691),2,4,81,1,904,H)
C         Coefficient construction for loop diagram with ID 393
          CALL FFS2L2_1(PL(0,689),W(1,16),GC_104,MDL_MD,ZERO,PL(0,692)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,689),4,COEFS,4,4,WL(1,0,1
     $     ,692))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,692),2,4,81,1,905,H)
C         Coefficient construction for loop diagram with ID 394
          CALL FFS4L2_1(PL(0,689),W(1,17),GC_105,MDL_MD,ZERO,PL(0,693)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,689),4,COEFS,4,4,WL(1,0,1
     $     ,693))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,693),2,4,81,1,906,H)
C         Coefficient construction for loop diagram with ID 395
          CALL FFV1L1_2(PL(0,122),W(1,6),GC_1,MDL_MD,ZERO,PL(0,694)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,122),4,COEFS,4,4,WL(1,0,1
     $     ,694))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,694),2,4,1,1,907,H)
C         Coefficient construction for loop diagram with ID 396
          CALL FFV1L1_2(PL(0,125),W(1,6),GC_1,MDL_MD,ZERO,PL(0,695)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,125),4,COEFS,4,4,WL(1,0,1
     $     ,695))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,695),4,4,24,1,908,H)
C         Coefficient construction for loop diagram with ID 397
          CALL FFV1L1_2(PL(0,128),W(1,6),GC_1,MDL_MD,ZERO,PL(0,696)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,128),4,COEFS,4,4,WL(1,0,1
     $     ,696))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,696),2,4,24,1,909,H)
C         Coefficient construction for loop diagram with ID 398
          CALL FFV1L1_2(PL(0,131),W(1,6),GC_1,MDL_MD,ZERO,PL(0,697)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,131),4,COEFS,4,4,WL(1,0,1
     $     ,697))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,697),2,4,25,1,910,H)
C         Coefficient construction for loop diagram with ID 399
          CALL FFV2_3L1_2(PL(0,122),W(1,7),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,698),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,122),4,COEFS,4,4,WL(1,0,1
     $     ,698))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,698),2,4,1,1,911,H)
C         Coefficient construction for loop diagram with ID 400
          CALL FFV2_3L1_2(PL(0,125),W(1,7),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,699),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,125),4,COEFS,4,4,WL(1,0,1
     $     ,699))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,699),4,4,24,1,912,H)
C         Coefficient construction for loop diagram with ID 401
          CALL FFV2_3L1_2(PL(0,128),W(1,7),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,700),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,128),4,COEFS,4,4,WL(1,0,1
     $     ,700))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,700),2,4,24,1,913,H)
C         Coefficient construction for loop diagram with ID 402
          CALL FFV2_3L1_2(PL(0,131),W(1,7),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,701),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,131),4,COEFS,4,4,WL(1,0,1
     $     ,701))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,701),2,4,25,1,914,H)
C         Coefficient construction for loop diagram with ID 403
          CALL FFS2L1_2(PL(0,122),W(1,8),GC_104,MDL_MD,ZERO,PL(0,702)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,122),4,COEFS,4,4,WL(1,0,1
     $     ,702))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,702),2,4,1,1,915,H)
C         Coefficient construction for loop diagram with ID 404
          CALL FFS2L1_2(PL(0,125),W(1,8),GC_104,MDL_MD,ZERO,PL(0,703)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,125),4,COEFS,4,4,WL(1,0,1
     $     ,703))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,703),4,4,24,1,916,H)
C         Coefficient construction for loop diagram with ID 405
          CALL FFS2L1_2(PL(0,128),W(1,8),GC_104,MDL_MD,ZERO,PL(0,704)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,128),4,COEFS,4,4,WL(1,0,1
     $     ,704))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,704),2,4,24,1,917,H)
C         Coefficient construction for loop diagram with ID 406
          CALL FFS2L1_2(PL(0,131),W(1,8),GC_104,MDL_MD,ZERO,PL(0,705)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,131),4,COEFS,4,4,WL(1,0,1
     $     ,705))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,705),2,4,25,1,918,H)
C         Coefficient construction for loop diagram with ID 407
          CALL FFS4L1_2(PL(0,122),W(1,9),GC_105,MDL_MD,ZERO,PL(0,706)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,122),4,COEFS,4,4,WL(1,0,1
     $     ,706))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,706),2,4,1,1,919,H)
C         Coefficient construction for loop diagram with ID 408
          CALL FFS4L1_2(PL(0,125),W(1,9),GC_105,MDL_MD,ZERO,PL(0,707)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,125),4,COEFS,4,4,WL(1,0,1
     $     ,707))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,707),4,4,24,1,920,H)
C         Coefficient construction for loop diagram with ID 409
          CALL FFS4L1_2(PL(0,128),W(1,9),GC_105,MDL_MD,ZERO,PL(0,708)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,128),4,COEFS,4,4,WL(1,0,1
     $     ,708))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,708),2,4,24,1,921,H)
C         Coefficient construction for loop diagram with ID 410
          CALL FFS4L1_2(PL(0,131),W(1,9),GC_105,MDL_MD,ZERO,PL(0,709)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,131),4,COEFS,4,4,WL(1,0,1
     $     ,709))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,709),2,4,25,1,922,H)
C         Coefficient construction for loop diagram with ID 411
          CALL FFV2_3L3_1(PL(0,0),W(1,3),GC_68,GC_76,MDL_MD,ZERO,PL(0
     $     ,710),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,710))
          CALL FFS4L2_3(PL(0,710),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,711),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,710),4,COEFS,4,1,WL(1,0,1
     $     ,711))
          CALL VVS1L3_1(PL(0,711),W(1,7),GC_99,MDL_MZ,MDL_WZ,PL(0,712)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,711),4,COEFS,1,4,WL(1,0,1
     $     ,712))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,712),2,4,82,1,923,H)
C         Coefficient construction for loop diagram with ID 412
          CALL FFS2L3_1(PL(0,0),W(1,3),GC_104,MDL_MD,ZERO,PL(0,713)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,4,WL(1,0,1
     $     ,713))
          CALL FFS4L2_3(PL(0,713),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,714),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,713),1,COEFS,4,1,WL(1,0,1
     $     ,714))
          CALL VSS1L3_2(PL(0,714),W(1,7),GC_78,MDL_MZ,MDL_WZ,PL(0,715)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,714),1,COEFS,1,1,WL(1,0,1
     $     ,715))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,715),2,1,82,1,924,H)
C         Coefficient construction for loop diagram with ID 413
          CALL FFS4L3_1(PL(0,0),W(1,3),GC_105,MDL_MD,ZERO,PL(0,716)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,4,WL(1,0,1
     $     ,716))
          CALL FFV2_3L2_3(PL(0,716),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,717),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,716),1,COEFS,4,4,WL(1,0,1
     $     ,717))
          CALL VVS1L1_3(PL(0,717),W(1,7),GC_99,MDL_MH,MDL_WH,PL(0,718)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,717),1,COEFS,4,1,WL(1,0,1
     $     ,718))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,718),3,1,83,1,925,H)
C         Coefficient construction for loop diagram with ID 414
          CALL FFS2L2_3(PL(0,716),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,719),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,716),1,COEFS,4,1,WL(1,0,1
     $     ,719))
          CALL VSS1L2_3(PL(0,719),W(1,7),GC_78,MDL_MH,MDL_WH,PL(0,720)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,719),1,COEFS,1,1,WL(1,0,1
     $     ,720))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,720),2,1,83,1,926,H)
C         Coefficient construction for loop diagram with ID 415
          CALL VSS1L3_1(PL(0,711),W(1,8),GC_78,MDL_MZ,MDL_WZ,PL(0,721)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,711),4,COEFS,1,4,WL(1,0,1
     $     ,721))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,721),4,4,82,1,927,H)
C         Coefficient construction for loop diagram with ID 416
          CALL SSS1L3_1(PL(0,714),W(1,8),GC_86,MDL_MZ,MDL_WZ,PL(0,722)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,714),1,COEFS,1,1,WL(1,0,1
     $     ,722))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,722),1,1,82,1,928,H)
C         Coefficient construction for loop diagram with ID 417
          CALL VSS1L1_3(PL(0,717),W(1,8),GC_78,MDL_MH,MDL_WH,PL(0,723)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,717),1,COEFS,4,1,WL(1,0,1
     $     ,723))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,723),4,1,83,1,929,H)
C         Coefficient construction for loop diagram with ID 418
          CALL SSS1L1_3(PL(0,719),W(1,8),GC_86,MDL_MH,MDL_WH,PL(0,724)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,719),1,COEFS,1,1,WL(1,0,1
     $     ,724))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,724),1,1,83,1,930,H)
C         Coefficient construction for loop diagram with ID 419
          CALL FFV2_3L2_3(PL(0,710),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,725),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,710),4,COEFS,4,4,WL(1,0,1
     $     ,725))
          CALL VVS1L2_1(PL(0,725),W(1,9),GC_99,MDL_MZ,MDL_WZ,PL(0,726)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,725),4,COEFS,4,4,WL(1,0,1
     $     ,726))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,726),5,4,84,1,931,H)
C         Coefficient construction for loop diagram with ID 420
          CALL FFS2L2_3(PL(0,710),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,727),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,710),4,COEFS,4,1,WL(1,0,1
     $     ,727))
          CALL VSS1L2_1(PL(0,727),W(1,9),GC_78,MDL_MZ,MDL_WZ,PL(0,728)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,727),4,COEFS,1,4,WL(1,0,1
     $     ,728))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,728),4,4,84,1,932,H)
C         Coefficient construction for loop diagram with ID 421
          CALL FFV2_3L2_3(PL(0,713),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,729),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,713),1,COEFS,4,4,WL(1,0,1
     $     ,729))
          CALL VSS1L1_2(PL(0,729),W(1,9),GC_78,MDL_MZ,MDL_WZ,PL(0,730)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,729),1,COEFS,4,1,WL(1,0,1
     $     ,730))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,730),4,1,84,1,933,H)
C         Coefficient construction for loop diagram with ID 422
          CALL FFS2L2_3(PL(0,713),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,731),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,713),1,COEFS,4,1,WL(1,0,1
     $     ,731))
          CALL SSS1L2_1(PL(0,731),W(1,9),GC_86,MDL_MZ,MDL_WZ,PL(0,732)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,731),1,COEFS,1,1,WL(1,0,1
     $     ,732))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,732),1,1,84,1,934,H)
C         Coefficient construction for loop diagram with ID 423
          CALL FFS4L2_3(PL(0,716),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,733),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,716),1,COEFS,4,1,WL(1,0,1
     $     ,733))
          CALL SSS1L2_1(PL(0,733),W(1,9),GC_87,MDL_MH,MDL_WH,PL(0,734)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,733),1,COEFS,1,1,WL(1,0,1
     $     ,734))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,734),1,1,85,1,935,H)
C         Coefficient construction for loop diagram with ID 424
          CALL FFV2L3_1(PL(0,0),W(1,2),GC_59,MDL_MD,ZERO,PL(0,735)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,735))
          CALL FFV1L2P0_3(PL(0,735),W(1,4),GC_1,ZERO,ZERO,PL(0,736)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,735),4,COEFS,4,4,WL(1,0,1
     $     ,736))
          CALL VVV1L1_3(PL(0,736),W(1,10),GC_4,MDL_MW,MDL_WW,PL(0,737)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,736),4,COEFS,4,4,WL(1,0,1
     $     ,737))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,737),3,4,86,1,936,H)
C         Coefficient construction for loop diagram with ID 425
          CALL FFV2_3L2_3(PL(0,735),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,738),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,735),4,COEFS,4,4,WL(1,0,1
     $     ,738))
          CALL VVV1L3_2(PL(0,738),W(1,10),GC_71,MDL_MW,MDL_WW,PL(0
     $     ,739),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,738),4,COEFS,4,4,WL(1,0,1
     $     ,739))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,739),5,4,87,1,937,H)
C         Coefficient construction for loop diagram with ID 426
          CALL FFS4L2_3(PL(0,735),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,740),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,735),4,COEFS,4,1,WL(1,0,1
     $     ,740))
          CALL VVS1L3_2(PL(0,740),W(1,10),GC_90,MDL_MW,MDL_WW,PL(0
     $     ,741),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,740),4,COEFS,1,4,WL(1,0,1
     $     ,741))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,741),2,4,88,1,938,H)
C         Coefficient construction for loop diagram with ID 427
          CALL FFS1_3L3_1(PL(0,0),W(1,2),GC_31,GC_40,MDL_MD,ZERO,PL(0
     $     ,742),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,4,WL(1,0,1
     $     ,742))
          CALL FFV1L2P0_3(PL(0,742),W(1,4),GC_1,ZERO,ZERO,PL(0,743)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,742),1,COEFS,4,4,WL(1,0,1
     $     ,743))
          CALL VVS1L1_3(PL(0,743),W(1,10),GC_92,MDL_MW,MDL_WW,PL(0
     $     ,744),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,743),1,COEFS,4,1,WL(1,0,1
     $     ,744))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,744),1,1,86,1,939,H)
C         Coefficient construction for loop diagram with ID 428
          CALL FFV2_3L2_3(PL(0,742),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,745),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,742),1,COEFS,4,4,WL(1,0,1
     $     ,745))
          CALL VVS1L2_3(PL(0,745),W(1,10),GC_85,MDL_MW,MDL_WW,PL(0
     $     ,746),COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,745),1,COEFS,4,1,WL(1,0,1
     $     ,746))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,746),3,1,87,1,940,H)
C         Coefficient construction for loop diagram with ID 429
          CALL FFS2L2_3(PL(0,742),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,747),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,742),1,COEFS,4,1,WL(1,0,1
     $     ,747))
          CALL VSS1L2_3(PL(0,747),W(1,10),GC_57,MDL_MW,MDL_WW,PL(0
     $     ,748),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,747),1,COEFS,1,1,WL(1,0,1
     $     ,748))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,748),2,1,87,1,941,H)
C         Coefficient construction for loop diagram with ID 430
          CALL FFS4L2_3(PL(0,742),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0
     $     ,749),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,742),1,COEFS,4,1,WL(1,0,1
     $     ,749))
          CALL VSS1L3_2(PL(0,749),W(1,10),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,750),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,749),1,COEFS,1,1,WL(1,0,1
     $     ,750))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,750),2,1,88,1,942,H)
C         Coefficient construction for loop diagram with ID 431
          CALL VVS1L1_2(PL(0,736),W(1,11),GC_93,MDL_MW,MDL_WW,PL(0
     $     ,751),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,736),4,COEFS,4,4,WL(1,0,1
     $     ,751))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,751),3,4,86,1,943,H)
C         Coefficient construction for loop diagram with ID 432
          CALL VVS1L2_1(PL(0,738),W(1,11),GC_84,MDL_MW,MDL_WW,PL(0
     $     ,752),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,738),4,COEFS,4,4,WL(1,0,1
     $     ,752))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,752),5,4,87,1,944,H)
C         Coefficient construction for loop diagram with ID 433
          CALL FFS2L2_3(PL(0,735),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0
     $     ,753),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,735),4,COEFS,4,1,WL(1,0,1
     $     ,753))
          CALL VSS1L2_1(PL(0,753),W(1,11),GC_56,MDL_MW,MDL_WW,PL(0
     $     ,754),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,753),4,COEFS,1,4,WL(1,0,1
     $     ,754))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,754),4,4,87,1,945,H)
C         Coefficient construction for loop diagram with ID 434
          CALL VSS1L3_1(PL(0,740),W(1,11),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,755),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,740),4,COEFS,1,4,WL(1,0,1
     $     ,755))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,755),4,4,88,1,946,H)
C         Coefficient construction for loop diagram with ID 435
          CALL VSS1L1_3(PL(0,743),W(1,11),GC_3,MDL_MW,MDL_WW,PL(0,756)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,743),1,COEFS,4,1,WL(1,0,1
     $     ,756))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,756),2,1,86,1,947,H)
C         Coefficient construction for loop diagram with ID 436
          CALL VSS1L1_3(PL(0,745),W(1,11),GC_79,MDL_MW,MDL_WW,PL(0
     $     ,757),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,745),1,COEFS,4,1,WL(1,0,1
     $     ,757))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,757),4,1,87,1,948,H)
C         Coefficient construction for loop diagram with ID 437
          CALL SSS1L3_2(PL(0,749),W(1,11),GC_86,MDL_MW,MDL_WW,PL(0
     $     ,758),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,749),1,COEFS,1,1,WL(1,0,1
     $     ,758))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,758),1,1,88,1,949,H)
C         Coefficient construction for loop diagram with ID 438
          CALL VVV1L1_2(PL(0,430),W(1,12),GC_4,MDL_MW,MDL_WW,PL(0,759)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,430),4,COEFS,4,4,WL(1,0,1
     $     ,759))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,759),3,4,89,1,950,H)
C         Coefficient construction for loop diagram with ID 439
          CALL VVV1L3_1(PL(0,436),W(1,12),GC_71,MDL_MW,MDL_WW,PL(0
     $     ,760),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,436),4,COEFS,4,4,WL(1,0,1
     $     ,760))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,760),5,4,90,1,951,H)
C         Coefficient construction for loop diagram with ID 440
          CALL VVS1L3_1(PL(0,448),W(1,12),GC_90,MDL_MW,MDL_WW,PL(0
     $     ,761),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,448),4,COEFS,1,4,WL(1,0,1
     $     ,761))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,761),2,4,91,1,952,H)
C         Coefficient construction for loop diagram with ID 441
          CALL VVS1L1_2(PL(0,430),W(1,13),GC_92,MDL_MW,MDL_WW,PL(0
     $     ,762),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,430),4,COEFS,4,4,WL(1,0,1
     $     ,762))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,762),3,4,89,1,953,H)
C         Coefficient construction for loop diagram with ID 442
          CALL VVS1L2_1(PL(0,436),W(1,13),GC_85,MDL_MW,MDL_WW,PL(0
     $     ,763),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,436),4,COEFS,4,4,WL(1,0,1
     $     ,763))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,763),5,4,90,1,954,H)
C         Coefficient construction for loop diagram with ID 443
          CALL VSS1L2_1(PL(0,442),W(1,13),GC_57,MDL_MW,MDL_WW,PL(0
     $     ,764),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,442),4,COEFS,1,4,WL(1,0,1
     $     ,764))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,764),4,4,90,1,955,H)
C         Coefficient construction for loop diagram with ID 444
          CALL VSS1L3_1(PL(0,448),W(1,13),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,765),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,448),4,COEFS,1,4,WL(1,0,1
     $     ,765))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,765),4,4,91,1,956,H)
C         Coefficient construction for loop diagram with ID 445
          CALL VVS1L1_3(PL(0,433),W(1,12),GC_93,MDL_MW,MDL_WW,PL(0
     $     ,766),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,433),1,COEFS,4,1,WL(1,0,1
     $     ,766))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,766),1,1,89,1,957,H)
C         Coefficient construction for loop diagram with ID 446
          CALL VVS1L2_3(PL(0,439),W(1,12),GC_84,MDL_MW,MDL_WW,PL(0
     $     ,767),COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,439),1,COEFS,4,1,WL(1,0,1
     $     ,767))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,767),3,1,90,1,958,H)
C         Coefficient construction for loop diagram with ID 447
          CALL VSS1L2_3(PL(0,445),W(1,12),GC_56,MDL_MW,MDL_WW,PL(0
     $     ,768),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,445),1,COEFS,1,1,WL(1,0,1
     $     ,768))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,768),2,1,90,1,959,H)
C         Coefficient construction for loop diagram with ID 448
          CALL VSS1L3_2(PL(0,451),W(1,12),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,769),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,451),1,COEFS,1,1,WL(1,0,1
     $     ,769))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,769),2,1,91,1,960,H)
C         Coefficient construction for loop diagram with ID 449
          CALL VSS1L1_2(PL(0,433),W(1,13),GC_3,MDL_MW,MDL_WW,PL(0,770)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,433),1,COEFS,4,1,WL(1,0,1
     $     ,770))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,770),2,1,89,1,961,H)
C         Coefficient construction for loop diagram with ID 450
          CALL VSS1L1_2(PL(0,439),W(1,13),GC_79,MDL_MW,MDL_WW,PL(0
     $     ,771),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,439),1,COEFS,4,1,WL(1,0,1
     $     ,771))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,771),4,1,90,1,962,H)
C         Coefficient construction for loop diagram with ID 451
          CALL SSS1L3_1(PL(0,451),W(1,13),GC_86,MDL_MW,MDL_WW,PL(0
     $     ,772),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,451),1,COEFS,1,1,WL(1,0,1
     $     ,772))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,772),1,1,91,1,963,H)
C         Coefficient construction for loop diagram with ID 452
          CALL VVV1L3_2(PL(0,454),W(1,14),GC_4,MDL_MW,MDL_WW,PL(0,773)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,454),4,COEFS,4,4,WL(1,0,1
     $     ,773))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,773),5,4,92,1,964,H)
C         Coefficient construction for loop diagram with ID 453
          CALL VVV1L2_1(PL(0,454),W(1,15),GC_71,MDL_MW,MDL_WW,PL(0
     $     ,774),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,454),4,COEFS,4,4,WL(1,0,1
     $     ,774))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,774),5,4,92,1,965,H)
C         Coefficient construction for loop diagram with ID 454
          CALL VVS1L2_1(PL(0,454),W(1,17),GC_90,MDL_MW,MDL_WW,PL(0
     $     ,775),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,454),4,COEFS,4,4,WL(1,0,1
     $     ,775))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,775),5,4,92,1,966,H)
C         Coefficient construction for loop diagram with ID 455
          CALL VVS1L3_2(PL(0,476),W(1,14),GC_92,MDL_MW,MDL_WW,PL(0
     $     ,776),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,476),4,COEFS,1,4,WL(1,0,1
     $     ,776))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,776),2,4,92,1,967,H)
C         Coefficient construction for loop diagram with ID 456
          CALL VVS1L3_1(PL(0,476),W(1,15),GC_85,MDL_MW,MDL_WW,PL(0
     $     ,777),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,476),4,COEFS,1,4,WL(1,0,1
     $     ,777))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,777),2,4,92,1,968,H)
C         Coefficient construction for loop diagram with ID 457
          CALL VSS1L3_1(PL(0,476),W(1,16),GC_57,MDL_MW,MDL_WW,PL(0
     $     ,778),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,476),4,COEFS,1,4,WL(1,0,1
     $     ,778))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,778),4,4,92,1,969,H)
C         Coefficient construction for loop diagram with ID 458
          CALL VSS1L2_1(PL(0,476),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,779),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,476),4,COEFS,1,4,WL(1,0,1
     $     ,779))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,779),4,4,92,1,970,H)
C         Coefficient construction for loop diagram with ID 459
          CALL VVS1L2_3(PL(0,465),W(1,14),GC_93,MDL_MW,MDL_WW,PL(0
     $     ,780),COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,465),1,COEFS,4,1,WL(1,0,1
     $     ,780))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,780),3,1,92,1,971,H)
C         Coefficient construction for loop diagram with ID 460
          CALL VVS1L1_3(PL(0,465),W(1,15),GC_84,MDL_MW,MDL_WW,PL(0
     $     ,781),COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,465),1,COEFS,4,1,WL(1,0,1
     $     ,781))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,781),3,1,92,1,972,H)
C         Coefficient construction for loop diagram with ID 461
          CALL VSS1L1_3(PL(0,465),W(1,16),GC_56,MDL_MW,MDL_WW,PL(0
     $     ,782),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,465),1,COEFS,4,1,WL(1,0,1
     $     ,782))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,782),4,1,92,1,973,H)
C         Coefficient construction for loop diagram with ID 462
          CALL VSS1L1_2(PL(0,465),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,783),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,465),1,COEFS,4,1,WL(1,0,1
     $     ,783))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,783),4,1,92,1,974,H)
C         Coefficient construction for loop diagram with ID 463
          CALL VSS1L3_2(PL(0,485),W(1,14),GC_3,MDL_MW,MDL_WW,PL(0,784)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,485),1,COEFS,1,1,WL(1,0,1
     $     ,784))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,784),2,1,92,1,975,H)
C         Coefficient construction for loop diagram with ID 464
          CALL VSS1L3_2(PL(0,485),W(1,15),GC_79,MDL_MW,MDL_WW,PL(0
     $     ,785),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,485),1,COEFS,1,1,WL(1,0,1
     $     ,785))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,785),2,1,92,1,976,H)
C         Coefficient construction for loop diagram with ID 465
          CALL SSS1L2_1(PL(0,485),W(1,17),GC_86,MDL_MW,MDL_WW,PL(0
     $     ,786),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,485),1,COEFS,1,1,WL(1,0,1
     $     ,786))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,786),1,1,92,1,977,H)
C         Coefficient construction for loop diagram with ID 466
          CALL FFV1L2_1(PL(0,84),W(1,14),GC_1,MDL_MD,ZERO,PL(0,787)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,84),4,COEFS,4,4,WL(1,0,1
     $     ,787))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,787),4,4,26,1,978,H)
C         Coefficient construction for loop diagram with ID 467
          CALL FFV2_3L2_1(PL(0,84),W(1,15),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,788),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,84),4,COEFS,4,4,WL(1,0,1
     $     ,788))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,788),4,4,26,1,979,H)
C         Coefficient construction for loop diagram with ID 468
          CALL FFS2L2_1(PL(0,84),W(1,16),GC_104,MDL_MD,ZERO,PL(0,789)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,84),4,COEFS,4,4,WL(1,0,1
     $     ,789))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,789),4,4,26,1,980,H)
C         Coefficient construction for loop diagram with ID 469
          CALL FFS4L2_1(PL(0,84),W(1,17),GC_105,MDL_MD,ZERO,PL(0,790)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,84),4,COEFS,4,4,WL(1,0,1
     $     ,790))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,790),4,4,26,1,981,H)
C         Coefficient construction for loop diagram with ID 470
          CALL FFV1L2_1(PL(0,88),W(1,14),GC_1,MDL_MD,ZERO,PL(0,791)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,88),4,COEFS,4,4,WL(1,0,1
     $     ,791))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,791),2,4,26,1,982,H)
C         Coefficient construction for loop diagram with ID 471
          CALL FFV2_3L2_1(PL(0,88),W(1,15),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,792),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,88),4,COEFS,4,4,WL(1,0,1
     $     ,792))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,792),2,4,26,1,983,H)
C         Coefficient construction for loop diagram with ID 472
          CALL FFS2L2_1(PL(0,88),W(1,16),GC_104,MDL_MD,ZERO,PL(0,793)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,88),4,COEFS,4,4,WL(1,0,1
     $     ,793))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,793),2,4,26,1,984,H)
C         Coefficient construction for loop diagram with ID 473
          CALL FFS4L2_1(PL(0,88),W(1,17),GC_105,MDL_MD,ZERO,PL(0,794)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,88),4,COEFS,4,4,WL(1,0,1
     $     ,794))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,794),2,4,26,1,985,H)
C         Coefficient construction for loop diagram with ID 474
          CALL FFV1L2P0_3(PL(0,84),W(1,4),GC_1,ZERO,ZERO,PL(0,795)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,84),4,COEFS,4,4,WL(1,0,1
     $     ,795))
          CALL FFV1L3_1(PL(0,795),W(1,3),GC_1,MDL_MD,ZERO,PL(0,796)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,795),4,COEFS,4,4,WL(1,0,1
     $     ,796))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,796),4,4,18,1,986,H)
C         Coefficient construction for loop diagram with ID 475
          CALL FFV2_3L2_3(PL(0,84),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,797),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,84),4,COEFS,4,4,WL(1,0,1
     $     ,797))
          CALL FFV2_3L3_1(PL(0,797),W(1,3),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,798),COEFS)
          CALL ML5_0_UPDATE_WL_5_1(WL(1,0,1,797),4,COEFS,4,4,WL(1,0,1
     $     ,798))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,798),6,4,93,1,987,H)
C         Coefficient construction for loop diagram with ID 476
          CALL FFS2L2_3(PL(0,84),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0,799)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,84),4,COEFS,4,1,WL(1,0,1
     $     ,799))
          CALL FFS2L3_1(PL(0,799),W(1,3),GC_104,MDL_MD,ZERO,PL(0,800)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,799),4,COEFS,1,4,WL(1,0,1
     $     ,800))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,800),4,4,93,1,988,H)
C         Coefficient construction for loop diagram with ID 477
          CALL FFS4L2_3(PL(0,84),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0,801)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,84),4,COEFS,4,1,WL(1,0,1
     $     ,801))
          CALL FFS4L3_1(PL(0,801),W(1,3),GC_105,MDL_MD,ZERO,PL(0,802)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,801),4,COEFS,1,4,WL(1,0,1
     $     ,802))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,802),4,4,94,1,989,H)
C         Coefficient construction for loop diagram with ID 478
          CALL FFV1L2P0_3(PL(0,88),W(1,4),GC_1,ZERO,ZERO,PL(0,803)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,88),4,COEFS,4,4,WL(1,0,1
     $     ,803))
          CALL FFV1L3_1(PL(0,803),W(1,3),GC_1,MDL_MD,ZERO,PL(0,804)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,803),4,COEFS,4,4,WL(1,0,1
     $     ,804))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,804),2,4,18,1,990,H)
C         Coefficient construction for loop diagram with ID 479
          CALL FFV2_3L2_3(PL(0,88),W(1,4),GC_68,GC_76,MDL_MZ,MDL_WZ
     $     ,PL(0,805),COEFS)
          CALL ML5_0_UPDATE_WL_1_2(WL(1,0,1,88),4,COEFS,4,4,WL(1,0,1
     $     ,805))
          CALL FFV2_3L3_1(PL(0,805),W(1,3),GC_68,GC_76,MDL_MD,ZERO
     $     ,PL(0,806),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,805),4,COEFS,4,4,WL(1,0,1
     $     ,806))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,806),4,4,93,1,991,H)
C         Coefficient construction for loop diagram with ID 480
          CALL FFS2L2_3(PL(0,88),W(1,4),GC_104,MDL_MZ,MDL_WZ,PL(0,807)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,88),4,COEFS,4,1,WL(1,0,1
     $     ,807))
          CALL FFS2L3_1(PL(0,807),W(1,3),GC_104,MDL_MD,ZERO,PL(0,808)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,807),4,COEFS,1,4,WL(1,0,1
     $     ,808))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,808),2,4,93,1,992,H)
C         Coefficient construction for loop diagram with ID 481
          CALL FFS4L2_3(PL(0,88),W(1,4),GC_105,MDL_MH,MDL_WH,PL(0,809)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,88),4,COEFS,4,1,WL(1,0,1
     $     ,809))
          CALL FFS4L3_1(PL(0,809),W(1,3),GC_105,MDL_MD,ZERO,PL(0,810)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,809),4,COEFS,1,4,WL(1,0,1
     $     ,810))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,810),2,4,94,1,993,H)
C         Coefficient construction for loop diagram with ID 482
          CALL FFV1L2_1(PL(0,0),W(1,6),GC_1,MDL_MS,ZERO,PL(0,811)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,811))
          CALL FFV1L2_1(PL(0,811),W(1,14),GC_1,MDL_MS,ZERO,PL(0,812)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,811),4,COEFS,4,4,WL(1,0,1
     $     ,812))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,812),2,4,95,1,994,H)
C         Coefficient construction for loop diagram with ID 483
          CALL FFV2_3L2_1(PL(0,811),W(1,15),GC_68,GC_76,MDL_MS,ZERO
     $     ,PL(0,813),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,811),4,COEFS,4,4,WL(1,0,1
     $     ,813))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,813),2,4,95,1,995,H)
C         Coefficient construction for loop diagram with ID 484
          CALL FFS2L2_1(PL(0,811),W(1,16),GC_114,MDL_MS,ZERO,PL(0,814)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,811),4,COEFS,4,4,WL(1,0,1
     $     ,814))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,814),2,4,95,1,996,H)
C         Coefficient construction for loop diagram with ID 485
          CALL FFS4L2_1(PL(0,811),W(1,17),GC_115,MDL_MS,ZERO,PL(0,815)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,811),4,COEFS,4,4,WL(1,0,1
     $     ,815))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,815),2,4,95,1,997,H)
C         Coefficient construction for loop diagram with ID 486
          CALL FFV2_3L2_1(PL(0,0),W(1,7),GC_68,GC_76,MDL_MS,ZERO,PL(0
     $     ,816),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,816))
          CALL FFV1L2_1(PL(0,816),W(1,14),GC_1,MDL_MS,ZERO,PL(0,817)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,816),4,COEFS,4,4,WL(1,0,1
     $     ,817))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,817),2,4,95,1,998,H)
C         Coefficient construction for loop diagram with ID 487
          CALL FFV2_3L2_1(PL(0,816),W(1,15),GC_68,GC_76,MDL_MS,ZERO
     $     ,PL(0,818),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,816),4,COEFS,4,4,WL(1,0,1
     $     ,818))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,818),2,4,95,1,999,H)
C         Coefficient construction for loop diagram with ID 488
          CALL FFS2L2_1(PL(0,816),W(1,16),GC_114,MDL_MS,ZERO,PL(0,819)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,816),4,COEFS,4,4,WL(1,0,1
     $     ,819))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,819),2,4,95,1,1000,H)
C         Coefficient construction for loop diagram with ID 489
          CALL FFS4L2_1(PL(0,816),W(1,17),GC_115,MDL_MS,ZERO,PL(0,820)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,816),4,COEFS,4,4,WL(1,0,1
     $     ,820))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,820),2,4,95,1,1001,H)
C         Coefficient construction for loop diagram with ID 490
          CALL FFS2L2_1(PL(0,0),W(1,8),GC_114,MDL_MS,ZERO,PL(0,821)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,821))
          CALL FFV1L2_1(PL(0,821),W(1,14),GC_1,MDL_MS,ZERO,PL(0,822)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,821),4,COEFS,4,4,WL(1,0,1
     $     ,822))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,822),2,4,95,1,1002,H)
C         Coefficient construction for loop diagram with ID 491
          CALL FFV2_3L2_1(PL(0,821),W(1,15),GC_68,GC_76,MDL_MS,ZERO
     $     ,PL(0,823),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,821),4,COEFS,4,4,WL(1,0,1
     $     ,823))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,823),2,4,95,1,1003,H)
C         Coefficient construction for loop diagram with ID 492
          CALL FFS2L2_1(PL(0,821),W(1,16),GC_114,MDL_MS,ZERO,PL(0,824)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,821),4,COEFS,4,4,WL(1,0,1
     $     ,824))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,824),2,4,95,1,1004,H)
C         Coefficient construction for loop diagram with ID 493
          CALL FFS4L2_1(PL(0,821),W(1,17),GC_115,MDL_MS,ZERO,PL(0,825)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,821),4,COEFS,4,4,WL(1,0,1
     $     ,825))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,825),2,4,95,1,1005,H)
C         Coefficient construction for loop diagram with ID 494
          CALL FFS4L2_1(PL(0,0),W(1,9),GC_115,MDL_MS,ZERO,PL(0,826)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,826))
          CALL FFV1L2_1(PL(0,826),W(1,14),GC_1,MDL_MS,ZERO,PL(0,827)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,826),4,COEFS,4,4,WL(1,0,1
     $     ,827))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,827),2,4,95,1,1006,H)
C         Coefficient construction for loop diagram with ID 495
          CALL FFV2_3L2_1(PL(0,826),W(1,15),GC_68,GC_76,MDL_MS,ZERO
     $     ,PL(0,828),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,826),4,COEFS,4,4,WL(1,0,1
     $     ,828))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,828),2,4,95,1,1007,H)
C         Coefficient construction for loop diagram with ID 496
          CALL FFS2L2_1(PL(0,826),W(1,16),GC_114,MDL_MS,ZERO,PL(0,829)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,826),4,COEFS,4,4,WL(1,0,1
     $     ,829))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,829),2,4,95,1,1008,H)
C         Coefficient construction for loop diagram with ID 497
          CALL FFS4L2_1(PL(0,826),W(1,17),GC_115,MDL_MS,ZERO,PL(0,830)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,826),4,COEFS,4,4,WL(1,0,1
     $     ,830))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,830),2,4,95,1,1009,H)
C         Coefficient construction for loop diagram with ID 498
          CALL VVV1L3_2(PL(0,458),W(1,14),GC_4,MDL_MW,MDL_WW,PL(0,831)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,458),4,COEFS,4,4,WL(1,0,1
     $     ,831))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,831),5,4,96,1,1010,H)
C         Coefficient construction for loop diagram with ID 499
          CALL VVV1L2_1(PL(0,458),W(1,15),GC_71,MDL_MW,MDL_WW,PL(0
     $     ,832),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,458),4,COEFS,4,4,WL(1,0,1
     $     ,832))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,832),5,4,96,1,1011,H)
C         Coefficient construction for loop diagram with ID 500
          CALL VVS1L2_1(PL(0,458),W(1,17),GC_90,MDL_MW,MDL_WW,PL(0
     $     ,833),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,458),4,COEFS,4,4,WL(1,0,1
     $     ,833))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,833),5,4,96,1,1012,H)
C         Coefficient construction for loop diagram with ID 501
          CALL VVS1L3_2(PL(0,479),W(1,14),GC_92,MDL_MW,MDL_WW,PL(0
     $     ,834),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,479),4,COEFS,1,4,WL(1,0,1
     $     ,834))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,834),2,4,96,1,1013,H)
C         Coefficient construction for loop diagram with ID 502
          CALL VVS1L3_1(PL(0,479),W(1,15),GC_85,MDL_MW,MDL_WW,PL(0
     $     ,835),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,479),4,COEFS,1,4,WL(1,0,1
     $     ,835))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,835),2,4,96,1,1014,H)
C         Coefficient construction for loop diagram with ID 503
          CALL VSS1L3_1(PL(0,479),W(1,16),GC_57,MDL_MW,MDL_WW,PL(0
     $     ,836),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,479),4,COEFS,1,4,WL(1,0,1
     $     ,836))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,836),4,4,96,1,1015,H)
C         Coefficient construction for loop diagram with ID 504
          CALL VSS1L2_1(PL(0,479),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,837),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,479),4,COEFS,1,4,WL(1,0,1
     $     ,837))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,837),4,4,96,1,1016,H)
C         Coefficient construction for loop diagram with ID 505
          CALL VVS1L2_3(PL(0,469),W(1,14),GC_93,MDL_MW,MDL_WW,PL(0
     $     ,838),COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,469),1,COEFS,4,1,WL(1,0,1
     $     ,838))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,838),3,1,96,1,1017,H)
C         Coefficient construction for loop diagram with ID 506
          CALL VVS1L1_3(PL(0,469),W(1,15),GC_84,MDL_MW,MDL_WW,PL(0
     $     ,839),COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,469),1,COEFS,4,1,WL(1,0,1
     $     ,839))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,839),3,1,96,1,1018,H)
C         Coefficient construction for loop diagram with ID 507
          CALL VSS1L1_3(PL(0,469),W(1,16),GC_56,MDL_MW,MDL_WW,PL(0
     $     ,840),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,469),1,COEFS,4,1,WL(1,0,1
     $     ,840))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,840),4,1,96,1,1019,H)
C         Coefficient construction for loop diagram with ID 508
          CALL VSS1L1_2(PL(0,469),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,841),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,469),1,COEFS,4,1,WL(1,0,1
     $     ,841))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,841),4,1,96,1,1020,H)
C         Coefficient construction for loop diagram with ID 509
          CALL VSS1L3_2(PL(0,488),W(1,14),GC_3,MDL_MW,MDL_WW,PL(0,842)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,488),1,COEFS,1,1,WL(1,0,1
     $     ,842))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,842),2,1,96,1,1021,H)
C         Coefficient construction for loop diagram with ID 510
          CALL VSS1L3_2(PL(0,488),W(1,15),GC_79,MDL_MW,MDL_WW,PL(0
     $     ,843),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,488),1,COEFS,1,1,WL(1,0,1
     $     ,843))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,843),2,1,96,1,1022,H)
C         Coefficient construction for loop diagram with ID 511
          CALL SSS1L2_1(PL(0,488),W(1,17),GC_86,MDL_MW,MDL_WW,PL(0
     $     ,844),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,488),1,COEFS,1,1,WL(1,0,1
     $     ,844))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,844),1,1,96,1,1023,H)
C         Coefficient construction for loop diagram with ID 512
          CALL FFV1L2_1(PL(0,136),W(1,14),GC_1,MDL_MS,ZERO,PL(0,845)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,136),4,COEFS,4,4,WL(1,0,1
     $     ,845))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,845),4,4,27,1,1024,H)
C         Coefficient construction for loop diagram with ID 513
          CALL FFV2_3L2_1(PL(0,136),W(1,15),GC_68,GC_76,MDL_MS,ZERO
     $     ,PL(0,846),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,136),4,COEFS,4,4,WL(1,0,1
     $     ,846))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,846),4,4,27,1,1025,H)
C         Coefficient construction for loop diagram with ID 514
          CALL FFS2L2_1(PL(0,136),W(1,16),GC_114,MDL_MS,ZERO,PL(0,847)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,136),4,COEFS,4,4,WL(1,0,1
     $     ,847))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,847),4,4,27,1,1026,H)
C         Coefficient construction for loop diagram with ID 515
          CALL FFS4L2_1(PL(0,136),W(1,17),GC_115,MDL_MS,ZERO,PL(0,848)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,136),4,COEFS,4,4,WL(1,0,1
     $     ,848))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,848),4,4,27,1,1027,H)
C         Coefficient construction for loop diagram with ID 516
          CALL FFV1L2_1(PL(0,139),W(1,14),GC_1,MDL_MS,ZERO,PL(0,849)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,139),4,COEFS,4,4,WL(1,0,1
     $     ,849))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,849),2,4,27,1,1028,H)
C         Coefficient construction for loop diagram with ID 517
          CALL FFV2_3L2_1(PL(0,139),W(1,15),GC_68,GC_76,MDL_MS,ZERO
     $     ,PL(0,850),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,139),4,COEFS,4,4,WL(1,0,1
     $     ,850))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,850),2,4,27,1,1029,H)
C         Coefficient construction for loop diagram with ID 518
          CALL FFS2L2_1(PL(0,139),W(1,16),GC_114,MDL_MS,ZERO,PL(0,851)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,139),4,COEFS,4,4,WL(1,0,1
     $     ,851))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,851),2,4,27,1,1030,H)
C         Coefficient construction for loop diagram with ID 519
          CALL FFS4L2_1(PL(0,139),W(1,17),GC_115,MDL_MS,ZERO,PL(0,852)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,139),4,COEFS,4,4,WL(1,0,1
     $     ,852))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,852),2,4,27,1,1031,H)
C         Coefficient construction for loop diagram with ID 520
          CALL FFV1L2_1(PL(0,0),W(1,6),GC_1,MDL_MB,ZERO,PL(0,853)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,853))
          CALL FFV1L2_1(PL(0,853),W(1,14),GC_1,MDL_MB,ZERO,PL(0,854)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,853),4,COEFS,4,4,WL(1,0,1
     $     ,854))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,854),2,4,97,1,1032,H)
C         Coefficient construction for loop diagram with ID 521
          CALL FFV2_3L2_1(PL(0,853),W(1,15),GC_68,GC_76,MDL_MB,ZERO
     $     ,PL(0,855),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,853),4,COEFS,4,4,WL(1,0,1
     $     ,855))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,855),2,4,97,1,1033,H)
C         Coefficient construction for loop diagram with ID 522
          CALL FFS2L2_1(PL(0,853),W(1,16),GC_100,MDL_MB,ZERO,PL(0,856)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,853),4,COEFS,4,4,WL(1,0,1
     $     ,856))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,856),2,4,97,1,1034,H)
C         Coefficient construction for loop diagram with ID 523
          CALL FFS4L2_1(PL(0,853),W(1,17),GC_101,MDL_MB,ZERO,PL(0,857)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,853),4,COEFS,4,4,WL(1,0,1
     $     ,857))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,857),2,4,97,1,1035,H)
C         Coefficient construction for loop diagram with ID 524
          CALL FFV2_3L2_1(PL(0,0),W(1,7),GC_68,GC_76,MDL_MB,ZERO,PL(0
     $     ,858),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,858))
          CALL FFV1L2_1(PL(0,858),W(1,14),GC_1,MDL_MB,ZERO,PL(0,859)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,858),4,COEFS,4,4,WL(1,0,1
     $     ,859))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,859),2,4,97,1,1036,H)
C         Coefficient construction for loop diagram with ID 525
          CALL FFV2_3L2_1(PL(0,858),W(1,15),GC_68,GC_76,MDL_MB,ZERO
     $     ,PL(0,860),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,858),4,COEFS,4,4,WL(1,0,1
     $     ,860))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,860),2,4,97,1,1037,H)
C         Coefficient construction for loop diagram with ID 526
          CALL FFS2L2_1(PL(0,858),W(1,16),GC_100,MDL_MB,ZERO,PL(0,861)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,858),4,COEFS,4,4,WL(1,0,1
     $     ,861))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,861),2,4,97,1,1038,H)
C         Coefficient construction for loop diagram with ID 527
          CALL FFS4L2_1(PL(0,858),W(1,17),GC_101,MDL_MB,ZERO,PL(0,862)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,858),4,COEFS,4,4,WL(1,0,1
     $     ,862))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,862),2,4,97,1,1039,H)
C         Coefficient construction for loop diagram with ID 528
          CALL FFS2L2_1(PL(0,0),W(1,8),GC_100,MDL_MB,ZERO,PL(0,863)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,863))
          CALL FFV1L2_1(PL(0,863),W(1,14),GC_1,MDL_MB,ZERO,PL(0,864)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,863),4,COEFS,4,4,WL(1,0,1
     $     ,864))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,864),2,4,97,1,1040,H)
C         Coefficient construction for loop diagram with ID 529
          CALL FFV2_3L2_1(PL(0,863),W(1,15),GC_68,GC_76,MDL_MB,ZERO
     $     ,PL(0,865),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,863),4,COEFS,4,4,WL(1,0,1
     $     ,865))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,865),2,4,97,1,1041,H)
C         Coefficient construction for loop diagram with ID 530
          CALL FFS2L2_1(PL(0,863),W(1,16),GC_100,MDL_MB,ZERO,PL(0,866)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,863),4,COEFS,4,4,WL(1,0,1
     $     ,866))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,866),2,4,97,1,1042,H)
C         Coefficient construction for loop diagram with ID 531
          CALL FFS4L2_1(PL(0,863),W(1,17),GC_101,MDL_MB,ZERO,PL(0,867)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,863),4,COEFS,4,4,WL(1,0,1
     $     ,867))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,867),2,4,97,1,1043,H)
C         Coefficient construction for loop diagram with ID 532
          CALL FFS4L2_1(PL(0,0),W(1,9),GC_101,MDL_MB,ZERO,PL(0,868)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,868))
          CALL FFV1L2_1(PL(0,868),W(1,14),GC_1,MDL_MB,ZERO,PL(0,869)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,868),4,COEFS,4,4,WL(1,0,1
     $     ,869))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,869),2,4,97,1,1044,H)
C         Coefficient construction for loop diagram with ID 533
          CALL FFV2_3L2_1(PL(0,868),W(1,15),GC_68,GC_76,MDL_MB,ZERO
     $     ,PL(0,870),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,868),4,COEFS,4,4,WL(1,0,1
     $     ,870))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,870),2,4,97,1,1045,H)
C         Coefficient construction for loop diagram with ID 534
          CALL FFS2L2_1(PL(0,868),W(1,16),GC_100,MDL_MB,ZERO,PL(0,871)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,868),4,COEFS,4,4,WL(1,0,1
     $     ,871))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,871),2,4,97,1,1046,H)
C         Coefficient construction for loop diagram with ID 535
          CALL FFS4L2_1(PL(0,868),W(1,17),GC_101,MDL_MB,ZERO,PL(0,872)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,868),4,COEFS,4,4,WL(1,0,1
     $     ,872))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,872),2,4,97,1,1047,H)
C         Coefficient construction for loop diagram with ID 536
          CALL VVV1L3_2(PL(0,462),W(1,14),GC_4,MDL_MW,MDL_WW,PL(0,873)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,462),4,COEFS,4,4,WL(1,0,1
     $     ,873))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,873),5,4,98,1,1048,H)
C         Coefficient construction for loop diagram with ID 537
          CALL VVV1L2_1(PL(0,462),W(1,15),GC_71,MDL_MW,MDL_WW,PL(0
     $     ,874),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,462),4,COEFS,4,4,WL(1,0,1
     $     ,874))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,874),5,4,98,1,1049,H)
C         Coefficient construction for loop diagram with ID 538
          CALL VVS1L2_1(PL(0,462),W(1,17),GC_90,MDL_MW,MDL_WW,PL(0
     $     ,875),COEFS)
          CALL ML5_0_UPDATE_WL_3_2(WL(1,0,1,462),4,COEFS,4,4,WL(1,0,1
     $     ,875))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,875),5,4,98,1,1050,H)
C         Coefficient construction for loop diagram with ID 539
          CALL VVS1L3_2(PL(0,482),W(1,14),GC_92,MDL_MW,MDL_WW,PL(0
     $     ,876),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,482),4,COEFS,1,4,WL(1,0,1
     $     ,876))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,876),2,4,98,1,1051,H)
C         Coefficient construction for loop diagram with ID 540
          CALL VVS1L3_1(PL(0,482),W(1,15),GC_85,MDL_MW,MDL_WW,PL(0
     $     ,877),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,482),4,COEFS,1,4,WL(1,0,1
     $     ,877))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,877),2,4,98,1,1052,H)
C         Coefficient construction for loop diagram with ID 541
          CALL VSS1L3_1(PL(0,482),W(1,16),GC_57,MDL_MW,MDL_WW,PL(0
     $     ,878),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,482),4,COEFS,1,4,WL(1,0,1
     $     ,878))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,878),4,4,98,1,1053,H)
C         Coefficient construction for loop diagram with ID 542
          CALL VSS1L2_1(PL(0,482),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,879),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,482),4,COEFS,1,4,WL(1,0,1
     $     ,879))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,879),4,4,98,1,1054,H)
C         Coefficient construction for loop diagram with ID 543
          CALL VVS1L2_3(PL(0,473),W(1,14),GC_93,MDL_MW,MDL_WW,PL(0
     $     ,880),COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,473),1,COEFS,4,1,WL(1,0,1
     $     ,880))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,880),3,1,98,1,1055,H)
C         Coefficient construction for loop diagram with ID 544
          CALL VVS1L1_3(PL(0,473),W(1,15),GC_84,MDL_MW,MDL_WW,PL(0
     $     ,881),COEFS)
          CALL ML5_0_UPDATE_WL_3_0(WL(1,0,1,473),1,COEFS,4,1,WL(1,0,1
     $     ,881))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,881),3,1,98,1,1056,H)
C         Coefficient construction for loop diagram with ID 545
          CALL VSS1L1_3(PL(0,473),W(1,16),GC_56,MDL_MW,MDL_WW,PL(0
     $     ,882),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,473),1,COEFS,4,1,WL(1,0,1
     $     ,882))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,882),4,1,98,1,1057,H)
C         Coefficient construction for loop diagram with ID 546
          CALL VSS1L1_2(PL(0,473),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,883),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,473),1,COEFS,4,1,WL(1,0,1
     $     ,883))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,883),4,1,98,1,1058,H)
C         Coefficient construction for loop diagram with ID 547
          CALL VSS1L3_2(PL(0,491),W(1,14),GC_3,MDL_MW,MDL_WW,PL(0,884)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,491),1,COEFS,1,1,WL(1,0,1
     $     ,884))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,884),2,1,98,1,1059,H)
C         Coefficient construction for loop diagram with ID 548
          CALL VSS1L3_2(PL(0,491),W(1,15),GC_79,MDL_MW,MDL_WW,PL(0
     $     ,885),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,491),1,COEFS,1,1,WL(1,0,1
     $     ,885))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,885),2,1,98,1,1060,H)
C         Coefficient construction for loop diagram with ID 549
          CALL SSS1L2_1(PL(0,491),W(1,17),GC_86,MDL_MW,MDL_WW,PL(0
     $     ,886),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,491),1,COEFS,1,1,WL(1,0,1
     $     ,886))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,886),1,1,98,1,1061,H)
C         Coefficient construction for loop diagram with ID 550
          CALL FFV1L2_1(PL(0,142),W(1,14),GC_1,MDL_MB,ZERO,PL(0,887)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,142),4,COEFS,4,4,WL(1,0,1
     $     ,887))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,887),4,4,28,1,1062,H)
C         Coefficient construction for loop diagram with ID 551
          CALL FFV2_3L2_1(PL(0,142),W(1,15),GC_68,GC_76,MDL_MB,ZERO
     $     ,PL(0,888),COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,142),4,COEFS,4,4,WL(1,0,1
     $     ,888))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,888),4,4,28,1,1063,H)
C         Coefficient construction for loop diagram with ID 552
          CALL FFS2L2_1(PL(0,142),W(1,16),GC_100,MDL_MB,ZERO,PL(0,889)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,142),4,COEFS,4,4,WL(1,0,1
     $     ,889))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,889),4,4,28,1,1064,H)
C         Coefficient construction for loop diagram with ID 553
          CALL FFS4L2_1(PL(0,142),W(1,17),GC_101,MDL_MB,ZERO,PL(0,890)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_3_1(WL(1,0,1,142),4,COEFS,4,4,WL(1,0,1
     $     ,890))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,890),4,4,28,1,1065,H)
C         Coefficient construction for loop diagram with ID 554
          CALL FFV1L2_1(PL(0,145),W(1,14),GC_1,MDL_MB,ZERO,PL(0,891)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,145),4,COEFS,4,4,WL(1,0,1
     $     ,891))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,891),2,4,28,1,1066,H)
C         Coefficient construction for loop diagram with ID 555
          CALL FFV2_3L2_1(PL(0,145),W(1,15),GC_68,GC_76,MDL_MB,ZERO
     $     ,PL(0,892),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,145),4,COEFS,4,4,WL(1,0,1
     $     ,892))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,892),2,4,28,1,1067,H)
C         Coefficient construction for loop diagram with ID 556
          CALL FFS2L2_1(PL(0,145),W(1,16),GC_100,MDL_MB,ZERO,PL(0,893)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,145),4,COEFS,4,4,WL(1,0,1
     $     ,893))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,893),2,4,28,1,1068,H)
C         Coefficient construction for loop diagram with ID 557
          CALL FFS4L2_1(PL(0,145),W(1,17),GC_101,MDL_MB,ZERO,PL(0,894)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,145),4,COEFS,4,4,WL(1,0,1
     $     ,894))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,894),2,4,28,1,1069,H)
C         Coefficient construction for loop diagram with ID 558
          CALL VVV1L1_3(PL(0,0),W(1,10),GC_4,MDL_MW,MDL_WW,PL(0,895)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,895))
          CALL VVV1L2P0_1(PL(0,895),W(1,12),GC_4,ZERO,ZERO,PL(0,896)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_1(WL(1,0,1,895),4,COEFS,4,4,WL(1,0,1
     $     ,896))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,896),3,4,99,1,1070,H)
C         Coefficient construction for loop diagram with ID 559
          CALL VVS1L1_3(PL(0,0),W(1,10),GC_92,MDL_MW,MDL_WW,PL(0,897)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,897))
          CALL VVS1L3P0_1(PL(0,897),W(1,12),GC_93,ZERO,ZERO,PL(0,898)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,897),4,COEFS,1,4,WL(1,0,1
     $     ,898))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,898),0,4,99,1,1071,H)
C         Coefficient construction for loop diagram with ID 560
          CALL VVS1L2P0_1(PL(0,895),W(1,13),GC_92,ZERO,ZERO,PL(0,899)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,895),4,COEFS,4,4,WL(1,0,1
     $     ,899))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,899),2,4,99,1,1072,H)
C         Coefficient construction for loop diagram with ID 561
          CALL VSS1L2P0_1(PL(0,897),W(1,13),GC_3,ZERO,ZERO,PL(0,900)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,897),4,COEFS,1,4,WL(1,0,1
     $     ,900))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,900),1,4,99,1,1073,H)
C         Coefficient construction for loop diagram with ID 562
          CALL VSS1L1_3(PL(0,0),W(1,11),GC_3,MDL_MW,MDL_WW,PL(0,901)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,901))
          CALL VVS1L3P0_1(PL(0,901),W(1,12),GC_93,ZERO,ZERO,PL(0,902)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,901),4,COEFS,1,4,WL(1,0,1
     $     ,902))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,902),1,4,99,1,1074,H)
C         Coefficient construction for loop diagram with ID 563
          CALL VVS1L1_2(PL(0,0),W(1,11),GC_93,MDL_MW,MDL_WW,PL(0,903)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,903))
          CALL VVV1L2P0_1(PL(0,903),W(1,12),GC_4,ZERO,ZERO,PL(0,904)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_1(WL(1,0,1,903),4,COEFS,4,4,WL(1,0,1
     $     ,904))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,904),3,4,99,1,1075,H)
C         Coefficient construction for loop diagram with ID 564
          CALL VSS1L2P0_1(PL(0,901),W(1,13),GC_3,ZERO,ZERO,PL(0,905)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,901),4,COEFS,1,4,WL(1,0,1
     $     ,905))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,905),2,4,99,1,1076,H)
C         Coefficient construction for loop diagram with ID 565
          CALL VVS1L2P0_1(PL(0,903),W(1,13),GC_92,ZERO,ZERO,PL(0,906)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_0(WL(1,0,1,903),4,COEFS,4,4,WL(1,0,1
     $     ,906))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,906),2,4,99,1,1077,H)
C         Coefficient construction for loop diagram with ID 566
          CALL VVS1L1_3(PL(0,0),W(1,7),GC_99,MDL_MH,MDL_WH,PL(0,907)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,907))
          CALL VVS1L3_1(PL(0,907),W(1,15),GC_99,MDL_MZ,MDL_WZ,PL(0
     $     ,908),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,907),4,COEFS,1,4,WL(1,0,1
     $     ,908))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,908),1,4,101,1,1078,H)
C         Coefficient construction for loop diagram with ID 567
          CALL VSS1L3_1(PL(0,907),W(1,16),GC_78,MDL_MZ,MDL_WZ,PL(0
     $     ,909),COEFS)
          CALL ML5_0_UPDATE_WL_0_3(WL(1,0,1,907),4,COEFS,1,4,WL(1,0,1
     $     ,909))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,909),3,4,101,1,1079,H)
C         Coefficient construction for loop diagram with ID 568
          CALL VSS1L1_3(PL(0,0),W(1,8),GC_78,MDL_MH,MDL_WH,PL(0,910)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,910))
          CALL VVS1L3_1(PL(0,910),W(1,15),GC_99,MDL_MZ,MDL_WZ,PL(0
     $     ,911),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,910),4,COEFS,1,4,WL(1,0,1
     $     ,911))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,911),2,4,101,1,1080,H)
C         Coefficient construction for loop diagram with ID 569
          CALL VVSS1L2_1(PL(0,0),W(1,8),W(1,16),GC_83,MDL_MZ,MDL_WZ
     $     ,PL(0,912),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,912))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,912),2,4,100,2,1081,H)
C         Coefficient construction for loop diagram with ID 570
          CALL VSS1L3_1(PL(0,910),W(1,16),GC_78,MDL_MZ,MDL_WZ,PL(0
     $     ,913),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,910),4,COEFS,1,4,WL(1,0,1
     $     ,913))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,913),4,4,101,1,1082,H)
C         Coefficient construction for loop diagram with ID 571
          CALL VVSS1L2_1(PL(0,0),W(1,9),W(1,17),GC_83,MDL_MZ,MDL_WZ
     $     ,PL(0,914),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,914))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,914),2,4,100,2,1083,H)
C         Coefficient construction for loop diagram with ID 572
          CALL VSS1L1_2(PL(0,0),W(1,9),GC_78,MDL_MZ,MDL_WZ,PL(0,915)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,915))
          CALL VSS1L2_1(PL(0,915),W(1,17),GC_78,MDL_MZ,MDL_WZ,PL(0
     $     ,916),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,915),4,COEFS,1,4,WL(1,0,1
     $     ,916))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,916),4,4,102,1,1084,H)
C         Coefficient construction for loop diagram with ID 573
          CALL VVS1L2_1(PL(0,0),W(1,9),GC_99,MDL_MZ,MDL_WZ,PL(0,917)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,917))
          CALL VVS1L2_1(PL(0,917),W(1,17),GC_99,MDL_MZ,MDL_WZ,PL(0
     $     ,918),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,917),4,COEFS,4,4,WL(1,0,1
     $     ,918))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,918),4,4,102,2,1085,H)
C         Coefficient construction for loop diagram with ID 574
          CALL VVVV2L4_3(PL(0,0),W(1,10),W(1,12),GC_54,MDL_MZ,MDL_WZ
     $     ,PL(0,919),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,919))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,919),2,4,100,2,1086,H)
C         Coefficient construction for loop diagram with ID 575
          CALL VVV1L3_2(PL(0,0),W(1,10),GC_71,MDL_MW,MDL_WW,PL(0,920)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,920))
          CALL VVV1L1_3(PL(0,920),W(1,12),GC_71,MDL_MZ,MDL_WZ,PL(0
     $     ,921),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,920),4,COEFS,4,4,WL(1,0,1
     $     ,921))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,921),4,4,103,1,1087,H)
C         Coefficient construction for loop diagram with ID 576
          CALL VVS1L2_3(PL(0,0),W(1,10),GC_85,MDL_MW,MDL_WW,PL(0,922)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,922))
          CALL VVS1L3_2(PL(0,922),W(1,12),GC_84,MDL_MZ,MDL_WZ,PL(0
     $     ,923),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,922),4,COEFS,1,4,WL(1,0,1
     $     ,923))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,923),1,4,103,1,1088,H)
C         Coefficient construction for loop diagram with ID 577
          CALL VVS1L1_2(PL(0,920),W(1,13),GC_85,MDL_MZ,MDL_WZ,PL(0
     $     ,924),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,920),4,COEFS,4,4,WL(1,0,1
     $     ,924))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,924),4,4,103,1,1089,H)
C         Coefficient construction for loop diagram with ID 578
          CALL VSS1L2_1(PL(0,922),W(1,13),GC_79,MDL_MZ,MDL_WZ,PL(0
     $     ,925),COEFS)
          CALL ML5_0_UPDATE_WL_0_3(WL(1,0,1,922),4,COEFS,1,4,WL(1,0,1
     $     ,925))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,925),3,4,103,1,1090,H)
C         Coefficient construction for loop diagram with ID 579
          CALL VSS1L1_3(PL(0,0),W(1,11),GC_79,MDL_MW,MDL_WW,PL(0,926)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,926))
          CALL VVS1L3_2(PL(0,926),W(1,12),GC_84,MDL_MZ,MDL_WZ,PL(0
     $     ,927),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,926),4,COEFS,1,4,WL(1,0,1
     $     ,927))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,927),2,4,103,1,1091,H)
C         Coefficient construction for loop diagram with ID 580
          CALL VVS1L2_1(PL(0,0),W(1,11),GC_84,MDL_MW,MDL_WW,PL(0,928)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,928))
          CALL VVV1L1_3(PL(0,928),W(1,12),GC_71,MDL_MZ,MDL_WZ,PL(0
     $     ,929),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,928),4,COEFS,4,4,WL(1,0,1
     $     ,929))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,929),4,4,103,1,1092,H)
C         Coefficient construction for loop diagram with ID 581
          CALL VVSS1L2_1(PL(0,0),W(1,11),W(1,13),GC_82,MDL_MZ,MDL_WZ
     $     ,PL(0,930),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,930))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,930),2,4,100,2,1093,H)
C         Coefficient construction for loop diagram with ID 582
          CALL VSS1L2_1(PL(0,926),W(1,13),GC_79,MDL_MZ,MDL_WZ,PL(0
     $     ,931),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,926),4,COEFS,1,4,WL(1,0,1
     $     ,931))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,931),4,4,103,1,1094,H)
C         Coefficient construction for loop diagram with ID 583
          CALL VVS1L1_2(PL(0,928),W(1,13),GC_85,MDL_MZ,MDL_WZ,PL(0
     $     ,932),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,928),4,COEFS,4,4,WL(1,0,1
     $     ,932))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,932),4,4,103,1,1095,H)
C         Coefficient construction for loop diagram with ID 584
          CALL VVVV2L4_3(PL(0,0),W(1,6),W(1,14),GC_5,MDL_MW,MDL_WW
     $     ,PL(0,933),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,933))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,933),2,4,104,1,1096,H)
C         Coefficient construction for loop diagram with ID 585
          CALL VVV1L3_2(PL(0,0),W(1,6),GC_4,MDL_MW,MDL_WW,PL(0,934)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,934))
          CALL VVV1L3_2(PL(0,934),W(1,14),GC_4,MDL_MW,MDL_WW,PL(0,935)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,934),4,COEFS,4,4,WL(1,0,1
     $     ,935))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,935),4,4,105,1,1097,H)
C         Coefficient construction for loop diagram with ID 586
          CALL VVS1L2_3(PL(0,0),W(1,6),GC_93,MDL_MW,MDL_WW,PL(0,936)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,936))
          CALL VVS1L3_2(PL(0,936),W(1,14),GC_92,MDL_MW,MDL_WW,PL(0
     $     ,937),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,936),4,COEFS,1,4,WL(1,0,1
     $     ,937))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,937),1,4,105,1,1098,H)
C         Coefficient construction for loop diagram with ID 587
          CALL VVS1L2_3(PL(0,0),W(1,6),GC_92,MDL_MW,MDL_WW,PL(0,938)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,938))
          CALL VVS1L3_2(PL(0,938),W(1,14),GC_93,MDL_MW,MDL_WW,PL(0
     $     ,939),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,938),4,COEFS,1,4,WL(1,0,1
     $     ,939))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,939),1,4,105,1,1099,H)
C         Coefficient construction for loop diagram with ID 588
          CALL VVVV5L3_2(PL(0,0),W(1,6),W(1,15),GC_75,MDL_MW,MDL_WW
     $     ,PL(0,940),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,940))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,940),2,4,104,1,1100,H)
C         Coefficient construction for loop diagram with ID 589
          CALL VVV1L2_1(PL(0,934),W(1,15),GC_71,MDL_MW,MDL_WW,PL(0
     $     ,941),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,934),4,COEFS,4,4,WL(1,0,1
     $     ,941))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,941),4,4,105,1,1101,H)
C         Coefficient construction for loop diagram with ID 590
          CALL VVS1L3_1(PL(0,936),W(1,15),GC_85,MDL_MW,MDL_WW,PL(0
     $     ,942),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,936),4,COEFS,1,4,WL(1,0,1
     $     ,942))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,942),1,4,105,1,1102,H)
C         Coefficient construction for loop diagram with ID 591
          CALL VVS1L3_1(PL(0,938),W(1,15),GC_84,MDL_MW,MDL_WW,PL(0
     $     ,943),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,938),4,COEFS,1,4,WL(1,0,1
     $     ,943))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,943),1,4,105,1,1103,H)
C         Coefficient construction for loop diagram with ID 592
          CALL VSS1L3_1(PL(0,936),W(1,16),GC_57,MDL_MW,MDL_WW,PL(0
     $     ,944),COEFS)
          CALL ML5_0_UPDATE_WL_0_3(WL(1,0,1,936),4,COEFS,1,4,WL(1,0,1
     $     ,944))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,944),3,4,105,1,1104,H)
C         Coefficient construction for loop diagram with ID 593
          CALL VSS1L3_1(PL(0,938),W(1,16),GC_56,MDL_MW,MDL_WW,PL(0
     $     ,945),COEFS)
          CALL ML5_0_UPDATE_WL_0_3(WL(1,0,1,938),4,COEFS,1,4,WL(1,0,1
     $     ,945))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,945),3,4,105,1,1105,H)
C         Coefficient construction for loop diagram with ID 594
          CALL VVS1L2_1(PL(0,934),W(1,17),GC_90,MDL_MW,MDL_WW,PL(0
     $     ,946),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,934),4,COEFS,4,4,WL(1,0,1
     $     ,946))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,946),4,4,105,1,1106,H)
C         Coefficient construction for loop diagram with ID 595
          CALL VSS1L2_1(PL(0,936),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,947),COEFS)
          CALL ML5_0_UPDATE_WL_0_3(WL(1,0,1,936),4,COEFS,1,4,WL(1,0,1
     $     ,947))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,947),3,4,105,1,1107,H)
C         Coefficient construction for loop diagram with ID 596
          CALL VSS1L2_1(PL(0,938),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,948),COEFS)
          CALL ML5_0_UPDATE_WL_0_3(WL(1,0,1,938),4,COEFS,1,4,WL(1,0,1
     $     ,948))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,948),3,4,105,1,1108,H)
C         Coefficient construction for loop diagram with ID 597
          CALL VVVV5L3_2(PL(0,0),W(1,14),W(1,7),GC_75,MDL_MW,MDL_WW
     $     ,PL(0,949),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,949))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,949),2,4,104,1,1109,H)
C         Coefficient construction for loop diagram with ID 598
          CALL VVV1L2_1(PL(0,0),W(1,7),GC_71,MDL_MW,MDL_WW,PL(0,950)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,950))
          CALL VVV1L3_2(PL(0,950),W(1,14),GC_4,MDL_MW,MDL_WW,PL(0,951)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,950),4,COEFS,4,4,WL(1,0,1
     $     ,951))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,951),4,4,105,1,1110,H)
C         Coefficient construction for loop diagram with ID 599
          CALL VVS1L1_3(PL(0,0),W(1,7),GC_84,MDL_MW,MDL_WW,PL(0,952)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,952))
          CALL VVS1L3_2(PL(0,952),W(1,14),GC_92,MDL_MW,MDL_WW,PL(0
     $     ,953),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,952),4,COEFS,1,4,WL(1,0,1
     $     ,953))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,953),1,4,105,1,1111,H)
C         Coefficient construction for loop diagram with ID 600
          CALL VVS1L1_3(PL(0,0),W(1,7),GC_85,MDL_MW,MDL_WW,PL(0,954)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,954))
          CALL VVS1L3_2(PL(0,954),W(1,14),GC_93,MDL_MW,MDL_WW,PL(0
     $     ,955),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,954),4,COEFS,1,4,WL(1,0,1
     $     ,955))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,955),1,4,105,1,1112,H)
C         Coefficient construction for loop diagram with ID 601
          CALL VVVV2L2_1(PL(0,0),W(1,7),W(1,15),GC_54,MDL_MW,MDL_WW
     $     ,PL(0,956),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,956))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,956),2,4,104,1,1113,H)
C         Coefficient construction for loop diagram with ID 602
          CALL VVV1L2_1(PL(0,950),W(1,15),GC_71,MDL_MW,MDL_WW,PL(0
     $     ,957),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,950),4,COEFS,4,4,WL(1,0,1
     $     ,957))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,957),4,4,105,1,1114,H)
C         Coefficient construction for loop diagram with ID 603
          CALL VVS1L3_1(PL(0,952),W(1,15),GC_85,MDL_MW,MDL_WW,PL(0
     $     ,958),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,952),4,COEFS,1,4,WL(1,0,1
     $     ,958))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,958),1,4,105,1,1115,H)
C         Coefficient construction for loop diagram with ID 604
          CALL VVS1L3_1(PL(0,954),W(1,15),GC_84,MDL_MW,MDL_WW,PL(0
     $     ,959),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,954),4,COEFS,1,4,WL(1,0,1
     $     ,959))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,959),1,4,105,1,1116,H)
C         Coefficient construction for loop diagram with ID 605
          CALL VSS1L3_1(PL(0,952),W(1,16),GC_57,MDL_MW,MDL_WW,PL(0
     $     ,960),COEFS)
          CALL ML5_0_UPDATE_WL_0_3(WL(1,0,1,952),4,COEFS,1,4,WL(1,0,1
     $     ,960))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,960),3,4,105,1,1117,H)
C         Coefficient construction for loop diagram with ID 606
          CALL VSS1L3_1(PL(0,954),W(1,16),GC_56,MDL_MW,MDL_WW,PL(0
     $     ,961),COEFS)
          CALL ML5_0_UPDATE_WL_0_3(WL(1,0,1,954),4,COEFS,1,4,WL(1,0,1
     $     ,961))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,961),3,4,105,1,1118,H)
C         Coefficient construction for loop diagram with ID 607
          CALL VVS1L2_1(PL(0,950),W(1,17),GC_90,MDL_MW,MDL_WW,PL(0
     $     ,962),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,950),4,COEFS,4,4,WL(1,0,1
     $     ,962))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,962),4,4,105,1,1119,H)
C         Coefficient construction for loop diagram with ID 608
          CALL VSS1L2_1(PL(0,952),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,963),COEFS)
          CALL ML5_0_UPDATE_WL_0_3(WL(1,0,1,952),4,COEFS,1,4,WL(1,0,1
     $     ,963))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,963),3,4,105,1,1120,H)
C         Coefficient construction for loop diagram with ID 609
          CALL VSS1L2_1(PL(0,954),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,964),COEFS)
          CALL ML5_0_UPDATE_WL_0_3(WL(1,0,1,954),4,COEFS,1,4,WL(1,0,1
     $     ,964))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,964),3,4,105,1,1121,H)
C         Coefficient construction for loop diagram with ID 610
          CALL VSS1L1_3(PL(0,0),W(1,8),GC_56,MDL_MW,MDL_WW,PL(0,965)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,965))
          CALL VVS1L3_2(PL(0,965),W(1,14),GC_92,MDL_MW,MDL_WW,PL(0
     $     ,966),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,965),4,COEFS,1,4,WL(1,0,1
     $     ,966))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,966),2,4,105,1,1122,H)
C         Coefficient construction for loop diagram with ID 611
          CALL VSS1L1_3(PL(0,0),W(1,8),GC_57,MDL_MW,MDL_WW,PL(0,967)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,967))
          CALL VVS1L3_2(PL(0,967),W(1,14),GC_93,MDL_MW,MDL_WW,PL(0
     $     ,968),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,967),4,COEFS,1,4,WL(1,0,1
     $     ,968))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,968),2,4,105,1,1123,H)
C         Coefficient construction for loop diagram with ID 612
          CALL VVS1L3_1(PL(0,965),W(1,15),GC_85,MDL_MW,MDL_WW,PL(0
     $     ,969),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,965),4,COEFS,1,4,WL(1,0,1
     $     ,969))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,969),2,4,105,1,1124,H)
C         Coefficient construction for loop diagram with ID 613
          CALL VVS1L3_1(PL(0,967),W(1,15),GC_84,MDL_MW,MDL_WW,PL(0
     $     ,970),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,967),4,COEFS,1,4,WL(1,0,1
     $     ,970))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,970),2,4,105,1,1125,H)
C         Coefficient construction for loop diagram with ID 614
          CALL VVSS1L2_1(PL(0,0),W(1,8),W(1,16),GC_52,MDL_MW,MDL_WW
     $     ,PL(0,971),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,971))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,971),2,4,104,1,1126,H)
C         Coefficient construction for loop diagram with ID 615
          CALL VSS1L3_1(PL(0,965),W(1,16),GC_57,MDL_MW,MDL_WW,PL(0
     $     ,972),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,965),4,COEFS,1,4,WL(1,0,1
     $     ,972))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,972),4,4,105,1,1127,H)
C         Coefficient construction for loop diagram with ID 616
          CALL VSS1L3_1(PL(0,967),W(1,16),GC_56,MDL_MW,MDL_WW,PL(0
     $     ,973),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,967),4,COEFS,1,4,WL(1,0,1
     $     ,973))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,973),4,4,105,1,1128,H)
C         Coefficient construction for loop diagram with ID 617
          CALL VSS1L2_1(PL(0,965),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,974),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,965),4,COEFS,1,4,WL(1,0,1
     $     ,974))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,974),4,4,105,1,1129,H)
C         Coefficient construction for loop diagram with ID 618
          CALL VSS1L2_1(PL(0,967),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,975),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,967),4,COEFS,1,4,WL(1,0,1
     $     ,975))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,975),4,4,105,1,1130,H)
C         Coefficient construction for loop diagram with ID 619
          CALL VSS1L1_2(PL(0,0),W(1,9),GC_55,MDL_MW,MDL_WW,PL(0,976)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,976))
          CALL VVS1L3_2(PL(0,976),W(1,14),GC_92,MDL_MW,MDL_WW,PL(0
     $     ,977),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,976),4,COEFS,1,4,WL(1,0,1
     $     ,977))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,977),2,4,105,1,1131,H)
C         Coefficient construction for loop diagram with ID 620
          CALL VVS1L2_1(PL(0,0),W(1,9),GC_90,MDL_MW,MDL_WW,PL(0,978)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,978))
          CALL VVV1L3_2(PL(0,978),W(1,14),GC_4,MDL_MW,MDL_WW,PL(0,979)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,978),4,COEFS,4,4,WL(1,0,1
     $     ,979))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,979),4,4,105,1,1132,H)
C         Coefficient construction for loop diagram with ID 621
          CALL VSS1L1_2(PL(0,0),W(1,9),GC_55,MDL_MW,MDL_WW,PL(0,980)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,980))
          CALL VVS1L3_2(PL(0,980),W(1,14),GC_93,MDL_MW,MDL_WW,PL(0
     $     ,981),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,980),4,COEFS,1,4,WL(1,0,1
     $     ,981))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,981),2,4,105,1,1133,H)
C         Coefficient construction for loop diagram with ID 622
          CALL VVS1L3_1(PL(0,976),W(1,15),GC_85,MDL_MW,MDL_WW,PL(0
     $     ,982),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,976),4,COEFS,1,4,WL(1,0,1
     $     ,982))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,982),2,4,105,1,1134,H)
C         Coefficient construction for loop diagram with ID 623
          CALL VVV1L2_1(PL(0,978),W(1,15),GC_71,MDL_MW,MDL_WW,PL(0
     $     ,983),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,978),4,COEFS,4,4,WL(1,0,1
     $     ,983))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,983),4,4,105,1,1135,H)
C         Coefficient construction for loop diagram with ID 624
          CALL VVS1L3_1(PL(0,980),W(1,15),GC_84,MDL_MW,MDL_WW,PL(0
     $     ,984),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,980),4,COEFS,1,4,WL(1,0,1
     $     ,984))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,984),2,4,105,1,1136,H)
C         Coefficient construction for loop diagram with ID 625
          CALL VSS1L3_1(PL(0,976),W(1,16),GC_57,MDL_MW,MDL_WW,PL(0
     $     ,985),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,976),4,COEFS,1,4,WL(1,0,1
     $     ,985))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,985),4,4,105,1,1137,H)
C         Coefficient construction for loop diagram with ID 626
          CALL VSS1L3_1(PL(0,980),W(1,16),GC_56,MDL_MW,MDL_WW,PL(0
     $     ,986),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,980),4,COEFS,1,4,WL(1,0,1
     $     ,986))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,986),4,4,105,1,1138,H)
C         Coefficient construction for loop diagram with ID 627
          CALL VVSS1L2_1(PL(0,0),W(1,9),W(1,17),GC_52,MDL_MW,MDL_WW
     $     ,PL(0,987),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,987))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,987),2,4,104,1,1139,H)
C         Coefficient construction for loop diagram with ID 628
          CALL VSS1L2_1(PL(0,976),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,988),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,976),4,COEFS,1,4,WL(1,0,1
     $     ,988))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,988),4,4,105,1,1140,H)
C         Coefficient construction for loop diagram with ID 629
          CALL VVS1L2_1(PL(0,978),W(1,17),GC_90,MDL_MW,MDL_WW,PL(0
     $     ,989),COEFS)
          CALL ML5_0_UPDATE_WL_2_2(WL(1,0,1,978),4,COEFS,4,4,WL(1,0,1
     $     ,989))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,989),4,4,105,1,1141,H)
C         Coefficient construction for loop diagram with ID 630
          CALL VSS1L2_1(PL(0,980),W(1,17),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,990),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,980),4,COEFS,1,4,WL(1,0,1
     $     ,990))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,990),4,4,105,1,1142,H)
C         Coefficient construction for loop diagram with ID 631
          CALL VVVV2L3_1(PL(0,0),W(1,10),W(1,12),GC_53,MDL_MW,MDL_WW
     $     ,PL(0,991),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,991))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,991),2,4,104,1,1143,H)
C         Coefficient construction for loop diagram with ID 632
          CALL VVS1L2_3(PL(0,0),W(1,10),GC_90,MDL_MH,MDL_WH,PL(0,992)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,992))
          CALL VVS1L3_1(PL(0,992),W(1,12),GC_90,MDL_MW,MDL_WW,PL(0
     $     ,993),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,992),4,COEFS,1,4,WL(1,0,1
     $     ,993))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,993),1,4,107,1,1144,H)
C         Coefficient construction for loop diagram with ID 633
          CALL VSS1L3_1(PL(0,992),W(1,13),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,994),COEFS)
          CALL ML5_0_UPDATE_WL_0_3(WL(1,0,1,992),4,COEFS,1,4,WL(1,0,1
     $     ,994))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,994),3,4,107,1,1145,H)
C         Coefficient construction for loop diagram with ID 634
          CALL VSS1L1_3(PL(0,0),W(1,11),GC_55,MDL_MH,MDL_WH,PL(0,995)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,995))
          CALL VVS1L3_1(PL(0,995),W(1,12),GC_90,MDL_MW,MDL_WW,PL(0
     $     ,996),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,995),4,COEFS,1,4,WL(1,0,1
     $     ,996))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,996),2,4,107,1,1146,H)
C         Coefficient construction for loop diagram with ID 635
          CALL VVSS1L2_1(PL(0,0),W(1,11),W(1,13),GC_52,MDL_MW,MDL_WW
     $     ,PL(0,997),COEFS)
          CALL ML5_0_UPDATE_WL_0_2(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,997))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,997),2,4,104,1,1147,H)
C         Coefficient construction for loop diagram with ID 636
          CALL VSS1L1_2(PL(0,0),W(1,11),GC_56,MDL_MZ,MDL_WZ,PL(0,998)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1
     $     ,998))
          CALL VSS1L2_1(PL(0,998),W(1,13),GC_57,MDL_MW,MDL_WW,PL(0
     $     ,999),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,998),4,COEFS,1,4,WL(1,0,1
     $     ,999))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,999),4,4,106,1,1148,H)
C         Coefficient construction for loop diagram with ID 637
          CALL VSS1L3_1(PL(0,995),W(1,13),GC_55,MDL_MW,MDL_WW,PL(0
     $     ,1000),COEFS)
          CALL ML5_0_UPDATE_WL_1_3(WL(1,0,1,995),4,COEFS,1,4,WL(1,0,1
     $     ,1000))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1000),4,4,107,1,1149,H)
C         Coefficient construction for loop diagram with ID 638
          CALL UUV1L1_2(PL(0,0),W(1,10),GC_3,MDL_MW,ZERO,PL(0,1001)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1001))
          CALL UUV1L1_2(PL(0,1001),W(1,12),GC_3,ZERO,ZERO,PL(0,1002)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1001),1,COEFS,1,1,WL(1,0,1
     $     ,1002))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1002),2,1,99,1,1150,H)
C         Coefficient construction for loop diagram with ID 639
          CALL UUV1L2_1(PL(0,0),W(1,10),GC_4,MDL_MW,ZERO,PL(0,1003)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1003))
          CALL UUV1L2_1(PL(0,1003),W(1,12),GC_4,ZERO,ZERO,PL(0,1004)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1003),1,COEFS,1,1,WL(1,0,1
     $     ,1004))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1004),2,1,99,1,1151,H)
C         Coefficient construction for loop diagram with ID 640
          CALL UUS1L1_2(PL(0,1001),W(1,13),GC_93,ZERO,ZERO,PL(0,1005)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1001),1,COEFS,1,1,WL(1,0,1
     $     ,1005))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1005),1,1,99,1,1152,H)
C         Coefficient construction for loop diagram with ID 641
          CALL UUS1L2_1(PL(0,0),W(1,11),GC_92,MDL_MW,ZERO,PL(0,1006)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1006))
          CALL UUV1L2_1(PL(0,1006),W(1,12),GC_4,ZERO,ZERO,PL(0,1007)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1006),1,COEFS,1,1,WL(1,0,1
     $     ,1007))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1007),1,1,99,1,1153,H)
C         Coefficient construction for loop diagram with ID 642
          CALL UUS1L1_2(PL(0,0),W(1,9),GC_98,MDL_MZ,ZERO,PL(0,1008)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1008))
          CALL UUS1L1_2(PL(0,1008),W(1,17),GC_98,MDL_MZ,ZERO,PL(0
     $     ,1009),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1008),1,COEFS,1,1,WL(1,0,1
     $     ,1009))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1009),0,1,102,1,1154,H)
C         Coefficient construction for loop diagram with ID 643
          CALL UUV1L1_2(PL(0,0),W(1,10),GC_70,MDL_MW,ZERO,PL(0,1010)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1010))
          CALL UUV1L1_2(PL(0,1010),W(1,12),GC_70,MDL_MZ,ZERO,PL(0
     $     ,1011),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1010),1,COEFS,1,1,WL(1,0,1
     $     ,1011))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1011),2,1,103,1,1155,H)
C         Coefficient construction for loop diagram with ID 644
          CALL UUV1L2_1(PL(0,0),W(1,10),GC_71,MDL_MW,ZERO,PL(0,1012)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1012))
          CALL UUV1L2_1(PL(0,1012),W(1,12),GC_71,MDL_MZ,ZERO,PL(0
     $     ,1013),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1012),1,COEFS,1,1,WL(1,0,1
     $     ,1013))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1013),2,1,103,1,1156,H)
C         Coefficient construction for loop diagram with ID 645
          CALL UUS1L1_2(PL(0,1010),W(1,13),GC_96,MDL_MZ,ZERO,PL(0
     $     ,1014),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1010),1,COEFS,1,1,WL(1,0,1
     $     ,1014))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1014),1,1,103,1,1157,H)
C         Coefficient construction for loop diagram with ID 646
          CALL UUS1L2_1(PL(0,1012),W(1,13),GC_94,MDL_MZ,ZERO,PL(0
     $     ,1015),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1012),1,COEFS,1,1,WL(1,0,1
     $     ,1015))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1015),1,1,103,1,1158,H)
C         Coefficient construction for loop diagram with ID 647
          CALL UUS1L1_2(PL(0,0),W(1,11),GC_97,MDL_MW,ZERO,PL(0,1016)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1016))
          CALL UUV1L1_2(PL(0,1016),W(1,12),GC_70,MDL_MZ,ZERO,PL(0
     $     ,1017),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1016),1,COEFS,1,1,WL(1,0,1
     $     ,1017))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1017),1,1,103,1,1159,H)
C         Coefficient construction for loop diagram with ID 648
          CALL UUS1L2_1(PL(0,0),W(1,11),GC_95,MDL_MW,ZERO,PL(0,1018)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1018))
          CALL UUV1L2_1(PL(0,1018),W(1,12),GC_71,MDL_MZ,ZERO,PL(0
     $     ,1019),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1018),1,COEFS,1,1,WL(1,0,1
     $     ,1019))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1019),1,1,103,1,1160,H)
C         Coefficient construction for loop diagram with ID 649
          CALL UUS1L1_2(PL(0,1016),W(1,13),GC_96,MDL_MZ,ZERO,PL(0
     $     ,1020),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1016),1,COEFS,1,1,WL(1,0,1
     $     ,1020))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1020),0,1,103,1,1161,H)
C         Coefficient construction for loop diagram with ID 650
          CALL UUS1L2_1(PL(0,1018),W(1,13),GC_94,MDL_MZ,ZERO,PL(0
     $     ,1021),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1018),1,COEFS,1,1,WL(1,0,1
     $     ,1021))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1021),0,1,103,1,1162,H)
C         Coefficient construction for loop diagram with ID 651
          CALL UUV1L1_2(PL(0,0),W(1,6),GC_3,MDL_MW,ZERO,PL(0,1022)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1022))
          CALL UUV1L1_2(PL(0,1022),W(1,14),GC_3,MDL_MW,ZERO,PL(0,1023)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1022),1,COEFS,1,1,WL(1,0,1
     $     ,1023))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1023),2,1,105,1,1163,H)
C         Coefficient construction for loop diagram with ID 652
          CALL UUV1L1_2(PL(0,1022),W(1,15),GC_70,MDL_MW,ZERO,PL(0
     $     ,1024),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1022),1,COEFS,1,1,WL(1,0,1
     $     ,1024))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1024),2,1,105,1,1164,H)
C         Coefficient construction for loop diagram with ID 653
          CALL UUS1L1_2(PL(0,1022),W(1,16),GC_91,MDL_MW,ZERO,PL(0
     $     ,1025),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1022),1,COEFS,1,1,WL(1,0,1
     $     ,1025))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1025),1,1,105,1,1165,H)
C         Coefficient construction for loop diagram with ID 654
          CALL UUS1L1_2(PL(0,1022),W(1,17),GC_89,MDL_MW,ZERO,PL(0
     $     ,1026),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1022),1,COEFS,1,1,WL(1,0,1
     $     ,1026))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1026),1,1,105,1,1166,H)
C         Coefficient construction for loop diagram with ID 655
          CALL UUV1L1_2(PL(0,0),W(1,7),GC_70,MDL_MW,ZERO,PL(0,1027)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1027))
          CALL UUV1L1_2(PL(0,1027),W(1,14),GC_3,MDL_MW,ZERO,PL(0,1028)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1027),1,COEFS,1,1,WL(1,0,1
     $     ,1028))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1028),2,1,105,1,1167,H)
C         Coefficient construction for loop diagram with ID 656
          CALL UUV1L1_2(PL(0,1027),W(1,15),GC_70,MDL_MW,ZERO,PL(0
     $     ,1029),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1027),1,COEFS,1,1,WL(1,0,1
     $     ,1029))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1029),2,1,105,1,1168,H)
C         Coefficient construction for loop diagram with ID 657
          CALL UUS1L1_2(PL(0,1027),W(1,16),GC_91,MDL_MW,ZERO,PL(0
     $     ,1030),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1027),1,COEFS,1,1,WL(1,0,1
     $     ,1030))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1030),1,1,105,1,1169,H)
C         Coefficient construction for loop diagram with ID 658
          CALL UUS1L1_2(PL(0,1027),W(1,17),GC_89,MDL_MW,ZERO,PL(0
     $     ,1031),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1027),1,COEFS,1,1,WL(1,0,1
     $     ,1031))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1031),1,1,105,1,1170,H)
C         Coefficient construction for loop diagram with ID 659
          CALL UUS1L1_2(PL(0,0),W(1,8),GC_91,MDL_MW,ZERO,PL(0,1032)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1032))
          CALL UUV1L1_2(PL(0,1032),W(1,14),GC_3,MDL_MW,ZERO,PL(0,1033)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1032),1,COEFS,1,1,WL(1,0,1
     $     ,1033))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1033),1,1,105,1,1171,H)
C         Coefficient construction for loop diagram with ID 660
          CALL UUV1L1_2(PL(0,1032),W(1,15),GC_70,MDL_MW,ZERO,PL(0
     $     ,1034),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1032),1,COEFS,1,1,WL(1,0,1
     $     ,1034))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1034),1,1,105,1,1172,H)
C         Coefficient construction for loop diagram with ID 661
          CALL UUS1L1_2(PL(0,1032),W(1,16),GC_91,MDL_MW,ZERO,PL(0
     $     ,1035),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1032),1,COEFS,1,1,WL(1,0,1
     $     ,1035))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1035),0,1,105,1,1173,H)
C         Coefficient construction for loop diagram with ID 662
          CALL UUS1L1_2(PL(0,1032),W(1,17),GC_89,MDL_MW,ZERO,PL(0
     $     ,1036),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1032),1,COEFS,1,1,WL(1,0,1
     $     ,1036))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1036),0,1,105,1,1174,H)
C         Coefficient construction for loop diagram with ID 663
          CALL UUS1L1_2(PL(0,0),W(1,9),GC_89,MDL_MW,ZERO,PL(0,1037)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1037))
          CALL UUV1L1_2(PL(0,1037),W(1,14),GC_3,MDL_MW,ZERO,PL(0,1038)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1037),1,COEFS,1,1,WL(1,0,1
     $     ,1038))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1038),1,1,105,1,1175,H)
C         Coefficient construction for loop diagram with ID 664
          CALL UUV1L1_2(PL(0,1037),W(1,15),GC_70,MDL_MW,ZERO,PL(0
     $     ,1039),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1037),1,COEFS,1,1,WL(1,0,1
     $     ,1039))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1039),1,1,105,1,1176,H)
C         Coefficient construction for loop diagram with ID 665
          CALL UUS1L1_2(PL(0,1037),W(1,16),GC_91,MDL_MW,ZERO,PL(0
     $     ,1040),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1037),1,COEFS,1,1,WL(1,0,1
     $     ,1040))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1040),0,1,105,1,1177,H)
C         Coefficient construction for loop diagram with ID 666
          CALL UUS1L1_2(PL(0,1037),W(1,17),GC_89,MDL_MW,ZERO,PL(0
     $     ,1041),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1037),1,COEFS,1,1,WL(1,0,1
     $     ,1041))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1041),0,1,105,1,1178,H)
C         Coefficient construction for loop diagram with ID 667
          CALL UUV1L1_2(PL(0,0),W(1,6),GC_4,MDL_MW,ZERO,PL(0,1042)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1042))
          CALL UUV1L1_2(PL(0,1042),W(1,14),GC_4,MDL_MW,ZERO,PL(0,1043)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1042),1,COEFS,1,1,WL(1,0,1
     $     ,1043))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1043),2,1,105,1,1179,H)
C         Coefficient construction for loop diagram with ID 668
          CALL UUV1L1_2(PL(0,1042),W(1,15),GC_71,MDL_MW,ZERO,PL(0
     $     ,1044),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1042),1,COEFS,1,1,WL(1,0,1
     $     ,1044))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1044),2,1,105,1,1180,H)
C         Coefficient construction for loop diagram with ID 669
          CALL UUS1L1_2(PL(0,1042),W(1,16),GC_88,MDL_MW,ZERO,PL(0
     $     ,1045),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1042),1,COEFS,1,1,WL(1,0,1
     $     ,1045))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1045),1,1,105,1,1181,H)
C         Coefficient construction for loop diagram with ID 670
          CALL UUS1L1_2(PL(0,1042),W(1,17),GC_89,MDL_MW,ZERO,PL(0
     $     ,1046),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1042),1,COEFS,1,1,WL(1,0,1
     $     ,1046))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1046),1,1,105,1,1182,H)
C         Coefficient construction for loop diagram with ID 671
          CALL UUV1L1_2(PL(0,0),W(1,7),GC_71,MDL_MW,ZERO,PL(0,1047)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1047))
          CALL UUV1L1_2(PL(0,1047),W(1,14),GC_4,MDL_MW,ZERO,PL(0,1048)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1047),1,COEFS,1,1,WL(1,0,1
     $     ,1048))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1048),2,1,105,1,1183,H)
C         Coefficient construction for loop diagram with ID 672
          CALL UUV1L1_2(PL(0,1047),W(1,15),GC_71,MDL_MW,ZERO,PL(0
     $     ,1049),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1047),1,COEFS,1,1,WL(1,0,1
     $     ,1049))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1049),2,1,105,1,1184,H)
C         Coefficient construction for loop diagram with ID 673
          CALL UUS1L1_2(PL(0,1047),W(1,16),GC_88,MDL_MW,ZERO,PL(0
     $     ,1050),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1047),1,COEFS,1,1,WL(1,0,1
     $     ,1050))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1050),1,1,105,1,1185,H)
C         Coefficient construction for loop diagram with ID 674
          CALL UUS1L1_2(PL(0,1047),W(1,17),GC_89,MDL_MW,ZERO,PL(0
     $     ,1051),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1047),1,COEFS,1,1,WL(1,0,1
     $     ,1051))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1051),1,1,105,1,1186,H)
C         Coefficient construction for loop diagram with ID 675
          CALL UUS1L1_2(PL(0,0),W(1,8),GC_88,MDL_MW,ZERO,PL(0,1052)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1052))
          CALL UUV1L1_2(PL(0,1052),W(1,14),GC_4,MDL_MW,ZERO,PL(0,1053)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1052),1,COEFS,1,1,WL(1,0,1
     $     ,1053))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1053),1,1,105,1,1187,H)
C         Coefficient construction for loop diagram with ID 676
          CALL UUV1L1_2(PL(0,1052),W(1,15),GC_71,MDL_MW,ZERO,PL(0
     $     ,1054),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1052),1,COEFS,1,1,WL(1,0,1
     $     ,1054))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1054),1,1,105,1,1188,H)
C         Coefficient construction for loop diagram with ID 677
          CALL UUS1L1_2(PL(0,1052),W(1,16),GC_88,MDL_MW,ZERO,PL(0
     $     ,1055),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1052),1,COEFS,1,1,WL(1,0,1
     $     ,1055))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1055),0,1,105,1,1189,H)
C         Coefficient construction for loop diagram with ID 678
          CALL UUS1L1_2(PL(0,1052),W(1,17),GC_89,MDL_MW,ZERO,PL(0
     $     ,1056),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1052),1,COEFS,1,1,WL(1,0,1
     $     ,1056))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1056),0,1,105,1,1190,H)
C         Coefficient construction for loop diagram with ID 679
          CALL UUS1L1_2(PL(0,0),W(1,9),GC_89,MDL_MW,ZERO,PL(0,1057)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1057))
          CALL UUV1L1_2(PL(0,1057),W(1,14),GC_4,MDL_MW,ZERO,PL(0,1058)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1057),1,COEFS,1,1,WL(1,0,1
     $     ,1058))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1058),1,1,105,1,1191,H)
C         Coefficient construction for loop diagram with ID 680
          CALL UUV1L1_2(PL(0,1057),W(1,15),GC_71,MDL_MW,ZERO,PL(0
     $     ,1059),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1057),1,COEFS,1,1,WL(1,0,1
     $     ,1059))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1059),1,1,105,1,1192,H)
C         Coefficient construction for loop diagram with ID 681
          CALL UUS1L1_2(PL(0,1057),W(1,16),GC_88,MDL_MW,ZERO,PL(0
     $     ,1060),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1057),1,COEFS,1,1,WL(1,0,1
     $     ,1060))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1060),0,1,105,1,1193,H)
C         Coefficient construction for loop diagram with ID 682
          CALL UUS1L1_2(PL(0,1057),W(1,17),GC_89,MDL_MW,ZERO,PL(0
     $     ,1061),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1057),1,COEFS,1,1,WL(1,0,1
     $     ,1061))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1061),0,1,105,1,1194,H)
C         Coefficient construction for loop diagram with ID 683
          CALL FFV2L2_1(PL(0,0),W(1,7),GC_80,ZERO,ZERO,PL(0,1062)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1062))
          CALL FFV2L2_1(PL(0,1062),W(1,15),GC_80,ZERO,ZERO,PL(0,1063)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1062),4,COEFS,4,4,WL(1,0,1
     $     ,1063))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1063),2,4,108,1,1195,H)
C         Coefficient construction for loop diagram with ID 684
          CALL FFV2L1_2(PL(0,0),W(1,10),GC_58,ZERO,ZERO,PL(0,1064)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1064))
          CALL FFV2L1_2(PL(0,1064),W(1,12),GC_58,MDL_ME,ZERO,PL(0
     $     ,1065),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1064),4,COEFS,4,4,WL(1,0,1
     $     ,1065))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1065),2,4,109,1,1196,H)
C         Coefficient construction for loop diagram with ID 685
          CALL FFS1L1_2(PL(0,1064),W(1,13),GC_107,MDL_ME,ZERO,PL(0
     $     ,1066),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1064),4,COEFS,4,4,WL(1,0,1
     $     ,1066))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1066),2,4,109,1,1197,H)
C         Coefficient construction for loop diagram with ID 686
          CALL FFS3L1_2(PL(0,0),W(1,11),GC_106,ZERO,ZERO,PL(0,1067)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1067))
          CALL FFV2L1_2(PL(0,1067),W(1,12),GC_58,MDL_ME,ZERO,PL(0
     $     ,1068),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1067),4,COEFS,4,4,WL(1,0,1
     $     ,1068))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1068),2,4,109,1,1198,H)
C         Coefficient construction for loop diagram with ID 687
          CALL FFS1L1_2(PL(0,1067),W(1,13),GC_107,MDL_ME,ZERO,PL(0
     $     ,1069),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1067),4,COEFS,4,4,WL(1,0,1
     $     ,1069))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1069),2,4,109,1,1199,H)
C         Coefficient construction for loop diagram with ID 688
          CALL FFV2L2_1(PL(0,0),W(1,7),GC_80,ZERO,ZERO,PL(0,1070)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1070))
          CALL FFV2L2_1(PL(0,1070),W(1,15),GC_80,ZERO,ZERO,PL(0,1071)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1070),4,COEFS,4,4,WL(1,0,1
     $     ,1071))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1071),2,4,108,1,1200,H)
C         Coefficient construction for loop diagram with ID 689
          CALL FFV2L1_2(PL(0,0),W(1,10),GC_58,ZERO,ZERO,PL(0,1072)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1072))
          CALL FFV2L1_2(PL(0,1072),W(1,12),GC_58,MDL_MM,ZERO,PL(0
     $     ,1073),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1072),4,COEFS,4,4,WL(1,0,1
     $     ,1073))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1073),2,4,110,1,1201,H)
C         Coefficient construction for loop diagram with ID 690
          CALL FFS1L1_2(PL(0,1072),W(1,13),GC_111,MDL_MM,ZERO,PL(0
     $     ,1074),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1072),4,COEFS,4,4,WL(1,0,1
     $     ,1074))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1074),2,4,110,1,1202,H)
C         Coefficient construction for loop diagram with ID 691
          CALL FFS3L1_2(PL(0,0),W(1,11),GC_110,ZERO,ZERO,PL(0,1075)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1075))
          CALL FFV2L1_2(PL(0,1075),W(1,12),GC_58,MDL_MM,ZERO,PL(0
     $     ,1076),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1075),4,COEFS,4,4,WL(1,0,1
     $     ,1076))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1076),2,4,110,1,1203,H)
C         Coefficient construction for loop diagram with ID 692
          CALL FFS1L1_2(PL(0,1075),W(1,13),GC_111,MDL_MM,ZERO,PL(0
     $     ,1077),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1075),4,COEFS,4,4,WL(1,0,1
     $     ,1077))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1077),2,4,110,1,1204,H)
C         Coefficient construction for loop diagram with ID 693
          CALL FFV2L2_1(PL(0,0),W(1,7),GC_80,ZERO,ZERO,PL(0,1078)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1078))
          CALL FFV2L2_1(PL(0,1078),W(1,15),GC_80,ZERO,ZERO,PL(0,1079)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1078),4,COEFS,4,4,WL(1,0,1
     $     ,1079))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1079),2,4,108,1,1205,H)
C         Coefficient construction for loop diagram with ID 694
          CALL FFV2L1_2(PL(0,0),W(1,10),GC_58,ZERO,ZERO,PL(0,1080)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1080))
          CALL FFV2L1_2(PL(0,1080),W(1,12),GC_58,MDL_MTA,ZERO,PL(0
     $     ,1081),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1080),4,COEFS,4,4,WL(1,0,1
     $     ,1081))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1081),2,4,111,1,1206,H)
C         Coefficient construction for loop diagram with ID 695
          CALL FFS1L1_2(PL(0,1080),W(1,13),GC_119,MDL_MTA,ZERO,PL(0
     $     ,1082),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1080),4,COEFS,4,4,WL(1,0,1
     $     ,1082))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1082),2,4,111,1,1207,H)
C         Coefficient construction for loop diagram with ID 696
          CALL FFS3L1_2(PL(0,0),W(1,11),GC_118,ZERO,ZERO,PL(0,1083)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1083))
          CALL FFV2L1_2(PL(0,1083),W(1,12),GC_58,MDL_MTA,ZERO,PL(0
     $     ,1084),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1083),4,COEFS,4,4,WL(1,0,1
     $     ,1084))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1084),2,4,111,1,1208,H)
C         Coefficient construction for loop diagram with ID 697
          CALL FFS1L1_2(PL(0,1083),W(1,13),GC_119,MDL_MTA,ZERO,PL(0
     $     ,1085),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1083),4,COEFS,4,4,WL(1,0,1
     $     ,1085))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1085),2,4,111,1,1209,H)
C         Coefficient construction for loop diagram with ID 698
          CALL FFV1L2_1(PL(0,0),W(1,6),GC_3,MDL_ME,ZERO,PL(0,1086)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1086))
          CALL FFV1L2_1(PL(0,1086),W(1,14),GC_3,MDL_ME,ZERO,PL(0,1087)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1086),4,COEFS,4,4,WL(1,0,1
     $     ,1087))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1087),2,4,112,1,1210,H)
C         Coefficient construction for loop diagram with ID 699
          CALL FFV2_4L2_1(PL(0,1086),W(1,15),GC_68,GC_77,MDL_ME,ZERO
     $     ,PL(0,1088),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1086),4,COEFS,4,4,WL(1,0,1
     $     ,1088))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1088),2,4,112,1,1211,H)
C         Coefficient construction for loop diagram with ID 700
          CALL FFS2L2_1(PL(0,1086),W(1,16),GC_108,MDL_ME,ZERO,PL(0
     $     ,1089),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1086),4,COEFS,4,4,WL(1,0,1
     $     ,1089))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1089),2,4,112,1,1212,H)
C         Coefficient construction for loop diagram with ID 701
          CALL FFS4L2_1(PL(0,1086),W(1,17),GC_109,MDL_ME,ZERO,PL(0
     $     ,1090),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1086),4,COEFS,4,4,WL(1,0,1
     $     ,1090))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1090),2,4,112,1,1213,H)
C         Coefficient construction for loop diagram with ID 702
          CALL FFV2_4L2_1(PL(0,0),W(1,7),GC_68,GC_77,MDL_ME,ZERO,PL(0
     $     ,1091),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1091))
          CALL FFV1L2_1(PL(0,1091),W(1,14),GC_3,MDL_ME,ZERO,PL(0,1092)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1091),4,COEFS,4,4,WL(1,0,1
     $     ,1092))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1092),2,4,112,1,1214,H)
C         Coefficient construction for loop diagram with ID 703
          CALL FFV2_4L2_1(PL(0,1091),W(1,15),GC_68,GC_77,MDL_ME,ZERO
     $     ,PL(0,1093),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1091),4,COEFS,4,4,WL(1,0,1
     $     ,1093))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1093),2,4,112,1,1215,H)
C         Coefficient construction for loop diagram with ID 704
          CALL FFS2L2_1(PL(0,1091),W(1,16),GC_108,MDL_ME,ZERO,PL(0
     $     ,1094),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1091),4,COEFS,4,4,WL(1,0,1
     $     ,1094))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1094),2,4,112,1,1216,H)
C         Coefficient construction for loop diagram with ID 705
          CALL FFS4L2_1(PL(0,1091),W(1,17),GC_109,MDL_ME,ZERO,PL(0
     $     ,1095),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1091),4,COEFS,4,4,WL(1,0,1
     $     ,1095))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1095),2,4,112,1,1217,H)
C         Coefficient construction for loop diagram with ID 706
          CALL FFS2L2_1(PL(0,0),W(1,8),GC_108,MDL_ME,ZERO,PL(0,1096)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1096))
          CALL FFV1L2_1(PL(0,1096),W(1,14),GC_3,MDL_ME,ZERO,PL(0,1097)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1096),4,COEFS,4,4,WL(1,0,1
     $     ,1097))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1097),2,4,112,1,1218,H)
C         Coefficient construction for loop diagram with ID 707
          CALL FFV2_4L2_1(PL(0,1096),W(1,15),GC_68,GC_77,MDL_ME,ZERO
     $     ,PL(0,1098),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1096),4,COEFS,4,4,WL(1,0,1
     $     ,1098))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1098),2,4,112,1,1219,H)
C         Coefficient construction for loop diagram with ID 708
          CALL FFS2L2_1(PL(0,1096),W(1,16),GC_108,MDL_ME,ZERO,PL(0
     $     ,1099),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1096),4,COEFS,4,4,WL(1,0,1
     $     ,1099))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1099),2,4,112,1,1220,H)
C         Coefficient construction for loop diagram with ID 709
          CALL FFS4L2_1(PL(0,1096),W(1,17),GC_109,MDL_ME,ZERO,PL(0
     $     ,1100),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1096),4,COEFS,4,4,WL(1,0,1
     $     ,1100))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1100),2,4,112,1,1221,H)
C         Coefficient construction for loop diagram with ID 710
          CALL FFS4L2_1(PL(0,0),W(1,9),GC_109,MDL_ME,ZERO,PL(0,1101)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1101))
          CALL FFV1L2_1(PL(0,1101),W(1,14),GC_3,MDL_ME,ZERO,PL(0,1102)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1101),4,COEFS,4,4,WL(1,0,1
     $     ,1102))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1102),2,4,112,1,1222,H)
C         Coefficient construction for loop diagram with ID 711
          CALL FFV2_4L2_1(PL(0,1101),W(1,15),GC_68,GC_77,MDL_ME,ZERO
     $     ,PL(0,1103),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1101),4,COEFS,4,4,WL(1,0,1
     $     ,1103))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1103),2,4,112,1,1223,H)
C         Coefficient construction for loop diagram with ID 712
          CALL FFS2L2_1(PL(0,1101),W(1,16),GC_108,MDL_ME,ZERO,PL(0
     $     ,1104),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1101),4,COEFS,4,4,WL(1,0,1
     $     ,1104))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1104),2,4,112,1,1224,H)
C         Coefficient construction for loop diagram with ID 713
          CALL FFS4L2_1(PL(0,1101),W(1,17),GC_109,MDL_ME,ZERO,PL(0
     $     ,1105),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1101),4,COEFS,4,4,WL(1,0,1
     $     ,1105))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1105),2,4,112,1,1225,H)
C         Coefficient construction for loop diagram with ID 714
          CALL FFV1L2_1(PL(0,0),W(1,6),GC_3,MDL_MM,ZERO,PL(0,1106)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1106))
          CALL FFV1L2_1(PL(0,1106),W(1,14),GC_3,MDL_MM,ZERO,PL(0,1107)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1106),4,COEFS,4,4,WL(1,0,1
     $     ,1107))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1107),2,4,113,1,1226,H)
C         Coefficient construction for loop diagram with ID 715
          CALL FFV2_4L2_1(PL(0,1106),W(1,15),GC_68,GC_77,MDL_MM,ZERO
     $     ,PL(0,1108),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1106),4,COEFS,4,4,WL(1,0,1
     $     ,1108))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1108),2,4,113,1,1227,H)
C         Coefficient construction for loop diagram with ID 716
          CALL FFS2L2_1(PL(0,1106),W(1,16),GC_112,MDL_MM,ZERO,PL(0
     $     ,1109),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1106),4,COEFS,4,4,WL(1,0,1
     $     ,1109))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1109),2,4,113,1,1228,H)
C         Coefficient construction for loop diagram with ID 717
          CALL FFS4L2_1(PL(0,1106),W(1,17),GC_113,MDL_MM,ZERO,PL(0
     $     ,1110),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1106),4,COEFS,4,4,WL(1,0,1
     $     ,1110))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1110),2,4,113,1,1229,H)
C         Coefficient construction for loop diagram with ID 718
          CALL FFV2_4L2_1(PL(0,0),W(1,7),GC_68,GC_77,MDL_MM,ZERO,PL(0
     $     ,1111),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1111))
          CALL FFV1L2_1(PL(0,1111),W(1,14),GC_3,MDL_MM,ZERO,PL(0,1112)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1111),4,COEFS,4,4,WL(1,0,1
     $     ,1112))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1112),2,4,113,1,1230,H)
C         Coefficient construction for loop diagram with ID 719
          CALL FFV2_4L2_1(PL(0,1111),W(1,15),GC_68,GC_77,MDL_MM,ZERO
     $     ,PL(0,1113),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1111),4,COEFS,4,4,WL(1,0,1
     $     ,1113))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1113),2,4,113,1,1231,H)
C         Coefficient construction for loop diagram with ID 720
          CALL FFS2L2_1(PL(0,1111),W(1,16),GC_112,MDL_MM,ZERO,PL(0
     $     ,1114),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1111),4,COEFS,4,4,WL(1,0,1
     $     ,1114))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1114),2,4,113,1,1232,H)
C         Coefficient construction for loop diagram with ID 721
          CALL FFS4L2_1(PL(0,1111),W(1,17),GC_113,MDL_MM,ZERO,PL(0
     $     ,1115),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1111),4,COEFS,4,4,WL(1,0,1
     $     ,1115))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1115),2,4,113,1,1233,H)
C         Coefficient construction for loop diagram with ID 722
          CALL FFS2L2_1(PL(0,0),W(1,8),GC_112,MDL_MM,ZERO,PL(0,1116)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1116))
          CALL FFV1L2_1(PL(0,1116),W(1,14),GC_3,MDL_MM,ZERO,PL(0,1117)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1116),4,COEFS,4,4,WL(1,0,1
     $     ,1117))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1117),2,4,113,1,1234,H)
C         Coefficient construction for loop diagram with ID 723
          CALL FFV2_4L2_1(PL(0,1116),W(1,15),GC_68,GC_77,MDL_MM,ZERO
     $     ,PL(0,1118),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1116),4,COEFS,4,4,WL(1,0,1
     $     ,1118))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1118),2,4,113,1,1235,H)
C         Coefficient construction for loop diagram with ID 724
          CALL FFS2L2_1(PL(0,1116),W(1,16),GC_112,MDL_MM,ZERO,PL(0
     $     ,1119),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1116),4,COEFS,4,4,WL(1,0,1
     $     ,1119))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1119),2,4,113,1,1236,H)
C         Coefficient construction for loop diagram with ID 725
          CALL FFS4L2_1(PL(0,1116),W(1,17),GC_113,MDL_MM,ZERO,PL(0
     $     ,1120),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1116),4,COEFS,4,4,WL(1,0,1
     $     ,1120))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1120),2,4,113,1,1237,H)
C         Coefficient construction for loop diagram with ID 726
          CALL FFS4L2_1(PL(0,0),W(1,9),GC_113,MDL_MM,ZERO,PL(0,1121)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1121))
          CALL FFV1L2_1(PL(0,1121),W(1,14),GC_3,MDL_MM,ZERO,PL(0,1122)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1121),4,COEFS,4,4,WL(1,0,1
     $     ,1122))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1122),2,4,113,1,1238,H)
C         Coefficient construction for loop diagram with ID 727
          CALL FFV2_4L2_1(PL(0,1121),W(1,15),GC_68,GC_77,MDL_MM,ZERO
     $     ,PL(0,1123),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1121),4,COEFS,4,4,WL(1,0,1
     $     ,1123))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1123),2,4,113,1,1239,H)
C         Coefficient construction for loop diagram with ID 728
          CALL FFS2L2_1(PL(0,1121),W(1,16),GC_112,MDL_MM,ZERO,PL(0
     $     ,1124),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1121),4,COEFS,4,4,WL(1,0,1
     $     ,1124))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1124),2,4,113,1,1240,H)
C         Coefficient construction for loop diagram with ID 729
          CALL FFS4L2_1(PL(0,1121),W(1,17),GC_113,MDL_MM,ZERO,PL(0
     $     ,1125),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1121),4,COEFS,4,4,WL(1,0,1
     $     ,1125))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1125),2,4,113,1,1241,H)
C         Coefficient construction for loop diagram with ID 730
          CALL FFV1L2_1(PL(0,0),W(1,6),GC_3,MDL_MTA,ZERO,PL(0,1126)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1126))
          CALL FFV1L2_1(PL(0,1126),W(1,14),GC_3,MDL_MTA,ZERO,PL(0
     $     ,1127),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1126),4,COEFS,4,4,WL(1,0,1
     $     ,1127))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1127),2,4,114,1,1242,H)
C         Coefficient construction for loop diagram with ID 731
          CALL FFV2_4L2_1(PL(0,1126),W(1,15),GC_68,GC_77,MDL_MTA,ZERO
     $     ,PL(0,1128),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1126),4,COEFS,4,4,WL(1,0,1
     $     ,1128))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1128),2,4,114,1,1243,H)
C         Coefficient construction for loop diagram with ID 732
          CALL FFS2L2_1(PL(0,1126),W(1,16),GC_120,MDL_MTA,ZERO,PL(0
     $     ,1129),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1126),4,COEFS,4,4,WL(1,0,1
     $     ,1129))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1129),2,4,114,1,1244,H)
C         Coefficient construction for loop diagram with ID 733
          CALL FFS4L2_1(PL(0,1126),W(1,17),GC_121,MDL_MTA,ZERO,PL(0
     $     ,1130),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1126),4,COEFS,4,4,WL(1,0,1
     $     ,1130))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1130),2,4,114,1,1245,H)
C         Coefficient construction for loop diagram with ID 734
          CALL FFV2_4L2_1(PL(0,0),W(1,7),GC_68,GC_77,MDL_MTA,ZERO,PL(0
     $     ,1131),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1131))
          CALL FFV1L2_1(PL(0,1131),W(1,14),GC_3,MDL_MTA,ZERO,PL(0
     $     ,1132),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1131),4,COEFS,4,4,WL(1,0,1
     $     ,1132))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1132),2,4,114,1,1246,H)
C         Coefficient construction for loop diagram with ID 735
          CALL FFV2_4L2_1(PL(0,1131),W(1,15),GC_68,GC_77,MDL_MTA,ZERO
     $     ,PL(0,1133),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1131),4,COEFS,4,4,WL(1,0,1
     $     ,1133))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1133),2,4,114,1,1247,H)
C         Coefficient construction for loop diagram with ID 736
          CALL FFS2L2_1(PL(0,1131),W(1,16),GC_120,MDL_MTA,ZERO,PL(0
     $     ,1134),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1131),4,COEFS,4,4,WL(1,0,1
     $     ,1134))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1134),2,4,114,1,1248,H)
C         Coefficient construction for loop diagram with ID 737
          CALL FFS4L2_1(PL(0,1131),W(1,17),GC_121,MDL_MTA,ZERO,PL(0
     $     ,1135),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1131),4,COEFS,4,4,WL(1,0,1
     $     ,1135))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1135),2,4,114,1,1249,H)
C         Coefficient construction for loop diagram with ID 738
          CALL FFS2L2_1(PL(0,0),W(1,8),GC_120,MDL_MTA,ZERO,PL(0,1136)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1136))
          CALL FFV1L2_1(PL(0,1136),W(1,14),GC_3,MDL_MTA,ZERO,PL(0
     $     ,1137),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1136),4,COEFS,4,4,WL(1,0,1
     $     ,1137))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1137),2,4,114,1,1250,H)
C         Coefficient construction for loop diagram with ID 739
          CALL FFV2_4L2_1(PL(0,1136),W(1,15),GC_68,GC_77,MDL_MTA,ZERO
     $     ,PL(0,1138),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1136),4,COEFS,4,4,WL(1,0,1
     $     ,1138))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1138),2,4,114,1,1251,H)
C         Coefficient construction for loop diagram with ID 740
          CALL FFS2L2_1(PL(0,1136),W(1,16),GC_120,MDL_MTA,ZERO,PL(0
     $     ,1139),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1136),4,COEFS,4,4,WL(1,0,1
     $     ,1139))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1139),2,4,114,1,1252,H)
C         Coefficient construction for loop diagram with ID 741
          CALL FFS4L2_1(PL(0,1136),W(1,17),GC_121,MDL_MTA,ZERO,PL(0
     $     ,1140),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1136),4,COEFS,4,4,WL(1,0,1
     $     ,1140))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1140),2,4,114,1,1253,H)
C         Coefficient construction for loop diagram with ID 742
          CALL FFS4L2_1(PL(0,0),W(1,9),GC_121,MDL_MTA,ZERO,PL(0,1141)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1
     $     ,1141))
          CALL FFV1L2_1(PL(0,1141),W(1,14),GC_3,MDL_MTA,ZERO,PL(0
     $     ,1142),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1141),4,COEFS,4,4,WL(1,0,1
     $     ,1142))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1142),2,4,114,1,1254,H)
C         Coefficient construction for loop diagram with ID 743
          CALL FFV2_4L2_1(PL(0,1141),W(1,15),GC_68,GC_77,MDL_MTA,ZERO
     $     ,PL(0,1143),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1141),4,COEFS,4,4,WL(1,0,1
     $     ,1143))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1143),2,4,114,1,1255,H)
C         Coefficient construction for loop diagram with ID 744
          CALL FFS2L2_1(PL(0,1141),W(1,16),GC_120,MDL_MTA,ZERO,PL(0
     $     ,1144),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1141),4,COEFS,4,4,WL(1,0,1
     $     ,1144))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1144),2,4,114,1,1256,H)
C         Coefficient construction for loop diagram with ID 745
          CALL FFS4L2_1(PL(0,1141),W(1,17),GC_121,MDL_MTA,ZERO,PL(0
     $     ,1145),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1141),4,COEFS,4,4,WL(1,0,1
     $     ,1145))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1145),2,4,114,1,1257,H)
C         Coefficient construction for loop diagram with ID 746
          CALL VVSS1L4_3(PL(0,0),W(1,7),W(1,15),GC_83,MDL_MH,MDL_WH
     $     ,PL(0,1146),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1146))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1146),0,1,115,2,1258,H)
C         Coefficient construction for loop diagram with ID 747
          CALL VSS1L3_2(PL(0,0),W(1,7),GC_78,MDL_MZ,MDL_WZ,PL(0,1147)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1147))
          CALL VSS1L2_3(PL(0,1147),W(1,15),GC_78,MDL_MH,MDL_WH,PL(0
     $     ,1148),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1147),1,COEFS,1,1,WL(1,0,1
     $     ,1148))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1148),2,1,116,1,1259,H)
C         Coefficient construction for loop diagram with ID 748
          CALL SSS1L1_3(PL(0,1147),W(1,16),GC_86,MDL_MH,MDL_WH,PL(0
     $     ,1149),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1147),1,COEFS,1,1,WL(1,0,1
     $     ,1149))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1149),1,1,116,1,1260,H)
C         Coefficient construction for loop diagram with ID 749
          CALL SSS1L3_1(PL(0,0),W(1,8),GC_86,MDL_MZ,MDL_WZ,PL(0,1150)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1150))
          CALL VSS1L2_3(PL(0,1150),W(1,15),GC_78,MDL_MH,MDL_WH,PL(0
     $     ,1151),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1150),1,COEFS,1,1,WL(1,0,1
     $     ,1151))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1151),1,1,116,1,1261,H)
C         Coefficient construction for loop diagram with ID 750
          CALL SSSS1L4_3(PL(0,0),W(1,8),W(1,16),GC_49,MDL_MH,MDL_WH
     $     ,PL(0,1152),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1152))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1152),0,1,115,2,1262,H)
C         Coefficient construction for loop diagram with ID 751
          CALL SSS1L1_3(PL(0,1150),W(1,16),GC_86,MDL_MH,MDL_WH,PL(0
     $     ,1153),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1150),1,COEFS,1,1,WL(1,0,1
     $     ,1153))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1153),0,1,116,1,1263,H)
C         Coefficient construction for loop diagram with ID 752
          CALL SSSS1L2_1(PL(0,0),W(1,9),W(1,17),GC_51,MDL_MH,MDL_WH
     $     ,PL(0,1154),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1154))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1154),0,1,115,2,1264,H)
C         Coefficient construction for loop diagram with ID 753
          CALL SSS1L2_1(PL(0,0),W(1,9),GC_87,MDL_MH,MDL_WH,PL(0,1155)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1155))
          CALL SSS1L2_1(PL(0,1155),W(1,17),GC_87,MDL_MH,MDL_WH,PL(0
     $     ,1156),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1155),1,COEFS,1,1,WL(1,0,1
     $     ,1156))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1156),0,1,117,2,1265,H)
C         Coefficient construction for loop diagram with ID 754
          CALL VVSS1L4_3(PL(0,0),W(1,10),W(1,12),GC_52,MDL_MH,MDL_WH
     $     ,PL(0,1157),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1157))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1157),0,1,115,2,1266,H)
C         Coefficient construction for loop diagram with ID 755
          CALL VSS1L3_2(PL(0,0),W(1,10),GC_55,MDL_MW,MDL_WW,PL(0,1158)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1158))
          CALL VSS1L2_3(PL(0,1158),W(1,12),GC_55,MDL_MH,MDL_WH,PL(0
     $     ,1159),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1158),1,COEFS,1,1,WL(1,0,1
     $     ,1159))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1159),2,1,118,1,1267,H)
C         Coefficient construction for loop diagram with ID 756
          CALL SSS1L1_3(PL(0,1158),W(1,13),GC_86,MDL_MH,MDL_WH,PL(0
     $     ,1160),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1158),1,COEFS,1,1,WL(1,0,1
     $     ,1160))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1160),1,1,118,1,1268,H)
C         Coefficient construction for loop diagram with ID 757
          CALL SSS1L3_2(PL(0,0),W(1,11),GC_86,MDL_MW,MDL_WW,PL(0,1161)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1161))
          CALL VSS1L2_3(PL(0,1161),W(1,12),GC_55,MDL_MH,MDL_WH,PL(0
     $     ,1162),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1161),1,COEFS,1,1,WL(1,0,1
     $     ,1162))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1162),1,1,118,1,1269,H)
C         Coefficient construction for loop diagram with ID 758
          CALL SSSS1L4_3(PL(0,0),W(1,11),W(1,13),GC_49,MDL_MH,MDL_WH
     $     ,PL(0,1163),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1163))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1163),0,1,115,2,1270,H)
C         Coefficient construction for loop diagram with ID 759
          CALL SSS1L1_3(PL(0,1161),W(1,13),GC_86,MDL_MH,MDL_WH,PL(0
     $     ,1164),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1161),1,COEFS,1,1,WL(1,0,1
     $     ,1164))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1164),0,1,118,1,1271,H)
C         Coefficient construction for loop diagram with ID 760
          CALL VVSS1L4_3(PL(0,0),W(1,7),W(1,15),GC_83,MDL_MZ,MDL_WZ
     $     ,PL(0,1165),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1165))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1165),0,1,100,2,1272,H)
C         Coefficient construction for loop diagram with ID 761
          CALL SSSS1L2_1(PL(0,0),W(1,8),W(1,16),GC_51,MDL_MZ,MDL_WZ
     $     ,PL(0,1166),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1166))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1166),0,1,100,2,1273,H)
C         Coefficient construction for loop diagram with ID 762
          CALL SSSS1L2_1(PL(0,0),W(1,9),W(1,17),GC_49,MDL_MZ,MDL_WZ
     $     ,PL(0,1167),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1167))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1167),0,1,100,2,1274,H)
C         Coefficient construction for loop diagram with ID 763
          CALL SSS1L2_1(PL(0,0),W(1,9),GC_86,MDL_MZ,MDL_WZ,PL(0,1168)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1168))
          CALL SSS1L2_1(PL(0,1168),W(1,17),GC_86,MDL_MZ,MDL_WZ,PL(0
     $     ,1169),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1168),1,COEFS,1,1,WL(1,0,1
     $     ,1169))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1169),0,1,102,2,1275,H)
C         Coefficient construction for loop diagram with ID 764
          CALL VVSS1L4_3(PL(0,0),W(1,10),W(1,12),GC_52,MDL_MZ,MDL_WZ
     $     ,PL(0,1170),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1170))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1170),0,1,100,2,1276,H)
C         Coefficient construction for loop diagram with ID 765
          CALL VSS1L2_3(PL(0,0),W(1,10),GC_57,MDL_MW,MDL_WW,PL(0,1171)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1171))
          CALL VSS1L3_2(PL(0,1171),W(1,12),GC_56,MDL_MZ,MDL_WZ,PL(0
     $     ,1172),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1171),1,COEFS,1,1,WL(1,0,1
     $     ,1172))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1172),2,1,103,1,1277,H)
C         Coefficient construction for loop diagram with ID 766
          CALL SSSS1L2_1(PL(0,0),W(1,11),W(1,13),GC_49,MDL_MZ,MDL_WZ
     $     ,PL(0,1173),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1173))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1173),0,1,100,2,1278,H)
C         Coefficient construction for loop diagram with ID 767
          CALL VVSS1L4_3(PL(0,0),W(1,6),W(1,14),GC_6,MDL_MW,MDL_WW
     $     ,PL(0,1174),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1174))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1174),0,1,104,1,1279,H)
C         Coefficient construction for loop diagram with ID 768
          CALL VSS1L3_2(PL(0,0),W(1,6),GC_3,MDL_MW,MDL_WW,PL(0,1175)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1175))
          CALL VSS1L3_2(PL(0,1175),W(1,14),GC_3,MDL_MW,MDL_WW,PL(0
     $     ,1176),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1175),1,COEFS,1,1,WL(1,0,1
     $     ,1176))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1176),2,1,105,1,1280,H)
C         Coefficient construction for loop diagram with ID 769
          CALL VVSS1L4_3(PL(0,0),W(1,6),W(1,15),GC_81,MDL_MW,MDL_WW
     $     ,PL(0,1177),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1177))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1177),0,1,104,1,1281,H)
C         Coefficient construction for loop diagram with ID 770
          CALL VSS1L3_2(PL(0,1175),W(1,15),GC_79,MDL_MW,MDL_WW,PL(0
     $     ,1178),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1175),1,COEFS,1,1,WL(1,0,1
     $     ,1178))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1178),2,1,105,1,1282,H)
C         Coefficient construction for loop diagram with ID 771
          CALL SSS1L2_1(PL(0,1175),W(1,17),GC_86,MDL_MW,MDL_WW,PL(0
     $     ,1179),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1175),1,COEFS,1,1,WL(1,0,1
     $     ,1179))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1179),1,1,105,1,1283,H)
C         Coefficient construction for loop diagram with ID 772
          CALL VVSS1L4_3(PL(0,0),W(1,14),W(1,7),GC_81,MDL_MW,MDL_WW
     $     ,PL(0,1180),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1180))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1180),0,1,104,1,1284,H)
C         Coefficient construction for loop diagram with ID 773
          CALL VSS1L3_2(PL(0,0),W(1,7),GC_79,MDL_MW,MDL_WW,PL(0,1181)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1181))
          CALL VSS1L3_2(PL(0,1181),W(1,14),GC_3,MDL_MW,MDL_WW,PL(0
     $     ,1182),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1181),1,COEFS,1,1,WL(1,0,1
     $     ,1182))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1182),2,1,105,1,1285,H)
C         Coefficient construction for loop diagram with ID 774
          CALL VVSS1L4_3(PL(0,0),W(1,7),W(1,15),GC_82,MDL_MW,MDL_WW
     $     ,PL(0,1183),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1183))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1183),0,1,104,1,1286,H)
C         Coefficient construction for loop diagram with ID 775
          CALL VSS1L3_2(PL(0,1181),W(1,15),GC_79,MDL_MW,MDL_WW,PL(0
     $     ,1184),COEFS)
          CALL ML5_0_UPDATE_WL_1_1(WL(1,0,1,1181),1,COEFS,1,1,WL(1,0,1
     $     ,1184))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1184),2,1,105,1,1287,H)
C         Coefficient construction for loop diagram with ID 776
          CALL SSS1L2_1(PL(0,1181),W(1,17),GC_86,MDL_MW,MDL_WW,PL(0
     $     ,1185),COEFS)
          CALL ML5_0_UPDATE_WL_1_0(WL(1,0,1,1181),1,COEFS,1,1,WL(1,0,1
     $     ,1185))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1185),1,1,105,1,1288,H)
C         Coefficient construction for loop diagram with ID 777
          CALL SSSS1L4_3(PL(0,0),W(1,8),W(1,16),GC_49,MDL_MW,MDL_WW
     $     ,PL(0,1186),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1186))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1186),0,1,104,1,1289,H)
C         Coefficient construction for loop diagram with ID 778
          CALL SSS1L2_1(PL(0,0),W(1,9),GC_86,MDL_MW,MDL_WW,PL(0,1187)
     $     ,COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1187))
          CALL VSS1L3_2(PL(0,1187),W(1,14),GC_3,MDL_MW,MDL_WW,PL(0
     $     ,1188),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1187),1,COEFS,1,1,WL(1,0,1
     $     ,1188))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1188),1,1,105,1,1290,H)
C         Coefficient construction for loop diagram with ID 779
          CALL VSS1L3_2(PL(0,1187),W(1,15),GC_79,MDL_MW,MDL_WW,PL(0
     $     ,1189),COEFS)
          CALL ML5_0_UPDATE_WL_0_1(WL(1,0,1,1187),1,COEFS,1,1,WL(1,0,1
     $     ,1189))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1189),1,1,105,1,1291,H)
C         Coefficient construction for loop diagram with ID 780
          CALL SSSS1L2_1(PL(0,0),W(1,9),W(1,17),GC_49,MDL_MW,MDL_WW
     $     ,PL(0,1190),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1190))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1190),0,1,104,1,1292,H)
C         Coefficient construction for loop diagram with ID 781
          CALL SSS1L2_1(PL(0,1187),W(1,17),GC_86,MDL_MW,MDL_WW,PL(0
     $     ,1191),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,1187),1,COEFS,1,1,WL(1,0,1
     $     ,1191))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1191),0,1,105,1,1293,H)
C         Coefficient construction for loop diagram with ID 782
          CALL VVSS1L4_3(PL(0,0),W(1,10),W(1,12),GC_52,MDL_MW,MDL_WW
     $     ,PL(0,1192),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1192))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1192),0,1,104,1,1294,H)
C         Coefficient construction for loop diagram with ID 783
          CALL SSSS1L3_1(PL(0,0),W(1,11),W(1,13),GC_50,MDL_MW,MDL_WW
     $     ,PL(0,1193),COEFS)
          CALL ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1
     $     ,1193))
          CALL ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,1193),0,1,104,1,1295,H)
C         At this point, all loop coefficients needed for (QCD=2
C          QED=4), i.e. of split order ID=1, are computed.
          IF(FILTER_SO.AND.SQSO_TARGET.EQ.2) GOTO 4000
C         At this point, all loop coefficients needed for (QCD=0
C          QED=6), i.e. of split order ID=2, are computed.
          IF(FILTER_SO.AND.SQSO_TARGET.EQ.3) GOTO 4000
 4000     CONTINUE
          LOOP_REQ_SO_DONE=.TRUE.

        ENDIF
      ENDDO

C     Grouping of loop diagrams now done directly when creating the
C      LOOPCOEFS.

      DO I=0,NSQUAREDSO
        DO J=1,3
          BUFFR_BIS(J,I)=ANS(J,I)
        ENDDO
      ENDDO

 300  CONTINUE
C     Free cache when using IREGI
      IF(IREGIRECY.AND.MLREDUCTIONLIB(I_LIB).EQ.3)CALL IREGI_FREE_PS

      DO I=0,NSQUAREDSO
        DO J=1,3
          ANS(J,I)=BUFFR_BIS(J,I)
        ENDDO
      ENDDO

      IF(SKIPLOOPEVAL) THEN
        GOTO 1226
      ENDIF

      DO I_SO=1,NSQUAREDSO
        DO J=1,NLOOPGROUPS
          S(I_SO,J)=.TRUE.
        ENDDO
        IF (FILTER_SO.AND.SQSO_TARGET.NE.I_SO) GOTO 5001
C       CutTools call for loop numbers 1,2,3,4,47,388,392,396,400
        CALL ML5_0_LOOP_3(3,4,6,DCMPLX(ZERO),DCMPLX(MDL_MD),DCMPLX(MDL_
     $   MD),2,I_SO,1)
C       CutTools call for loop numbers 5,6,107,111
        CALL ML5_0_LOOP_3(2,4,10,DCMPLX(ZERO),DCMPLX(MDL_MD),DCMPLX(MDL
     $   _MU),2,I_SO,2)
C       CutTools call for loop numbers 7,8,129,130
        CALL ML5_0_LOOP_3(1,3,12,DCMPLX(ZERO),DCMPLX(MDL_MD),DCMPLX(MDL
     $   _MU),2,I_SO,3)
C       CutTools call for loop numbers 9,212,10,214
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(ZERO),DCMPLX(MDL_MU)
     $   ,DCMPLX(MDL_MW),DCMPLX(MDL_MU),4,I_SO,4)
C       CutTools call for loop numbers 11,12,13,14,39,196,197,198,199
        CALL ML5_0_LOOP_3(1,2,14,DCMPLX(ZERO),DCMPLX(MDL_MU),DCMPLX(MDL
     $   _MU),2,I_SO,5)
C       CutTools call for loop numbers 15,31,151
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MU),DCMPLX(ZERO)
     $   ,DCMPLX(MDL_MD),DCMPLX(ZERO),2,I_SO,6)
C       CutTools call for loop numbers 16,153,17,155
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MU),DCMPLX(MDL_MZ)
     $   ,DCMPLX(MDL_MD),DCMPLX(ZERO),4,I_SO,7)
C       CutTools call for loop numbers 18,157
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MU),DCMPLX(MDL_MH)
     $   ,DCMPLX(MDL_MD),DCMPLX(ZERO),2,I_SO,8)
C       CutTools call for loop numbers 19,25,152
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MU),DCMPLX(ZERO)
     $   ,DCMPLX(MDL_MD),DCMPLX(ZERO),2,I_SO,9)
C       CutTools call for loop numbers 20,154,21,156
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MU),DCMPLX(MDL_MZ)
     $   ,DCMPLX(MDL_MD),DCMPLX(ZERO),4,I_SO,10)
C       CutTools call for loop numbers 22,158
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MU),DCMPLX(MDL_MH)
     $   ,DCMPLX(MDL_MD),DCMPLX(ZERO),2,I_SO,11)
C       CutTools call for loop numbers 23,213,24,215
        CALL ML5_0_LOOP_4(1,3,2,4,DCMPLX(MDL_MU),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MD),DCMPLX(ZERO),4,I_SO,12)
C       CutTools call for loop numbers 26,160,27,168
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MU),DCMPLX(ZERO)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MZ),4,I_SO,13)
C       CutTools call for loop numbers 28,176
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MU),DCMPLX(ZERO)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MH),2,I_SO,14)
C       CutTools call for loop numbers 29,228,30,229
        CALL ML5_0_LOOP_4(1,3,2,4,DCMPLX(MDL_MD),DCMPLX(ZERO)
     $   ,DCMPLX(MDL_MU),DCMPLX(MDL_MW),4,I_SO,15)
C       CutTools call for loop numbers 32,159,33,167
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MU),DCMPLX(ZERO)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MZ),4,I_SO,16)
C       CutTools call for loop numbers 34,175
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MU),DCMPLX(ZERO)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MH),2,I_SO,17)
C       CutTools call for loop numbers 35,467,36,471
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MW),DCMPLX(MDL_MD)
     $   ,DCMPLX(ZERO),DCMPLX(MDL_MD),4,I_SO,18)
C       CutTools call for loop numbers 37,73,75,77,79,38,74,76,78,80
        CALL ML5_0_LOOP_3(3,4,5,DCMPLX(MDL_MW),DCMPLX(MDL_MU)
     $   ,DCMPLX(MDL_MU),4,I_SO,19)
C       CutTools call for loop numbers 40,200,201,202,203,41,204,205,20
C       6,207
        CALL ML5_0_LOOP_3(1,2,18,DCMPLX(MDL_MZ),DCMPLX(MDL_MU)
     $   ,DCMPLX(MDL_MU),4,I_SO,20)
C       CutTools call for loop numbers 42,208,209,210,211
        CALL ML5_0_LOOP_3(1,2,18,DCMPLX(MDL_MH),DCMPLX(MDL_MU)
     $   ,DCMPLX(MDL_MU),2,I_SO,21)
C       CutTools call for loop numbers 43,264,266,268,270,44,265,267,26
C       9,271
        CALL ML5_0_LOOP_3(3,4,5,DCMPLX(MDL_MW),DCMPLX(MDL_MC)
     $   ,DCMPLX(MDL_MC),4,I_SO,22)
C       CutTools call for loop numbers 45,326,328,330,332,46,327,329,33
C       1,333
        CALL ML5_0_LOOP_3(3,4,5,DCMPLX(MDL_MW),DCMPLX(MDL_MT)
     $   ,DCMPLX(MDL_MT),4,I_SO,23)
C       CutTools call for loop numbers 48,389,393,397,401,49,390,394,39
C       8,402
        CALL ML5_0_LOOP_3(3,4,5,DCMPLX(MDL_MZ),DCMPLX(MDL_MD)
     $   ,DCMPLX(MDL_MD),4,I_SO,24)
C       CutTools call for loop numbers 50,391,395,399,403
        CALL ML5_0_LOOP_3(3,4,5,DCMPLX(MDL_MH),DCMPLX(MDL_MD)
     $   ,DCMPLX(MDL_MD),2,I_SO,25)
C       CutTools call for loop numbers 51,459,460,461,462,52,463,464,46
C       5,466
        CALL ML5_0_LOOP_3(1,2,18,DCMPLX(MDL_MW),DCMPLX(MDL_MD)
     $   ,DCMPLX(MDL_MD),4,I_SO,26)
C       CutTools call for loop numbers 53,505,506,507,508,54,509,510,51
C       1,512
        CALL ML5_0_LOOP_3(1,2,18,DCMPLX(MDL_MW),DCMPLX(MDL_MS)
     $   ,DCMPLX(MDL_MS),4,I_SO,27)
C       CutTools call for loop numbers 55,543,544,545,546,56,547,548,54
C       9,550
        CALL ML5_0_LOOP_3(1,2,18,DCMPLX(MDL_MW),DCMPLX(MDL_MB)
     $   ,DCMPLX(MDL_MB),4,I_SO,28)
C       At this point, all reductions needed for (QCD=4 QED=2), i.e.
C        of split order ID=0, are computed.
        IF(FILTER_SO.AND.SQSO_TARGET.EQ.1) GOTO 5000
C       CutTools call for loop numbers 57,58,59,60,61,62,63,64,65,66,67
C       ,68,69,70,71,72
        CALL ML5_0_LOOP_2(6,14,DCMPLX(MDL_MU),DCMPLX(MDL_MU),2,I_SO,29)
C       CutTools call for loop numbers 81,85,91,89,90,92,93,83,87,82,84
C       ,86,88,94
        CALL ML5_0_LOOP_3(3,4,6,DCMPLX(MDL_MU),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MW),5,I_SO,30)
C       CutTools call for loop numbers 95,98,101,104
        CALL ML5_0_LOOP_2(10,12,DCMPLX(MDL_MU),DCMPLX(MDL_MD),2,I_SO
     $   ,31)
C       CutTools call for loop numbers 96,99,102,105
        CALL ML5_0_LOOP_2(10,12,DCMPLX(MDL_MS),DCMPLX(MDL_MU),2,I_SO
     $   ,32)
C       CutTools call for loop numbers 97,100,103,106
        CALL ML5_0_LOOP_2(10,12,DCMPLX(MDL_MB),DCMPLX(MDL_MU),2,I_SO
     $   ,33)
C       CutTools call for loop numbers 108,112,109,113
        CALL ML5_0_LOOP_3(2,4,10,DCMPLX(MDL_MZ),DCMPLX(MDL_MD)
     $   ,DCMPLX(MDL_MU),4,I_SO,34)
C       CutTools call for loop numbers 110,114
        CALL ML5_0_LOOP_3(2,4,10,DCMPLX(MDL_MH),DCMPLX(MDL_MD)
     $   ,DCMPLX(MDL_MU),2,I_SO,35)
C       CutTools call for loop numbers 115,122,123,116
        CALL ML5_0_LOOP_3(2,4,10,DCMPLX(MDL_MU),DCMPLX(MDL_MW)
     $   ,DCMPLX(ZERO),4,I_SO,36)
C       CutTools call for loop numbers 117,124,125,126,118,119
        CALL ML5_0_LOOP_3(2,4,10,DCMPLX(MDL_MU),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MZ),5,I_SO,37)
C       CutTools call for loop numbers 127,120,121,128
        CALL ML5_0_LOOP_3(2,4,11,DCMPLX(MDL_MU),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MH),4,I_SO,38)
C       CutTools call for loop numbers 131,132,133,134
        CALL ML5_0_LOOP_3(1,3,12,DCMPLX(MDL_MZ),DCMPLX(MDL_MD)
     $   ,DCMPLX(MDL_MU),4,I_SO,39)
C       CutTools call for loop numbers 135,136
        CALL ML5_0_LOOP_3(1,3,12,DCMPLX(MDL_MH),DCMPLX(MDL_MD)
     $   ,DCMPLX(MDL_MU),2,I_SO,40)
C       CutTools call for loop numbers 137,139,140,138
        CALL ML5_0_LOOP_3(1,3,12,DCMPLX(MDL_MU),DCMPLX(MDL_MW)
     $   ,DCMPLX(ZERO),4,I_SO,41)
C       CutTools call for loop numbers 141,143,144,146,142,145
        CALL ML5_0_LOOP_3(1,3,12,DCMPLX(MDL_MU),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MZ),5,I_SO,42)
C       CutTools call for loop numbers 149,147,148,150
        CALL ML5_0_LOOP_3(1,3,13,DCMPLX(MDL_MU),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MH),4,I_SO,43)
C       CutTools call for loop numbers 161,163,169,171
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MU),DCMPLX(MDL_MZ)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MZ),6,I_SO,44)
C       CutTools call for loop numbers 162,164,170,172
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MU),DCMPLX(MDL_MZ)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MZ),6,I_SO,45)
C       CutTools call for loop numbers 165,173
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MU),DCMPLX(MDL_MH)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MZ),4,I_SO,46)
C       CutTools call for loop numbers 166,174
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MU),DCMPLX(MDL_MH)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MZ),4,I_SO,47)
C       CutTools call for loop numbers 177,179
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MU),DCMPLX(MDL_MZ)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MH),4,I_SO,48)
C       CutTools call for loop numbers 178,180
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MU),DCMPLX(MDL_MZ)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MH),4,I_SO,49)
C       CutTools call for loop numbers 181
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MU),DCMPLX(MDL_MH)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MH),2,I_SO,50)
C       CutTools call for loop numbers 182
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MU),DCMPLX(MDL_MH)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MH),2,I_SO,51)
C       CutTools call for loop numbers 183,184,187,188
        CALL ML5_0_LOOP_3(1,2,17,DCMPLX(MDL_MU),DCMPLX(MDL_MZ)
     $   ,DCMPLX(MDL_MZ),5,I_SO,52)
C       CutTools call for loop numbers 186,185,189,190
        CALL ML5_0_LOOP_3(1,2,16,DCMPLX(MDL_MU),DCMPLX(MDL_MH)
     $   ,DCMPLX(MDL_MZ),4,I_SO,53)
C       CutTools call for loop numbers 192,191,193,194
        CALL ML5_0_LOOP_3(1,2,16,DCMPLX(MDL_MU),DCMPLX(MDL_MZ)
     $   ,DCMPLX(MDL_MH),4,I_SO,54)
C       CutTools call for loop numbers 195
        CALL ML5_0_LOOP_3(1,2,17,DCMPLX(MDL_MU),DCMPLX(MDL_MH)
     $   ,DCMPLX(MDL_MH),1,I_SO,55)
C       CutTools call for loop numbers 216,218,220,222
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MZ),DCMPLX(MDL_MU)
     $   ,DCMPLX(MDL_MW),DCMPLX(MDL_MU),6,I_SO,56)
C       CutTools call for loop numbers 217,219,221,223
        CALL ML5_0_LOOP_4(1,3,2,4,DCMPLX(MDL_MU),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MZ),6,I_SO,57)
C       CutTools call for loop numbers 224,226
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MH),DCMPLX(MDL_MU)
     $   ,DCMPLX(MDL_MW),DCMPLX(MDL_MU),4,I_SO,58)
C       CutTools call for loop numbers 225,227
        CALL ML5_0_LOOP_4(1,3,2,4,DCMPLX(MDL_MU),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MD),DCMPLX(MDL_MH),4,I_SO,59)
C       CutTools call for loop numbers 230,231,232,233
        CALL ML5_0_LOOP_4(1,3,2,4,DCMPLX(MDL_MD),DCMPLX(MDL_MZ)
     $   ,DCMPLX(MDL_MU),DCMPLX(MDL_MW),6,I_SO,60)
C       CutTools call for loop numbers 234,235
        CALL ML5_0_LOOP_4(1,3,2,4,DCMPLX(MDL_MD),DCMPLX(MDL_MH)
     $   ,DCMPLX(MDL_MU),DCMPLX(MDL_MW),4,I_SO,61)
C       CutTools call for loop numbers 236,239,242,245
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MD),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MU),DCMPLX(MDL_MW),6,I_SO,62)
C       CutTools call for loop numbers 237,240,243,246
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MS),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MU),DCMPLX(MDL_MW),6,I_SO,63)
C       CutTools call for loop numbers 238,241,244,247
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MB),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MU),DCMPLX(MDL_MW),6,I_SO,64)
C       CutTools call for loop numbers 248,249,250,251,252,253,254,255,
C       256,257,258,259,260,261,262,263
        CALL ML5_0_LOOP_2(6,14,DCMPLX(MDL_MC),DCMPLX(MDL_MC),2,I_SO,65)
C       CutTools call for loop numbers 272,276,282,280,281,283,284,274,
C       278,273,275,277,279,285
        CALL ML5_0_LOOP_3(3,4,6,DCMPLX(MDL_MC),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MW),5,I_SO,66)
C       CutTools call for loop numbers 286,289,292,295
        CALL ML5_0_LOOP_2(10,12,DCMPLX(MDL_MC),DCMPLX(MDL_MD),2,I_SO
     $   ,67)
C       CutTools call for loop numbers 287,290,293,296
        CALL ML5_0_LOOP_2(10,12,DCMPLX(MDL_MC),DCMPLX(MDL_MS),2,I_SO
     $   ,68)
C       CutTools call for loop numbers 288,291,294,297
        CALL ML5_0_LOOP_2(10,12,DCMPLX(MDL_MB),DCMPLX(MDL_MC),2,I_SO
     $   ,69)
C       CutTools call for loop numbers 298,301,304,307
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MD),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MC),DCMPLX(MDL_MW),6,I_SO,70)
C       CutTools call for loop numbers 299,302,305,308
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MS),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MC),DCMPLX(MDL_MW),6,I_SO,71)
C       CutTools call for loop numbers 300,303,306,309
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MB),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MC),DCMPLX(MDL_MW),6,I_SO,72)
C       CutTools call for loop numbers 310,311,312,313,314,315,316,317,
C       318,319,320,321,322,323,324,325
        CALL ML5_0_LOOP_2(6,14,DCMPLX(MDL_MT),DCMPLX(MDL_MT),2,I_SO,73)
C       CutTools call for loop numbers 334,338,344,342,343,345,346,336,
C       340,335,337,339,341,347
        CALL ML5_0_LOOP_3(3,4,6,DCMPLX(MDL_MT),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MW),5,I_SO,74)
C       CutTools call for loop numbers 348,351,354,357
        CALL ML5_0_LOOP_2(10,12,DCMPLX(MDL_MT),DCMPLX(MDL_MD),2,I_SO
     $   ,75)
C       CutTools call for loop numbers 349,352,355,358
        CALL ML5_0_LOOP_2(10,12,DCMPLX(MDL_MT),DCMPLX(MDL_MS),2,I_SO
     $   ,76)
C       CutTools call for loop numbers 350,353,356,359
        CALL ML5_0_LOOP_2(10,12,DCMPLX(MDL_MT),DCMPLX(MDL_MB),2,I_SO
     $   ,77)
C       CutTools call for loop numbers 360,363,366,369
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MD),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MT),DCMPLX(MDL_MW),6,I_SO,78)
C       CutTools call for loop numbers 361,364,367,370
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MS),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MT),DCMPLX(MDL_MW),6,I_SO,79)
C       CutTools call for loop numbers 362,365,368,371
        CALL ML5_0_LOOP_4(1,2,3,4,DCMPLX(MDL_MB),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MT),DCMPLX(MDL_MW),6,I_SO,80)
C       CutTools call for loop numbers 372,373,374,375,376,377,378,379,
C       380,381,382,383,384,385,386,387
        CALL ML5_0_LOOP_2(6,14,DCMPLX(MDL_MD),DCMPLX(MDL_MD),2,I_SO,81)
C       CutTools call for loop numbers 408,404,405,409
        CALL ML5_0_LOOP_3(3,4,8,DCMPLX(MDL_MD),DCMPLX(MDL_MH)
     $   ,DCMPLX(MDL_MZ),4,I_SO,82)
C       CutTools call for loop numbers 410,406,407,411
        CALL ML5_0_LOOP_3(3,4,8,DCMPLX(MDL_MD),DCMPLX(MDL_MZ)
     $   ,DCMPLX(MDL_MH),4,I_SO,83)
C       CutTools call for loop numbers 412,413,414,415
        CALL ML5_0_LOOP_3(3,4,9,DCMPLX(MDL_MD),DCMPLX(MDL_MZ)
     $   ,DCMPLX(MDL_MZ),5,I_SO,84)
C       CutTools call for loop numbers 416
        CALL ML5_0_LOOP_3(3,4,9,DCMPLX(MDL_MD),DCMPLX(MDL_MH)
     $   ,DCMPLX(MDL_MH),1,I_SO,85)
C       CutTools call for loop numbers 417,424,428,420
        CALL ML5_0_LOOP_3(2,4,10,DCMPLX(MDL_MD),DCMPLX(ZERO),DCMPLX(MDL
     $   _MW),3,I_SO,86)
C       CutTools call for loop numbers 418,425,426,429,421,422
        CALL ML5_0_LOOP_3(2,4,10,DCMPLX(MDL_MD),DCMPLX(MDL_MZ)
     $   ,DCMPLX(MDL_MW),5,I_SO,87)
C       CutTools call for loop numbers 427,419,423,430
        CALL ML5_0_LOOP_3(2,4,11,DCMPLX(MDL_MD),DCMPLX(MDL_MH)
     $   ,DCMPLX(MDL_MW),4,I_SO,88)
C       CutTools call for loop numbers 431,434,442,438
        CALL ML5_0_LOOP_3(1,3,12,DCMPLX(MDL_MD),DCMPLX(ZERO),DCMPLX(MDL
     $   _MW),3,I_SO,89)
C       CutTools call for loop numbers 432,435,436,443,439,440
        CALL ML5_0_LOOP_3(1,3,12,DCMPLX(MDL_MD),DCMPLX(MDL_MZ)
     $   ,DCMPLX(MDL_MW),5,I_SO,90)
C       CutTools call for loop numbers 437,433,441,444
        CALL ML5_0_LOOP_3(1,3,13,DCMPLX(MDL_MD),DCMPLX(MDL_MH)
     $   ,DCMPLX(MDL_MW),4,I_SO,91)
C       CutTools call for loop numbers 445,446,447,450,451,454,455,452,
C       453,448,449,456,457,458
        CALL ML5_0_LOOP_3(1,2,14,DCMPLX(MDL_MD),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MW),5,I_SO,92)
C       CutTools call for loop numbers 468,469,472,473
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MW),DCMPLX(MDL_MD)
     $   ,DCMPLX(MDL_MZ),DCMPLX(MDL_MD),6,I_SO,93)
C       CutTools call for loop numbers 470,474
        CALL ML5_0_LOOP_4(1,2,4,3,DCMPLX(MDL_MW),DCMPLX(MDL_MD)
     $   ,DCMPLX(MDL_MH),DCMPLX(MDL_MD),4,I_SO,94)
C       CutTools call for loop numbers 475,476,477,478,479,480,481,482,
C       483,484,485,486,487,488,489,490
        CALL ML5_0_LOOP_2(6,14,DCMPLX(MDL_MS),DCMPLX(MDL_MS),2,I_SO,95)
C       CutTools call for loop numbers 491,492,493,496,497,500,501,498,
C       499,494,495,502,503,504
        CALL ML5_0_LOOP_3(1,2,14,DCMPLX(MDL_MS),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MW),5,I_SO,96)
C       CutTools call for loop numbers 513,514,515,516,517,518,519,520,
C       521,522,523,524,525,526,527,528
        CALL ML5_0_LOOP_2(6,14,DCMPLX(MDL_MB),DCMPLX(MDL_MB),2,I_SO,97)
C       CutTools call for loop numbers 529,530,531,534,535,538,539,536,
C       537,532,533,540,541,542
        CALL ML5_0_LOOP_3(1,2,14,DCMPLX(MDL_MB),DCMPLX(MDL_MW)
     $   ,DCMPLX(MDL_MW),5,I_SO,98)
C       CutTools call for loop numbers 551,556,553,557,558,631,632,554,
C       555,633,634,552
        CALL ML5_0_LOOP_2(10,12,DCMPLX(MDL_MW),DCMPLX(ZERO),3,I_SO,99)
C       CutTools call for loop numbers 562,564,567,574,753,754,755,757,
C       759
        CALL ML5_0_LOOP_1_2(2,8,16,DCMPLX(MDL_MZ),2,I_SO,100)
C       CutTools call for loop numbers 563,560,561,559
        CALL ML5_0_LOOP_2(8,16,DCMPLX(MDL_MH),DCMPLX(MDL_MZ),4,I_SO
     $   ,101)
C       CutTools call for loop numbers 565,566,635,756
        CALL ML5_0_LOOP_2(9,17,DCMPLX(MDL_MZ),DCMPLX(MDL_MZ),4,I_SO
     $   ,102)
C       CutTools call for loop numbers 568,570,573,575,576,571,572,636,
C       637,758,569,638,639,640,641,642,643
        CALL ML5_0_LOOP_2(10,12,DCMPLX(MDL_MW),DCMPLX(MDL_MZ),4,I_SO
     $   ,103)
C       CutTools call for loop numbers 577,581,590,594,607,620,624,628,
C       760,762,765,767,770,773,775,776
        CALL ML5_0_LOOP_1_2(2,6,14,DCMPLX(MDL_MW),2,I_SO,104)
C       CutTools call for loop numbers 578,582,587,591,595,600,608,609,
C       610,611,613,616,618,619,621,622,623,585,586,588,589,598,599,601
C       ,602,603,604,605,606,612,614,615,617,644,645,648,649,660,661,66
C       4,665,761,763,766,768,579,580,583,584,592,593,596,597,646,647,6
C       50,651,652,653,656,657,662,663,666,667,668,669,672,673,764,769,
C       771,772,654,655,658,659,670,671,674,675,774
        CALL ML5_0_LOOP_2(6,14,DCMPLX(MDL_MW),DCMPLX(MDL_MW),4,I_SO
     $   ,105)
C       CutTools call for loop numbers 629
        CALL ML5_0_LOOP_2(11,13,DCMPLX(MDL_MZ),DCMPLX(MDL_MW),4,I_SO
     $   ,106)
C       CutTools call for loop numbers 630,626,627,625
        CALL ML5_0_LOOP_2(11,13,DCMPLX(MDL_MH),DCMPLX(MDL_MW),4,I_SO
     $   ,107)
C       CutTools call for loop numbers 676,681,686
        CALL ML5_0_LOOP_2(7,15,DCMPLX(ZERO),DCMPLX(ZERO),2,I_SO,108)
C       CutTools call for loop numbers 677,678,679,680
        CALL ML5_0_LOOP_2(10,12,DCMPLX(ZERO),DCMPLX(MDL_ME),2,I_SO,109)
C       CutTools call for loop numbers 682,683,684,685
        CALL ML5_0_LOOP_2(10,12,DCMPLX(ZERO),DCMPLX(MDL_MM),2,I_SO,110)
C       CutTools call for loop numbers 687,688,689,690
        CALL ML5_0_LOOP_2(10,12,DCMPLX(ZERO),DCMPLX(MDL_MTA),2,I_SO
     $   ,111)
C       CutTools call for loop numbers 691,692,693,694,695,696,697,698,
C       699,700,701,702,703,704,705,706
        CALL ML5_0_LOOP_2(6,14,DCMPLX(MDL_ME),DCMPLX(MDL_ME),2,I_SO
     $   ,112)
C       CutTools call for loop numbers 707,708,709,710,711,712,713,714,
C       715,716,717,718,719,720,721,722
        CALL ML5_0_LOOP_2(6,14,DCMPLX(MDL_MM),DCMPLX(MDL_MM),2,I_SO
     $   ,113)
C       CutTools call for loop numbers 723,724,725,726,727,728,729,730,
C       731,732,733,734,735,736,737,738
        CALL ML5_0_LOOP_2(6,14,DCMPLX(MDL_MTA),DCMPLX(MDL_MTA),2,I_SO
     $   ,114)
C       CutTools call for loop numbers 739,743,745,747,751
        CALL ML5_0_LOOP_1_2(2,7,15,DCMPLX(MDL_MH),0,I_SO,115)
C       CutTools call for loop numbers 740,741,742,744
        CALL ML5_0_LOOP_2(7,15,DCMPLX(MDL_MZ),DCMPLX(MDL_MH),2,I_SO
     $   ,116)
C       CutTools call for loop numbers 746
        CALL ML5_0_LOOP_2(9,17,DCMPLX(MDL_MH),DCMPLX(MDL_MH),0,I_SO
     $   ,117)
C       CutTools call for loop numbers 748,749,750,752
        CALL ML5_0_LOOP_2(10,12,DCMPLX(MDL_MW),DCMPLX(MDL_MH),2,I_SO
     $   ,118)
C       At this point, all reductions needed for (QCD=2 QED=4), i.e.
C        of split order ID=1, are computed.
        IF(FILTER_SO.AND.SQSO_TARGET.EQ.2) GOTO 5000
C       At this point, all reductions needed for (QCD=0 QED=6), i.e.
C        of split order ID=2, are computed.
        IF(FILTER_SO.AND.SQSO_TARGET.EQ.3) GOTO 5000
        GOTO 5001
 5000   CONTINUE
        CTCALL_REQ_SO_DONE=.TRUE.
 5001   CONTINUE
      ENDDO

      DO I=1,NLOOPGROUPS
        LTEMP=.TRUE.
        DO K=1,NSQUAREDSO
          IF (.NOT.FILTER_SO.OR.SQSO_TARGET.EQ.K) THEN
            IF (.NOT.S(K,I)) LTEMP=.FALSE.
            DO J=1,3
              ANS(J,K)=ANS(J,K)+LOOPRES(J,K,I)
              ANS(J,0)=ANS(J,0)+LOOPRES(J,K,I)
            ENDDO
          ENDIF
        ENDDO
        IF((CTMODERUN.NE.-1).AND..NOT.CHECKPHASE.AND.(.NOT.LTEMP)) THEN
          WRITE(*,*) '##W03 WARNING Contribution ',I,' is unstable.'
        ENDIF
      ENDDO

 1226 CONTINUE

      IF (CHECKPHASE.OR.(.NOT.HELDOUBLECHECKED)) THEN
        IF((USERHEL.EQ.-1).OR.(USERHEL.EQ.HELPICKED)) THEN
C         TO KEEP TRACK OF THE FINAL ANSWER TO BE RETURNED DURING
C          CHECK PHASE
          DO I=0,NSQUAREDSO
            DO K=1,3
              BUFFR(K,I)=BUFFR(K,I)+ANS(K,I)
            ENDDO
          ENDDO
        ENDIF
C       SAVE RESULT OF EACH INDEPENDENT HELICITY FOR COMPARISON DURING
C        THE HELICITY FILTER SETUP
        HELSAVED(1,HELPICKED)=ANS(1,0)
        HELSAVED(2,HELPICKED)=ANS(2,0)
        HELSAVED(3,HELPICKED)=ANS(3,0)

        IF (CHECKPHASE) THEN
C         SET THE HELICITY FILTER
          IF(.NOT.FOUNDHELFILTER) THEN
            HEL_INCONSISTENT=.FALSE.
            IF(ML5_0_ISZERO(ABS(ANS(1,0))+ABS(ANS(2,0))+ABS(ANS(3,0))
     $       ,REF/DBLE(NCOMB),-1,-1)) THEN
              IF(NTRY.EQ.1) THEN
                GOODHEL(HELPICKED)=-HELOFFSET
              ELSEIF(GOODHEL(HELPICKED).NE.-HELOFFSET) THEN
                WRITE(*,*) '##W02A WARNING Inconsistent helicity '
     $           ,HELPICKED
                IF(HELINITSTARTOVER) THEN
                  WRITE(*,*) '##I01 INFO Initialization starting ove'
     $             //'r because of inconsistency in the helicit'
     $             //'y filter setup.'
                  NTRY=0
                ELSE
                  HEL_INCONSISTENT=.TRUE.
                ENDIF
              ENDIF
            ELSE
              DO H=1,HELPICKED-1
                IF(GOODHEL(H).GT.-HELOFFSET) THEN
C                 Be looser for helicity check, bring a factor 100
                  DUMMY=ML5_0_ISSAME(ANS(1,0),HELSAVED(1,H),REF
     $             ,.FALSE.)
                  IF(DUMMY.NE.0) THEN
                    IF(NTRY.EQ.1) THEN
C                     Set the matching helicity to be contributing
C                      once more
                      GOODHEL(H)=GOODHEL(H)+DUMMY
C                     Use an offset to clearly show it is linked to an
C                      other one and to avoid overlap
                      GOODHEL(HELPICKED)=-H-HELOFFSET
C                     Make sure we have paired this hel config to the
C                      same one last PS point
                    ELSEIF(GOODHEL(HELPICKED).NE.(-H-HELOFFSET)) THEN
                      WRITE(*,*) '##W02B WARNING Inconsistent helicit'
     $                 //'y ',HELPICKED
                      IF(HELINITSTARTOVER) THEN
                        WRITE(*,*) '##I01 INFO Initialization startin'
     $                   //'g over because of inconsistency in th'
     $                   //'e helicity filter setup.'
                        NTRY=0
                      ELSE
                        HEL_INCONSISTENT=.TRUE.
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
              ENDDO
            ENDIF
            IF(HEL_INCONSISTENT) THEN
C             This helicity has unstable filter so we will always
C              compute it by itself.
C             We therefore also need to remove it from the multiplicati
C             ve factor of the corresponding helicity.
              IF(GOODHEL(HELPICKED).LT.-HELOFFSET) THEN
                GOODHEL(-GOODHEL(HELPICKED)-HELOFFSET)=GOODHEL(
     $           -GOODHEL(HELPICKED)-HELOFFSET)-1
              ENDIF
C             If several helicities were matched to that one, we need
C              to chose another one as reference and redirect the
C              others to this new one
C             Of course if it is one, then we do not need to do
C              anything (because with HELINITSTARTOVER=.FALSE. we only
C              support exactly identical Hels.)
              IF(GOODHEL(HELPICKED).GT.-HELOFFSET.AND.GOODHEL(HELPICKED
     $         ).NE.1) THEN
                NEWHELREF=-1
                DO H=1,NCOMB
                  IF (GOODHEL(H).EQ.(-HELOFFSET-HELPICKED)) THEN
                    IF (NEWHELREF.EQ.-1) THEN
                      NEWHELREF=H
                      GOODHEL(H)=GOODHEL(HELPICKED)-1
                    ELSE
                      GOODHEL(H)=-NEWHELREF-HELOFFSET
                    ENDIF
                  ENDIF
                ENDDO
              ENDIF
C             In all cases, from now on this helicity will be computed
C              independantly of the others.
C             In particular, it is the only thing to do if the
C              helicity was flagged not contributing.
              GOODHEL(HELPICKED)=1
            ENDIF
          ENDIF

C         SET THE LOOP FILTER
          IF(.NOT.FOUNDLOOPFILTER.AND.USELOOPFILTER) THEN
            DO I=1,NLOOPGROUPS
              DO J=1,NSQUAREDSO
                IF(.NOT.ML5_0_ISZERO(ABS(LOOPRES(1,J,I))+ABS(LOOPRES(2
     $           ,J,I))+ABS(LOOPRES(3,J,I)),(REF*1.0D-4),I,J)) THEN
                  IF(NTRY.EQ.1) THEN
                    GOODAMP(J,I)=.TRUE.
                    LOOPFILTERBUFF(J,I)=.TRUE.
                  ELSEIF(.NOT.LOOPFILTERBUFF(J,I)) THEN
                    WRITE(*,*) '##W02 WARNING Inconsistent loop amp '
     $               ,I,'.'
                    IF(LOOPINITSTARTOVER) THEN
                      WRITE(*,*) '##I01 INFO Initialization startin'
     $                 //'g over because of inconsistency in the loo'
     $                 //'p filter setup.'
                      NTRY=0
                    ELSE
                      GOODAMP(J,I)=.TRUE.
                    ENDIF
                  ENDIF
                ENDIF
              ENDDO
            ENDDO
          ENDIF
        ELSEIF (.NOT.HELDOUBLECHECKED.AND.NTRY.NE.0)THEN
C         DOUBLE CHECK THE HELICITY FILTER
          IF (GOODHEL(HELPICKED).EQ.-HELOFFSET) THEN
            IF (.NOT.ML5_0_ISZERO(ABS(ANS(1,0))+ABS(ANS(2,0))
     $       +ABS(ANS(3,0)),REF/DBLE(NCOMB),-1,-1)) THEN
              WRITE(*,*) '##W15 Helicity filter could not be successfu'
     $         //'lly double checked.'
              WRITE(*,*) 'One reason for this is that you might hav'
     $         //'e changed sensible parameters which affected wha'
     $         //'t are the zero helicity configurations.'
              WRITE(*,*) 'MadLoop will try to reset the Helicit'
     $         //'y filter with the next PS points it receives.'
              NTRY=0
              OPEN(29,FILE=HELFILTERFN,ERR=348)
 348          CONTINUE
              CLOSE(29,STATUS='delete')
            ENDIF
          ENDIF
          IF (GOODHEL(HELPICKED).LT.-HELOFFSET.AND.NTRY.NE.0) THEN
            IF(ML5_0_ISSAME(ANS(1,0),HELSAVED(1,ABS(GOODHEL(HELPICKED)
     $       +HELOFFSET)),REF,.TRUE.).EQ.0) THEN
              WRITE(*,*) '##W15 Helicity filter could not be successfu'
     $         //'lly double checked.'
              WRITE(*,*) 'One reason for this is that you might hav'
     $         //'e changed sensible parameters which affected th'
     $         //'e helicity dependance relations.'
              WRITE(*,*) 'MadLoop will try to reset the Helicit'
     $         //'y filter with the next PS points it receives.'
              NTRY=0
              OPEN(30,FILE=HELFILTERFN,ERR=349)
 349          CONTINUE
              CLOSE(30,STATUS='delete')
            ENDIF
          ENDIF
C         SET HELDOUBLECHECKED TO .TRUE. WHEN DONE
C         even if it failed we do not want to redo the check afterwards
C          if HELINITSTARTOVER=.FALSE.
          IF (HELPICKED.EQ.NCOMB.AND.(NTRY.NE.0.OR..NOT.HELINITSTARTOVE
     $     R)) THEN
            DONEHELDOUBLECHECK=.TRUE.
          ENDIF
        ENDIF

C       GOTO NEXT HELICITY OR FINISH
        IF(HELPICKED.NE.NCOMB) THEN
          HELPICKED=HELPICKED+1
          MP_DONE=.FALSE.
          GOTO 200
        ELSE
C         Useful printout
C         do I=1,NCOMB
C         write(*,*) 'HELSAVED(1,',I,')=',HELSAVED(1,I)
C         write(*,*) 'HELSAVED(2,',I,')=',HELSAVED(2,I)
C         write(*,*) 'HELSAVED(3,',I,')=',HELSAVED(3,I)
C         write(*,*) '   GOODHEL(',I,')=',GOODHEL(I)
C         ENDDO
          DO I=0,NSQUAREDSO
            DO K=1,3
              ANS(K,I)=BUFFR(K,I)
            ENDDO
          ENDDO
          IF(NTRY.EQ.0) THEN
            NATTEMPTS=NATTEMPTS+1
            IF(NATTEMPTS.EQ.MAXATTEMPTS) THEN
              WRITE(*,*) '##E01 ERROR Could not initialize the filter'
     $         //'s in ',MAXATTEMPTS,' trials'
              STOP 1
            ENDIF
          ENDIF
        ENDIF

      ENDIF

      DO K=1,3
        DO I=0,NSQUAREDSO
          ANS(K,I)=ANS(K,I)/DBLE(IDEN)
          IF (USERHEL.NE.-1) THEN
            ANS(K,I)=ANS(K,I)*HELAVGFACTOR
          ENDIF
        ENDDO
      ENDDO

      IF(.NOT.CHECKPHASE.AND.HELDOUBLECHECKED.AND.(CTMODERUN.EQ.
     $ -1)) THEN
        STAB_INDEX=STAB_INDEX+1
        IF(DOING_QP_EVALS.AND.MLREDUCTIONLIB(I_LIB).EQ.1) THEN
C         NOW,ONLY CUTTOOLS PROVIDES QP
          DO I=0,NSQUAREDSO
            DO K=1,3
              QP_RES(K,I,STAB_INDEX)=ANS(K,I)
            ENDDO
          ENDDO
        ELSE
          DO I=0,NSQUAREDSO
            DO K=1,3
              DP_RES(K,I,STAB_INDEX)=ANS(K,I)
            ENDDO
          ENDDO
        ENDIF

        IF(DOING_QP_EVALS.AND.MLREDUCTIONLIB(I_LIB).EQ.1) THEN
          BASIC_CT_MODE=4
        ELSE
          BASIC_CT_MODE=1
        ENDIF

C       BEGINNING OF THE DEFINITIONS OF THE DIFFERENT EVALUATION
C        METHODS

        IF(.NOT.EVAL_DONE(2)) THEN
          EVAL_DONE(2)=.TRUE.
          IF(LOOPLIBS_DIRECTEST(MLREDUCTIONLIB(I_LIB)))THEN
            CTMODE=BASIC_CT_MODE+1
            GOTO 300
          ELSE
C           NO DIRECTION TEST LIBRARIES: e.g. PJFry++ and Golem95
            STAB_INDEX=STAB_INDEX+1
            IF(DOING_QP_EVALS)THEN
              DO I=0,NSQUAREDSO
                DO K=1,3
                  QP_RES(K,I,STAB_INDEX)=ANS(K,I)
                ENDDO
              ENDDO
            ELSE
              DO I=0,NSQUAREDSO
                DO K=1,3
                  DP_RES(K,I,STAB_INDEX)=ANS(K,I)
                ENDDO
              ENDDO
            ENDIF
          ENDIF
        ENDIF

        CTMODE=BASIC_CT_MODE

        IF(.NOT.EVAL_DONE(3).AND. ((DOING_QP_EVALS.AND.NROTATIONS_QP.GE
     $   .1).OR.((.NOT.DOING_QP_EVALS).AND.NROTATIONS_DP.GE.1)) ) THEN
          EVAL_DONE(3)=.TRUE.
          CALL ML5_0_ROTATE_PS(PS,P,1)
          IF (DOING_QP_EVALS) CALL ML5_0_MP_ROTATE_PS(MP_PS,MP_P,1)
          GOTO 200
        ENDIF

        IF(.NOT.EVAL_DONE(4).AND. ((DOING_QP_EVALS.AND.NROTATIONS_QP.GE
     $   .2).OR.((.NOT.DOING_QP_EVALS).AND.NROTATIONS_DP.GE.2)) ) THEN
          EVAL_DONE(4)=.TRUE.
          CALL ML5_0_ROTATE_PS(PS,P,2)
          IF (DOING_QP_EVALS) CALL ML5_0_MP_ROTATE_PS(MP_PS,MP_P,2)
          GOTO 200
        ENDIF

        CALL ML5_0_ROTATE_PS(PS,P,0)
        IF (DOING_QP_EVALS) CALL ML5_0_MP_ROTATE_PS(MP_PS,MP_P,0)

C       END OF THE DEFINITIONS OF THE DIFFERENT EVALUATION METHODS

        IF(DOING_QP_EVALS.AND.MLREDUCTIONLIB(I_LIB).EQ.1) THEN
          CALL ML5_0_COMPUTE_ACCURACY(QP_RES,N_QP_EVAL,ACC,ANS)
          DO I=0,NSQUAREDSO
            ACCURACY(I)=ACC(I)
          ENDDO
          RET_CODE_H=3
          RET_CODE_U=SET_RET_CODE_U(MLREDUCTIONLIB(I_LIB),.TRUE.
     $     ,.TRUE.)
          IF(MAXVAL(ACC).GE.MLSTABTHRES) THEN
            I_QP_LIB=I_QP_LIB+1
            IF(I_QP_LIB.GT.QP_NLOOPLIB.OR.INDEX_QP_TOOLS(I_QP_LIB
     $       ).EQ.0)THEN
              RET_CODE_H=4
              RET_CODE_U=SET_RET_CODE_U(MLREDUCTIONLIB(I_LIB),.TRUE.
     $         ,.FALSE.)
              NEPS=NEPS+1
              CALL ML5_0_COMPUTE_ACCURACY(DP_RES,N_DP_EVAL,TEMP1,TEMP)
              IF(NEPS.LE.10) THEN
                WRITE(*,*) '##W03 WARNING An unstable PS point was'
     $           ,       ' detected.'
                IF (NSQUAREDSO.NE.1) THEN
                  WRITE(*,*) 'Accuracies for each split orde'
     $             //'r, starting with the summed case'
                  WRITE(*,*) 'DP accuracies (for each split order): '
     $             ,(TEMP1(I),I=0,NSQUAREDSO)
                  WRITE(*,*) 'QP accuracies (for each split order): '
     $             ,(ACC(I),I=0,NSQUAREDSO)
                ELSE
                  WRITE(*,*) 'DP accuracy: ',TEMP1(1)
                  WRITE(*,*) 'QP accuracy: ',ACC(1)
                ENDIF
                DO J=0,NSQUAREDSO
                  IF (NSQUAREDSO.NE.1.OR.J.NE.0) THEN
                    IF (J.EQ.0) THEN
                      WRITE(*,*) 'Details for all split orders summe'
     $                 //'d :'
                    ELSE
                      WRITE(*,*) 'Details for split order index : ',J
                    ENDIF
                    WRITE(*,*) 'Best estimate (fin,1eps,2eps):',(ANS(I
     $               ,J),I=1,3)
                    WRITE(*,*) 'Finite double precision evaluations :'
     $               ,(DP_RES(1,J,I),I=1,N_DP_EVAL)
                    WRITE(*,*) 'Finite quad   precision evaluations :'
     $               ,(QP_RES(1,J,I),I=1,N_QP_EVAL)
                  ENDIF
                ENDDO
                WRITE(*,*) 'PS point specification :'
                WRITE(*,*) 'Renormalization scale MU_R=',MU_R
                DO I=1,NEXTERNAL
                  WRITE (*,'(i2,1x,4e27.17)') I, P(0,I),P(1,I),P(2,I)
     $             ,P(3,I)
                ENDDO
              ENDIF
              IF(NEPS.EQ.10) THEN
                WRITE(*,*) 'Further output of the details of thes'
     $           //'e unstable PS points will now be suppressed.'
              ENDIF
            ELSE
              I_LIB=INDEX_QP_TOOLS(I_QP_LIB)
              EVAL_DONE(1)=.TRUE.
              DO I=2,MAXSTABILITYLENGTH
                EVAL_DONE(I)=.FALSE.
              ENDDO
              STAB_INDEX=0
              IF(NROTATIONS_QP.GE.1)THEN
                GOTO 200
              ELSE
                GOTO 300
              ENDIF
            ENDIF
          ENDIF
        ELSEIF(.NOT.DOING_QP_EVALS)THEN
          CALL ML5_0_COMPUTE_ACCURACY(DP_RES,N_DP_EVAL,ACC,ANS)
          IF(MAXVAL(ACC).GE.MLSTABTHRES) THEN
            I_LIB=I_LIB+1
            IF((I_LIB.GT.NLOOPLIB.OR.MLREDUCTIONLIB(I_LIB).EQ.0
     $       ).AND.QP_TOOLS_AVAILABLE)THEN
              I_LIB=INDEX_QP_TOOLS(1)
              I_QP_LIB=1
              DOING_QP_EVALS=.TRUE.
              EVAL_DONE(1)=.TRUE.
              DO I=2,MAXSTABILITYLENGTH
                EVAL_DONE(I)=.FALSE.
              ENDDO
              STAB_INDEX=0
              CTMODE=4
              GOTO 200
            ELSEIF(I_LIB.LE.NLOOPLIB.AND.MLREDUCTIONLIB(I_LIB).GT.0
     $       )THEN
              EVAL_DONE(1)=.TRUE.
              DO I=2,MAXSTABILITYLENGTH
                EVAL_DONE(I)=.FALSE.
              ENDDO
              STAB_INDEX=0
              IF(NROTATIONS_DP.GE.1)THEN
                GOTO 200
              ELSE
                GOTO 300
              ENDIF
            ELSE
              DO I=0,NSQUAREDSO
                ACCURACY(I)=ACC(I)
              ENDDO
              RET_CODE_H=4
              RET_CODE_U=SET_RET_CODE_U(MLREDUCTIONLIB(I_LIB),.FALSE.
     $         ,.FALSE.)
              NEPS=NEPS+1
              IF(NEPS.LE.10) THEN
                WRITE(*,*) '##W03 WARNING An unstable PS point was'
     $           ,       ' detected.'
                WRITE(*,*) '##W03 WARNING No quadruple precision wil'
     $           //'l be used.'
                IF (NSQUAREDSO.NE.1) THEN
                  WRITE(*,*) 'Accuracies for each split orde'
     $             //'r, starting with the summed case'
                  WRITE(*,*) 'DP accuracies (for each split order): '
     $             ,(ACC(I),I=0,NSQUAREDSO)
                ELSE
                  WRITE(*,*) 'DP accuracy: ',ACC(1)
                ENDIF
                DO J=0,NSQUAREDSO
                  IF (NSQUAREDSO.NE.1.OR.J.NE.0) THEN
                    IF (J.EQ.0) THEN
                      WRITE(*,*) 'Details for all split orders summe'
     $                 //'d :'
                    ELSE
                      WRITE(*,*) 'Details for split order index : ',J
                    ENDIF
                    WRITE(*,*) 'Best estimate (fin,1eps,2eps):',(ANS(I
     $               ,J),I=1,3)
                    WRITE(*,*) 'Finite double precision evaluations :'
     $               ,(DP_RES(1,J,I),I=1,N_DP_EVAL)
                  ENDIF
                ENDDO
                WRITE(*,*) 'PS point specification :'
                WRITE(*,*) 'Renormalization scale MU_R=',MU_R
                DO I=1,NEXTERNAL
                  WRITE (*,'(i2,1x,4e27.17)') I, P(0,I),P(1,I),P(2,I)
     $             ,P(3,I)
                ENDDO
              ENDIF
              IF(NEPS.EQ.10) THEN
                WRITE(*,*) 'Further output of the details of thes'
     $           //'e unstable PS points will now be suppressed.'
              ENDIF
            ENDIF
          ELSE
            DO I=0,NSQUAREDSO
              ACCURACY(I)=ACC(I)
            ENDDO
            RET_CODE_H=2
            RET_CODE_U=SET_RET_CODE_U(MLREDUCTIONLIB(I_LIB),.FALSE.
     $       ,.TRUE.)
          ENDIF
        ENDIF
      ELSE
        RET_CODE_H=1
        DO I=0,NSQUAREDSO
          ACCURACY(I)=-1.0D0
        ENDDO
        RET_CODE_U=SET_RET_CODE_U(MLREDUCTIONLIB(I_LIB),.FALSE.
     $   ,.FALSE.)
      ENDIF

 9999 CONTINUE

C     Finalize the return code
      IF (MP_DONE_ONCE) THEN
        RET_CODE_T=2
      ELSE
        RET_CODE_T=1
      ENDIF
      IF(CHECKPHASE.OR..NOT.HELDOUBLECHECKED) THEN
        RET_CODE_H=1
        RET_CODE_U=SET_RET_CODE_U(MLREDUCTIONLIB(I_LIB),.FALSE.
     $   ,.FALSE.)
        RET_CODE_T=RET_CODE_T+2
        DO I=0,NSQUAREDSO
          ACCURACY(I)=-1.0D0
        ENDDO
      ENDIF

C     Finally for the summed result in ANS(1:3,0), make sure to only
C     consider the squared order asked for by the user.
C     Notice that this filtering using CHOSEN_SO_CONFIGS happens
C     here only while everywhere else one always considers the sum.
      DO J=1,3
        ANS(J,0)=0.0D0
      ENDDO
      DO I=1,NSQUAREDSO
        IF (CHOSEN_SO_CONFIGS(I)) THEN
          DO J=1,3
            ANS(J,0)=ANS(J,0)+ANS(J,I)
          ENDDO
        ENDIF
      ENDDO

C     Reinitialize the default threshold if it was specified by the
C      user
      IF (USER_STAB_PREC.GT.0.0D0) THEN
        MLSTABTHRES=MLSTABTHRES_BU
        CTMODEINIT=CTMODEINIT_BU
      ENDIF

C     Reinitialize the check phase logicals and the filters if check
C      bypassed
      IF (BYPASS_CHECK) THEN
        CHECKPHASE = OLD_CHECKPHASE
        HELDOUBLECHECKED = OLD_HELDOUBLECHECKED
        DO I=1,NCOMB
          GOODHEL(I)=OLD_GOODHEL(I)
        ENDDO
        DO I=1,NSQUAREDSO
          DO J=1,NLOOPGROUPS
            GOODAMP(I,J)=OLD_GOODAMP(I,J)
          ENDDO
        ENDDO
      ENDIF
      END

C     --=========================================--
C     General Helper functions and subroutine
C     for the main sloopmatrix subroutine
C     --=========================================--

      LOGICAL FUNCTION ML5_0_ISZERO(TOTEST, REFERENCE_VALUE, LOOP
     $ , SOINDEX)
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NLOOPGROUPS
      PARAMETER (NLOOPGROUPS=118)
      INTEGER    NSQUAREDSO
      PARAMETER (NSQUAREDSO=3)
C     
C     ARGUMENTS 
C     
      REAL*8 TOTEST, REFERENCE_VALUE
      INTEGER LOOP, SOINDEX
C     
C     GLOBAL 
C     
      INCLUDE 'MadLoopParams.inc'
      COMPLEX*16 LOOPRES(3,NSQUAREDSO,NLOOPGROUPS)
      LOGICAL S(NSQUAREDSO,NLOOPGROUPS)
      COMMON/ML5_0_LOOPRES/LOOPRES,S
C     ----------
C     BEGIN CODE
C     ----------
      IF(ABS(REFERENCE_VALUE).EQ.0.0D0) THEN
        ML5_0_ISZERO=.FALSE.
        WRITE(*,*) '##E02 ERRROR Reference value for comparison i'
     $   //'s zero.'
        STOP 1
      ELSE
        ML5_0_ISZERO=((ABS(TOTEST)/ABS(REFERENCE_VALUE)).LT.ZEROTHRES)
      ENDIF

      IF(LOOP.NE.-1) THEN
        IF((.NOT.ML5_0_ISZERO).AND.(.NOT.S(SOINDEX,LOOP))) THEN
          WRITE(*,*) '##W01 WARNING Contribution ',LOOP,' of spli'
     $     //'t order ',SOINDEX,' is detected as contributing wit'
     $     //'h CR=',(ABS(TOTEST)/ABS(REFERENCE_VALUE)),' but i'
     $     //'s unstable.'
        ENDIF
      ENDIF

      END

      INTEGER FUNCTION ML5_0_ISSAME(RESA,RESB,REF,USEMAX)
      IMPLICIT NONE
C     This function compares the result from two different helicity
C      configuration A and B
C     It returns 0 if they are not related and (+/-wgt) if A=(+/-wgt)*B
C     .
C     For now, the only wgt implemented is the integer 1 or -1.
C     If useMax is .TRUE., it uses all implemented weights no matter
C      what is HELINITSTARTOVER
C     
C     CONSTANTS
C     
      INTEGER MAX_WGT_TO_TRY
      PARAMETER (MAX_WGT_TO_TRY=2)
C     
C     ARGUMENTS 
C     
      REAL*8 RESA(3), RESB(3)
      REAL*8 REF
      LOGICAL USEMAX
C     
C     LOCAL VARIABLES
C     
      LOGICAL ML5_0_ISZERO
      INTEGER I,J
      INTEGER N_WGT_TO_TRY
      INTEGER WGT_TO_TRY(MAX_WGT_TO_TRY)
      DATA WGT_TO_TRY/1,-1/
C     
C     INCLUDES
C     
      INCLUDE 'MadLoopParams.inc'
C     ----------
C     BEGIN CODE
C     ----------
      ML5_0_ISSAME=0

C     If the helicity can be constructed progressively while allowing
C      inconsistency, then we only allow for weight one comparisons.
      IF (.NOT.HELINITSTARTOVER.AND..NOT.USEMAX) THEN
        N_WGT_TO_TRY=1
      ELSE
        N_WGT_TO_TRY=MAX_WGT_TO_TRY
      ENDIF

      DO I=1,N_WGT_TO_TRY
        DO J=1,3
          IF (ML5_0_ISZERO(ABS(RESB(J)),REF,-1,-1)) THEN
            IF(.NOT.ML5_0_ISZERO(ABS(RESB(J))+ABS(RESA(J)),REF,-1,
     $       -1)) THEN
              GOTO 1231
            ENDIF
C           Be loser for helicity comparison, so bring a factor 100
          ELSEIF(.NOT.ML5_0_ISZERO((RESA(J)/RESB(J))-DBLE(WGT_TO_TRY(I
     $     )),REF*100.0D0,-1,-1)) THEN
            GOTO 1231
          ENDIF
        ENDDO
        ML5_0_ISSAME = WGT_TO_TRY(I)
        RETURN
 1231   CONTINUE
      ENDDO
      END

      SUBROUTINE ML5_0_COMPUTE_ACCURACY(FULLLIST, LENGTH, ACC
     $ , ESTIMATE)
      IMPLICIT NONE
C     
C     PARAMETERS 
C     
      INTEGER MAXSTABILITYLENGTH
      COMMON/ML5_0_STABILITY_TESTS/MAXSTABILITYLENGTH
      INTEGER    NSQUAREDSO
      PARAMETER (NSQUAREDSO=3)
C     
C     ARGUMENTS 
C     
      REAL*8 FULLLIST(3,0:NSQUAREDSO,MAXSTABILITYLENGTH)
      INTEGER LENGTH
      REAL*8 ACC(0:NSQUAREDSO), ESTIMATE(0:3,0:NSQUAREDSO)
C     
C     LOCAL VARIABLES 
C     
      LOGICAL MASK(MAXSTABILITYLENGTH)
      LOGICAL MASK3(3)
      DATA MASK3/.TRUE.,.TRUE.,.TRUE./
      INTEGER I,J,K
      REAL*8 AVG
      REAL*8 DIFF
      REAL*8 ACCURACIES(3)
      REAL*8 LIST(MAXSTABILITYLENGTH)

C     ----------
C     BEGIN CODE
C     ----------
      DO I=1,LENGTH
        MASK(I)=.TRUE.
      ENDDO
      DO I=LENGTH+1,MAXSTABILITYLENGTH
        MASK(I)=.FALSE.
C       For some architectures, it is necessary to initialize all the
C        elements of fulllist(i,j)
C       Beware that if the length provided is incorrect, then this can
C        corrup the fulllist given in argument.
        DO J=0,NSQUAREDSO
          DO K=1,3
            FULLLIST(K,J,I)=0.0D0
          ENDDO
        ENDDO
      ENDDO

      DO K=0,NSQUAREDSO

        DO I=1,3
          DO J=1,MAXSTABILITYLENGTH
            LIST(J)=FULLLIST(I,K,J)
          ENDDO
          DIFF=MAXVAL(LIST,1,MASK)-MINVAL(LIST,1,MASK)
          AVG=(MAXVAL(LIST,1,MASK)+MINVAL(LIST,1,MASK))/2.0D0
          ESTIMATE(I,K)=AVG
          IF (AVG.EQ.0.0D0) THEN
            ACCURACIES(I)=DIFF
          ELSE
            ACCURACIES(I)=DIFF/ABS(AVG)
          ENDIF
        ENDDO

C       The technique below is too sensitive, typically to
C       unstablities in very small poles
C       acc(k)=MAXVAL(ACCURACIES,1,MASK3)
C       The following is used instead
        ACC(K) = 0.0D0
        AVG = 0.0D0
        DO I=1,3
          ACC(K) = ACC(K) + ACCURACIES(I)*ABS(ESTIMATE(I,K))
          AVG = AVG + ESTIMATE(I,K)
        ENDDO
        IF (AVG.NE.0.0D0) THEN
          ACC(K)  = ACC(K) / ( ABS(AVG) / 3.0D0)
        ENDIF

      ENDDO

      END

      SUBROUTINE ML5_0_SET_N_EVALS(N_DP_EVALS,N_QP_EVALS)

      IMPLICIT NONE
      INTEGER N_DP_EVALS, N_QP_EVALS

      INCLUDE 'MadLoopParams.inc'

      IF(CTMODERUN.LE.-1) THEN
        N_DP_EVALS=2+NROTATIONS_DP
        N_QP_EVALS=2+NROTATIONS_QP
      ELSE
        N_DP_EVALS=1
        N_QP_EVALS=1
      ENDIF

      IF(N_DP_EVALS.GT.20.OR.N_QP_EVALS.GT.20) THEN
        WRITE(*,*) 'ERROR:: Increase hardcoded maxstabilitylength.'
        STOP 1
      ENDIF

      END

C     THIS SUBROUTINE SIMPLY SET THE GLOBAL PS CONFIGURATION GLOBAL
C      VARIABLES FROM A GIVEN VARIABLE IN DOUBLE PRECISION
      SUBROUTINE ML5_0_SET_MP_PS(P)

      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=4)
      REAL*16 MP_PS(0:3,NEXTERNAL),MP_P(0:3,NEXTERNAL)
      COMMON/ML5_0_MP_PSPOINT/MP_PS,MP_P
      REAL*8 P(0:3,NEXTERNAL)

      DO I=1,NEXTERNAL
        DO J=0,3
          MP_PS(J,I)=P(J,I)
        ENDDO
      ENDDO
      CALL ML5_0_MP_IMPROVE_PS_POINT_PRECISION(MP_PS)
      DO I=1,NEXTERNAL
        DO J=0,3
          MP_P(J,I)=MP_PS(J,I)
        ENDDO
      ENDDO

      END

C     --=========================================--
C     Functions for dealing with the ordering
C     and indexing of split order contributions
C     --=========================================--

      SUBROUTINE ML5_0_GET_NSQSO_LOOP(NSQSO)
C     
C     Simple subroutine returning the number of squared split order
C     contributions returned in ANS when calling sloopmatrix 
C     
      INTEGER    NSQUAREDSO
      PARAMETER (NSQUAREDSO=3)

      INTEGER NSQSO

      NSQSO=NSQUAREDSO

      END

      SUBROUTINE ML5_0_GET_ANSWER_DIMENSION(ANS_DIM)
C     
C     MadLoop subroutines return an array of dimension ANS(0:3,0:ANS_DI
C     M)
C     In order for the user program to be able to correctly declare
C      this
C     array when calling MadLoop, this subroutine returns its dimension
C     
      INTEGER    NSQUAREDSO
      PARAMETER (NSQUAREDSO=3)
      INTEGER ANS_DIM

      INCLUDE 'nsqso_born.inc'

      ANS_DIM=MAX(NSQSO_BORN,NSQUAREDSO)

      END

      INTEGER FUNCTION ML5_0_ML5SOINDEX_FOR_SQUARED_ORDERS(ORDERS)
C     
C     This functions returns the integer index identifying the split
C      orders list passed in argument which correspond to the values
C      of the following list of couplings (and in this order):
C     ['QCD', 'QED']
C     
C     CONSTANTS
C     
      INTEGER    NSO, NSQSO
      PARAMETER (NSO=2, NSQSO=3)
C     
C     ARGUMENTS
C     
      INTEGER ORDERS(NSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I,J
      INTEGER SQPLITORDERS(NSQSO,NSO)
      DATA (SQPLITORDERS(  1,I),I=  1,  2) /    4,    2/
      DATA (SQPLITORDERS(  2,I),I=  1,  2) /    2,    4/
      DATA (SQPLITORDERS(  3,I),I=  1,  2) /    0,    6/
C     
C     BEGIN CODE
C     
      DO I=1,NSQSO
        DO J=1,NSO
          IF (ORDERS(J).NE.SQPLITORDERS(I,J)) GOTO 1009
        ENDDO
        ML5_0_ML5SOINDEX_FOR_SQUARED_ORDERS = I
        RETURN
 1009   CONTINUE
      ENDDO

      WRITE(*,*) 'ERROR:: Stopping function ML5_0_ML5SOINDEX_FOR_SQUAR'
     $ //'ED_ORDERS'
      WRITE(*,*) 'Could not find squared orders ',(ORDERS(I),I=1,NSO)
      STOP

      END

      INTEGER FUNCTION ML5_0_ML5SOINDEX_FOR_BORN_AMP(AMPID)
C     
C     For a given born amplitude number, it returns the ID of the
C      split orders it has
C     
C     CONSTANTS
C     
      INTEGER NBORNAMPS
      PARAMETER (NBORNAMPS=7)
C     
C     ARGUMENTS
C     
      INTEGER AMPID
C     
C     LOCAL VARIABLES
C     
      INTEGER BORNAMPORDERS(NBORNAMPS)
      DATA (BORNAMPORDERS(I),I=  1,  5) /    1,    2,    2,    2,    2/
      DATA (BORNAMPORDERS(I),I=  6,  7) /    2,    2/
C     -----------
C     BEGIN CODE
C     -----------
      IF (AMPID.GT.NBORNAMPS) THEN
        WRITE(*,*) 'ERROR:: Born amplitude ID ',AMPID,' above th'
     $   //'e maximum ',NBORNAMPS
      ENDIF
      ML5_0_ML5SOINDEX_FOR_BORN_AMP = BORNAMPORDERS(AMPID)

      END

      INTEGER FUNCTION ML5_0_ML5SOINDEX_FOR_LOOP_AMP(AMPID)
C     
C     For a given loop amplitude number, it returns the ID of the
C      split orders it has
C     
C     CONSTANTS
C     
      INTEGER    NLOOPAMPS
      PARAMETER (NLOOPAMPS=1295)
C     
C     ARGUMENTS
C     
      INTEGER AMPID
C     
C     LOCAL VARIABLES
C     
      INTEGER LOOPAMPORDERS(NLOOPAMPS)
      DATA (LOOPAMPORDERS(I),I=  1,  5) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I=  6, 10) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I= 11, 15) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I= 16, 20) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I= 21, 25) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I= 26, 30) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I= 31, 35) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I= 36, 40) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I= 41, 45) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I= 46, 50) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I= 51, 55) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I= 56, 60) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I= 61, 65) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I= 66, 70) /    3,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I= 71, 75) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I= 76, 80) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I= 81, 85) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I= 86, 90) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I= 91, 95) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I= 96,100) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=101,105) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=106,110) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=111,115) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=116,120) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=121,125) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=126,130) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=131,135) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=136,140) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=141,145) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=146,150) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=151,155) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=156,160) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=161,165) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=166,170) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=171,175) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=176,180) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=181,185) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=186,190) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=191,195) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=196,200) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=201,205) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=206,210) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=211,215) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=216,220) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=221,225) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=226,230) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=231,235) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=236,240) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=241,245) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=246,250) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=251,255) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=256,260) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=261,265) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=266,270) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=271,275) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=276,280) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=281,285) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=286,290) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=291,295) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=296,300) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=301,305) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=306,310) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=311,315) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=316,320) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=321,325) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=326,330) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=331,335) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=336,340) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=341,345) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=346,350) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=351,355) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=356,360) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=361,365) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=366,370) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=371,375) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=376,380) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=381,385) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=386,390) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=391,395) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=396,400) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=401,405) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=406,410) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=411,415) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=416,420) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=421,425) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=426,430) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=431,435) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=436,440) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=441,445) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=446,450) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=451,455) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=456,460) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=461,465) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=466,470) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=471,475) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=476,480) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=481,485) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=486,490) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=491,495) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=496,500) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=501,505) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=506,510) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=511,515) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=516,520) /    4,    4,    4,    4,    3/
      DATA (LOOPAMPORDERS(I),I=521,525) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I=526,530) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I=531,535) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I=536,540) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I=541,545) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I=546,550) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I=551,555) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I=556,560) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I=561,565) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I=566,570) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I=571,575) /    3,    3,    3,    3,    3/
      DATA (LOOPAMPORDERS(I),I=576,580) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=581,585) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=586,590) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=591,595) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=596,600) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=601,605) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=606,610) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=611,615) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=616,620) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=621,625) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=626,630) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=631,635) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=636,640) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=641,645) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=646,650) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=651,655) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=656,660) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=661,665) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=666,670) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=671,675) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=676,680) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=681,685) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=686,690) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=691,695) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=696,700) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=701,705) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=706,710) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=711,715) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=716,720) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=721,725) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=726,730) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=731,735) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=736,740) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=741,745) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=746,750) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=751,755) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=756,760) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=761,765) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=766,770) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=771,775) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=776,780) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=781,785) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=786,790) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=791,795) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=796,800) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=801,805) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=806,810) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=811,815) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=816,820) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=821,825) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=826,830) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=831,835) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=836,840) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=841,845) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=846,850) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=851,855) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=856,860) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=861,865) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=866,870) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=871,875) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=876,880) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=881,885) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=886,890) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=891,895) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=896,900) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=901,905) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=906,910) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=911,915) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=916,920) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=921,925) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=926,930) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=931,935) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=936,940) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=941,945) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=946,950) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=951,955) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=956,960) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=961,965) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=966,970) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=971,975) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=976,980) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=981,985) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=986,990) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=991,995) /    4,    4,    4,    4,    4/
      DATA (LOOPAMPORDERS(I),I=996,1000) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1001,1005) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1006,1010) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1011,1015) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1016,1020) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1021,1025) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1026,1030) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1031,1035) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1036,1040) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1041,1045) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1046,1050) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1051,1055) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1056,1060) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1061,1065) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1066,1070) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1071,1075) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1076,1080) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1081,1085) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1086,1090) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1091,1095) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1096,1100) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1101,1105) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1106,1110) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1111,1115) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1116,1120) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1121,1125) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1126,1130) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1131,1135) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1136,1140) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1141,1145) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1146,1150) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1151,1155) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1156,1160) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1161,1165) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1166,1170) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1171,1175) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1176,1180) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1181,1185) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1186,1190) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1191,1195) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1196,1200) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1201,1205) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1206,1210) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1211,1215) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1216,1220) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1221,1225) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1226,1230) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1231,1235) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1236,1240) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1241,1245) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1246,1250) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1251,1255) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1256,1260) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1261,1265) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1266,1270) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1271,1275) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1276,1280) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1281,1285) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1286,1290) /    4,    4,    4,    4
     $ ,    4/
      DATA (LOOPAMPORDERS(I),I=1291,1295) /    4,    4,    4,    4
     $ ,    4/
C     -----------
C     BEGIN CODE
C     -----------
      IF (AMPID.GT.NLOOPAMPS) THEN
        WRITE(*,*) 'ERROR:: Loop amplitude ID ',AMPID,' above th'
     $   //'e maximum ',NLOOPAMPS
      ENDIF
      ML5_0_ML5SOINDEX_FOR_LOOP_AMP = LOOPAMPORDERS(AMPID)

      END


      INTEGER FUNCTION ML5_0_ML5SQSOINDEX(ORDERINDEXA, ORDERINDEXB)
C     
C     This functions plays the role of the interference matrix. It can
C      be hardcoded or 
C     made more elegant using hashtables if its execution speed ever
C      becomes a relevant
C     factor. From two split order indices, it return the corresponding
C      index in the squared 
C     order canonical ordering.
C     
C     CONSTANTS
C     

      INTEGER    NSO, NSQUAREDSO, NAMPSO
      PARAMETER (NSO=2, NSQUAREDSO=3, NAMPSO=4)
C     
C     ARGUMENTS
C     
      INTEGER ORDERINDEXA, ORDERINDEXB
C     
C     LOCAL VARIABLES
C     
      INTEGER I, SQORDERS(NSO)
      INTEGER AMPSPLITORDERS(NAMPSO,NSO)
      DATA (AMPSPLITORDERS(  1,I),I=  1,  2) /    2,    0/
      DATA (AMPSPLITORDERS(  2,I),I=  1,  2) /    0,    2/
      DATA (AMPSPLITORDERS(  3,I),I=  1,  2) /    2,    2/
      DATA (AMPSPLITORDERS(  4,I),I=  1,  2) /    0,    4/
C     
C     FUNCTION
C     
      INTEGER ML5_0_ML5SOINDEX_FOR_SQUARED_ORDERS
C     
C     BEGIN CODE
C     
      DO I=1,NSO
        SQORDERS(I)=AMPSPLITORDERS(ORDERINDEXA,I)+AMPSPLITORDERS(ORDERI
     $   NDEXB,I)
      ENDDO
      ML5_0_ML5SQSOINDEX=ML5_0_ML5SOINDEX_FOR_SQUARED_ORDERS(SQORDERS)
      END

C     --=========================================--
C     Definition of additional access routines
C     --=========================================--

      SUBROUTINE ML5_0_FORCE_STABILITY_CHECK(ONOFF)
C     
C     This function can be called by the MadLoop user so as to always
C      have stability
C     checked, even during initialisation, when calling the *_thres
C      routines.
C     
      LOGICAL ONOFF

      LOGICAL BYPASS_CHECK, ALWAYS_TEST_STABILITY
      DATA BYPASS_CHECK, ALWAYS_TEST_STABILITY /.FALSE.,.FALSE./
      COMMON/ML5_0_BYPASS_CHECK/BYPASS_CHECK, ALWAYS_TEST_STABILITY

      ALWAYS_TEST_STABILITY = ONOFF

      END

      SUBROUTINE ML5_0_SET_COUPLINGORDERS_TARGET(SOTARGET)
      IMPLICIT NONE
C     
C     This routine can be accessed by an external user to set the
C      squared split order target.
C     If set to a value different than -1, the code will try to avoid
C      computing anything which
C     does not contribute to contributions of squared split orders
C      SQSO_TARGET and below.
C     This can considerably speed up the code. However, keep in mind
C      that any contribution of
C     'squared order index' larger than SQSO_TARGET cannot be trust.
C     
C     ARGUMENTS
C     
      INTEGER SOTARGET
C     
C     GLOBAL
C     
      INTEGER SQSO_TARGET
      COMMON/ML5_0_SOCHOICE/SQSO_TARGET
C     ----------
C     BEGIN CODE
C     ----------
      SQSO_TARGET = SOTARGET
      END

      SUBROUTINE ML5_0_SLOOPMATRIXHEL(P,HEL,ANS)
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=4)
      INTEGER    NSQUAREDSO
      PARAMETER (NSQUAREDSO=3)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL)
      REAL*8 ANS(0:3,0:NSQUAREDSO)
      INTEGER HEL, USERHEL
      COMMON/ML5_0_USERCHOICE/USERHEL
C     ----------
C     BEGIN CODE
C     ----------
      USERHEL=HEL
      CALL ML5_0_SLOOPMATRIX(P,ANS)
      END

      SUBROUTINE ML5_0_SLOOPMATRIXHEL_THRES(P,HEL,ANS,PREC_ASKED
     $ ,PREC_FOUND,RET_CODE)
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=4)
      INTEGER    NSQUAREDSO
      PARAMETER (NSQUAREDSO=3)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL)
      REAL*8 ANS(0:3,0:NSQUAREDSO)
      INTEGER HEL, RET_CODE
      REAL*8 PREC_ASKED,PREC_FOUND(0:NSQUAREDSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I
C     
C     GLOBAL VARIABLES
C     
      REAL*8 USER_STAB_PREC
      COMMON/ML5_0_USER_STAB_PREC/USER_STAB_PREC

      INTEGER H,T,U
      REAL*8 ACCURACY(0:NSQUAREDSO)
      COMMON/ML5_0_ACC/ACCURACY,H,T,U

      LOGICAL BYPASS_CHECK, ALWAYS_TEST_STABILITY
      COMMON/ML5_0_BYPASS_CHECK/BYPASS_CHECK, ALWAYS_TEST_STABILITY

C     ----------
C     BEGIN CODE
C     ----------
      USER_STAB_PREC = PREC_ASKED

      CALL ML5_0_SLOOPMATRIXHEL(P,HEL,ANS)
      IF(ALWAYS_TEST_STABILITY.AND.(H.EQ.1.OR.ACCURACY(0).LT.0.0D0)
     $ ) THEN
        BYPASS_CHECK = .TRUE.
        CALL ML5_0_SLOOPMATRIXHEL(P,HEL,ANS)
        BYPASS_CHECK = .FALSE.
C       Make sure we correctly return an initialization-type T code
        IF (T.EQ.2) T=4
        IF (T.EQ.1) T=3
      ENDIF

C     Reset it to default value not to affect next runs
      USER_STAB_PREC = -1.0D0

      DO I=0,NSQUAREDSO
        PREC_FOUND(I)=ACCURACY(I)
      ENDDO
      RET_CODE=100*H+10*T+U

      END

      SUBROUTINE ML5_0_SLOOPMATRIX_THRES(P,ANS,PREC_ASKED,PREC_FOUND
     $ ,RET_CODE)
C     
C     Inputs are:
C     P(0:3, Nexternal)  double  :: Kinematic configuration (E,px,py,pz
C     )
C     PEC_ASKED          double  :: Target relative accuracy, -1 for
C      default
C     
C     Outputs are:
C     ANS(3)             double  :: Result (finite, single pole,
C      double pole) 
C     PREC_FOUND         double  :: Relative accuracy estimated for
C      the result
C     Returns -1 if no stab test could be performed.
C     RET_CODE			 integer :: Return code. See below for details
C     
C     Return code conventions: RET_CODE = H*100 + T*10 + U
C     
C     H == 1
C     Stability unknown.
C     H == 2
C     Stable PS (SPS) point.
C     No stability rescue was necessary.
C     H == 3
C     Unstable PS (UPS) point.
C     Stability rescue necessary, and successful.
C     H == 4
C     Exceptional PS (EPS) point.
C     Stability rescue attempted, but unsuccessful.
C     
C     T == 1
C     Default computation (double prec.) was performed.
C     T == 2
C     Quadruple precision was used for this PS point.
C     T == 3
C     MadLoop in initialization phase. Only double precision used.
C     T == 4
C     MadLoop in initialization phase. Quadruple precision used.
C     
C     U == 0
C     Not stable.
C     U == 1
C     Stable with CutTools in double precision.
C     U == 2
C     Stable with PJFry++.
C     U == 3
C     Stable with IREGI.
C     U == 4
C     Stable with Golem95
C     U == 9
C     Stable with CutTools in quadruple precision.         
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=4)
      INTEGER    NSQUAREDSO
      PARAMETER (NSQUAREDSO=3)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL)
      REAL*8 ANS(0:3,0:NSQUAREDSO)
      REAL*8 PREC_ASKED,PREC_FOUND(0:NSQUAREDSO)
      INTEGER RET_CODE
C     
C     LOCAL VARIABLES
C     
      INTEGER I
C     
C     GLOBAL VARIABLES
C     
      REAL*8 USER_STAB_PREC
      COMMON/ML5_0_USER_STAB_PREC/USER_STAB_PREC

      INTEGER H,T,U
      REAL*8 ACCURACY(0:NSQUAREDSO)
      COMMON/ML5_0_ACC/ACCURACY,H,T,U

      LOGICAL BYPASS_CHECK, ALWAYS_TEST_STABILITY
      COMMON/ML5_0_BYPASS_CHECK/BYPASS_CHECK, ALWAYS_TEST_STABILITY

C     ----------
C     BEGIN CODE
C     ----------
      USER_STAB_PREC = PREC_ASKED
      CALL ML5_0_SLOOPMATRIX(P,ANS)
      IF(ALWAYS_TEST_STABILITY.AND.(H.EQ.1.OR.ACCURACY(0).LT.0.0D0)
     $ ) THEN
        BYPASS_CHECK = .TRUE.
        CALL ML5_0_SLOOPMATRIX(P,ANS)
        BYPASS_CHECK = .FALSE.
C       Make sure we correctly return an initialization-type T code
        IF (T.EQ.2) T=4
        IF (T.EQ.1) T=3
      ENDIF

C     Reset it to default value not to affect next runs
      USER_STAB_PREC = -1.0D0
      DO I=0,NSQUAREDSO
        PREC_FOUND(I)=ACCURACY(I)
      ENDDO
      RET_CODE=100*H+10*T+U

      END

